// O(N^2 * K)

#include <stdio.h>

#define NMAX 100100
#define INF 11111111111111111
#define BIGINT long long //__int64
#define fmt "%lld" // "%I64d"

BIGINT x[NMAX], w[NMAX], f[NMAX], wsum[NMAX], wxsum[2][NMAX];
BIGINT cmin[2][2][NMAX], v;
int i, j, k, N, K, c, a;

int main()
{
	freopen("rompetrol.in", "r", stdin);
	freopen("rompetrol.out", "w", stdout);

	// read data

	scanf("%d %d", &N, &K);

	for (i = 1; i <= N; i++)
	{
		scanf(fmt, &x[i]);
		scanf(fmt, &w[i]);
		scanf(fmt, &f[i]);
	}

	// precomputations

	wsum[0] = 0;
	for (i = 1; i <= N; i++)
		wsum[i] = wsum[i - 1] + w[i];

	wxsum[0][N + 1] = 0;
	for (i = N; i >= 1; i--)
		wxsum[0][i] = wxsum[0][i + 1] + w[i] * (x[N] - x[i]);	

	wxsum[1][0] = 0;
	for (i = 1; i <= N; i++)
		wxsum[1][i] = wxsum[1][i - 1] + w[i] * (x[i] - x[1]);

	// initialize for k = 0

	a = c = 0;

	for (i = 1; i <= N; i++)
		cmin[c][0][i] =	cmin[c][1][i] = INF;

	cmin[c][0][0] = 0;
	cmin[c][1][0] = 0;
	
	// dynamic programming

	for (k = 1; k <= K; k++)
	{
		a = c;
		c = 1 - c;

		for (i = 0; i < k; i++)
			cmin[c][0][i] = cmin[c][1][i] = INF;

		for (i = k; i <= N; i++)
		{
			// 1. compute cmin[c][0][i]  -  when the k-th center is located in i -> it is based on cmin[a][1][j], 0 <= j < i

			cmin[c][0][i] = INF;

			for (j = i - 1; j >= k - 1; j--)
			{
				v = cmin[a][1][j] + (wxsum[0][j + 1] - wxsum[0][i + 1] - (wsum[i] - wsum[j]) * (x[N] - x[i]));

				if (v + f[i] < cmin[c][0][i])
					cmin[c][0][i] = v + f[i];
			}

			// 2. compute cmin[c][1][i] - when the cover interval of the k-th center ends in i -> it is based on cmin[c][0][j], 1 <= j <= i

			cmin[c][1][i] = INF;

			for (j = i; j >= k; j--)
			{
				v = cmin[c][0][j] + (wxsum[1][i] - wxsum[1][j] - (wsum[i] - wsum[j]) * (x[j] - x[1]));

				if (v < cmin[c][1][i])
					cmin[c][1][i] = v;
			}
		}

		//fprintf(stderr, "k=%d -> ", k);
		//fprintf(stderr, fmt, cmin[c][1][N]);
		//fprintf(stderr, "\n");
	}

	printf(fmt, cmin[c][1][N]);
	printf("\n");

	return 0;
}
