#include <stdio.h>

#define NMAX 100100
#define INF 11111111111111111
#define BIGINT long long //__int64
#define fmt "%lld" // "%I64d"

BIGINT cmin[2][2][NMAX], dq[2][NMAX], firstmin[2][NMAX], v, vj, dC, dP, fmin, xi;
BIGINT x[NMAX], w[NMAX], f[NMAX], wsum[NMAX], wxsum[2][NMAX];
int li[2], ls[2], poz[2][NMAX];
int i, j, k, N, K, c, a;

int main()
{
	freopen("rompetrol.in", "r", stdin);
	freopen("rompetrol.out", "w", stdout);

	// read data

	scanf("%d %d", &N, &K);

	for (i = 1; i <= N; i++)
	{
		scanf(fmt, &x[i]);
		scanf(fmt, &w[i]);
		scanf(fmt, &f[i]);
	}

	// precomputations

	wsum[0] = 0;
	for (i = 1; i <= N; i++)
		wsum[i] = wsum[i - 1] + w[i];

	wxsum[0][N + 1] = 0;
	for (i = N; i >= 1; i--)
		wxsum[0][i] = wxsum[0][i + 1] + w[i] * (x[N] - x[i]);	

	wxsum[1][0] = 0;
	for (i = 1; i <= N; i++)
		wxsum[1][i] = wxsum[1][i - 1] + w[i] * (x[i] - x[1]);

	// initialize for k = 0

	a = c = 0;

	for (i = 1; i <= N; i++)
		cmin[c][0][i] =	cmin[c][1][i] = INF;

	cmin[c][0][0] = 0;
	cmin[c][1][0] = 0;
	
	// dynamic programming

	for (k = 1; k <= K; k++)
	{
		a = c;
		c = 1 - c;

		for (i = 0; i < k; i++)
			cmin[c][0][i] = cmin[c][1][i] = INF;

		for (j = 0; j < 2; j++)
			ls[j] = 0,
			li[j] = 1;

		for (i = k; i <= N; i++)
		{
			// 1. compute cmin[c][0][i]  -  when the k-th center is located in i -> it is based on cmin[a][1][j], 0 <= j < i

			v = cmin[a][1][i - 1];

			if (v < INF)
			{
				fmin = x[i];

				// cleanup the front end of the deque

				while (li[0] < ls[0] && firstmin[0][li[0] + 1] <= fmin)
					li[0]++;

				while (li[0] <= ls[0])
				{
					j = poz[0][ls[0]];

					// compute the moment when function 'i' becomes smaller than function 'j'

					vj = dq[0][ls[0]] + (wxsum[0][j] - wxsum[0][i + 1] - (wsum[i] - wsum[j - 1]) * (x[N] - x[i])); 
					dC = v - vj;
					dP = (wsum[i - 1] - wsum[j - 1]);

					if (dC <= 0)
						xi = -1;
					else
					{
						xi = x[i] + dC/dP;

						if (dC % dP > 0)
							xi++;
					}

					if (xi <= firstmin[0][ls[0]])
						ls[0]--;
					else
					{
						fmin = xi;
						break;
					}
				}

				ls[0]++;
				dq[0][ls[0]] = v;
				poz[0][ls[0]] = i;
				firstmin[0][ls[0]] = fmin;
			}

			if (li[0] <= ls[0])
			{
				j = poz[0][li[0]];
				cmin[c][0][i] = dq[0][li[0]] + (wxsum[0][j] - wxsum[0][i + 1] - (wsum[i] - wsum[j - 1]) * (x[N] - x[i])) + f[i];
			}
			else
				cmin[c][0][i] = INF;

			// 2. compute cmin[c][1][i] - when the cover interval of the k-th center ends in i -> it is based on cmin[c][0][j], 1 <= j <= i

			v = cmin[c][0][i];

			if (v < INF)
			{
				fmin = wsum[i];

				// cleanup the front end of the deque

				while (li[1] < ls[1] && firstmin[1][li[1] + 1] <= fmin)
					li[1]++;

				while (li[1] <= ls[1])
				{
					j = poz[1][ls[1]];

					// compute the moment when function 'i' becomes smaller than function 'j'

					vj = dq[1][ls[1]] + (wxsum[1][i] - wxsum[1][j] - (wsum[i] - wsum[j]) * (x[j] - x[1]) );
					dC = v - vj;
					dP = x[i] - x[j];

					if (dC <= 0)
						xi = -1;
					else
					{
						xi = wsum[i] + dC/dP;

						if (dC % dP > 0)
							xi++;
					}

					if (xi <= firstmin[1][ls[1]])
						ls[1]--;
					else
					{
						fmin = xi;
						break;
					}
				}

				ls[1]++;
				dq[1][ls[1]] = v;
				poz[1][ls[1]] = i;
				firstmin[1][ls[1]] = fmin;
			}

			if (li[1] <= ls[1])
			{
				j = poz[1][li[1]];
				cmin[c][1][i] = dq[1][li[1]] + (wxsum[1][i] - wxsum[1][j] - (wsum[i] - wsum[j]) * (x[j] - x[1]) );
			}
			else
				cmin[c][1][i] = INF;
		}

		//fprintf(stderr, "k=%d -> ", k);
		//fprintf(stderr, fmt, cmin[c][1][N]);
		//fprintf(stderr, "\n");
	}

	printf(fmt, cmin[c][1][N]);
	printf("\n");

	return 0;
}
