// O(N * 3^6 * 6^3) -> ideea solutiei este gresita, pt ca nu este corecta definitia unei stari din dinamica

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DIFMAX 6
#define NSTATES 729

#define STATE_SINGLE 0
#define STATE_ENDPOINT 1
#define STATE_INSIDE 2

#define NMAX 1001
#define INF 666666666

char A[NMAX][NMAX];
int minp[2][NSTATES], minc[2][NSTATES];
int state[NSTATES][DIFMAX + 1], ss[DIFMAX + 1];
int i, j, si, sj, k, n, s, snou, N, K, X, M, c, a, vmax, vmin, nstates;

int getStateNumber(int ss[])
{
	int i, sn = 0;

	for (i = K - 1; i >= 0; i--)
		sn = sn * 3 + ss[i];

	return sn;
}

int minpathcover(void)
{
	int vmin, c, a;

	// dynamic programming

	c = a = 0;

	for (s = 0; s < NSTATES; s++)
		minp[c][s] = INF;

	minp[c][0] = 1;

	//fprintf(stderr, "starting: N=%d\n", N);

	for (n = 2; n <= N; n++)
	{
		a = c;
		c = 1 - c;

		for (s = 0; s < NSTATES; s++)
			minp[c][s] = INF;

		for (s = 0; s < NSTATES; s++)
			if (minp[a][s] < INF)
			{
				//printf("%d %d\n", n - 1, s);

				//fprintf(stderr, "###### n=%d, s=%d, minp[a][s]=%d\n", n - 1, s, minp[a][s]);
				
				// option 1: extend a path

				for (i = n - 1; i >= n - DIFMAX && i > 0; i--)
					if (A[n][i] && state[s][n - i - 1] != STATE_INSIDE)
					{
						if (state[s][n - i - 1] == STATE_SINGLE)
						{
							//fprintf(stderr, "# n=%d -> extend path: %d[%d]\n", n, i, state[s][n - i - 1]);

							// copy the state
							for (k = 0; k < DIFMAX; k++)
								ss[k + 1] = state[s][k];

							ss[0] = STATE_ENDPOINT;
							ss[n - i] = STATE_ENDPOINT;

							snou = getStateNumber(ss);

							if (minp[a][s] < minp[c][snou])
								minp[c][snou] = minp[a][s];

							//fprintf(stderr, "[snou=%d]: ", snou);
							//for (k = 0; k < DIFMAX; k++)
							//	fprintf(stderr, " %d", ss[k]);
							//fprintf(stderr, "\n");
						}
						else // state[s][n - i - 1] == STATE_ENDPOINT
						{
							//fprintf(stderr, "# n=%d -> extend path: %d[%d]\n", n, i, state[s][n - i - 1]);

							// copy the state
							for (k = 0; k < DIFMAX; k++)
								ss[k + 1] = state[s][k];

							ss[0] = state[s][n - i - 1];
							ss[n - i] = STATE_INSIDE;

							snou = getStateNumber(ss);

							if (minp[a][s] < minp[c][snou])
								minp[c][snou] = minp[a][s];

							//fprintf(stderr, "[snou=%d]: ", snou);
							//for (k = 0; k < DIFMAX; k++)
							//	fprintf(stderr, " %d", ss[k]);
							//fprintf(stderr, "\n");
						}
					}

				// option 2: connect two existing paths

				ss[0] = STATE_INSIDE;
				for (i = n - 1; i >= n - DIFMAX && i > 0; i--)
					if (A[n][i] && state[s][n - i - 1] != STATE_INSIDE)
						for (j = i - 1; j >= n - DIFMAX && j > 0; j--)
							if (A[n][j] && state[s][n - j - 1] != STATE_INSIDE)
							{
								//fprintf(stderr, "# n=%d -> connect two paths: %d[%d] - %d[%d]\n", n, i, state[s][n - i - 1], j, state[s][n - j - 1]);

								// copy the state
								for (k = 0; k < DIFMAX; k++)
									ss[k + 1] = state[s][k];
					
								if (state[s][n - i - 1] == STATE_SINGLE && state[s][n - j - 1] == STATE_SINGLE)
								{
									ss[n - i] = STATE_ENDPOINT;
									ss[n - j] = STATE_ENDPOINT;
								}
								else
								if (state[s][n - i - 1] == STATE_SINGLE && state[s][n - j - 1] > 0)
								{
									ss[n - i] = ss[n - j];
									ss[n - j] = STATE_INSIDE;
								}
								else
								if (state[s][n - i - 1] > 0 && state[s][n - j - 1] == STATE_SINGLE)
								{
									ss[n - j] = ss[n - i];
									ss[n - i] = STATE_INSIDE;
								}
								else // state[s][n - i -1] > 0 && state[s][n - j - 1] > 0
								{
									ss[n - i] = STATE_INSIDE;
									ss[n - j] = STATE_INSIDE;
								}

								snou = getStateNumber(ss);

								if (minp[a][s] - 1 < minp[c][snou])
									minp[c][snou] = minp[a][s] - 1;

								//fprintf(stderr, "[snou=%d]: ", snou);
								//for (k = 0; k < DIFMAX; k++)
								//	fprintf(stderr, " %d", ss[k]);
								//fprintf(stderr, "\n");
							}

				// option 3: add a single node

				ss[0] = STATE_SINGLE;
				for (i = 0; i < K; i++)
					ss[i + 1] = state[s][i];

				snou = getStateNumber(ss);

				if (minp[a][s] + 1 < minp[c][snou])
					minp[c][snou] = minp[a][s] + 1;

				//fprintf(stderr, "# n=%d -> single node; [snou=%d] :", n, snou);
				//for (i = 0; i < DIFMAX; i++)
				//	fprintf(stderr, " %d", ss[i]);
				//fprintf(stderr, "\n");
			}
	}

	vmin = INF;

	for (s = 0; s < NSTATES; s++)
		if (minp[c][s] < vmin)
			vmin = minp[c][s];

	if (vmin == INF)
		vmin = -1;

	return vmin;
}

int mincyclecover(void)
{
	int vmin, c, a, extrac;

	// dynamic programming

	c = a = 0;

	for (s = 0; s < NSTATES; s++)
		minc[c][s] = INF;

	minc[c][nstates - 3] = 0;

	//fprintf(stderr, "starting: N=%d\n", N);

	for (n = 2; n <= N; n++)
	{
		a = c;
		c = 1 - c;

		for (s = 0; s < NSTATES; s++)
			minc[c][s] = INF;

		for (s = 0; s < NSTATES; s++)
			if (minc[a][s] < INF)
			{		
				// option 1: extend a path

				for (i = n - 1; i >= n - DIFMAX && i > 0; i--)
					if (A[n][i] && state[s][n - i - 1] != STATE_INSIDE)
					{
						if (state[s][n - i - 1] == STATE_SINGLE)
						{
							//fprintf(stderr, "# n=%d -> extend path: %d[%d]\n", n, i, state[s][n - i - 1]);

							// copy the state
							for (k = 0; k < K; k++)
								ss[k + 1] = state[s][k];

							ss[0] = STATE_ENDPOINT;
							ss[n - i] = STATE_ENDPOINT;

							snou = getStateNumber(ss);

							if (minc[a][s] < minc[c][snou] && ss[K] == STATE_INSIDE)
								minc[c][snou] = minc[a][s];

							//fprintf(stderr, "[snou=%d]: ", snou);
							//for (k = 0; k < DIFMAX; k++)
							//	fprintf(stderr, " %d", ss[k]);
							//fprintf(stderr, "\n");
						}
						else // state[s][n - i - 1] == STATE_ENDPOINT
						{
							//fprintf(stderr, "# n=%d -> extend path: %d[%d]\n", n, i, state[s][n - i - 1]);

							// copy the state
							for (k = 0; k < K; k++)
								ss[k + 1] = state[s][k];

							ss[0] = state[s][n - i - 1];
							ss[n - i] = STATE_INSIDE;

							snou = getStateNumber(ss);

							if (minc[a][s] < minc[c][snou] && ss[K] == STATE_INSIDE)
								minc[c][snou] = minc[a][s];

							//fprintf(stderr, "[snou=%d]: ", snou);
							//for (k = 0; k < DIFMAX; k++)
							//	fprintf(stderr, " %d", ss[k]);
							//fprintf(stderr, "\n");
						}
					}

				// option 2: connect two existing paths

				ss[0] = STATE_INSIDE;
				for (i = n - 1; i >= n - K && i > 0; i--)
					if (A[n][i] && state[s][n - i - 1] != STATE_INSIDE)
						for (j = i - 1; j >= n - K && j > 0; j--)
							if (A[n][j] && state[s][n - j - 1] != STATE_INSIDE)
							{
								extrac = 0;						
								//fprintf(stderr, "# n=%d -> connect two paths: %d[%d] - %d[%d]\n", n, i, state[s][n - i - 1], j, state[s][n - j - 1]);

								// copy the state
								for (k = 0; k < K; k++)
									ss[k + 1] = state[s][k];
					
								if (state[s][n - i - 1] == STATE_SINGLE && state[s][n - j - 1] == STATE_SINGLE)
								{
									ss[n - i] = STATE_ENDPOINT;
									ss[n - j] = STATE_ENDPOINT;
								}
								else
								if (state[s][n - i - 1] == STATE_SINGLE && state[s][n - j - 1] > 0)
								{
									ss[n - i] = ss[n - j];
									ss[n - j] = STATE_INSIDE;
								}
								else
								if (state[s][n - i - 1] > 0 && state[s][n - j - 1] == STATE_SINGLE)
								{
									ss[n - j] = ss[n - i];
									ss[n - i] = STATE_INSIDE;
								}
								else // state[s][n - i -1] > 0 && state[s][n - j - 1] > 0
								{
									ss[n - i] = STATE_INSIDE;
									ss[n - j] = STATE_INSIDE;
									extrac = 1;
								}

								snou = getStateNumber(ss);

								if (minc[a][s] + extrac < minc[c][snou] && ss[K] == STATE_INSIDE)
									minc[c][snou] = minc[a][s] + extrac;

								//fprintf(stderr, "[snou=%d]: ", snou);
								//for (k = 0; k < DIFMAX; k++)
								//	fprintf(stderr, " %d", ss[k]);
								//fprintf(stderr, "\n");
							}

				// option 3: add a single node

				ss[0] = STATE_SINGLE;
				for (i = 0; i < K; i++)
					ss[i + 1] = state[s][i];

				snou = getStateNumber(ss);

				if (minc[a][s] < minc[c][snou] && ss[K] == STATE_INSIDE)
					minc[c][snou] = minc[a][s] + 1;

				//fprintf(stderr, "# n=%d -> single node; [snou=%d] :", n, snou);
				//for (i = 0; i < DIFMAX; i++)
				//	fprintf(stderr, " %d", ss[i]);
				//fprintf(stderr, "\n");
			}
	}

	vmin = minc[c][nstates - 1];

	if (vmin == INF)
		vmin = -1;

	return vmin;
}

int main()
{
	freopen("kcity.in", "r", stdin);

	scanf("%d %d %d %d", &N, &K, &X, &M);

	memset(A, 0, sizeof(A));

	for (k = 0; k < M; k++)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	// generate states

	nstates = 1;

	for (k = 0; k < K; k++)
		nstates *= 3;

	for (s = 0; s < nstates; s++)
	{
		snou = s;
		i = 0;

		while (i < K)
		{
			state[s][i] = snou % 3;
			snou /= 3;
			i++;
		}
	}

	freopen("kcity.out", "w", stdout);

	if (X == 1)
		printf("%d\n", minpathcover());
	else
		printf("%d\n", mincyclecover());

	return 0;
}
