#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 1010
#define INF 666666666
#define CYCINF 50
#define DIFMAX 6

#define STATE_SINGLE 0
#define STATE_INSIDE -1

char A[NMAX][NMAX];
char state[NMAX][NMAX];
int i, j, k, N, K, X, M, np, nc, npmin, ncmin;
int pid, used[DIFMAX + 3];

void bkt_paths(int n)
{
	int i, j, k, si, sj, npo, d;

	if (n > N)
	{
		if (np < npmin)
		{
			fprintf(stderr, "$$$ old npmin=%d, new npmin=%d\n", npmin, np);
			npmin = np;
		}

		return;
	}

	// check if the backtracking should continue

	npo = 0;

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (state[n - 1][i] == STATE_SINGLE)
			npo++;

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (state[n - 1][i] > 0)
		{
			npo++;

			for (j = i - 1; j >= n - K && j > 0; j--)
				if (state[n - 1][j] == state[n - 1][i])
				{
					npo--;
					break;
				}
		}

	d = npo - 1;
	if (N - n + 1 < d)
		d = N - n + 1;

	if (np - d >= npmin)
	{
		//fprintf(stderr, "### n=%d, np=%d, npo=%d, d=%d, np-d=%d, npmin=%d => NO FURTHER IMPROVEMENT POSSIBLE\n", n, np, npo, d, np - d, npmin);
		return;
	}

	//fprintf(stderr, "*** [ENTER] n=%d, np=%d, npo=%d, np-npo+1=%d, npmin=%d\n", n, np, npo, np-npo+1, npmin);
	//for (i = n - 1; /*i >= n - DIFMAX &&*/ i > 0; i--)
	//	fprintf(stderr, " -> state[%d]=%d\n", i, state[n - 1][i]);

	memset(used, 0, sizeof(used));

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (state[n - 1][i] > 0 && state[n - 1][i] <= DIFMAX)
			used[state[n - 1][i]] = 1;

	for (i = 1; i <= DIFMAX + 3; i++)
		if (!used[i])
		{
			pid = i;
			break;
		}

	// option 1. connect two existing paths

	state[n][n] = STATE_INSIDE;

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (A[n][i] && state[n - 1][i] != STATE_INSIDE)
			for (j = i - 1; j >= n - K && j > 0; j--)
				if (A[n][j] && state[n - 1][j] != STATE_INSIDE)
				{
					//fprintf(stderr, "! connecting (1) n=%d, %d[%d] - %d[%d]\n", n, i, state[n - 1][i], j, state[n - 1][j]);

					if (state[n - 1][i] > 0 && state[n - 1][i] == state[n - 1][j]) // the ends of the same path
						continue;

					//fprintf(stderr, "! connecting (2) n=%d, %d[%d] - %d[%d]\n", n, i, state[n - 1][i], j, state[n - 1][j]);


					// copy the previous state
					for (k = n - 1; k >= n - K && k > 0; k--)
						state[n][k] = state[n - 1][k];
					
					if (state[n - 1][i] == STATE_SINGLE && state[n - 1][j] == STATE_SINGLE)
					{
						state[n][i] = pid;
						state[n][j] = pid;
					}
					else
					if (state[n - 1][i] == STATE_SINGLE && state[n - 1][j] > 0)
					{
						state[n][i] = state[n - 1][j];
						state[n][j] = STATE_INSIDE;
					}
					else
					if (state[n - 1][i] > 0 && state[n - 1][j] == STATE_SINGLE)
					{
						state[n][j] = state[n - 1][i];
						state[n][i] = STATE_INSIDE;
					}
					else // state[n - 1][i] > 0 && state[n - 1][j] > 0
					{
						si = state[n - 1][i];
						sj = state[n - 1][j];
						state[n][i] = STATE_INSIDE;
						state[n][j] = STATE_INSIDE;

						for (k = n - 1; k >= n - K && k > 0; k--)
							if (state[n][k] == sj)
							{
								state[n][k] = si;
								break;
							}	
					}

					//fprintf(stderr, "!!! [CONNECTING] n=%d, np=%d\n", n, np);
					//for (k = n - 1; /*k >= n - K &&*/ k > 0; k--)
					//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
					//fprintf(stderr, "! connecting %d[%d] - %d[%d]\n", i, state[n - 1][i], j, state[n - 1][j]);
					//for (k = n; /*k >= n - K &&*/ k > 0; k--)
					//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

					np--;
					bkt_paths(n + 1);
					np++;
				}

	// option 2. add the node to the end of an existing path

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (A[i][n] && state[n - 1][i] == STATE_SINGLE)
		{
			// copy the previous state
			for (j = n - 1; j >= n - K && j > 0; j--)
				state[n][j] = state[n - 1][j];

			// set the new state
			state[n][i] = pid;
			state[n][n] = pid;

			//fprintf(stderr, "@@@ [EXTENDING] n=%d, np=%d\n", n, np);
			//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
			//fprintf(stderr, "@ linking %d - %d\n", n, i);
			//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

			bkt_paths(n + 1);
		}
		else
		if (A[i][n] && state[n - 1][i] > 0)
		{
			// copy the previous state
			for (j = n - 1; j >= n - K && j > 0; j--)
				state[n][j] = state[n - 1][j];

			// set the new state
			state[n][i] = STATE_INSIDE;
			state[n][n] = state[n - 1][i];

			//fprintf(stderr, "@@@ [EXTENDING] n=%d, np=%d\n", n, np);
			//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
			//fprintf(stderr, "@ linking %d - %d\n", n, i);
			//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

			bkt_paths(n + 1);
		}

	// option 3. start a new path with a single node (n)
	
	// copy the previous state
	for (j = n - 1; j >= n - K && j > 0; j--)
		state[n][j] = state[n - 1][j];

	state[n][n] = STATE_SINGLE;

	//fprintf(stderr, "... [SINGLE NODE] n=%d, np=%d\n", n, np);
	//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
	//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
	//fprintf(stderr, ". single node: n=%d\n", n);
	//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
	//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

	np++;
	bkt_paths(n + 1);
	np--;
}

void bkt_cycles(int n)
{
	int i, j, k, si, sj, npo, d, allinside, extrac;

	if (n > N)
	{
		allinside = 1;

		for (i = N; i >= N - K; i--)
			if (state[n - 1][i] != STATE_INSIDE)
			{
				allinside = 0;
				break;
			}

		if (nc < ncmin && allinside)
		{
			fprintf(stderr, "$$$ old ncmin=%d, new ncmin=%d\n", ncmin, nc);
			ncmin = nc;
		}

		return;
	}

	//fprintf(stderr, "*** [ENTER] n=%d, np=%d, npo=%d, np-npo+1=%d, npmin=%d\n", n, np, npo, np-npo+1, npmin);
	//for (i = n - 1; /*i >= n - DIFMAX &&*/ i > 0; i--)
	//	fprintf(stderr, " -> state[%d]=%d\n", i, state[n - 1][i]);

	memset(used, 0, sizeof(used));

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (state[n - 1][i] > 0 && state[n - 1][i] <= DIFMAX)
			used[state[n - 1][i]] = 1;

	for (i = 1; i <= DIFMAX + 3; i++)
		if (!used[i])
		{
			pid = i;
			break;
		}

	// option 1. connect two existing paths

	state[n][n] = STATE_INSIDE;

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (A[n][i] && state[n - 1][i] != STATE_INSIDE)
			for (j = i - 1; j >= n - K && j > 0; j--)
				if (A[n][j] && state[n - 1][j] != STATE_INSIDE)
				{
					extrac = 0;
					//fprintf(stderr, "! connecting (1) n=%d, %d[%d] - %d[%d]\n", n, i, state[n - 1][i], j, state[n - 1][j]);

					//fprintf(stderr, "! connecting (2) n=%d, %d[%d] - %d[%d]\n", n, i, state[n - 1][i], j, state[n - 1][j]);

					// copy the previous state
					for (k = n - 1; k >= n - K && k > 0; k--)
						state[n][k] = state[n - 1][k];
					
					if (state[n - 1][i] == STATE_SINGLE && state[n - 1][j] == STATE_SINGLE)
					{
						state[n][i] = pid;
						state[n][j] = pid;
					}
					else
					if (state[n - 1][i] == STATE_SINGLE && state[n - 1][j] > 0)
					{
						state[n][i] = state[n - 1][j];
						state[n][j] = STATE_INSIDE;
					}
					else
					if (state[n - 1][i] > 0 && state[n - 1][j] == STATE_SINGLE)
					{
						state[n][j] = state[n - 1][i];
						state[n][i] = STATE_INSIDE;
					}
					else
					if (state[n - 1][i] == state[n - 1][j]) // the ends of the same path
					{
						state[n][i] = STATE_INSIDE;
						state[n][j] = STATE_INSIDE;
						extrac = 1;
					}
					else // state[n - 1][i] > 0 && state[n - 1][j] > 0
					{
						si = state[n - 1][i];
						sj = state[n - 1][j];
						state[n][i] = STATE_INSIDE;
						state[n][j] = STATE_INSIDE;

						for (k = n - 1; k >= n - K && k > 0; k--)
							if (state[n][k] == sj)
							{
								state[n][k] = si;
								break;
							}	
					}

					//fprintf(stderr, "!!! [CONNECTING] n=%d, np=%d\n", n, np);
					//for (k = n - 1; /*k >= n - K &&*/ k > 0; k--)
					//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
					//fprintf(stderr, "! connecting %d[%d] - %d[%d]\n", i, state[n - 1][i], j, state[n - 1][j]);
					//for (k = n; /*k >= n - K &&*/ k > 0; k--)
					//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

					nc += extrac;

					if (nc < ncmin && (n <= K || state[n][n - K] == STATE_INSIDE))
						bkt_cycles(n + 1);

					nc -= extrac;
				}

	// option 2. add the node to the end of an existing path

	for (i = n - 1; i >= n - K && i > 0; i--)
		if (A[i][n] && state[n - 1][i] == STATE_SINGLE)
		{
			// copy the previous state
			for (j = n - 1; j >= n - K && j > 0; j--)
				state[n][j] = state[n - 1][j];

			// set the new state
			state[n][i] = pid;
			state[n][n] = pid;

			//fprintf(stderr, "@@@ [EXTENDING] n=%d, np=%d\n", n, np);
			//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
			//fprintf(stderr, "@ linking %d - %d\n", n, i);
			//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

			if (n <= K || state[n][n - K] == STATE_INSIDE)
				bkt_cycles(n + 1);
		}
		else
		if (A[i][n] && state[n - 1][i] > 0)
		{
			// copy the previous state
			for (j = n - 1; j >= n - K && j > 0; j--)
				state[n][j] = state[n - 1][j];

			// set the new state
			state[n][i] = STATE_INSIDE;
			state[n][n] = state[n - 1][i];

			//fprintf(stderr, "@@@ [EXTENDING] n=%d, np=%d\n", n, np);
			//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
			//fprintf(stderr, "@ linking %d - %d\n", n, i);
			//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
			//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

			if (n <= K || state[n][n - K] == STATE_INSIDE)
				bkt_cycles(n + 1);
		}

	// option 3. start a new path with a single node (n)
	
	// copy the previous state
	for (j = n - 1; j >= n - K && j > 0; j--)
		state[n][j] = state[n - 1][j];

	state[n][n] = STATE_SINGLE;

	//fprintf(stderr, "... [SINGLE NODE] n=%d, np=%d\n", n, np);
	//for (k = n - 1; /*k >= n - DIFMAX &&*/ k > 0; k--)
	//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n - 1][k]);
	//fprintf(stderr, ". single node: n=%d\n", n);
	//for (k = n; /*k >= n - DIFMAX &&*/ k > 0; k--)
	//	fprintf(stderr, " -> state[%d]=%d\n", k, state[n][k]);

	if (n <= K || state[n][n - K] == STATE_INSIDE)
		bkt_cycles(n + 1);
}

int main()
{
	freopen("kcity.in", "r", stdin);
	freopen("kcity.out", "w", stdout);

	scanf("%d %d %d %d", &N, &K, &X, &M);

	memset(A, 0, sizeof(A));

	for (k = 0; k < M; k++)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	if (X == 1)
	{
		npmin = N;
		np = 1;
		pid = 0;
		state[1][1] = STATE_SINGLE;

		fprintf(stderr, "### paths ###\n");
		bkt_paths(2);
		printf("%d\n", npmin);
	}
	else
	{
		ncmin = CYCINF;
		nc = 0;
		pid = 0;
		state[1][1] = STATE_SINGLE;

		fprintf(stderr, "### cycles ###\n");
		bkt_cycles(2);

		if (ncmin == CYCINF)
			ncmin = -1;

		printf("%d\n", ncmin);
	}

	return 0;
}
