#include <stdio.h>
#include <string.h>

#define NMAX 11
#define INF 255

unsigned char min[1 << NMAX][1 << NMAX];
int touched[1 << NMAX][1 << NMAX];
char B[NMAX + 1][NMAX + 1];
int i, j, M, N, lM, lN, te, T;

inline int compute(int rows, int cols)
{
	int i, j, nrows, ncols, nextrows, nextcols, nkept, x, y, allzero, allone;

	if (touched[rows][cols] == te)
		return min[rows][cols];

	touched[rows][cols] = te;
	min[rows][cols] = INF;

	for (nrows = i = 0; i < M; i++)
		if (rows & (1 << i))
			nrows++;

	for (ncols = j = 0; j < N; j++)
		if (cols & (1 << j))
			ncols++;

	allzero = allone = 1;

	for (i = 0; i < M; i++)
		for (j = 0; j < N; j++)
			if ((rows & (1 << i)) && (cols & (1 << j)))
			{
				if (B[i][j] == '0')
					allone = 0;

				if (B[i][j] == '1')
					allzero = 0;
			}

	if (allzero || allone)
	{
		min[rows][cols] = 1;
		return 1;
	}

	if (nrows > 1)
	{
		/* A */
		nkept = nrows / 2;

		nextrows = 0;
		for (i = 0; i < M && nkept; i++)
			if (rows & (1 << i))
			{
				nextrows |= (1 << i);
				nkept--;
			}

		x = compute(nextrows, cols);
		y = compute(rows & (~nextrows), cols);

		if (1 + x + y < min[rows][cols])
			min[rows][cols] = 1 + x + y;
	}

	if (ncols > 1)
	{
		/* B */
		nkept = ncols / 2;

		nextcols = 0;
		for (i = 0; i < N && nkept; i++)
			if (cols & (1 << i))
			{
				nextcols |= (1 << i);
				nkept--;
			}

		x = compute(rows, nextcols);
		y = compute(rows, cols & (~nextcols));

		if (1 + x + y < min[rows][cols])
			min[rows][cols] = 1 + x + y;
	}

	if (nrows > 1)
	{
		/* C */
		nkept = 0;

		nextrows = 0;
		for (i = 0; i < M; i++)
			if (rows & (1 << i))
			{
				nkept++;

				if (nkept & 1)
					nextrows |= (1 << i);
			}

		x = compute(nextrows, cols);
		y = compute(rows & (~nextrows), cols);

		if (1 + x + y < min[rows][cols])
			min[rows][cols] = 1 + x + y;
	}

	if (ncols > 1)
	{
		/* D */
		nkept = 0;

		nextcols = 0;
		for (i = 0; i < N; i++)
			if (cols & (1 << i))
			{
				nkept++;

				if (nkept & 1)
					nextcols |= (1 << i);
			}

		x = compute(rows, nextcols);
		y = compute(rows, cols & (~nextcols));

		if (1 + x + y < min[rows][cols])
			min[rows][cols] = 1 + x + y;
	}

	return min[rows][cols];
}

int main()
{
	freopen("bitmap.in", "r", stdin);
	freopen("bitmap.out", "w", stdout);

	scanf("%d", &T);

	memset(touched, 0, sizeof(touched));

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &M, &N);

		for (i = 0; i < M; i++)
			scanf("%s", &B[i]);

		lM = 1 << M;
		lN = 1 << N;

		printf("%d\n", compute(lM - 1, lN - 1));

		//fprintf(stderr, "%d\n", T);
	}

	return 0;
}