// O(N*number_of_active_functions)

#include <stdio.h>
#include <string.h>

#define NMAX 131072
#define LLINF 100000000000000000//LL

#define BIGINT __int64 //long long
#define fmt "%I64d" //"%lld"

BIGINT f[NMAX], c[NMAX], s[NMAX], sp[NMAX], d[NMAX], dp[NMAX], p[NMAX];
BIGINT finit[NMAX], cmin[NMAX], l[NMAX], r[NMAX], vk, vi, sum, dC, dP, x, sumnaf;
int af[NMAX];
char out[NMAX];
int i, j, k, N, naf, naf2;

int main()
{
	freopen("ch.in", "r", stdin);

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
	{
		scanf(fmt, &f[i]);
		scanf(fmt, &c[i]);
		scanf(fmt, &s[i]);
		scanf(fmt, &d[i]);
	}

	// compute sp and dp (partial sums)

	sp[0] = dp[0] = 0;
		
	for (i = 1; i <= N; i++)
		sp[i] = s[i] + sp[i - 1],
		dp[i] = d[i] + dp[i - 1];

	dp[N + 1] = dp[N] + 1;

	// dynamic programming

	memset(out, 0, sizeof(out));

	naf = 0;
	sumnaf = 0;
	cmin[0] = 0;

	for (i = 1; i <= N; i++)
	{
		p[i] = c[i] - sp[i - 1];
		finit[i] = cmin[i - 1] + f[i];
		l[i] = dp[i];
		r[i] = dp[N + 1];

		vi = finit[i] + p[i] * (dp[i] - dp[i - 1]);

		for (j = 1; j <= naf; j++)
		{
			k = af[j];

			// compute the intersection of the functions i and k

			vk = finit[k] + p[k] * (dp[i] - dp[k - 1]);

			if (vi < vk)
			{
				if (p[i] <= p[k])
					out[k] = 1;
				else
				{
					dC = vk - vi;
					dP = p[i] - p[k];

					x = dp[i] + dC / dP;

					if (dC % dP > 0)
						x++;

					if (x < r[i])
						r[i] = x;

					if (x > l[k])
						l[k] = x;
				}
			}
			else
			{
				if (p[i] >= p[k])
				{
					out[i] = 1;
					break;
				}
				else
				{
					dC = vi - vk;
					dP = p[k] - p[i];

					x = dp[i] + dC / dP;

					if (dC % dP > 0)
						x++;

					if (x > l[i])
						l[i] = x;

					if (x < r[k])
						r[k] = x;
				}
			}
		}

		if (!out[i] && l[i] <= r[i])
			af[++naf] = i;

		// compute cmin

		for (naf2 = 0, j = 1; j <= naf; j++)
		{
			k = af[j];

			if (l[k] <= dp[i])
			{
				cmin[i] = finit[k] + p[k] * (dp[i] - dp[k - 1]);
			}

			if (l[k] < dp[i + 1])
				l[k] = dp[i + 1];

			if (l[k] > r[k])
				out[k] = 1;

			if (!out[k])
				af[++naf2] = k;
		}

		naf = naf2;
		sumnaf += (BIGINT) naf;

		/*
		if (i % 100 == 0)
			fprintf(stderr, "%d: %I64d\n", i, sumnaf);
		*/

		//fprintf(stderr, "%d: naf=%d\n", i, naf);
	}

	fprintf(stderr, "N=%d, sumnaf=", N);
	fprintf(stderr, fmt, sumnaf);
	fprintf(stderr, ", sumnaf/N=%.4lf\n", (double) sumnaf / (double) N);

	sum = 0;

	for (i = 1; i <= N; i++)
	{
		sum += d[i] * sp[i - 1];
		//fprintf(stderr, "%d: d=%lld, sp=%lld, sum=%lld\n", i, d[i], sp[i - 1], sum);
	}

	printf(fmt, cmin[N] + sum);
	printf("\n");

	//fprintf(stderr, "cmin=%lld\n", cmin[N]);
	//fprintf(stderr, "sum=%lld\n", sum);

	return 0;
}
