// O(M * nstates(N) * 2^N [ * log(nstates) ])

#include <stdio.h>
#include <string.h>

#define NMAX 10
#define MAXSTATES 2188
#define LAUX 1000
#define INF 666666666
#define ZERO '0'
#define ONE '1'
#define SINGLE_NODE_PATH -1

#include <map>
using namespace std;

int state[MAXSTATES + 1][NMAX], s[NMAX], nexts[NMAX], minc[2][MAXSTATES + 1], minp[2][MAXSTATES + 1], tunion[NMAX + 13][NMAX + 13];
map<int, int> hmap;
char row[NMAX + 13], up[NMAX + 13], left[NMAX + 13], used[NMAX + 13], saux[LAUX];
int i, j, k, r, M, N, X, nstates, nb, st, c, a, extrac, maxcyc, extrap, maxpath;

inline int hash(int* st)
{
	int i, h;

	h = 0;

	for (i = 0; i < N; i++)
		h = (h << 3) + st[i];

	return h;
}

void genstates(int niv)
{
	int j, lsup;

	if (niv >= N)
	{
		//nstates++;
		for (j = 0; j < N; j++)
		{
			state[nstates][j] = s[j];
			//fprintf(stderr, "%d ", s[j]);
		}

		//fprintf(stderr, "\n");

		hmap[hash(state[nstates])] = nstates;
		nstates++;
	}
	else
	{
		if (s[niv] != -1)
		{
			genstates(niv + 1);
			return;
		}

		/*
		if (X == 1)
		{
			s[niv] = -1;
			genstates(niv + 1);
		}
		*/

		s[niv] = 0;
		genstates(niv + 1);

		nb++;
		s[niv] = nb;
		lsup = niv + 1;

		if (X == 1)
			genstates(niv + 1);

		while (lsup < N && s[lsup] == -1)
			lsup++;

		for (j = lsup - 1; j > niv; j--)
		{
			s[j] = nb;
			genstates(niv + 1);
			s[j] = -1;
		}

		nb--;
		s[niv] = -1;
	}
}

void init_states_cycles(int niv)
{
	int j, lsup;

	if (niv >= N)
	{
		/*
		for (j = 0; j < N; j++)
			printf("%d ", s[j]);
		printf("\n");
		*/		
		minc[c][hmap[hash(s)]] = 0;
	}
	else
	{
		if (s[niv] != -1)
		{
			init_states_cycles(niv + 1);
			return;
		}

		if (row[niv] == ZERO)
		{
			s[niv] = 0;
			init_states_cycles(niv + 1);
		}
		else
		{
			nb++;
			s[niv] = nb;

			lsup = niv + 1;
			while (lsup < N && row[lsup] == ONE)
				lsup++;

			for (j = niv + 1; j < lsup; j++)
			{
				s[j] = nb;
				init_states_cycles(niv + 1);
				s[j] = 0;
			}

			for (j = niv + 1; j < lsup; j++)
				s[j] = -1;

			nb--;
		}

		s[niv] = -1;
	}
}

void localbkt_cycles(int niv, int curcyc)
{
	int i, ti, tj, cnt, stnext;

	if (niv >= N)
	{
		/*
		printf("\n\n###\nst_number=%d\nst      =", st);
		for (i = 0; i < N; i++)
			printf(" %d", state[st][i]);

		printf("\nminc[st]=%d", minc[a][st]);
		printf("\nextrac=%d", extrac);

		printf("\nrow     =");
		for (i = 0; i < N; i++)
			printf(" %c", row[i]);
		*/
		memcpy(s, nexts, sizeof(s));

		/*
		printf("\nnexts(1)=");
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		*/

		// unite the combined paths

		for (i = 0; i < N; i++)
		{
			ti = s[i];
			while (tunion[niv][ti] > 0)
				ti = tunion[niv][ti];

			s[i] = ti;
		}

		/*
		printf("\nnexts(2)=");
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		*/

		// reorder the cycles in nexts in increasing order

		memset(used, 0, sizeof(used));
		cnt = 0;

		for (i = 0; i < N; i++)
		{
			if (s[i] == 0)
				continue;

			if (!used[s[i]])
				used[s[i]] = ++cnt;

			s[i] = used[s[i]];
		}

		stnext = hmap[hash(s)];

		/*
		printf("\nnexts_number=%d\nnexts(3)=", stnext);
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		printf("\n");
		*/

		if (minc[a][st] + extrac < minc[c][stnext])
			minc[c][stnext] = minc[a][st] + extrac;
	}
	else
	{
		memcpy(tunion[niv + 1], tunion[niv], sizeof(tunion[niv]));

		if (left[niv] && up[niv]) // already part of a cycle
		{
			if (row[niv] == ZERO)
				return;
			else
			{
				// combine 2 cycles together or close one cycle

				ti = curcyc;
				while (tunion[niv + 1][ti] > 0)
					ti = tunion[niv][ti];

				tj = state[st][niv];
				while (tunion[niv + 1][tj] > 0)
					tj = tunion[niv][tj];

				if (ti == tj) // closing one cycle
				{
					extrac++;
					localbkt_cycles(niv + 1, 0);
					extrac--;
				}
				else // combining 2 paths
				{
					tunion[niv + 1][ti] = tj;
					localbkt_cycles(niv + 1, 0);
					tunion[niv + 1][ti] = 0;
				}
			}
		}
		else
		if (left[niv] && !up[niv])
		{
			if (row[niv] == ZERO)
				return;
			else
			{
				// expand right
				if (niv < N - 1)
				{
					left[niv + 1] = 1;
					localbkt_cycles(niv + 1, curcyc);
					left[niv + 1] = 0;
				}

				// expand down
				nexts[niv] = curcyc; // or some other number ?
				localbkt_cycles(niv + 1, 0);
				nexts[niv] = 0;
			}
		}
		else
		if (!left[niv] && up[niv])
		{
			if (row[niv] == ZERO)
				return;
			else
			{
				// expand right
				if (niv < N - 1)
				{
					left[niv + 1] = 1;
					localbkt_cycles(niv + 1, state[st][niv]);
					left[niv + 1] = 0;
				}

				// expand down
				nexts[niv] = state[st][niv]; // or some other number ?
				localbkt_cycles(niv + 1, 0);
				nexts[niv] = 0;
			}
		}
		else
		if (!left[niv] && !up[niv])
		{
			if (row[niv] == ZERO)
				localbkt_cycles(niv + 1, 0);
			else
			{
				// expand both right and down
				if (niv < N - 1)
				{
					left[niv + 1] = 1;
					maxcyc++;
					nexts[niv] = maxcyc; // or some other number ?
					
					localbkt_cycles(niv + 1, maxcyc);

					nexts[niv] = 0;
					maxcyc--;
					left[niv + 1] = 0;
				}
			}
		}
	}
}

int mincyclecover()
{
	// read the first row and initialize the states

	fgets(row, NMAX + 2, stdin);

	c = a = 0;
	for (i = 0; i <= nstates; i++)
		minc[c][i] = INF;

	nb = 0;
	for (i = 0; i < N; i++)
		s[i] = -1;

	init_states_cycles(0);

	memset(tunion, 0, sizeof(tunion));

	// read the following rows and use dynamic programming combined with local backtracking

	for (r = 2; r <= M; r++)
	{
		//printf("!!! row %d\n", r);

		fgets(row, NMAX + 2, stdin);

		a = c;
		c = 1 - c;

		for (i = 0; i <= nstates; i++)
			minc[c][i] = INF;
	
		for (st = 0; st <= nstates; st++)
			if (minc[a][st] < INF)
			{
				// expand the previous state st

				memset(up, 0, sizeof(up));
				memset(left, 0, sizeof(left));

				maxcyc = 0;

				for (i = 0; i < N; i++)
					if (state[st][i] > 0)
					{
						up[i] = 1;

						if (state[st][i] > maxcyc)
							maxcyc = state[st][i];
					}

				memset(nexts, 0, sizeof(nexts));
				extrac = 0;
				
				localbkt_cycles(0, 0);		
			}

		//fprintf(stderr, "row %d done\n", r);
	}

	memset(nexts, 0, sizeof(nexts));

	//printf("hash(final_state)=%d\n", hash(nexts));
	k = minc[c][hmap[hash(nexts)]];

	if (k < INF)
		return k;
	else
		return -1;
}

void init_states_paths(int niv)
{
	int j, lsup;

	if (niv >= N)
	{
		/*
		for (j = 0; j < N; j++)
			printf("%d ", s[j]);
		printf("\n");
		*/
		minp[c][hmap[hash(s)]] = nb;
	}
	else
	{
		if (s[niv] != -1)
		{
			init_states_paths(niv + 1);
			return;
		}

		if (row[niv] == ZERO)
		{
			s[niv] = 0;
			init_states_paths(niv + 1);
		}
		else
		{
			nb++;
			s[niv] = nb;

			init_states_paths(niv + 1);

			lsup = niv + 1;
			while (lsup < N && row[lsup] == ONE)
				lsup++;

			for (j = niv + 1; j < lsup; j++)
			{
				s[j] = nb;
				init_states_paths(niv + 1);
				s[j] = 0;
			}

			for (j = niv + 1; j < lsup; j++)
				s[j] = -1;

			nb--;
		}

		s[niv] = -1;
	}
}

void localbkt_paths(int niv)
{
	int i, ti, tj, cnt, stnext, resetup, resetleft, vup, vleft, vmaxp;

	if (niv >= N)
	{
		/*
		printf("\n\n###\nst_number=%d\nst      =", st);
		for (i = 0; i < N; i++)
			printf(" %d", state[st][i]);

		printf("\nminc[st]=%d", minc[a][st]);
		printf("\nextrac=%d", extrac);

		printf("\nrow     =");
		for (i = 0; i < N; i++)
			printf(" %c", row[i]);
		*/
		memcpy(s, nexts, sizeof(s));

		cnt = maxpath;

		for (i = 0; i < N; i++)
			if (s[i] == SINGLE_NODE_PATH)
			{
				cnt++;
				s[i] = cnt;
			}

		/*
		printf("\nnexts(1)=");
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		*/

		// unite the combined paths

		for (i = 0; i < N; i++)
		{
			ti = s[i];
			while (tunion[niv][ti] > 0)
				ti = tunion[niv][ti];

			s[i] = ti;
		}

		/*
		printf("\nnexts(2)=");
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		*/

		// reorder the cycles in s in increasing order

		memset(used, 0, sizeof(used));
		cnt = 0;

		for (i = 0; i < N; i++)
		{
			if (s[i] == 0)
				continue;

			if (!used[s[i]])
				used[s[i]] = ++cnt;

			s[i] = used[s[i]];
		}

		stnext = hmap[hash(s)];

		/*
		printf("\nnexts_number=%d\nnexts(3)=", stnext);
		for (i = 0; i < N; i++)
			printf(" %d", s[i]);
		printf("\n");
		*/

		if (minp[a][st] + extrap < minp[c][stnext])
			minp[c][stnext] = minp[a][st] + extrap;
	}
	else
	{
		memcpy(tunion[niv + 1], tunion[niv], sizeof(tunion[niv]));

		if (row[niv] == ZERO)
		{
			localbkt_paths(niv + 1);
			return;
		}

		// start a new path all alone

		nexts[niv] = SINGLE_NODE_PATH;

		if (niv > 0 && nexts[niv - 1] == SINGLE_NODE_PATH)
		{
			resetleft = 1;
			vleft = nexts[niv - 1];

			maxpath++;
			nexts[niv - 1] = maxpath;
		}
		else
			resetleft = 0;

		extrap++;
		localbkt_paths(niv + 1);
		extrap--;

		if (resetleft)
		{
			nexts[niv - 1] = vleft;
			maxpath--;
		}

		// connect upwards

		if (state[st][niv] > 0)
		{
			nexts[niv] = state[st][niv];

			if (niv > 0 && nexts[niv - 1] == SINGLE_NODE_PATH)
			{
				resetleft = 1;
				vleft = nexts[niv - 1];

				maxpath++;
				nexts[niv - 1] = maxpath;
			}
			else
				resetleft = 0;

			localbkt_paths(niv + 1);

			if (resetleft)
			{
				nexts[niv - 1] = vleft;
				maxpath--;
			}
		}

		// connect left

		if (niv > 0 && nexts[niv - 1] != 0)
		{
			if (nexts[niv - 1] == SINGLE_NODE_PATH)
			{
				resetleft = 1;
				vleft = nexts[niv - 1];

				maxpath++;
				nexts[niv - 1] = maxpath;
				nexts[niv] = maxpath;

				vmaxp = 1;
			}
			else
			{
				resetleft = 1;
				vleft = nexts[niv - 1];
				vmaxp = 0;

				nexts[niv] = nexts[niv - 1];
				nexts[niv - 1] = 0;
			}

			localbkt_paths(niv + 1);

			if (resetleft)
			{
				nexts[niv - 1] = vleft;
				maxpath -= vmaxp;
			}
		}

		// connect both upwards and left

		if (niv > 0 && nexts[niv - 1] != 0 && state[st][niv] > 0)
		{
			nexts[niv] = 0;
			if (nexts[niv - 1] == SINGLE_NODE_PATH)
			{
				resetleft = 1;
				vleft = nexts[niv - 1];

				maxpath++;
				vup = nexts[niv - 1] = maxpath;

				vmaxp = 1;
			}
			else
			{
				resetleft = 1;
				vleft = nexts[niv - 1];
				vmaxp = 0;

				vup = nexts[niv - 1];
				nexts[niv - 1] = 0;
			}

			ti = vup;
			while (tunion[niv + 1][ti] > 0)
				ti = tunion[niv + 1][ti];

			tj = state[st][niv];
			while (tunion[niv + 1][tj] > 0)
				tj = tunion[niv + 1][tj];

			if (ti != tj) // combine 2 different paths
			{
				tunion[niv + 1][ti] = tj;
				extrap--;
				localbkt_paths(niv + 1);
				extrap++;
				tunion[niv + 1][ti] = 0;
			}

			if (resetleft)
			{
				nexts[niv - 1] = vleft;
				maxpath -= vmaxp;
			}			
		}
	}
}

int minpathcover()
{
	int vmin;

	// read the first row and initialize the states

	fgets(row, NMAX + 2, stdin);

	c = a = 0;
	for (i = 0; i <= nstates; i++)
		minp[c][i] = INF;

	nb = 0;
	for (i = 0; i < N; i++)
		s[i] = -1;

	init_states_paths(0);

	memset(tunion, 0, sizeof(tunion));

	// read the following rows and use dynamic programming combined with local backtracking

	for (r = 2; r <= M; r++)
	{
		//printf("!!! row %d\n", r);

		fgets(row, NMAX + 2, stdin);

		a = c;
		c = 1 - c;

		for (i = 0; i <= nstates; i++)
			minp[c][i] = INF;
	
		for (st = 0; st <= nstates; st++)
			if (minp[a][st] < INF)
			{
				// expand the previous state st

				memset(left, 0, sizeof(left));

				maxpath = 0;

				for (i = 0; i < N; i++)
					if (state[st][i] > 0)
					{
						if (state[st][i] > maxpath)
							maxpath = state[st][i];
					}

				memset(nexts, 0, sizeof(nexts));
				extrap = 0;
				
				localbkt_paths(0);		
			}

		//fprintf(stderr, "row %d done\n", r);
	}

	memset(nexts, 0, sizeof(nexts));

	vmin = INF;

	for (st = 0; st <= nstates; st++)
		if (minp[c][st] < vmin)
			vmin = minp[c][st];

	return vmin;
}

int main()
{
	freopen("clear.in", "r", stdin);
	freopen("clear.out", "w", stdout);

	fgets(saux, LAUX - 2, stdin);
	sscanf(saux, "%d %d %d", &X, &M, &N);

	// generate all possible (paranthesis-like) states

	hmap.clear();
	nstates = nb = 0;
	for (i = 0; i < N; i++)
		s[i] = -1;

	genstates(0);

	//printf("%d\n", nstates);

	if (X == 1)
		printf("%d\n", minpathcover());
	else
		printf("%d\n", mincyclecover());

	return 0;
}
