// O(M * N * nstates(N) [ * log(nstates) ])

#include <stdio.h>
#include <string.h>

#define NMAX 10
#define MAXSTATES 3100
#define LAUX 1000
#define INF 666666666
#define ZERO '0'
#define ONE '1'
#define ALL_DONE 0
#define SINGLE_NODE_PATH -1

#include <map>
using namespace std;

int state[MAXSTATES + 1][NMAX][NMAX], s[NMAX], nexts[NMAX], minc[2][MAXSTATES + 1], minp[2][MAXSTATES + 1], tunion[NMAX + 13][NMAX + 13];
int nstates[NMAX];
map<int, int> hmpath[NMAX], hmcyc[NMAX];
char row[NMAX + 13], up[NMAX + 13], left[NMAX + 13], used[NMAX + 13], saux[LAUX];
int i, j, k, r, M, N, X, nb, st, c, a, extrac, maxcyc, extrap, maxpath, poz;

inline int hash_paths(int* st)
{
	int i, h;

	h = 0;

	for (i = 0; i < N; i++)
		h = (h << 4) + (st[i] + 1);

	/*
	if (hmpath[poz][h] != 0)
	{
		h = h;
	}
	*/

	return h;
}

void genstates_paths(int niv)
{
	int j, lsup;

	if (niv >= N)
	{
		/*
		for (j = 0; j < N; j++)
		{
			fprintf(stderr, "%d ", s[j]);
		}

		fprintf(stderr, "\n");
		*/

		if (poz >= 0)
		{
			for (j = 0; j < N; j++)
				state[nstates[poz]][poz][j] = s[j];

			hmpath[poz][hash_paths(state[nstates[poz]][poz])] = nstates[poz];
			nstates[poz]++;
		}
		else
		{
			for (poz = 0; poz < N; poz++)
			{
				for (j = 0; j < N; j++)
					state[nstates[poz]][poz][j] = s[j];

				hmpath[poz][hash_paths(state[nstates[poz]][poz])] = nstates[poz];
				nstates[poz]++;
			}

			poz = -1;
		}
	}
	else
	{
		if (s[niv] != -1)
		{
			genstates_paths(niv + 1);
			return;
		}

		if (poz == -1 && niv < N - 1)
		{
			poz = niv;
			s[niv] = SINGLE_NODE_PATH;
			genstates_paths(niv + 1);
			poz = -1;
		}

		s[niv] = ALL_DONE;
		genstates_paths(niv + 1);

		nb++;
		s[niv] = nb;
		lsup = niv + 1;

		genstates_paths(niv + 1);

		while (lsup < N && s[lsup] == -1)
			lsup++;

		for (j = lsup - 1; j > niv; j--)
		{
			s[j] = nb;
			genstates_paths(niv + 1);
			s[j] = -1;
		}

		nb--;
		s[niv] = -1;
	}
}

void adjustState_paths(int *st, int poz)
{
	int i, cnt = 0;

	memset(used, 0, sizeof(used));

	for (i = 0; i < N; i++)
	{
		if (s[i] == -1 && (i != poz || poz == N - 1))
		{
			cnt++;
			s[i] = cnt;
		}
		else
		if (s[i] > 0)
		{
			if (used[s[i]])
				s[i] = used[s[i]];
			else
			{
				cnt++;
				used[s[i]] = cnt;
				s[i] = cnt;
			}
		}
	}
}

int minpathcover()
{
	int vmin, rowv, colv, colvant, extrap, pmax, newst;

	// read the first row and initialize the states

	c = a = 0;
	for (i = 0; i <= nstates[N - 1]; i++)
		minp[c][i] = INF;

	nb = 0;
	for (i = 0; i < N; i++)
		s[i] = 0;

	//s[0] = 1;
	//printf("%d\n", hash_paths(s, N - 1));
	minp[c][hmpath[N - 1][hash_paths(s)]] = 0;

	for (rowv = 1; rowv <= M; rowv++)
	{
		fgets(row, NMAX + 2, stdin);
		
		for (colvant = N - 1, colv = 0; colv < N; colv++)
		{
				a = c;
				c = 1 - c;
	
				for (i = 0; i <= nstates[colv]; i++)
				{
					minp[c][i] = INF;

					/*
					if (minp[a][i] < 1 && rowv > 1)
					{
						printf("%d,%d -> %d\n", rowv, colv, i);
					}
					*/
				}

				for (st = 0; st < nstates[colvant]; st++)
					if (minp[a][st] < INF)
					{
						// find the largest path id
						pmax = 0;
						for (i = 0; i < N; i++)
							if (state[st][colvant][i] > pmax)
								pmax = state[st][colvant][i];

						if (row[colv] == ZERO)
						{
							for (i = 0; i < N; i++)
								s[i] = state[st][colvant][i];

							s[colv] = ALL_DONE;

							adjustState_paths(s, colv);

							newst = hmpath[colv][hash_paths(s)];

							if (minp[a][st] < minp[c][newst])
								minp[c][newst] = minp[a][st];
						}
						else // row[colv] == ONE
						{
							/*
							if (colv == 6 && minp[a][st] == 1 && rowv == 2)
							{
								colv = colv;
							}
							*/

							// start a new single path

							for (i = 0; i < N; i++)
								s[i] = state[st][colvant][i];

							if (colv > 0 && s[colv - 1] == SINGLE_NODE_PATH)
								s[colv - 1] = pmax + 1;

							s[colv] = SINGLE_NODE_PATH;

							adjustState_paths(s, colv);			

							newst = hmpath[colv][hash_paths(s)];

							if (minp[a][st] + 1 < minp[c][newst])
								minp[c][newst] = minp[a][st] + 1;

							// connect to the left

							if (colv > 0 && state[st][colvant][colv - 1] != ALL_DONE)
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								if (colv > 0 && s[colv - 1] == SINGLE_NODE_PATH)
								{
									s[colv - 1] = pmax + 1;
									s[colv] = s[colv - 1];
								}
								else
								{
									s[colv] = s[colv - 1];
									s[colv - 1] = ALL_DONE;
								}

								adjustState_paths(s, colv);			

								newst = hmpath[colv][hash_paths(s)];

								if (minp[a][st] < minp[c][newst])
									minp[c][newst] = minp[a][st];
							}

							// connect upwards

							if (state[st][colvant][colv] != ALL_DONE)
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								s[colv] = state[st][colvant][colv];

								adjustState_paths(s, colv);			

								newst = hmpath[colv][hash_paths(s)];

								if (minp[a][st] < minp[c][newst])
									minp[c][newst] = minp[a][st];
							}

							// connect to the left and upwards

							if (colv > 0 && state[st][colvant][colv - 1] != ALL_DONE && state[st][colvant][colv] != ALL_DONE && state[st][colvant][colv - 1] != state[st][colvant][colv])
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								s[colv] = state[st][colvant][colv];

								if (s[colv - 1] == SINGLE_NODE_PATH)
								{
									s[colv - 1] = s[colv];
								}
								else
								{
									j = s[colv - 1];
									s[colv - 1] = ALL_DONE;

									for (i = 0; i < N; i++)
										if (s[i] == j)
										{
											s[i] = s[colv];
											break;
										}
								}

								s[colv] = ALL_DONE;
								adjustState_paths(s, colv);			

								newst = hmpath[colv][hash_paths(s)];

								if (minp[a][st] - 1 < minp[c][newst])
									minp[c][newst] = minp[a][st] - 1;
							}
						}
					}

			colvant = colv;
		}

		//fprintf(stderr, "row %d done\n", rowv);
	}

	vmin = INF;

	for (st = 0; st < nstates[N - 1]; st++)
		if (minp[c][st] < vmin)
			vmin = minp[c][st];
    
	return vmin;
}

inline int hash_cycles(int* st)
{
	int i, h;

	h = 0;

	for (i = 0; i < N; i++)
		h = (h << 3) + (st[i] + 1);

	//h = h * 10 + poz;

	return h;
}

void genstates_cycles(int niv)
{
	int j, lsup;

	if (niv >= N)
	{
		/*
		for (j = 0; j < N; j++)
		{
			fprintf(stderr, "%d ", s[j]);
		}

		fprintf(stderr, "\n");
		*/

		if (poz >= 0)
		{
			for (j = 0; j < N; j++)
				state[nstates[poz]][poz][j] = s[j];

			hmcyc[poz][hash_cycles(state[nstates[poz]][poz])] = nstates[poz];
			nstates[poz]++;
		}
		else
		{
			for (poz = 0; poz < N; poz++)
			{
				for (j = 0; j < N; j++)
					state[nstates[poz]][poz][j] = s[j];

				hmcyc[poz][hash_cycles(state[nstates[poz]][poz])] = nstates[poz];
				nstates[poz]++;
			}

			poz = -1;
		}
	}
	else
	{
		if (s[niv] != -1)
		{
			genstates_cycles(niv + 1);
			return;
		}

		if (poz == -1 && niv < N - 1)
		{
			poz = niv;
			s[niv] = SINGLE_NODE_PATH;
			genstates_cycles(niv + 1);
			poz = -1;
		}

		s[niv] = ALL_DONE;
		genstates_cycles(niv + 1);

		nb++;
		s[niv] = nb;
		lsup = niv + 1;

		while (lsup < N && s[lsup] == -1)
			lsup++;

		for (j = lsup - 1; j > niv; j--)
		{
			s[j] = nb;
			genstates_cycles(niv + 1);
			s[j] = -1;
		}

		nb--;
		s[niv] = -1;
	}
}

void adjustState_cycles(int *st, int poz)
{
	int i, cnt = 0;

	memset(used, 0, sizeof(used));

	for (i = 0; i < N; i++)
		if (s[i] > 0)
		{
			if (used[s[i]])
				s[i] = used[s[i]];
			else
			{
				cnt++;
				used[s[i]] = cnt;
				s[i] = cnt;
			}
		}
}

int mincyclecover()
{
	int vmin, rowv, colv, colvant, extrac, cmax, newst;

	// read the first row and initialize the states

	c = a = 0;
	for (i = 0; i <= nstates[N - 1]; i++)
		minc[c][i] = INF;

	nb = 0;
	for (i = 0; i < N; i++)
		s[i] = 0;

	//s[0] = 1;
	//printf("%d\n", hash_paths(s, N - 1));
	minc[c][hmcyc[N-1][hash_cycles(s)]] = 0;

	for (rowv = 1; rowv <= M; rowv++)
	{
		fgets(row, NMAX + 2, stdin);
		
		for (colvant = N - 1, colv = 0; colv < N; colv++)
		{
				a = c;
				c = 1 - c;
	
				for (i = 0; i <= nstates[colv]; i++)
				{
					minc[c][i] = INF;

					/*
					if (minp[a][i] < 1 && rowv > 1)
					{
						printf("%d,%d -> %d\n", rowv, colv, i);
					}
					*/
				}

				for (st = 0; st < nstates[colvant]; st++)
					if (minc[a][st] < INF)
					{
						// find the largest cycle id
						cmax = 0;
						for (i = 0; i < N; i++)
							if (state[st][colvant][i] > cmax)
								cmax = state[st][colvant][i];

						if (row[colv] == ZERO)
						{
							for (i = 0; i < N; i++)
								s[i] = state[st][colvant][i];

							s[colv] = ALL_DONE;

							if ((colv > 0 && s[colv - 1] == SINGLE_NODE_PATH) || (state[st][colvant][colv] != ALL_DONE))
								continue;

							adjustState_cycles(s, colv);

							newst = hmcyc[colv][hash_cycles(s)];

							if (minc[a][st] < minc[c][newst])
								minc[c][newst] = minc[a][st];
						}
						else // row[colv] == ONE
						{
							/*
							if (colv == 6 && minp[a][st] == 1 && rowv == 2)
							{
								colv = colv;
							}
							*/

							// start a new single path

							if ((colv == 0 || (colv < N - 1 && state[st][colvant][colv - 1] != SINGLE_NODE_PATH)) && state[st][colvant][colv] == ALL_DONE)
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								s[colv] = SINGLE_NODE_PATH;

								adjustState_cycles(s, colv);			

								newst = hmcyc[colv][hash_cycles(s)];

								if (minc[a][st] < minc[c][newst])
									minc[c][newst] = minc[a][st];
							}

							// connect to the left

							if (colv > 0 && state[st][colvant][colv - 1] != ALL_DONE && state[st][colvant][colv] == ALL_DONE)
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								if (colv > 0 && s[colv - 1] == SINGLE_NODE_PATH)
								{
									s[colv - 1] = cmax + 1;
									s[colv] = s[colv - 1];
								}
								else
								{
									s[colv] = s[colv - 1];
									s[colv - 1] = ALL_DONE;
								}

								adjustState_cycles(s, colv);			

								newst = hmcyc[colv][hash_cycles(s)];

								if (minc[a][st] < minc[c][newst])
									minc[c][newst] = minc[a][st];
							}

							// connect upwards

							if (state[st][colvant][colv] != ALL_DONE && (colv == 0 || (colv > 0 && state[st][colvant][colv - 1] != SINGLE_NODE_PATH)))
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								s[colv] = state[st][colvant][colv];

								adjustState_cycles(s, colv);			

								newst = hmcyc[colv][hash_cycles(s)];

								if (minc[a][st] < minc[c][newst])
									minc[c][newst] = minc[a][st];
							}

							// connect to the left and upwards

							if (colv > 0 && state[st][colvant][colv - 1] != ALL_DONE && state[st][colvant][colv] != ALL_DONE)
							{
								for (i = 0; i < N; i++)
									s[i] = state[st][colvant][i];

								if (state[st][colvant][colv] == state[st][colvant][colv - 1])
									extrac = 1;
								else
									extrac = 0;

								s[colv] = state[st][colvant][colv];

								if (s[colv - 1] == SINGLE_NODE_PATH)
								{
									s[colv - 1] = s[colv];
								}
								else
								{
									j = s[colv - 1];
									s[colv - 1] = ALL_DONE;

									for (i = 0; i < N; i++)
										if (s[i] == j)
										{
											s[i] = s[colv];
											break;
										}
								}

								s[colv] = ALL_DONE;
								adjustState_cycles(s, colv);			

								newst = hmcyc[colv][hash_cycles(s)];

								if (minc[a][st] + extrac < minc[c][newst])
									minc[c][newst] = minc[a][st] + extrac;
							}
						}
					}

			colvant = colv;
		}

		//fprintf(stderr, "row %d done\n", rowv);
	}


	for (i = 0; i < N; i++)
		s[i] = 0;

	vmin = minc[c][hmcyc[N - 1][hash_cycles(s)]];

	if (vmin == INF)
		vmin = -1;

	return vmin;
}

int main()
{
	freopen("clear.in", "r", stdin);
	freopen("clear.out", "w", stdout);

	//freopen("clear.log.txt", "w", stderr);

	fgets(saux, LAUX - 2, stdin);
	sscanf(saux, "%d %d %d", &X, &M, &N);

	// generate all possible (paranthesis-like) states

	nb = 0;
	for (i = 0; i < N; i++)
		s[i] = -1;

	if (X == 1)
	{
		for (i = 0; i < N; i++)
			hmpath[i].clear();

		memset(nstates, 0, sizeof(nstates));
		poz = -1;

		genstates_paths(0);

		/*
		for (poz = 0; poz < N; poz++)
			fprintf(stderr, "nstates[%d]=%d\n", poz, nstates[poz]);
		*/

		printf("%d\n", minpathcover());
	}
	else
	{
		for (i = 0; i < N; i++)
			hmcyc[i].clear();

		memset(nstates, 0, sizeof(nstates));
		poz = -1;

		genstates_cycles(0);

		/*
		for (poz = 0; poz < N; poz++)
			fprintf(stderr, "nstates[%d]=%d\n", poz, nstates[poz]);
		*/

		printf("%d\n", mincyclecover());
	}

	return 0;
}
