#include <stdio.h>
#include <string.h>

#define NMAX 3001
#define PREFIXK2 8
#define PERIODK2 5

int prefixlen[3] = { 0, 8, 12 };
int periodlen[3] = { 1, 5, 0 };

int prefix[3][2][12] = 
{
{ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 } },
{ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, { 4, 4, 6, 6, 4, 4, 6, 4, 0, 0, 0, 0} },
{ { 2, 2, 4, 4, 4, 4, 8, 4, 8, 8, 16, 4}, { 0, 0, -2, -2, 0, -2, -2, -2, 0, -2, -6, 0} }
};

int period[3][12] = 
{
{ 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
{ 4, 12, 4, 4, 10, 0, 0, 0, 0, 0, 0, 0 },
{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

int gru[NMAX], used[NMAX], sump[12];
int i, j, k, N, K, T, t, klim, sprefix, speriod;

int main()
{
	freopen("kboard.in", "r", stdin);
	freopen("kboard.out", "w", stdout);

	scanf("%d %d", &K, &T);

	if (K > 2)
	{
		klim = 3;

		while (69 * klim - 19 < NMAX)
			klim++;

		fprintf(stderr, "klim=%d\n", klim);

		if (K >= klim)
			t = 2;
		else
		{
			for (i = 0; i < K; i++)
				gru[i] = 0;

			for (i = K; i < NMAX; i++)
			{
				memset(used, 0, sizeof(used));

				for (j = 1; j <= i - K + 1; j++)
				{
					k = gru[j - 1] ^ gru[i - (j + K - 1)];
					used[k] = 1;
				}

				for (k = 0; used[k]; k++);
			
				gru[i] = k;
			}
		}
	}
	else
	if (K == 1)
		t = 0;
	else
	if (K == 2)
		t = 1;

	while (T--)
	{
		scanf("%d", &N);

		if (K > 2 && K < klim)
		{
			if (gru[N])
				printf("1\n");
			else
				printf("2\n");
		}
		else
		{
			sprefix = K - 1;

			for (i = 0; i < prefixlen[t]; i++)
			{
				sprefix += prefix[t][0][i] * K + prefix[t][1][i];
				sump[i] = sprefix;
			}

			if (N <= sprefix)
			{
				if (N <= K - 1)
					printf("2\n");
				else
				{
					for (i = 0; i < prefixlen[t]; i++)
						if (N == sump[i])
							break;

					if (i < prefixlen[t])
						printf("2\n");
					else
						printf("1\n");
				}
			}
			else
			{
				N -= sprefix;
				speriod = 0;

				for (i = 0; i < periodlen[t]; i++)
				{
					speriod += period[t][i];
					sump[i] = speriod;
				}

				if (speriod == 0)
					printf("?\n");
				else
				{
					N %= speriod;

					if (N == 0)
						printf("2\n");
					else
					{
						for (i = 0; i < periodlen[t]; i++)
							if (N == sump[i])
								break;

						if (i < periodlen[t])
							printf("2\n");
						else
							printf("1\n");
					}
				}
			}
		}
	}

	return 0;
}
