// O(N^3 * logN)  - usor de optimizat la O(N^3), care este complexitatea optima

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using namespace std;

#define NMAX 340

vector<int> Tmin[NMAX], fiu[NMAX], efmut[NMAX];
vector<pair<int, int> > mut[NMAX], todo[NMAX];
pair<int, int> curmut, cmut, vmint, vmaxt;
int state[NMAX], viz[NMAX];
int i, j, jj, k, N, nviz;

int ok(int n, int t)
{
	int i, ja, jb, m, f, s, mmic;

	// initializeaza vectorul de timpi

	for (i = 0; i < N; i++)
		todo[i].clear();

	for (i = 0; i < fiu[n].size(); i++)
		if (state[fiu[n][i]] >= 0)
			todo[Tmin[fiu[n][i]][state[fiu[n][i]]]].push_back(make_pair(fiu[n][i], state[fiu[n][i]]));

	// verifica daca timpul t este de ajuns pentru ce avem de "rezolvat"

	curmut.first = curmut.second = 0;

	for (m = N - 1; m >= 0; m--)
	{
		if (todo[m].size() == 0)
			continue;

		// alege perechea (fiu, stare) corespunzatoare momentului m care are vectorul timpilor minim lexicografic

		vmint = todo[m][0];
		vmaxt = vmint;

		for (i = 1; i < todo[m].size(); i++)
		{
			mmic = 1;

			f = todo[m][i].first;
			s = todo[m][i].second;

			ja = vmint.second;
			jb = s;

			mmic = 0;

			while (ja < mut[vmint.first].size() && jb < mut[f].size())
			{
				if (Tmin[vmint.first][ja] < Tmin[f][jb])
				{
					mmic = -1;
					break;
				}
				else
				if (Tmin[vmint.first][ja] > Tmin[f][jb])
				{
					mmic = 1;
					break;
				}

			
				ja++;
				jb++;
			}

			if (mmic == 0 && ja < mut[vmint.first].size())
				mmic = 1;

			if (mmic == 1)
				vmint = todo[m][i];

			if (curmut.first == 0)
			{
				ja = vmaxt.second;
				jb = s;

				mmic = 0;

				while (ja < mut[vmaxt.first].size() && jb < mut[f].size())
				{
					if (Tmin[vmaxt.first][ja] < Tmin[f][jb])
					{
						mmic = -1;
						break;
					}
					else
					if (Tmin[vmaxt.first][ja] > Tmin[f][jb])
					{
						mmic = 1;
						break;
					}
			
					ja++;
					jb++;
				}

				if (mmic == 0 && jb < mut[f].size())
					mmic = -1;

				if (mmic == -1)
					vmaxt = todo[m][i];
			}
		}

		if (curmut.first == 0)
		{
			// trateaza elementul maxim la inceput

			f = vmaxt.first;
			s = vmaxt.second;

			if (t > Tmin[f][s])
			{
				t--;

				if (curmut.first == 0)
				{
					curmut.first = f;
					curmut.second = -1;
				}
			}
			else
			if (t == Tmin[f][s] && s < mut[f].size())
			{
				t--;

				if (curmut.first == 0)
				{
					curmut.first = f;
					curmut.second = s;
				}

				s++;

				todo[Tmin[f][s]].push_back(make_pair(f, s));
			}
			else
				return 0;
		}
		else
			vmaxt.first = 0;

		for (i = 0; i < todo[m].size(); i++)
		{
			f = todo[m][i].first;
			s = todo[m][i].second;

			if (f == vmint.first && s == vmint.second)
				continue;

			if (vmaxt.first > 0 && f == vmaxt.first && s == vmaxt.second)
				continue;

			if (t > Tmin[f][s])
			{
				t--;

				if (curmut.first == 0)
				{
					curmut.first = f;
					curmut.second = -1;
				}
			}
			else
			if (t == Tmin[f][s] && s < mut[f].size())
			{
				t--;

				if (curmut.first == 0)
				{
					curmut.first = f;
					curmut.second = s;
				}

				s++;

				todo[Tmin[f][s]].push_back(make_pair(f, s));
			}
			else
				return 0;
		}

		// trateaza la sfarsit elementul minim de la momentul m

		f = vmint.first;
		s = vmint.second;

		if (vmaxt.first > 0 && f == vmaxt.first && s == vmaxt.second)
			continue;

		if (t > Tmin[f][s])
		{
			t--;

			if (curmut.first == 0)
			{
				curmut.first = f;
				curmut.second = -1;
			}
		}
		else
		if (t == Tmin[f][s] && s < mut[f].size())
		{
			t--;

			if (curmut.first == 0)
			{
				curmut.first = f;
				curmut.second = s;
			}

			s++;

			todo[Tmin[f][s]].push_back(make_pair(f, s));
		}
		else
			return 0;
	}

	return 1;
}

void df(int n)
{
	int i, x, tmin, tmax, tmid, tok;

	for (i = 0; i < fiu[n].size(); i++)
	{
		x = fiu[n][i];
		df(x);
	}

	if (fiu[n].size() == 0) // frunza
	{
		Tmin[n].clear();
		Tmin[n].push_back(0);
		mut[n].clear();

		fprintf(stderr, "*** nod %d\n0 sons\n0 moves\n", n);
		fprintf(stderr, "* move 0\ntime before next moves: 0\n");

		return;
	}

	while (1)
	{
		// tine cont de mutarile efectuate anterior in cadrul strategiei optime

		for (i = 0; i < fiu[n].size(); i++)
			state[fiu[n][i]] = 0;

		for (i = 0; i < mut[n].size(); i++)
			if (mut[n][i].second < 0)
				state[mut[n][i].first] = -1;
			else
				state[mut[n][i].first] = mut[n][i].second + 1;

		for (i = 0; i < fiu[n].size(); i++)
			if (state[fiu[n][i]] >= 0)
				break;

		if (i >= fiu[n].size())
		{
			Tmin[n].push_back(0);
			break;
		}

		// initializeaza tmin si tmax

		tmin = 0;

		for (i = 0; i < fiu[n].size(); i++)
			if (state[fiu[n][i]] >= 0 && Tmin[fiu[n][i]][state[fiu[n][i]]] > tmin)
				tmin = Tmin[fiu[n][i]][state[fiu[n][i]]];

		tmax = N - 1;

		cmut.first = cmut.second = 0;

		while (tmin <= tmax)
		{
			tmid = (tmin + tmax) / 2;

			if (ok(n, tmid))
			{
				tok = tmid;		
				tmax = tmid - 1;
				cmut.first = curmut.first;
				cmut.second = curmut.second;
			}
			else
				tmin = tmid + 1;
		}

		Tmin[n].push_back(tok);
		mut[n].push_back(cmut);
	}

	efmut[n].clear();

	for (i = 0; i < mut[n].size(); i++)
		if (mut[n][i].second < 0)
			efmut[n].push_back(mut[n][i].first);
		else
			efmut[n].push_back(efmut[mut[n][i].first][mut[n][i].second]);

	// print information

	fprintf(stderr, "*** nod %d\n", n);
	fprintf(stderr, "%d sons:", fiu[n].size());

	for (i = 0; i < fiu[n].size(); i++)
		fprintf(stderr, " %d", fiu[n][i]);
	fprintf(stderr, "\n");

	fprintf(stderr, "%d moves\n", mut[n].size());

	for (i = 0; i < mut[n].size(); i++)
	{
		fprintf(stderr, "* move %d\n", i);
		fprintf(stderr, "time before next moves: %d\n", Tmin[n][i]);
		fprintf(stderr, "son=%d, state=%d\n", mut[n][i].first, mut[n][i].second);
		fprintf(stderr, "node=%d\n", efmut[n][i]);
	}

	fprintf(stderr, "* move %d\ntime before next moves: %d\n", mut[n].size(), Tmin[n][mut[n].size()]);
}

int main()
{
	freopen("optic.in", "r", stdin);

	freopen("log.txt", "w", stderr);

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
		fiu[i].clear();

	for (k = 1; k < N; k++)
	{
		scanf("%d %d", &i, &j);
		fiu[i].push_back(j);
	}

	df(1);

	freopen("optic.out", "w", stdout);

	printf("%d\n", Tmin[1][0]);
	//fprintf(stderr, "%d\n", Tmin[1][0]);

	// afisaza strategia

	memset(state, 0, sizeof(state));
	memset(viz, 0, sizeof(viz));

	viz[1] = nviz = 1;

	while (nviz < N)
	{
		mut[0].clear();

		for (i = 1; i <= N; i++)
			if (viz[i] && state[i] < efmut[i].size())
			{
				mut[0].push_back(make_pair(i, efmut[i][state[i]]));

				j = i; k = state[i];

				while (mut[j][k].second >= 0)
				{
					state[j]++;
					jj = mut[j][k].first;
					k = mut[j][k].second;
					j = jj;
				}

				state[j]++;
			}

		printf("%d\n", mut[0].size());

		for (i = 0; i < mut[0].size(); i++)
		{
			printf("%d %d\n", mut[0][i].first, mut[0][i].second);

			if (!viz[mut[0][i].second])
			{
				viz[mut[0][i].second] = 1;
				nviz++;
			}
			else
				fprintf(stderr, "??? %d -> %d\n", mut[0][i].first, mut[0][i].second);
		}
	}

	return 0;
}
