/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define lmaxc 2100
#define maxc 511
#define LIMIT 505
#define baza 10000
#define MAXVAL 100000000
#define powbaza 4
#define writestring "%04d"
#define fwd 2

typedef int BigNum[maxc];

int compare(BigNum, BigNum);
void add(BigNum, BigNum, BigNum);
void sub(BigNum, BigNum, BigNum);
void multbig(BigNum, BigNum, BigNum);
void divx(int, BigNum, BigNum, int*);
void div2(BigNum, BigNum, int*);

BigNum naux1, naux2, N, NN, li, ls, mid, x, unu;
char s[lmaxc];
int bit[10] = { 1, 2, 4, 8, 16, 32, 64, 128, 256, 512 };

int main()
{
int i, j, l, re, T, r, P, lastc, nsteps, maxbit;

freopen("puteri2.in", "r", stdin);
freopen("puteri2.out", "w", stdout);

scanf("%d", &T);

memset(unu, 0, sizeof(unu));
unu[0] = unu[1] = 1;

while (T--)
  { 
    memset(N, 0, sizeof(N));
    scanf("%s %d", s, &P);

	/*
	if (P != 111)
		continue;
	*/

	for (maxbit = 9; maxbit >= 0; maxbit--)
		if (P & bit[maxbit])
			break;
	
	l = strlen(s);
	
	for (i = l - 1; i >= 0; i -= powbaza)
	{
		r = 0;

		for (j = i - powbaza + 1; j <= i; j++)
			if (j >= 0)
				r = (r * 10) + (int) (s[j] - '0');

        N[0]++;
		N[N[0]] = r;
	}

	fprintf(stderr, "%d: started (P=%d)\n", T + 1, P);

    memset(li, 0, sizeof(li));
    li[0] = (N[0] / P);

	if (li[0] < 1)
		li[0] = 1;

	//li[0] = 1;

	li[li[0]] = 1;

    memset(ls, 0, sizeof(ls));
    ls[0] = (N[0] / P) + 2;
    ls[ls[0]] = 1;

    lastc = -1;
	nsteps = 0;
    while (compare(li, ls) <= 0)
      {
        add(li, ls, naux1);
        //divx(2, naux1, mid, &r);
        div2(naux1, mid, &r);

		memset(NN, 0, sizeof(NN));
        NN[0] = NN[1] = 1;

		// exponential multiplication

/*
        for (j = -1, i = 1; i <= P && NN[0] <= N[0]; i++)
          {
            multbig(mid, NN, naux1);
            memmove(NN, naux1, sizeof(BigNum));
          }
*/

		if (nsteps == 8)
			nsteps++;

		multbig(mid, NN, naux1);
		memmove(NN, naux1, sizeof(BigNum));

		for (i = P + 1, j = maxbit - 1; j >= 0 && NN[0] <= N[0]; j--)
		{
			if (2 * NN[0] >= LIMIT)
				break;

            multbig(NN, NN, naux1);
	        memmove(NN, naux1, sizeof(BigNum));

			if (P & bit[j])
			{
				if (NN[0] + mid[0] >= LIMIT)
					break;

				multbig(mid, NN, naux1);
		        memmove(NN, naux1, sizeof(BigNum));
			}
		}

        if (/*i > P*/ j < 0 && (r = compare(NN, N)) <= 0)
          {
            lastc = r;
            memmove(x, mid, sizeof(BigNum));
            add(mid, unu, li);
          }
        else
          {
            sub(mid, unu, ls);
          }

		  
		  nsteps++;
		  if (nsteps % 1000 == 0)
			  fprintf(stderr, "%d: %d\n", T + 1, nsteps);
		  
	}

    printf("%d", x[x[0]]);
    for (i = x[0] - 1; i > 0; i--)
      printf(writestring, x[i]);
    printf("\n");

    if (lastc != 0)
      fprintf(stderr, "eroare\n");

	fprintf(stderr, "%d: done\n", T + 1);
  }

return 0;
}

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
int compare(BigNum n1, BigNum n2)
{
int i, res;

if (n1[0] > n2[0]) return 1;
if (n1[0] < n2[0]) return -1;

for (res = 0, i = n1[0]; i >= 1; i--)
  if (n1[i] > n2[i])
    {
      res=1;
      break;
    }
  else
  if (n1[i] < n2[i])
    {
      res=-1;
      break;
    }

return res;
}

void add(BigNum n1, BigNum n2, BigNum rez)
{
int i, ndigits = n1[0];

if (n2[0] > ndigits)
  ndigits = n2[0];

memset(rez, 0, (ndigits + fwd + 1) * sizeof(int));
for (i = 1; i <= ndigits; i++)
  rez[i] = n1[i]+n2[i];

for (i = 1 ;i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }

if (!rez[0])
  rez[0] = 1;
}

void sub(BigNum n1, BigNum n2, BigNum res)
{
int i, ndigits = n1[0];

memset(res, 0, (ndigits + 1) * sizeof(int));
for (i = 1; i <= ndigits; i++)
  res[i] = n1[i] - n2[i];

for (i = 1; i <= ndigits; i++)
  while (res[i] < 0)
    {
      res[i] += baza;
      res[i+1]--;
    }

for (res[0] = 1, i = ndigits; i >= 1; i--)
  if (res[i])
    {
      res[0] = i;
      break;
    }

if (!res[0])
  res[0] = 1;
}

void multbig(BigNum n1, BigNum n2, BigNum rez)
{
int i, j, ndigits = n1[0]+n2[0]-1;

memset(rez, 0, (ndigits + fwd + 1) * sizeof(int));
for (i = 1; i <= n1[0]; i++)
  for (j = 1; j <= n2[0]; j++)
  {
    rez[i+j-1] += (n1[i]*n2[j]);

	if (rez[i + j - 1] >= MAXVAL)
	{
		rez[i + j] += (rez[i + j - 1] / baza);
		rez[i + j - 1] %= baza;
	}
  }

for (i = 1; i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }

if (!rez[0])
  rez[0] = 1;
}

void divx(int x, BigNum n, BigNum cat, int* rest)
{
int i, j, ndigits = 0, v;

memset(cat, 0, (n[0] + fwd) * sizeof(int));
v = 0, i = n[0];
while (v < x && i)
  {
    v = v*baza+n[i];
    i--;
  }

ndigits = 1, cat[1] = v/x, v=v%x;

for (; i; i--)
  {
    v = v*baza+n[i];
    cat[++ndigits] = v/x;
    v %= x;
  }
*rest = v;

for (v = ndigits>>1, i = 1; i <= v; i++)
  {
    j = cat[i];
    cat[i] = cat[ndigits-i+1];
    cat[ndigits-i+1]=j;
  }

cat[0] = ndigits;
}

void div2(BigNum n, BigNum cat, int* rest)
{
int i, j, ndigits = 0, v;

memset(cat, 0, (n[0] + fwd) * sizeof(int));
v = 0, i = n[0];
while (v < 2 && i)
  {
    v = v*baza+n[i];
    i--;
  }

ndigits = 1, cat[1] = v >> 1, v = v & 1;

for (; i; i--)
  {
    v = v*baza+n[i];
    cat[++ndigits] = v >> 1;
    v &= 1;
  }
*rest = v;

for (v = ndigits>>1, i = 1; i <= v; i++)
  {
    j = cat[i];
    cat[i] = cat[ndigits-i+1];
    cat[ndigits-i+1]=j;
  }

cat[0] = ndigits;
}
