import java.io.*;
import java.util.*;

public class chain_md implements Runnable {
	class Trie {
		final int MAX = 250000;
		int[][] go = new int[MAX + 1][26];
		int[] id = new int[MAX + 1];
		int[] tin = new int[MAX + 1];
		int[] tout = new int[MAX + 1];
		int trie = 1;
		int[] id2pos = new int[MAX];
		int time = 0;
		
		public void add(String s, int num) {
			int cur = 0;
			for (int i = 0; i < s.length(); i++) {
				int c = s.charAt(i) - 'a';
				if (go[cur][c] == 0) {
					go[cur][c] = trie++;
				}
				cur = go[cur][c];
			}
			id[cur] = num;
			id2pos[num] = cur;
		}
		
		public void traverse() {
			dfs(0);
		}

		private void dfs(int i) {
			tin[i] = time++;
			for (int c = 0; c < 26; c++) {
				if (go[i][c] > 0)
					dfs(go[i][c]);
			}
			tout[i] = time++;
		}
		
		public boolean isPrefix(int id1, int id2) {
			int a = id2pos[id1];
			int b = id2pos[id2];
			return tin[a] < tin[b] && tout[b] < tout[a];
		}
	}
	
	private BufferedReader in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("chain.in"));
		out = new PrintWriter("chain.out");
		int n = Integer.parseInt(in.readLine());
		String[] s = new String[n];
		Trie t = new Trie();
		for (int i = 0; i < n; i++) {
			s[i] = in.readLine();
			t.add(s[i], i);
		}
		t.traverse();
		int m = Integer.parseInt(in.readLine());
		int[] a = new int[m];
		StringTokenizer st = new StringTokenizer(in.readLine());
		int lcur = 0;
		int lbest = 0;
		int rbest = 0;
		for (int i = 0; i < m; i++) {
			a[i] = Integer.parseInt(st.nextToken()) - 1;
			if (i > 0) {
				boolean isPref = t.isPrefix(a[i - 1], a[i]);
				if (isPref)
					continue;
				if (i - 1 - lcur > rbest - lbest) {
					lbest = lcur;
					rbest = i - 1;
				}
				lcur = i;
			}
		}
		if (m - 1 - lcur > rbest - lbest) {
			lbest = lcur;
			rbest = m - 1;
		}
		out.println((lbest + 1) + " " + (rbest + 1));
		in.close();
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new chain_md()).start();
	}

}
