import java.util.Scanner;
import java.io.PrintWriter;
import java.io.File;
import java.math.BigInteger;

/**
 * @author Vitaly Goldshtein
 */

public class kitchen_vg {

    Scanner in;
    PrintWriter out;
    int a, b, n;
    int[] w;
    BigInteger[][] res, nres;
    BigInteger[] fac;

    void initRes(BigInteger[][] res) {
        for (int i = 0; i <= a; ++i) {
            for (int t = 0; t <= n; ++t) {
                res[i][t] = BigInteger.ZERO;
            }
        }
    }

    void putRes() {
        for (int i = 0; i <= a; ++i) {
            for (int t = 0; t <= n; ++t) {
                res[i][t] = nres[i][t];
            }
        }
    }

    void init() {
        fac = new BigInteger[n + 1];
        fac[0] = BigInteger.ONE;
        for(int i = 1; i <= n; ++i) {
            fac[i] = fac[i - 1].multiply(BigInteger.valueOf(i));
        }
        res = new BigInteger[a + 1][n + 1];
        nres = new BigInteger[a + 1][n + 1];
        initRes(res);
        initRes(nres);
        res[0][0] = BigInteger.ONE;
    }

    void solve() {
        init();
        int sum = 0;
        for(int i = 0; i < n; ++i) {
            initRes(nres);
            for(int la = 0; la <= Math.min(a, sum); ++la) {
                int lb = sum - la;
                for(int k = 0; k <= i; ++k) {
                    if (la + w[i] <= a) {
                        nres[la + w[i]][k + 1] =
                                nres[la + w[i]][k + 1].add(res[la][k]);
                    }
                    if (lb + w[i] <= b) {
                        nres[la][k] =
                                nres[la][k].add(res[la][k]);
                    }
                }
            }
            sum += w[i];
            putRes();
        }
        BigInteger ans = BigInteger.ZERO;
        for(int la = 0; la <= a; ++la) {
            for(int k = 0; k <= n; ++k) {
                ans = ans.add(res[la][k].multiply(fac[k]).multiply(fac[n - k]));
            }
        }
        out.println(ans.toString());
    }

    void run() throws Exception {
        in = new Scanner(new File("kitchen.in"));
        out = new PrintWriter(new File("kitchen.out"));
        a = in.nextInt();
        b = in.nextInt();
        n = in.nextInt();
        w = new int[n];
        for(int i = 0; i < n; ++i) {
            w[i] = in.nextInt();
        }
        solve();
        out.close();
    }

    public static void main(String[] args) throws Exception {
        kitchen_vg inv = new kitchen_vg();
        inv.run();
    }
}
