import java.util.Scanner;
import java.io.PrintWriter;
import java.io.File;
import java.math.BigInteger;

/**
 * @author Vitaly Goldshtein
 */

public class kitchen_vg_tl {

    Scanner in;
    PrintWriter out;
    int a, b, n;
    int[] w;
    BigInteger[][][] res, nres;
    BigInteger[] fac;

    void initRes(BigInteger[][][] res) {
        for (int i = 0; i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                for (int t = 0; t <= n; ++t) {
                    res[i][j][t] = BigInteger.ZERO;
                }
            }
        }
    }

    void putRes() {
        for (int i = 0; i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                for (int t = 0; t <= n; ++t) {
                    res[i][j][t] = nres[i][j][t];
                }
            }
        }
    }

    void init() {
        fac = new BigInteger[n + 1];
        fac[0] = BigInteger.ONE;
        for(int i = 1; i <= n; ++i) {
            fac[i] = fac[i - 1].multiply(BigInteger.valueOf(i));
        }
        res = new BigInteger[a + 1][b + 1][n + 1];
        nres = new BigInteger[a + 1][b + 1][n + 1];
        initRes(res);
        initRes(nres);
        res[0][0][0] = BigInteger.ONE;
    }

    void solve() {
        init();
        for(int i = 0; i < n; ++i) {
            if (i % 99 == 0) System.gc();
            initRes(nres);
            for(int la = 0; la <= a; ++la) {
                for(int lb = 0; lb <= b; ++lb) {
                    for(int k = 0; k <= i; ++k) {
                        if (la + w[i] <= a) {
                            nres[la + w[i]][lb][k + 1] =
                                    nres[la + w[i]][lb][k + 1].add(res[la][lb][k]);
                        }
                        if (lb + w[i] <= b) {
                            nres[la][lb + w[i]][k] =
                                    nres[la][lb + w[i]][k].add(res[la][lb][k]);
                        }
                    }
                }
            }
            putRes();
        }
        BigInteger ans = BigInteger.ZERO;
        for(int la = 0; la <= a; ++la) {
            for(int lb = 0; lb <= b; ++lb) {
                for(int k = 0; k <= n; ++k) if (!res[la][lb][k].equals(BigInteger.ZERO)) {
                    //System.out.println(la + " " + lb + " " + k + " " + res[la][lb][k].toString());
                    ans = ans.add(res[la][lb][k].multiply(fac[k]).multiply(fac[n - k]));
                }
            }
        }
        out.println(ans.toString());
    }

    void run() throws Exception {
        in = new Scanner(new File("kitchen.in"));
        out = new PrintWriter(new File("kitchen.out"));
        a = in.nextInt();
        b = in.nextInt();
        n = in.nextInt();
        w = new int[n];
        for(int i = 0; i < n; ++i) {
            w[i] = in.nextInt();
        }
        solve();
        out.close();
    }

    public static void main(String[] args) throws Exception {
        kitchen_vg_tl inv = new kitchen_vg_tl();
        inv.run();
    }
}
