import java.util.Scanner;
import java.io.PrintWriter;
import java.io.File;

/**
 * @author Vitaly Goldshtein
 */

public class kitchen_vg_tl_int64 {

    Scanner in;
    PrintWriter out;
    int a, b, n;
    int[] w;
    long[][][] res, nres;
    long[] fac;

    void initRes(long[][][] res) {
        for (int i = 0; i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                for (int t = 0; t <= n; ++t) {
                    res[i][j][t] = 0;
                }
            }
        }
    }

    void putRes() {
        for (int i = 0; i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                for (int t = 0; t <= n; ++t) {
                    res[i][j][t] = nres[i][j][t];
                }
            }
        }
    }

    void init() {
        fac = new long[n + 1];
        fac[0] = 1;
        for(int i = 1; i <= n; ++i) {
            fac[i] = fac[i - 1] * i;
        }
        res = new long[a + 1][b + 1][n + 1];
        nres = new long[a + 1][b + 1][n + 1];
        initRes(res);
        initRes(nres);
        res[0][0][0] = 1;
    }

    void solve() {
        init();
        for(int i = 0; i < n; ++i) {
            if (i % 99 == 0) System.gc();
            initRes(nres);
            for(int la = 0; la <= a; ++la) {
                for(int lb = 0; lb <= b; ++lb) {
                    for(int k = 0; k <= i; ++k) {
                        if (la + w[i] <= a) {
                            nres[la + w[i]][lb][k + 1] += res[la][lb][k];
                        }
                        if (lb + w[i] <= b) {
                            nres[la][lb + w[i]][k] += res[la][lb][k];
                        }
                    }
                }
            }
            putRes();
        }
        long ans = 0;
        for(int la = 0; la <= a; ++la) {
            for(int lb = 0; lb <= b; ++lb) {
                for(int k = 0; k <= n; ++k) {
                    ans += res[la][lb][k] * fac[k] * fac[n - k];
                }
            }
        }
        out.println(ans);
    }

    void run() throws Exception {
        in = new Scanner(new File("kitchen.in"));
        out = new PrintWriter(new File("kitchen.out"));
        a = in.nextInt();
        b = in.nextInt();
        n = in.nextInt();
        w = new int[n];
        for(int i = 0; i < n; ++i) {
            w[i] = in.nextInt();
        }
        solve();
        out.close();
    }

    public static void main(String[] args) throws Exception {
        kitchen_vg_tl_int64 inv = new kitchen_vg_tl_int64();
        inv.run();
    }
}
