import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Locale;
import java.util.StringTokenizer;

public class kitchen_vi implements Runnable {

	private PrintWriter out;
	private BufferedReader in;
	private StringTokenizer st;
	
	private void solve() throws Exception {
		int a = nextInt();
		int b = nextInt();
		int n = nextInt();
		BigInteger[][] d = new BigInteger[n + 1][a + 1];
		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j <= a; ++j) {
				d[i][j] = BigInteger.ZERO;
			}
		}
		
		int sum = 0;
		d[0][0] = BigInteger.ONE;
		for (int i = 2; i <= n; ++i) {
			d[0][0] = d[0][0].multiply(BigInteger.valueOf(i));
		}
		for (int i = 0; i < n; ++i) {
			int x = nextInt();
			sum += x;
			for (int j = n - 1; j >= 0; --j) {
				for (int k = 0; k + x <= a; ++k) {
					d[j + 1][k + x] = d[j + 1][k + x].add(d[j][k].multiply(BigInteger.valueOf(j + 1)).divide(BigInteger.valueOf(n - j)));
				}
			}
		}
		BigInteger ans = BigInteger.ZERO;
		for (int i = 0; i <= n; ++i) {
			for (int j = Math.max(sum - b, 0); j <= a; ++j) {
				ans = ans.add(d[i][j]);
			}
		}
		out.println(ans);
	}
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-15);
		} finally {
			out.close();
		}
	}

	kitchen_vi() {
		Locale.setDefault(Locale.US);
		try {
			in = new BufferedReader(new FileReader(new File("kitchen.in")));
			st = new StringTokenizer("");
			out = new PrintWriter(new File("kitchen.out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(02);
		}
	}
	
	public static void main(String[] args) {
		(new Thread(new kitchen_vi())).start();
	}

}
