#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "mahjong.in"
#define C_OUT_FILE "mahjong.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int NMAX = 302;
int n, m;
int a[NMAX][NMAX];
typedef int tarint[NMAX];
int pans;
tarint l, r, u, d;
int c1[NMAX * NMAX], c2[NMAX * NMAX], ans[NMAX * NMAX];

int kq = 0, q[NMAX * NMAX];

void outdata() {
	printf("%d\n", pans);
	forn(i, pans) {
		if (i > 0) printf(" ");
		printf("%d", ans[i]);
	}
	printf("\n");
}

void solve() {
	forn(i, n) {
		l[i] = 0;
		r[i] = m - 1;
	}
	forn(i, m) {
		u[i] = 0;
		d[i] = n - 1;
	}
	pans = 0;
	bool ok = true;
   	memset(c1, 255, sizeof c1);
   	memset(c2, 255, sizeof c2);
	while (ok) {
		ok = false;
		//left right
		kq = 0;
		forn(i, n) {
			while (l[i] <= r[i] && a[i][l[i]] == -1) ++l[i];
			while (l[i] <= r[i] && a[i][r[i]] == -1) --r[i];
			if (l[i] <= r[i]) {
				int c = a[i][l[i]];
				assert(c != -1);
				if (c1[c] != -1) {
					a[i][l[i]] = -1;
					a[c1[c]][l[c1[c]]] = -1;
					ans[pans++] = c;
					ok = true;
				} else {
					c1[c] = i;
					q[kq++] = c;
				}
			}			
			while (l[i] <= r[i] && a[i][l[i]] == -1) ++l[i];
			while (l[i] <= r[i] && a[i][r[i]] == -1) --r[i];
			if (l[i] <= r[i]) {
				int c = a[i][r[i]];
				assert(c != -1);
				if (c2[c] != -1) {
					a[i][r[i]] = -1;
					a[c2[c]][r[c2[c]]] = -1;
					ans[pans++] = c;
					ok = true;
				} else {
					c2[c] = i;
					q[kq++] = c;
				}
			}
		}
		forn(i, kq) c1[q[i]] = c2[q[i]] = -1;
		//up down
		kq = 0;
		forn(i, m) {
			while (u[i] <= d[i] && a[u[i]][i] == -1) ++u[i];
			while (u[i] <= d[i] && a[d[i]][i] == -1) --d[i];
			if (u[i] <= d[i]) {
				int c = a[u[i]][i];
				assert(c != -1);
				if (c1[c] != -1) {
					a[u[i]][i] = -1;
					a[u[c1[c]]][c1[c]] = -1;
					ans[pans++] = c;
					ok = true;
				} else {
					c1[c] = i;
					q[kq++] = c;
				}

			}			
			while (u[i] <= d[i] && a[u[i]][i] == -1) ++u[i];
			while (u[i] <= d[i] && a[d[i]][i] == -1) --d[i];
			if (u[i] <= d[i]) {
				int c = a[d[i]][i];
				assert(c != -1);
				if (c2[c] != -1) {
					a[d[i]][i] = -1;
					a[d[c2[c]]][c2[c]] = -1;
					ans[pans++] = c;
					ok = true;
				} else {
					c2[c] = i;
					q[kq++] = c;
				}
			}			
		}
		forn(i, kq) c1[q[i]] = c2[q[i]] = -1;
	}

}

int ex[NMAX * NMAX];

void readdata() {
	memset(a, 255, sizeof a);
	scanf("%d%d", &n, &m);
	assert(1 <= n && n <= 300);
	assert(1 <= m && m <= 300);
	assert(n * m % 2 == 0);
	memset(ex, 0, sizeof ex);
	forn(i, n) forn(j, m) {
		scanf("%d", &a[i][j]);
		assert(1 <= a[i][j] && a[i][j] <= (n * m) / 2);
		++ex[a[i][j]];
	}
	forn(i, n * m / 2) assert(ex[i + 1] == 2);
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
