#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "mahjong.in"
#define C_OUT_FILE "mahjong.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int NMAX = 1000;
int n, m;
int a[NMAX][NMAX];
typedef int tarint[NMAX];
int pans;
tarint l, r, u, d, ans, c1, c2;

void outdata() {
	printf("%d\n", pans);
	forn(i, pans) {
		if (i > 0) printf(" ");
		printf("%d", ans[i]);
	}
	printf("\n");
}

void solve() {
	forn(i, n) {
		l[i] = 0;
		r[i] = m - 1;
	}
	forn(i, m) {
		u[i] = 0;
		d[i] = n - 1;
	}
	pans = 0;
	bool ok = true;
	while (ok) {
		ok = false;
		//left right
		memset(c1, 255, sizeof c1);
		memset(c2, 255, sizeof c2);
		forn(i, n) {
			if (l[i] <= r[i]) {
				int c = a[i][l[i]];
				if (c1[c] != -1) {
					++l[c1[c]];
					++l[i];
					ans[pans++] = c;
				} else c1[c] = i;
			}			
			if (l[i] <= r[i]) {
				int c = a[i][r[i]];
				if (c2[c] != -1) {
					++r[c2[c]];
					++r[i];
					ans[pans++] = c;
				} else c2[c] = i;
			}
		}
		//up down
		memset(c1, 255, sizeof c1);
		memset(c2, 255, sizeof c2);
		forn(i, m) {
			if (u[i] <= d[i]) {
				int c = a[u[i]][i];
				if (c1[c] != -1) {
					++u[c1[c]];
					++u[i];
					ans[pans++] = c;
				} else c1[c] = i;
			}			
			if (u[i] <= d[i]) {
				int c = a[d[i]][i];
				if (c2[c] != -1) {
					++d[c2[c]];
					++d[i];
					ans[pans++] = c;
				} else c2[c] = i;
			}			
		}
	}

}

void readdata() {
	scanf("%d%d", &n, &m);
	forn(i, n) forn(j, m) {
		scanf("%d", &a[i][j]);
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

