{$o-,q+,r+}
uses
    math;
const
    max_n = 100000;
    eps = 1e-5;
var
    n, l: longint;
    x, y: array [0..max_n + 3] of longint;
    ax, ay, bx, by: longint;
    a, b: longint;
    d, vd, vx, s: array [1..max_n + 3] of double;
    lb: double;

function add(ax, ay: longint): longint;
var
    i, j: longint;
begin
    i := 1;
    while (x[i] < ax) do inc(i);
    if (x[i] > ax) then begin
        inc(n);
        for j := n downto i + 1 do begin
            x[j] := x[j - 1];
            y[j] := y[j - 1];
        end;
        x[i] := ax;
        y[i] := ay;
    end;
    add := i;
end;

function between(a, x, b: double): boolean;
begin
    between := (a <= x + eps) and (x - eps <= b);
end;

var
    i, j: longint;
    h: array [0..max_n + 2] of longint;
    ch: longint;
    xi, xj: double;
    min, minx1, minx2, miny: double;

procedure update(q: double);
var
    z: double;
begin
    if (q >= lb - eps) and between(y[j + 1], q, y[j]) and between(y[i - 1], q, y[i]) then begin
        xi := x[i] + s[i - 1] * (q - y[i]);
        xj := x[j] + s[j    ] * (q - y[j]);
        if (xi - xj) <= l + eps then begin
            z := abs(d[a] - (d[j] + hypot(xj - x[j], q - y[j]))) + abs(d[b] - (d[i] - hypot(xi - x[i], q - y[i]))) + (xi - xj);
            if min > z then begin
                min := z;
                minx1 := xj;
                minx2 := xi;
                miny := q;
            end;
        end;
    end;
end;

var
    k, m, c: longint;

procedure updateB(vl, vr: longint);
begin
    if min > abs(d[a] - vd[vl]) + abs(d[b] - vd[vr]) + (vx[vr] - vx[vl]) then begin
        min := abs(d[a] - vd[vl]) + abs(d[b] - vd[vr]) + (vx[vr] - vx[vl]);
        minx1 := vx[vl];
        minx2 := vx[vr];
        miny := y[h[ch]];
    end;
end;

procedure train(vl: longint);
var
    vr: longint;
begin
    vr := vl;
    while (vl < c) do begin
        while (vr <= c) and (vx[vr] - vx[vl] <= l + eps) do begin
            updateB(vl, vr);
            inc(vr);
        end;
        inc(vl);
    end;
end;

procedure trainBack(vr: longint);
var
    vl: longint;
begin
    vl := vr;
    while (vr > 1) do begin
        while (vl >= 1) and (vx[vr] - vx[vl] <= l + eps) do begin
            updateB(vl, vr);
            dec(vl);
        end;
        dec(vr);
    end;
end;

begin
    reset(input, 'bridge.in');
    rewrite(output, 'bridge.out');

    read(n, l);
    read(ax, ay, bx, by);
    for i := 1 to n do begin
        read(x[i], y[i]);
    end;
    if (ax < bx) then begin
        a := add(ax, ay);
        b := add(bx, by);
    end else begin
        a := add(bx, by);
        b := add(ax, ay);
    end;

    d[1] := 0;
    for i := 2 to n do begin
        d[i] := d[i - 1] + math.hypot(x[i] - x[i - 1], y[i] - y[i - 1]);
    end;

    for j := 1 to n - 1 do begin
        if y[j] <> y[j + 1] then begin  
            s[j] := (x[j + 1] - x[j]) / (y[j + 1] - y[j]);
        end else begin
            s[j] := 0;
        end;
    end;

    y[0] := maxlongint;
    x[n + 1] := x[n];
    y[n + 1] := 1000001;

    min := abs(d[a] - d[b]);
    h[0] := 0;
    ch := 0;
    for i := 1 to n do begin
        lb := -1e6 - 1;
        while true do begin
            j := h[ch];
            if (j > 0) then begin
                update(y[j]);
                update(y[i]);
                update(lb);
                if (y[i - 1] <> y[i]) and (y[j + 1] <> y[j]) and (s[i - 1] <> s[j]) then begin
                    update((l + (y[i] * s[i - 1] - x[i]) - (y[j] * s[j] - x[j])) / (s[i - 1] - s[j]));
                end;
            end;
            if y[h[ch]] >= y[i] then break;
            lb := y[h[ch]];
            dec(ch);
        end;
        inc(ch);
        h[ch] := i;
    end;

    ch := 0;
    for i := 1 to n + 1 do begin
        while y[h[ch]] < y[i] do begin
            k := ch;
            while (k > 0) and (y[h[k]] = y[h[ch]]) do dec(k);

            if ch - k >= 2 then begin
                c := 0;
                if k <> 0 then begin
                    j := h[k];
                    xj := x[j] + s[j] * (y[h[ch]] - y[j]);

                    inc(c);
                    vd[c] := d[j] + hypot(xj - x[j], y[h[ch]] - y[j]);
                    vx[c] := xj;
                end;
                for m := k + 1 to ch do begin
                    inc(c);
                    vd[c] := d[h[m]];
                    vx[c] := x[h[m]];
                end;

                if (i <= n) then begin
                    xi := x[i] + s[i - 1] * (y[h[ch]] - y[i]);
                    inc(c);
                    vd[c] := d[i] - hypot(xi - x[i], y[h[ch]] - y[i]);
                    vx[c] := xi;
                end;

                train(1);
                for m := 2 to c - 1 do begin
                    if (vx[m] <= x[a]) and (x[a] <= vx[m + 1]) or (vx[m - 1] <= x[a]) and (x[a] <= vx[m]) then begin
                        train(m);
                    end;
                    if (vx[m] <= x[b]) and (x[b] <= vx[m + 1]) or (vx[m - 1] <= x[b]) and (x[b] <= vx[m]) then begin
                        trainBack(m);
                    end;
                end;
            end;

            ch := k;
        end;
        assert(y[h[ch]] >= y[i]);
        inc(ch);
        h[ch] := i;
    end;

    writeln(minx1:0:10, ' ', miny:0:10, ' ', minx2:0:10, ' ', miny:0:10);

    close(input);
    close(output);
end.
