uses
    math;
const
    max_n = 100000;
    eps = 1e-5;
var
    n, l: longint;
    x, y: array [0..max_n + 2] of longint;
    ax, ay, bx, by: longint;
    a, b: longint;
    d: array [1..max_n + 2] of double;

function add(ax, ay: longint): longint;
var
    i, j: longint;
begin
    i := 1;
    while (x[i] < ax) do inc(i);
    if (x[i] > ax) then begin
        inc(n);
        for j := n downto i + 1 do begin
            x[j] := x[j - 1];
            y[j] := y[j - 1];
        end;
        x[i] := ax;
        y[i] := ay;
    end;
    add := i;
end;

function between(a, x, b: double): boolean;
begin
    between := (a <= x + eps) and (x - eps <= b);
end;

var
    i, j: longint;
    h: array [0..max_n + 2] of longint;
    ch: longint;
    si, sj: double;
    xi, xj: double;
    min, minx1, minx2, miny: double;
    q, lb: double;
    k: longint;

procedure update(q: double);
begin
    if (q >= lb - eps) and between(y[j + 1], q, y[j]) and between(y[i - 1], q, y[i]) then begin
        xi := x[i] + si * (q - y[i]);
        xj := x[j] + sj * (q - y[j]);
        if (xi - xj) <= l + eps then begin
            if min > abs(d[a] - (d[j] + hypot(xj - x[j], q - y[j]))) + abs(d[b] - (d[i] - hypot(xi - x[i], q - y[i]))) + (xi - xj) then begin
                min := abs(d[a] - (d[j] + hypot(xj - x[j], q - y[j]))) + abs(d[b] - (d[i] - hypot(xi - x[i], q - y[i]))) + (xi - xj);
                minx1 := xj;
                minx2 := xi;
                miny := q;
            end;
        end;
    end;
end;

begin
    reset(input, 'bridge.in');
    rewrite(output, 'bridge.out');

    read(n, l);
    read(ax, ay, bx, by);
    for i := 1 to n do begin
        read(x[i], y[i]);
    end;
    if (ax < bx) then begin
        a := add(ax, ay);
        b := add(bx, by);
    end else begin
        a := add(bx, by);
        b := add(ax, ay);
    end;

    d[1] := 0;
    for i := 2 to n do begin
        d[i] := d[i - 1] + math.hypot(x[i] - x[i - 1], y[i] - y[i - 1]);
    end;

    min := abs(d[a] - d[b]);
    y[0] := maxlongint;
    h[0] := 0;
    ch := 0;
    for i := 1 to n do begin
        lb := y[i];
        for k := ch downto 1 do begin
            j := h[k];
            if (j > 0) then begin
                if (y[j + 1] <> y[j]) then begin
                    sj := (x[j + 1] - x[j]) / (y[j + 1] - y[j]);
                end else begin
                    sj := 0;
                end;
                if (y[i - 1] <> y[i]) then begin
                    si := (x[i - 1] - x[i]) / (y[i - 1] - y[i]);
                end else begin
                    si := 0;
                end;
                update(y[j]);
                update(y[i]);
                update(lb);
                if (y[i - 1] <> y[i]) and (y[j + 1] <> y[j]) and (si <> sj) then begin
                    q := (l + (y[i] * si - x[i]) - (y[j] * sj - x[j])) / (si - sj);
                    update(q);
                end;
            end;
            if (y[j] > y[i]) then break;
            lb := y[h[k]];
        end;
        while y[h[ch]] < y[i] do begin
            dec(ch);
        end;
        inc(ch);
        h[ch] := i;
    end;

    writeln(minx1:0:10, ' ', miny:0:10, ' ', minx2:0:10, ' ', miny:0:10);

    close(input);
    close(output);
end.
