#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

#define inf 1e9
#define eps 1e-9
#define maxn 100010

typedef double dbl;
struct pnt
{
  dbl x, y;
  pnt() { }
  pnt( dbl _x, dbl _y ) { x = _x, y = _y; }
  pnt( int f ) { scanf("%lf%lf", &x, &y); }
};

pnt operator -( pnt a, pnt b ) { return pnt(a.x - b.x, a.y - b.y); } 
pnt operator +( pnt a, pnt b ) { return pnt(a.x + b.x, a.y + b.y); }
pnt operator *( pnt a, dbl k ) { return pnt(a.x * k, a.y * k); }
dbl operator !( pnt p ) { return sqrt(p.x * p.x + p.y * p.y); }
dbl operator ==( pnt a, pnt b ) { return fabs(a.x - b.x) < eps && fabs(a.y - b.y) < eps; } 

int N, A, B, sp = 0, id[maxn];
pnt st, en, ss[maxn];
vector <pnt> p;
dbl L, D[maxn];

dbl MinD = inf;
pnt Rp1, Rp2;

int AddP( pnt a )
{
  int i;
  for (i = 0; i < N; i++)
    if (p[i] == a)
      return i;
  for (i = 1; i < N; i++)
    if (fabs((a.x - p[i].x) * (p[i - 1].y - p[i].y) - (a.y - p[i].y) * (p[i - 1].x - p[i].x)) < eps &&
        min(p[i - 1].x, p[i].x) - eps < a.x && a.x < max(p[i - 1].x, p[i].x) + eps &&
        min(p[i - 1].y, p[i].y) - eps < a.y && a.y < max(p[i - 1].y, p[i].y) + eps)
      break;
  p.insert(p.begin() + i, a);
  N++;
  return i;
}

pnt GetP( int i, dbl y )
{
  return p[i] + (p[i + 1] - p[i]) * ((y - p[i].y) / (p[i + 1].y - p[i].y));
}

dbl DD( int A, int ai, pnt a )
{
  if (ai < A)
    ai++;
  return !(p[ai] - a) + fabs(D[A] - D[ai]);
}

void Try( pnt a, pnt b, int ai, int bi )
{
  dbl d = DD(A, ai, a) + b.x - a.x + DD(B, bi, b);
  if (d < MinD)
    MinD = d, Rp1 = a, Rp2 = b;
}

void Solve( int i, int j )
{
  if (i < 0 || j >= sp || i > j || fabs(ss[i].y - ss[j].y) > eps)
    return;
  int i1 = i;
  while (i <= j)
  {
    while (i1 <= j && ss[i1].x - ss[i].x < L + eps)
      i1++;
    Try(ss[i], ss[i1 - 1], id[i], id[i1 - 1]);
    i++;
  }
}

int main( void )
{
  freopen("bridge.in", "rt", stdin);
  freopen("bridge.out", "wt", stdout);
  
  int i;
  scanf("%d%lf", &N, &L);
  pnt st(0), en(0);
  for (i = 0; i < N; i++)
    p.push_back(pnt(0));
  p.push_back(pnt(inf, inf)), N++;
  A = AddP(st), B = AddP(en);
  if (B <= A)
    A++;
  if (A > B)
    swap(st, en), swap(A, B);
  D[0] = 0;
  for (i = 1; i < N; i++)
    D[i] = D[i - 1] + !(p[i] - p[i - 1]);

  for (i = 0; i < N; i++)
  {
    while (sp && ss[sp - 1].y + eps < p[i].y)
    {
      int j = sp - 1, i1, i2;
      while (j >= 0 && fabs(ss[j].y - ss[sp - 1].y) < eps)
        j--;
      i1 = j + 1, i2 = sp - 1;
      while (i1 < sp - 1 && id[i1 + 1] <= A)
        i1++;
      while (i2 > j && id[i2 - 1] >= B)
        i2--;
      Solve(i1, i2);
      Solve(i1, i2 - 1);
      if (j >= 0)
      {
        i1 = id[j], i2 = id[sp - 1];
        dbl yma = min(ss[j].y, p[i].y);
        pnt a = GetP(i1, yma), d = GetP(i2, yma);
        sp = j + 1;
        if (!(a == ss[sp - 1]))
          id[sp] = id[sp - 1], ss[sp++] = a;
        id[sp] = p[i2 + 1] == d ? i : i - 1, ss[sp++] = d;
      }
      else
        sp = 0;
    }
    if (!sp || !(ss[sp - 1] == p[i]))
      id[sp] = i, ss[sp++] = p[i];
  }
  printf("%.9lf %.9lf\n%.9lf %.9lf\n", Rp1.x, Rp1.y, Rp2.x, Rp2.y);
  return 0;
}
