#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "bridge.in"
#define C_OUT_FILE "bridge.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>
#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

const int NMAX = 110000;

struct point {
	double x, y;

	point() {
		x = y = 0;
	}

	point(double x, double y) {
		this->x = x;
		this->y = y;
	}

};

int n, m;
double len;
point s, f;
int sr, fr;
point p[NMAX];
double dfs[NMAX];
point a, b, c, d;
double ans;
point lans, rans;

void outdata() {
}

double xside(point a, point b, double h) {
	return (double)(b.x - a.x) / (double)(b.y - a.y) * (double)(h - a.y) + a.x;
}

double dist(point p1, point p2) {
	return hypot(p2.x - p1.x, p2.y - p1.y);
}

double dist(int fr, int sr, point s, point f) {
	if (fr == sr) return dist(s, f);
	if (sr < fr) {
		swap(sr, fr);
		swap(s, f);
	}
	double res = dfs[sr] - dfs[fr + 1];
	res += dist(s, p[fr + 1]) + dist(p[sr], f);
	return res;
}

void check(int i, int j, double h) {
	a = p[i]; b = p[i + 1];
	c = p[j]; d = p[j + 1];
	if (h > min(a.y, d.y)) return;
	double lx = xside(a, b, h), rx = xside(c, d, h);
	if (rx - lx > len + EPS) return ;
	if (rx < s.x || lx > f.x) return ;
	double res = dist(sr, i, s, point(lx, h));
	res += rx - lx;
	res += dist(fr, j, f, point(rx, h));
	if (ans > res) {
		ans = res;
		lans = point(lx, h);
		rans = point(rx, h);
	}
}

void solve() {
	ans = 1e+100;
	forn(i, n - 1) {
		a = p[i]; b = p[i + 1];
		if (a.y <= b.y) continue;
		double maxh = -1e+100;
		for(int j = i + 1; j < n - 1; ++j) {
			c = p[j]; d = p[j + 1];
			maxh = max(maxh, c.y);
			if (c.y >= d.y) continue;			
			if (min(a.y, d.y) < maxh) continue;
			check(i, j, maxh);
			double h = maxh;
			double lx = xside(a, b, h), rx = xside(c, d, h);
			double clen = rx - lx;
			double kf = fabs((b.x - a.x) / (a.y - b.y)) + fabs((d.x - c.x) / (d.y - c.y));
			if (clen > len - EPS) continue;
			double dy = (len - clen) / kf;
			h += dy;
			h = min(h, min(a.y, d.y));
			check(i, j, h);
		}
	}
	double res = dist(fr, sr, s, f);
	if (ans > res) {
		ans = res;
		printf("No\n");
		return ;
	}
	/* printf("Yes\n"); */
	printf("%lf %lf\n%lf %lf\n", lans.x, lans.y, rans.x, rans.y);
}

void readdata() {
	scanf("%d%lf", &n, &len);
	scanf("%lf%lf", &s.x, &s.y);
	scanf("%lf%lf", &f.x, &f.y);
	if (s.x > f.x) swap(s, f);
	dfs[0] = 0;
	forn(i, n) {
		scanf("%lf%lf", &p[i].x, &p[i].y);
	}
	forn(i, n - 1) {
		if (p[i].x <= s.x + EPS && s.x <= p[i + 1].x + EPS) sr = i;
		if (p[i].x <= f.x + EPS && f.x <= p[i + 1].x + EPS) fr = i;
	}
	forn(i, n - 1) {
		dfs[i + 1] = dfs[i] + hypot(p[i + 1].x - p[i].x, p[i + 1].y - p[i].y);
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

