// linear algorithm using graph of edges
// using hash with opened addr

#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES
#pragma comment (linker, "/STACK:30000000")

#include <algorithm>
#include <iostream>
#include <cassert>
#include <memory>
#include <vector>

using namespace std;
using namespace stdext;

#define cinfile "rail.in"
#define coutfile "rail.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define tr(a, it) for (typeof((a).begin()) it = (a).begin(), it != (a).end(); ++it)
#define f0(a) memset((a), 0, sizeof(a))
#define ff(a) memset((a), -1, sizeof(a))
#define fv(a, value) tr(a, it) { (*it) = value; }
#define present(a, x) ((a).find(x) != (a).end())
#define sz(a) (int)((a).size())

typedef vector < int > VI;
typedef vector < VI > VII;
typedef pair < int, int > pii;
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

typedef long long i64;

const int inf = (int)1e+9;
const double eps = (double)1e-9;
const int nmax = 100001;
const int mmax = 200001;
const int hsize = 500003;

int n, m;

int ans[nmax];
VI g[nmax];

int use[mmax];
VI d[mmax];

struct tedge { int x, y; } edge[mmax];
int table[hsize];

int h(int x, int y, int step) {
    return ((19*x + 14*y + 9) % hsize + step*(432*(x + y) + 90*y + 64) % (hsize - 1)) % hsize;
}

int hnum(int x, int y) {
    int temp;
    for (int step = 0; step < hsize; ++step) {
        temp = table[h(x, y, step)];
        if (temp == -1) return -1;
        if (edge[temp].x == x && edge[temp].y == y) return temp;
    }
    return -1;
}

void hadd(int x, int y, int v) {
    edge[v].x = x;
    edge[v].y = y;
    g[x].pb(v);

    int temp;
    for (int step = 0; step < hsize; ++step) {
        temp = h(x, y, step);
        if (table[temp] == -1) {
            table[temp] = v;
            return;
        }
    }
}

void gadd(int x, int y, int z) {
    int e1 = hnum(x, y);
    int e2 = hnum(y, z);
    d[e1].pb(e2);
    d[e2].pb(e1);
}

int inv(int x) {
    return (x % 2 == 0) ? x + 1 : x - 1;
}

void init() {
    ff(table);
    int x, y, z;
    scanf("%d%d", &n, &m);
    forn(i, n) { ans[i] = -inf; }
    forn(i, m) {
        scanf("%d%d", &x, &y);
        --x;
        --y;
        hadd(x, y, 2*i);
        hadd(y, x, 2*i + 1);
    }

    int k;
    scanf("%d", &k);
    forn(i, k) {
        scanf("%d%d%d", &x, &y, &z);
        x--;
        y--;
        while (z > 0) {
            z--;
            gadd(x, y, z);
            gadd(z, y, x);
            x = y;
            y = z;
            scanf("%d", &z);
        }
    }
}

bool dfs(int x, int orient) {
    if (use[inv(x)] == orient) return false;
    use[x] = orient;

    forn(j, sz(d[x])) if (use[d[x][j]] == 0) {
        if (!dfs(d[x][j], orient)) return false;
    }

    return true;
}

void genans(int x) {
    forn(j, sz(g[x])) {
        int e = g[x][j];
        int i = edge[e].y;

        if (ans[i] == -inf)  {
            if (use[e] > 0) ans[i] = ans[x] + 1; else ans[i] = ans[x] - 1;
            genans(i);
        }
    }
}

void solve() {
    f0(use);
    forn(i, 2*m) if (use[i] == 0) {
        int ori = (use[inv(i)] == 0) ? 1 : -1;
        if (!dfs(i, ori)) return;
    }

    forn(i, n) if (ans[i] == -inf) {
        ans[i] = 0;
        genans(i);
    }
    int minv = *min_element(ans, ans + n);
    forn(i, n) { ans[i] -= (minv - 1); }
}

void writeanswer() {
    if (ans[0] == -inf) printf("NO");
    else {
        printf("YES\n");
        forn(i, n) {
            if (i > 0) printf(" ");
            printf("%d", ans[i]);
        }
    }
}

int main() {
    freopen(cinfile, "rt", stdin);
    freopen(coutfile, "wt", stdout);

    init();
    solve();
    writeanswer();

    return 0;
}
