{$q+,r+,o-}
{$MAXSTACKSIZE $01000000}
uses
    sysutils;
const
    max_n = 100000;
    max_k = 100000;
    max_m = 200000;

function sgn(x: longint): longint;
begin
    if x < 0 then begin
        sgn := -1;
    end else if x > 0 then begin
        sgn := 1;
    end else begin
        sgn := 0;
    end;
end;

var
    n, m: longint;
    b, e, nextb, nexte: array [1..max_m] of longint;
    i, j, k: longint;
    headb, heade: array [1..max_n] of longint;
    heads, nexts: array [1..max_k] of longint;
    nextt, headt, edge, train: array [1..max_m] of longint;
    utrain: array [1..max_k] of boolean;
    uedge: array [1..max_m] of boolean;
    u: array [1..max_n] of boolean;
    pd, pv, pe: array [1..max_n] of longint;
    traind: array [1..max_k] of longint;
    edged: array [1..max_m] of longint;
    zone: array [1..max_n] of longint;

procedure dfs(i, parentv, parente, dir: longint);
var
    j: longint;
begin
    if u[i] then exit;
    u[i] := true;

    pv[i] := parentv;
    pe[i] := parente;
    pd[i] := dir;

    j := headb[i];
    while j <> 0 do begin
        dfs(e[j], i, j, 1);
        j := nextb[j];
    end;

    j := heade[i];
    while j <> 0 do begin
        dfs(b[j], i, j, -1);
        j := nexte[j];
    end;
end;

procedure dfsTrain(i, dir: longint); forward;

procedure dfsSpan(i, dir: longint);
var
    p: longint;
begin
    if uedge[i] then begin
        if edged[i] <> dir then begin
            writeln('NO');
            halt(0);
        end;
        exit;
    end;
//    writeln('Edge ', i, ' ', dir);
    uedge[i] := true;
    edged[i] := dir;

    p := heads[i];
    while p <> 0 do begin
        dfsTrain(abs(train[p]), sgn(train[p]) * dir);
        p := nexts[p];
    end;
end;

procedure dfsTrain(i, dir: longint);
var
    p: longint;
begin
    if utrain[i] then begin
        if traind[i] <> dir then begin
            writeln('NO');
            halt(0);
        end;
        exit;
    end;
//    writeln('Train ', i, ' ', dir);
    utrain[i] := true;
    traind[i] := dir;

    p := headt[i];
    while p <> 0 do begin
        dfsSpan(abs(edge[p]), sgn(edge[p]) * dir);
        p := nextt[p];
    end;
end;

var
    count: longint;

procedure dfs2(i: longint);
var
    j: longint;
begin
    if u[i] then exit;
    u[i] := true;

    j := headb[i];
    while j <> 0 do begin
        if 1 = edged[j] then begin
            dfs2(e[j]);
        end;
        j := nextb[j];
    end;

    j := heade[i];
    while j <> 0 do begin
        if -1 = edged[j] then begin
            dfs2(b[j]);
        end;
        j := nexte[j];
    end;
    inc(count);
    zone[i] := count;
end;

var
    v1, v2: longint;
begin
    reset(input, 'rail.in');
    rewrite(output, 'rail.out');

    read(n, m);
    for i := 1 to m do begin
        read(b[i], e[i]);
        nextb[i] := headb[b[i]];
        headb[b[i]] := i;
        nexte[i] := heade[e[i]];
        heade[e[i]] := i;
    end;

    for i := 1 to n do begin
        dfs(i, 0, 0, 1);
    end;

    read(k);
    j := 0;
    for i := 1 to k do begin
        read(v2);
        while true do begin
            v1 := v2;
            read(v2);
            if v2 = 0 then break;
            inc(j);

            if pv[v1] = v2 then begin
                edge[j] := -pe[v1] * pd[v1];
                train[j] := -i * pd[v1];
            end else begin
                edge[j] := pe[v2] * pd[v2];
                train[j] := i * pd[v2];
            end;

            nexts[j] := heads[abs(edge[j])];
            heads[abs(edge[j])] := j;

            nextt[j] := headt[abs(train[j])];
            headt[abs(train[j])] := j;
        end;
    end;

    for i := 1 to k do begin
        if not utrain[i] then begin
            dfsTrain(i, 1);
        end;
    end;

    writeln('YES');

    fillchar(u, sizeof(u), 0);
    for i := 1 to n do begin
        dfs2(i);
        writeln(zone[i]);
    end;

    close(input);
    close(output);
end.