#pragma comment(linker, "/STACK:60000000")

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back

#define NMAX 2 * 111111

typedef pair<int, int> edge;

edge e[NMAX];
int n, m, k;

vector<int> path[NMAX];
vector<int> numbers[NMAX];

int get_num(const edge &a) {
	return (int)(lower_bound(e, e + 2 * m, a) - e);
}

int color[NMAX];

vector<int> G[NMAX];

int kc;

void go(int v) {
	if (color[v] != -1) return;
	color[v] = kc;
	forn (i, G[v].size())  go(G[v][i]);
}

vector<int> result[NMAX];

int ko;
int order[NMAX];
int answer[NMAX];

void go1(int v) {
	if (color[v] != 0) return;
	color[v] = 1;
	forn (i, result[v].size()) go1(result[v][i]);
	order[ko++] = v;
}

int main() {
	freopen("rail.in", "rt", stdin);
	freopen("rail.out", "wt", stdout);

	scanf("%d%d", &n, &m);

	forn (i, m) {
		int a, b;
		scanf("%d%d", &a, &b);
		--a; --b;
		e[2 * i] = edge(a, b);
		e[2 * i + 1] = edge(b, a);
	}

	sort(e, e + 2 * m);

	scanf("%d", &k);
	forn (i, k) {
		int v;
		while (scanf("%d", &v), v) 
			path[i].pb(v - 1);		
		forn (j, path[i].size() - 1) {
			int num = get_num(make_pair(path[i][j], path[i][j + 1]));
			numbers[num].pb(i);
		}
	}

	memset(color, 255, sizeof(color));

	forn (i, 2 * m) {
		forn (j, numbers[i].size())
			forn (t, j) {
				G[numbers[i][j]].pb(numbers[i][t]);										
				G[numbers[i][t]].pb(numbers[i][j]);										
			}
	}

	kc = 0;
	forn (i, k)
		if (color[i] == -1) {
			go(i);
			++kc;
		}

	forn (i, 2 * m) {
		edge t = e[i];
		swap(t.first, t.second);
		int j = get_num(t);
		forn (p1, numbers[i].size())
			forn (p2, numbers[j].size())
				if (color[numbers[i][p1]] == color[numbers[j][p2]]) {
					printf("NO\n");
					return 0;
				}
	}

	set<pair<int, int> > inserted;

	forn (i, kc) {
		int dir = 0;
		forn (j, k) if (color[j] == i) {
			forn (ptr, path[j].size() - 1) {
				int a = path[j][ptr];
				int b = path[j][ptr + 1];
				edge t = edge(a, b);

				if (inserted.count(t) != 0) {
					if (dir == 0) dir = 1;
					if (dir != 1) {
						printf("NO\n");
						return 0;
					}
				}

				swap(t.first, t.second);
				if (inserted.count(t) != 0) {
					if (dir == 0) dir = -1;
					if (dir != -1) {
						printf("NO\n");						
						return 0;
					}
				}
			}
		}
		if (dir == 0) {
			dir = 1;
		}
		forn (j, k) if (color[j] == i) {
			forn (ptr, path[j].size() - 1) {
				int a = path[j][ptr];
				int b = path[j][ptr + 1];

				edge t(a, b);
				if (dir == -1) swap(t.first, t.second);

				inserted.insert(t);

				result[t.first].pb(t.second);
			}
		}

	}

	ko = 0;
	memset(color, 0, sizeof(color));
	forn (i, n) go1(i);

	forn (i, n) answer[order[i]] = i;

	printf("YES\n");
	forn (i, n) printf("%d ", answer[i] + 1);
	printf("\n");
}
