//	Stack Overflow solution

#include <vector>
#include <iostream>
#include <string>
#include <utility>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define mp make_pair
#define pb push_back

#define EMAX 100000
#define NMAX 100000
#define KVMAX 2 * NMAX

typedef pair<int, int> edge;
void norm(edge &e) {
	if (e.first > e.second) {
		swap(e.first, e.second);
	}
} 

edge e[EMAX];
int ke = 0;

int n, m, k;

vector<int> g[KVMAX];
vector<int> el;
vector<int> result[NMAX];

int edge_num(const edge &c) {
	edge t(c);
	norm(t);
	int res = (int)(lower_bound(e, e + m, t) - e);
	if (t != c) res += m;
	return res;
}

void add_edge(const edge &a, const edge &b) {
	int v1 = edge_num(a);
	int v2 = edge_num(b);

	g[v1].pb(v2);
	g[v2].pb(v1);
}

bool u[KVMAX];
int comp[KVMAX];
int kc;
vector<int> compv[KVMAX];
int order[KVMAX];
int ko;
int kv;

int answer[NMAX];

void go(int v) {
	if (u[v]) return;
	u[v] = true;
	forn (i, g[v].size())
		go(g[v][i]);
	order[ko++] = v;
}

void go1(int v) {
	if (u[v]) return;
	u[v] = true;
	comp[v] = kc;
	compv[kc].pb(v);
	forn (i, g[v].size())
		go1(g[v][i]);
}

void go2(int v) {
	if (u[v]) return ;
	u[v] = true;
	forn (i, result[v].size())
		go2(result[v][i]);
	order[ko++] = v;
}

void solve() {
	memset(u, false, sizeof(u));
	kv = 2 * m;

	ko = 0;
	forn (i, kv)
		if (!u[i]) go(i);

	kc = 0;
	memset(u, false, sizeof(u));
	for (int i = kv - 1; i >= 0; --i) {
		int v = order[i];
		if (u[v]) continue;
		go1(v);
		++kc;
	}

	forn (i, m)
		if (comp[i] == comp[m + i]) {
			printf("NO\n");
			return ;
		}

	memset(u, false, sizeof(u));
	for (int i = kc - 1; i >= 0; --i) {
		int cv = i;
		if (u[cv]) continue;
		u[cv] = true;
		int opp = -1;
		forn (j, compv[cv].size()) {
			int v = compv[cv][j];
			if (v < m)
				result[e[v].first].pb(e[v].second);
			else
				result[e[v - m].second].pb(e[v - m].first);
			if (v < m)
				v += m;
			else
				v -= m;
			u[comp[v]] = true;
		}
	}

	memset(u, false, sizeof(u));
	ko = 0;
	forn (i, n) go2(i);

	forn (i, n) answer[order[i]] = i;

	printf("YES\n");
	forn (i, n) {
		if (i > 0) printf(" ");
		printf("%d", answer[i] + 1);
	}
	printf("\n");
}

int main() {
	freopen("rail.in", "rt", stdin);
	freopen("rail.out", "wt", stdout);

	scanf("%d%d", &n, &m);	
	forn (i, m) {
		scanf("%d%d", &e[ke].first, &e[ke].second);
		--e[ke].first;
		--e[ke].second;
		norm(e[ke]);
		++ke;
	}

	sort(e, e + ke);	

	scanf("%d", &k);

	int suml = 0;

	forn (ii, k) {
		int v;
		el.clear();
		while (scanf("%d", &v), v) el.pb(v - 1);		
		
		suml += el.size();

		forn (i, el.size() - 2) {
			edge e1(el[i], el[i + 1]);
			edge e2(el[i + 1], el[i + 2]);

			edge t1(e1), t2(e2);
			norm(t1);
			norm(t2);
			int nt1 = (int)(lower_bound(e, e + m, t1) - e);
			int nt2 = (int)(lower_bound(e, e + m, t2) - e);

			int v1 = (e1 == t1 ? nt1 : nt1 + m);
			int v2 = (e2 == t2 ? nt2 : nt2 + m);

			g[v1].pb(v2);
			g[v2].pb(v1);

			swap(e1.first, e1.second);
			swap(e2.first, e2.second);

			v1 = (e1 == t1 ? nt1 : nt1 + m);
			v2 = (e2 == t2 ? nt2 : nt2 + m);

			g[v1].pb(v2);
			g[v2].pb(v1);
		}
	}	

	solve();

	cerr << suml << endl;

	return 0;
}