#pragma comment(linker, "/STACK:60000000")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back

int n, m, k;

#define NMAX 111111

pair<int, int> edge[NMAX];

int find_edge(int a, int b) {
	if (a > b) swap(a, b);
	return lower_bound(edge, edge + m, make_pair(a, b)) - edge;
}

vector<int> result[NMAX];

int added[NMAX];

int path[NMAX];
int tmp[NMAX];

int ko;
int order[NMAX];
bool used[NMAX];

int answer[NMAX];
int pathN[NMAX];

void go(int v) {
	if (used[v]) return ;
	used[v] = true;
	forn (i, result[v].size()) go(result[v][i]);
	order[ko++] = v;
}

int main() {
	freopen("rail.in", "rt", stdin);
	freopen("rail.out", "wt", stdout);

	scanf("%d %d", &n, &m);

	forn (i, m) {
		int a, b;
		scanf("%d%d", &a, &b);
		edge[i].first = min(a, b) - 1;
		edge[i].second = max(a, b) - 1;
	}

	sort(edge, edge + m);

	scanf("%d", &k);

	memset(added, 0, sizeof(added));

	forn (i, k) {
		int l = 0;
		int v;
		while (scanf("%d", &v), v) path[l++] = v - 1;

		memmove(tmp, path, sizeof(int) * l);
		sort(tmp, tmp + l);
		int r = unique(tmp, tmp + l) - tmp;
		if (r != l) {
			printf("NO\n");
			return 0;					
		}

		int dir = 0;
		forn (i, l - 1) {
			int a = min(path[i], path[i + 1]);
			int b = max(path[i], path[i + 1]);

			int num = find_edge(a, b);
			pathN[i] = num;
			int cdir = 0;
			if (added[num] != 0) {
				cdir = added[num];		
			}
			if (cdir == 0) continue;
			if (path[i] > path[i + 1])
				cdir = -cdir;
			if (dir == 0) dir = cdir;
			if (dir != cdir) {
				printf("NO\n");
				return 0;
			}
		}

		if (dir == 0) {
			if (rand() & 1)
				dir = 1;
		        else
		        	dir = -1;
		}
		if (dir == 1)
			forn (j, l - 1) {
				int a = path[j], b = path[j + 1];
				if (make_pair(a, b) != edge[pathN[j]]) added[pathN[j]] = -1; else added[pathN[j]] = 1;
				result[a].pb(b);
			}
		else
			for (int j = l - 1; j > 0; --j) {
				int a = path[j], b = path[j - 1];
				if (make_pair(a, b) != edge[pathN[j - 1]]) added[pathN[j - 1]] = -1; else added[pathN[j - 1]] = 1;
				result[a].pb(b);
			}
			
	}

	ko = 0;
	memset(used, false, sizeof(used));
	forn (i, n) go(i);

	forn (i, n) answer[order[i]] = i;

	printf("YES\n");
	forn (i, n) printf("%d ", answer[i] + 1);
	printf("\n"); 

	return 0;
}