#include <io.h>
#include <fcntl.h>
#include <stdlib.h>

const int MAX_BUF_SIZE = 30 * 1024 * 1024;
char buf[MAX_BUF_SIZE];
char outBuf[MAX_BUF_SIZE];
int outSize;
int bufSize;
int bufPos;

int nextInt() {
  int value = 0;
  char ch;
  while (true) {
    ch = buf[bufPos];
    if ('0' <= ch && ch <= '9')
      break;
    ++bufPos;
  }
  while ('0' <= ch && ch <= '9') {
    value = value * 10 + (ch - '0');
    ch = buf[++bufPos];
  }
  return value;
}

void writeChar(char ch) {
  outBuf[outSize++] = ch;
}

void writeInt(int x) {
  int cnt = 0;
  int p10 = 1;
  while (x >= p10) {
    p10 *= 10;
    ++cnt;
  }
  for (int i = 0; i < cnt; ++i) {
    p10 /= 10;
    writeChar('0' + (x / p10) % 10);
  }
}

int main() {
  int inHandle = open("sport.in", O_RDONLY | O_BINARY);
  bufSize = read(inHandle, buf, sizeof(buf));
  bufPos = 0;
  close(inHandle);
  buf[bufSize++] = 0;

  int n = nextInt();
  int x = nextInt() - 1;
  int k = nextInt();

  int* a = (int*) malloc(n * sizeof(int));
  for (int i = 0; i < n; ++i)
    a[i] = nextInt();

  int cntBigger = 0;
  for (int i = 0; i < x; ++i)
    if (a[i] > a[x])
      ++cntBigger;

  int cntPay = k;
  if (n - 1 - cntBigger < cntPay)
    cntPay = n - 1 - cntBigger;

  for (int step = 0; step < n - 1; ++step) {
    bool pay = step >= n - 1 - cntPay;
    for (int i = 0; i < n - 1; ++i) {
      if (pay && (i == x || i + 1 == x))
        continue;
      if (a[i] > a[i + 1]) {
        int t = a[i];
        a[i] = a[i + 1];
        a[i + 1] = t;
        if (i == x)
          x = i + 1;
        else if (i + 1 == x)
          x = i;
      }
    }
  }

  ++x;
  outSize = 0;
  writeInt(x);
  writeChar(13);
  writeChar(10);
  for (int step = 0; step < n - 1; ++step) {
    bool pay = step >= n - 1 - cntPay;
    if (pay)
      writeChar('+');
    else
      writeChar('-');
  }
  writeChar(13);
  writeChar(10);

  int outHandle = open("sport.out", O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, 0777);
  write(outHandle, outBuf, outSize);
  close(outHandle);

  free(a);
}
