#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define inpfile "digit.in"
#define outfile "digit.out"

const int NMAX = 105;
const int MMAX = 9*NMAX;
const int SMAX = NMAX*NMAX*10;

struct NODE {
	int s, p, d, x;
	int prev;
};

int ans[NMAX];
NODE a[NMAX][SMAX];
int u[MMAX][MMAX][10];
int k, s, p, d;
int an[NMAX];

void Init()
{
	freopen(inpfile, "r", stdin);
	freopen(outfile, "w", stdout);
	memset(u, 0, sizeof(u));
}

void Out(bool ok)
{
	if (ok)
		for (int i = 1; i <= k; i++)
			printf("%d", ans[i]);
	else
		printf("-1\n");
	exit(0);
}

void Inp()
{
	scanf("%d %d %d %d", &k, &s, &p, &d);
}

void GetAns(int h, int x)
{
	if (h == 0) return;
	ans[k - h + 1] = a[h][x].x;
	GetAns(h - 1, a[h][x].prev);
}

void Solve()
{
	int ss, pp, dd;

	memset(an, 0, sizeof(an));
	an[0] = 1;
	a[0][0].s = 0;
	a[0][0].p = 0;
	a[0][0].d = 0;
	a[0][0].prev = NULL;

	for (int i = 1; i <= k + 1; i++)
	{
		for (int x = 0; x <= 9; x++)
		{
			if ((x == 0) && (i == k)) x = 1;
			if ((x > 0) && (i == k + 1)) break;
			for (int j = 0; j < an[i - 1]; j++)
			{
				ss = a[i - 1][j].s + x;
				if (ss > s) continue;
				dd = d*x + a[i - 1][j].d;
				pp = a[i - 1][j].p + (dd % 10);
				if (pp > p) continue;
				dd /= 10;

				if (u[ss][pp][dd] != i)
				{
					a[i][an[i]].s = ss;
					a[i][an[i]].p = pp;
					a[i][an[i]].d = dd;
					a[i][an[i]].x = x;
					a[i][an[i]].prev = j;
					an[i]++;
					u[ss][pp][dd] = i;
				}
			}
		}
	}

	if (u[s][p][0] != k + 1) Out(false);

	for (int i = 0; i < an[k + 1]; i++)
		if ((a[k + 1][i].s == s) && (a[k + 1][i].p == p) && (a[k + 1][i].d == 0))
		{
			GetAns(k, a[k + 1][i].prev);
			break;
		}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out(true);
	return 0;
}
