#include <fstream>
#include <map>
#include <vector>
#include <sstream>
#include <iostream>
#include <cstdio>
using namespace std;

const int MAXN = 100;
const int MAXSUM = MAXN * 9;

int n, sum, summ, d;

void Load()
{
	cin >> n >> sum >> summ >> d;
}

class Param
{
public:
	unsigned char n, r;
	short s1, s2;
	void Init(int a, int b, int c, int d)
	{
		n = a;
		s1 = b;
		s2 = c;
		r = d;
	}
};

bool operator<(const Param &a, const Param &b)
{
	if (a.n < b.n) return true;
	if (a.n > b.n) return false;
	if (a.s1 < b.s1) return true;
	if (a.s1 > b.s1) return false;
	if (a.s2 < b.s2) return true;
	if (a.s2 > b.s2) return false;
	if (a.r < b.r) return true;
	if (a.r > b.r) return false;
	return false;
}

bool operator!=(const Param &a, const Param &b)
{
	if ((a.n != b.n) || (a.s1 != b.s1) || (a.s2 != b.s2) || (a.r != b.r)) return true;
	else return false;
}

///////////////////////////////////////////////////////////////
const int HASHMOD = 239017;
int hfirst[HASHMOD];
vector<int> hnext;
vector<int> hres;
vector<Param> hval;

void Init()
{
	memset(hfirst, 0xFF, sizeof(hfirst));
	hnext.clear();
	hres.clear();
	hval.clear();
}

int GetHash(Param &a)
{
	int hr = ((int)a.n) * 1784236 + ((int)a.s1) * 7688 + ((int)a.s2) * ((int)a.r) * 1356;
	hr %= HASHMOD;
	if (hr < 0) hr += HASHMOD;
	return hr;
}

int Get(int n, int s1, int s2, int r)
{
	Param a;
	a.Init(n, s1, s2, r);
	int cur = hfirst[GetHash(a)];
	while ((cur != -1) && (hval[cur] != a))
	{
		cur = hnext[cur];
	}
	if (cur == -1) return -1;
	else return hres[cur];
}

void Set(int n, int s1, int s2, int r, char val)
{
	Param a;
	a.Init(n, s1, s2, r);
	int pos = GetHash(a);
	int cur = hfirst[pos];
	while ((cur != -1) && (hval[cur] != a))
	{
		cur = hnext[cur];
	}
	if (cur == -1)
	{
		hval.push_back(a);
		hnext.push_back(hfirst[pos]);
		hfirst[pos] = hval.size() - 1;
		hres.push_back(0);
		cur = hval.size() - 1;
//		if (hres.size() % 10000 == 0) cerr << "Hash entries: " << hres.size() << "\n";
	}
	hres[cur] = val;
}

int Count(int n, int s1, int s2, int r)
{
	if (Get(n, s1, s2, r) != -1) return Get(n, s1, s2, r);
	if (n == 0)
	{
		if ((s1 == 0) && (s2 == 0) && (r == 0))
		{
			Set(n, s1, s2, r, 1);
		}
		else Set(n, s1, s2, r, 0);
		return Get(n, s1, s2, r);
	}
	Set(n, s1, s2, r, 0);
	int i;
	for (i = 0; i <= 9; i++)
	{	
		if (s1 < i) continue;
		if (s2 < (r * 10 + i) / d) continue;
		if (Count(n - 1, s1 - i, s2 - (r * 10 + i) / d, (r * 10 + i) % d) != 0)
		{
			Set(n, s1, s2, r, 1);
			return 1;
		}
	}
	return 0;
}

void RAns(ostringstream &oss, int n, int s1, int s2, int r)
{
	int i;
	while (n != 0)
	{
		for (i = 0; i <= 9; i++)
		{	
			if (s1 < i) continue;
			if (Count(n - 1, s1 - i, s2 - (r * 10 + i) / d, (r * 10 + i) % d) != 0)
			{
				oss << i;
				s1 -= i;
				s2 -= (r * 10 + i) / d;
				r = (r * 10 + i) % d;
				break;
			}
		}
		n--;
	}
}

void Solve()
{
	string ans = "";
	int i;
	for (i = 0; i < n + 1; i++) ans += "9";
	for (i = 1; i <= 9; i++)
	{
		ostringstream oss;
		oss << i;
		if ((i >= d) && (summ >= i) && (sum >= 1))
		{
			if (Count(n - 1, summ - i, sum - i / d, i % d))
				RAns(oss, n - 1, summ - i, sum - i / d, i % d);
			else continue;
		}	
		else if (summ >= i)
		{
			if (Count(n, summ - i, sum, i % d))
				RAns(oss, n, summ - i, sum, i % d);
			else continue;
		}
		else continue;
		string cur = oss.str();
		if ((cur.length() < ans.length()) || ((cur.length() == ans.length()) && (cur < ans))) ans = cur;
	}
	if ((ans.length() == n + 1) && (ans[0] == '9'))
	{
		cout << "-1";
		return;
	}
	string ans2;
	ans2 = "";
	int rem = 0;
	for (i = 0; i < ans.length(); i++)
	{
		int cur = ((ans[i] - '0') + rem * 10) / d;
		if (! ((i == 0) && (cur == 0)) )
		{
			ans2 += (char)(cur + '0');
		}
		rem = ((ans[i] - '0') + rem * 10) % d;
	}

	cout << ans2;
}

int main()
{
	freopen("digit.in", "rt", stdin);
	freopen("digit.out", "wt", stdout);
	Init();
	Load();
	Solve();
	return 0;
}