#include <fstream>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <cstdio>
using namespace std;

const int MAXN = 210;
const int QSIZE = 50000;
const int MNOGO = 0x7F7F7F7F;

int n, s, p, d;

void Load()
{
	cin >> n >> s >> p >> d;
}

class State
{
public:
	short s1, s2, r;
};

short res[9 * MAXN][9 * MAXN][10];
State q[QSIZE];

int GetNext(int a)
{
	a++;
	if (a >= QSIZE) a = 0;
	return a;
}

void CountResults()
{
	memset(res, 0x7F, sizeof(res));
	int hd, tl;
	hd = 0;
	tl = -1;
	int i;
	State a;
	for (i = 0; i < 10; i++)
	{           
		a.s1 = i;
		a.s2 = (i * d) % 10;
		a.r = (i * d) / 10;
		tl = GetNext(tl);
		q[tl] = a;
		res[a.s1][a.s2][a.r] = 1;
	}
	res[0][0][0] = 0;
	int ns1, ns2, nr;
	while (hd != GetNext(tl))
	{
		for (i = 0; i <= 9; i++)
		{
			ns1 = q[hd].s1 + i;
			ns2 = q[hd].s2 + (q[hd].r + i * d) % 10;
			nr = (q[hd].r + i * d) / 10;
			if ((ns1 > s) || (ns2 > p)) continue; 
			if (res[ns1][ns2][nr] > res[q[hd].s1][q[hd].s2][q[hd].r] + 1)
			{
				res[ns1][ns2][nr] = res[q[hd].s1][q[hd].s2][q[hd].r] + 1;
				a.s1 = ns1;
				a.s2 = ns2;
				a.r = nr;
				tl = GetNext(tl);
				q[tl] = a;
			}
		}
		hd = GetNext(hd);
	}
}

int GetSum(int a)
{
	int r = 0;
	while (a != 0)
	{
		r += (a % 10);
		a /= 10;
	}
	return r;
}

void RAns(ostringstream &oss, int len, int s1, int s2, int r)
{
	int i;
	for (i = 0; i < len; i++)
	{
		int k1, k2;
		int f = 0;
		for (k1 = 0; k1 <= 9; k1++)
		{
			for (k2 = 0; k2 <= 9; k2++)
			{
				int ns1, ns2, nr;
				ns1 = s1 - k1;
				nr = r * 10 - k1 * d + k2;
				ns2 = s2 - k2;
				if ((nr < 0) || (nr > 9)) continue;
				if ((ns1 < 0) || (ns2 < 0)) continue;
				if (res[ns1][ns2][nr] > len - i - 1) continue;
				s1 = ns1;
				s2 = ns2;
				r = nr;
				oss << k1;
				f = 1;
				break;
			}
			if (f == 1) break;
		}
		if (f == 0)
		{
			for (k1 = i; k1 < len; k1++) oss << "0";
			return;
		}
	}
}
	
void Solve()
{
	string rres;
	rres = "";
	CountResults();
	int i;
	for (i = 0; i < MAXN + 1; i++) rres += "9";
	for (i = 1; i <= 9; i++)
	{
		int s1 = s - i;
		if (s1 < 0) continue;
		int j;
		int cursum;
		for (j = 0; j < 10; j++)
		{
			for (cursum = 0; cursum <= p; cursum++)
			{
				if (res[s1][cursum][j] > n - 1) continue;
				// we use as n - 1
				if (cursum + GetSum(i * d + j) == p)
				{
					ostringstream oss;
					RAns(oss, n - 1, s1, cursum, j);
					string last = oss.str();
					ostringstream oss2;
					oss2 << i;
					int u;
					for (u = 0; u < n - last.length() - 1; u++) oss2 << "0";
					oss2 << last;
					string cres = oss2.str();
					if ( (cres.length() < rres.length()) || ((cres.length() == rres.length()) && (cres < rres)) )
					{
						rres = cres;
					}		
				}
				// we use as less than n - 1
				if ((res[s1][cursum][j] < n - 1) && (cursum + j + GetSum(i * d) == p))
				{
					ostringstream oss;
					RAns(oss, res[s1][cursum][j], s1, cursum, j);
					string last = oss.str();
					ostringstream oss2;
					oss2 << i;
					int u;
					for (u = 0; u < n - last.length() - 1; u++) oss2 << "0";
					oss2 << last;
					string cres = oss2.str();
					if ( (cres.length() < rres.length()) || ((cres.length() == rres.length()) && (cres < rres)) )
					{
						rres = cres;
					}	
				}
			}
		}
	}
	if (rres.length() > MAXN) 
	{
		cout << "-1\n";
		return;
	}
	else
	{
		cout << rres << "\n";
		return;
	}
}

int main()
{
	freopen("digit.in", "rt", stdin);
	freopen("digit.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}