import java.io.*;
import java.util.*;

public class digit_md_cube implements Runnable {
	private Scanner in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		Locale.setDefault(Locale.US);
		in = new Scanner(new FileReader("digit.in"));
		out = new PrintWriter("digit.out");
		int k = in.nextInt();
		int a = in.nextInt();
		int b = in.nextInt();
		int d = in.nextInt();
		int[][][][] s = new int[k + 1][a + 1][b + 1][10];
		int[][][][] h = new int[k + 1][a + 1][b + 1][10];
		for (int i = 0; i <= k; i++) {
			for (int aa = 0; aa <= a; aa++) {
				for (int bb = 0; bb <= b; bb++) {
					Arrays.fill(s[i][aa][bb], -1);
				}
			}
		}
		s[0][0][0][0] = 0;
		for (int i = 0; i < k; i++) {
			for (int aa = 0; aa <= a; aa++) {
				for (int bb = 0; bb <= b; bb++) {
					for (int c = 0; c < 10; c++) {
						if (s[i][aa][bb][c] < 0)
							continue;
						for (int t = 0; t < 10; t++) {
							if (i == k - 1 && t == 0)
								continue;
							int q = d * t + c;
							if (aa + t > a || bb + q % 10 > b)
								continue;
							s[i + 1][aa + t][bb + q % 10][q / 10] = t;
							h[i + 1][aa + t][bb + q % 10][q / 10] = 10 * bb + c;
						}
					}
				}
			}
		}
		for (int c = 0; c < 10 && c <= b; c++) {
			if (s[k][a][b - c][c] >= 0) {
				b -= c;
				while (k > 0) {
					int t = s[k][a][b][c];
					out.print(t);
					int a1 = a - t;
					t = h[k][a][b][c];
					int b1 = t / 10;
					int c1 = t % 10;
					k--;
					a = a1;
					b = b1;
					c = c1;
				}
				out.println();
				in.close();
				out.close();
				return;
			}
		}
		out.println(-1);
		in.close();
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new digit_md_cube()).start();
	}
}
