{$q+,r+,o-}
uses
    sysutils;
const
	max_n = 5000;
	dx: array [1..4] of longint = (1, 0, -1, 0);
	dy: array [1..4] of longint = (0, 1, 0, -1);
   	bx: array [1..4, 1..2] of longint = ((0,  0), (0, -1), (-1, -1), ( 0, -1));
  	by: array [1..4, 1..2] of longint = ((0, -1), (0,  0), ( 0, -1), (-1, -1));

type
    tarrv = array [1..6 * max_n] of int64;
    tarri = array [1..6 * max_n] of longint;
var
	i, n: longint;
	k: int64;
	x, y, d, l: tarrv;
    xi, yi: tarri;
	ch: char;
    u: array [1..6 * max_n, 1..6 * max_n] of boolean;

procedure qsort(var a: tarrv; l, r: longint);
var
    i, j: longint;
    x, t: int64;
begin
    x := a[l + random(r - l + 1)];
    i := l;
    j := r;
    while (i <= j) do begin
        while (a[i] < x) do inc(i);
        while (a[j] > x) do dec(j);
        if (i <= j) then begin
            t := a[i]; a[i] := a[j]; a[j] := t;
            inc(i);
            dec(j);
        end;
    end;
    if (l <= j) then qsort(a, l, j);
    if (i <= r) then qsort(a, i, r);
end;

function find(v: int64; var a: tarrv; l, r: longint): longint;
var
    m: longint;
begin
    m := (l + r) div 2;
    if v < a[m] then begin
        find := find(v, a, l, m - 1);
    end else if v > a[m] then begin
        find := find(v, a, m + 1, r);
    end else begin
        assert(v = a[m]);
        find := m;
    end;
end;

procedure compressRemap(var a: tarrv; var ai: tarri; n: longint);
var
    b: tarrv;
    i, z: longint;
begin
    b := a;
    qsort(a, 1, n);

    z := 1;
    for i := 2 to n do begin
        if (a[i] <> a[i - 1]) then begin
            inc(z);
            a[z] := a[i];
        end;
    end;

    for i := 1 to n do begin
        ai[i] := find(b[i], a, 1, z);
    end;
end;

function getArea(nxi, nyi: longint; px, py: int64): int64;
var
    rdx, rdy: int64;
begin
    if not u[nxi][nyi] then begin
        rdx := x[nxi + 1] - x[nxi];
        rdy := y[nyi + 1] - y[nyi];
        if (px + py) mod 2 = 0 then begin
            getArea := rdx * rdy - rdx * rdy div 2;
        end else begin
            getArea := rdx * rdy div 2;
        end;
    end else begin
        getArea := 0;
    end;
end;

var
    cxi, cyi, nxi1, nyi1, nxi2, nyi2: longint;
    nx1, ny1, nx2, ny2: int64;
    len: int64;
    count: int64;
    dcount: int64;
    xe, ye: longint;
    px1, py1, px2, py2: int64;
    z1, z2: int64;
begin
	reset(input, 'internet.in');
	rewrite(output, 'internet.out');

	read(n, k);
	for i := 1 to n do begin
		read(x[i], y[i]);
		if seekeof then;
		read(ch);
		d[i] := pos(ch, 'ENWS');
		read(l[i]);

        x[i + 1 * n] := x[i] + dx[d[i]] * l[i];
        x[i + 2 * n] := x[i] - 1;
        x[i + 3 * n] := x[i] + 1;
        x[i + 4 * n] := x[i + n] - 1;
        x[i + 5 * n] := x[i + n] + 1;

        y[i + 1 * n] := y[i] + dy[d[i]] * l[i];
        y[i + 2 * n] := y[i] - 1;
        y[i + 3 * n] := y[i] + 1;
        y[i + 4 * n] := y[i + n] - 1;
        y[i + 5 * n] := y[i + n] + 1;
	end;

    compressRemap(x, xi, 6 * n);
    compressRemap(y, yi, 6 * n);

    count := 0;
    for i := 1 to n do begin
        cxi := xi[i];
        cyi := yi[i];
        while (cxi <> xi[i + n]) or (cyi <> yi[i + n]) do begin
            nxi1 := cxi + bx[d[i]][1];
            nyi1 := cyi + by[d[i]][1];
            nxi2 := cxi + bx[d[i]][2];
            nyi2 := cyi + by[d[i]][2];

            px1 := x[cxi] + bx[d[i]][1];
            py1 := y[cyi] + by[d[i]][1];
            px2 := x[cxi] + bx[d[i]][2];
            py2 := y[cyi] + by[d[i]][2];

            dcount := getArea(nxi1, nyi1, px1, py1) + getArea(nxi2, nyi2, px2, py2);
            if count + dcount >= k then begin
                if u[nxi1][nyi1] then begin
                    assert(not u[nxi2][nyi2]);
                    len := 2 * (k - count - 1);
                    if (px2 + py2) mod 2 <> 0 then inc(len);
                end else if u[nxi2][nyi2] then begin
                    assert(not u[nxi1][nyi1]);
                    len := 2 * (k - count - 1);
                    if (px1 + py1) mod 2 <> 0 then inc(len);
                end else begin
                    len := k - count - 1;
                end;
                nx1 := x[cxi] + dx[d[i]] * len + bx[d[i]][1];
                ny1 := y[cyi] + dy[d[i]] * len + by[d[i]][1];
                nx2 := x[cxi] + dx[d[i]] * len + bx[d[i]][2];
                ny2 := y[cyi] + dy[d[i]] * len + by[d[i]][2];
                if (nx1 + ny1) mod 2 = 0 then begin
                    writeln(nx1, ' ', ny1);
                end else begin
                    assert((nx2 + ny2) mod 2 = 0);
                    writeln(nx2, ' ', ny2);
                end;
                exit;
            end;
            u[nxi1][nyi1] := true;
            u[nxi2][nyi2] := true;
            count := count + dcount;

            cxi := cxi + dx[d[i]];
            cyi := cyi + dy[d[i]];
        end;
    end;

	close(input);
	close(output);
end.