#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (long long i = 0; i < (long long)(n); ++i)
#define pb push_back
#define mp make_pair

typedef int __int;

#define int long long

int n;
long long k;

int dx[] = {0, 0, -1, 1};
int dy[] = {1, -1, 0, 0};

#define NMAX 5555

int dir[NMAX];
int pdir[NMAX];
int xs[NMAX];
int ys[NMAX];
int len[NMAX];

void readData() {
	cin >> n;
	cin >> k;
		
// x, y, dir, len

	forn (i, n) {
		cin >> xs[i] >> ys[i];
//		scanf("%d%d", &xs[i], &ys[i]);

		string buf;
		cin >> buf;
		if (buf[0] == 'N') {
			dir[i] = 0;
		}
		if (buf[0] == 'S') {
			dir[i] = 1;
		}
		if (buf[0] == 'W') {
			dir[i] = 2;
		}
		if (buf[0] == 'E') {
			dir[i] = 3;
		}
//		scanf("%d", &len[i]);
		cin >> len[i];

		forn (j, 4) 
			if (dx[j] * dx[dir[i]] + dy[j] * dy[dir[i]] == 0) {
				pdir[i] = j;
				break;
			}
	}
}

struct rect {
	int x1, y1, x2, y2;
	rect(int _x1, int _y1, int _x2, int _y2) {
		x1 = _x1;
		y1 = _y1;
		x2 = _x2;
		y2 = _y2;

		if (x1 > x2) swap(x1, x2);
		if (y1 > y2) swap(y1, y2);
	}
};

void add_rect(vector<rect> &r, int x1, int y1, int x2, int y2) {
	if (x1 >= x2 || y1 >= y2) return;
	r.pb(rect(x1, y1, x2, y2));
}

vector<rect> cut(const rect &a, const rect &b) {
	int xl = max(a.x1, b.x1);
	int xr = min(a.x2, b.x2);

	int yl = max(a.y1, b.y1);
	int yr = min(a.y2, b.y2);

	if (xl >= xr || yl >= yr) return vector<rect>(1, a);
	
	vector<rect> result;
	add_rect(result, a.x1, a.y1, xl,   yl);
	add_rect(result, a.x1, yl,   xl,   yr);
	add_rect(result, a.x1, yr,   xl,   a.y2);
	add_rect(result, xl,   a.y1, xr,   yl);
	add_rect(result, xl,   yr,   xr,   a.y2);
	add_rect(result, xr,   a.y1, a.x2, yl);
	add_rect(result, xr,   yl,   a.x2, yr);
	add_rect(result, xr,   yr,   a.x2, a.y2);

	return result;
}

vector<rect> cut(const rect &a, vector<rect> b) {
	if (b.size() == 0) return vector<rect>(1, a);
	vector<rect> result(1, a);
	forn (i, b.size()) {
		vector<rect> add;
		forn (j, result.size()) {
			vector<rect> t = cut(result[j], b[i]);
			forn (p, t.size()) add.pb(t[p]);
		}
		result = add;
	}
	return result;
}

int isblack(int x, int y) {
	return int((x + y) % 2 == 0); 
}

long long in_rect(const rect &r) {
	long long leny = r.y2 - r.y1;
	long long lenx = r.x2 - r.x1;
	long long in_line1 = (leny >> 1) + (leny & 1) * (isblack(r.x1, r.y1));
	long long in_line2 = (leny >> 1) + (leny & 1) * (isblack(r.x1, r.y1 + 1));
	long long answer = ((lenx >> 1) + (lenx & 1)) * in_line1;
	answer += (lenx >> 1) * in_line2;
	return answer;
}

vector<rect> used;

void find_ans(int i, long long k, int &x, int &y) {
	int l = 1, r = len[i];
	int d = dir[i], pd = pdir[i];
	while (l < r) {
		int mid = (l + r + 1) >> 1;

		int x1 = min(min(xs[i] - dx[pd], xs[i] + dx[pd]), min(xs[i] + mid * dx[d] - dx[pd], xs[i] + mid * dx[d] + dx[pd]));
		int x2 = max(max(xs[i] - dx[pd], xs[i] + dx[pd]), max(xs[i] + mid * dx[d] - dx[pd], xs[i] + mid * dx[d] + dx[pd]));
		int y1 = min(min(ys[i] - dy[pd], ys[i] + dy[pd]), min(ys[i] + mid * dy[d] - dy[pd], ys[i] + mid * dy[d] + dy[pd]));
		int y2 = max(max(ys[i] - dy[pd], ys[i] + dy[pd]), max(ys[i] + mid * dy[d] - dy[pd], ys[i] + mid * dy[d] + dy[pd]));

		rect use_now = rect(x1, y1, x2, y2);
		vector<rect> cur = cut(use_now, used);
		int cnt = 0;
		forn (i, cur.size()) cnt += in_rect(cur[i]);
		if (cnt > k) 
			r = mid - 1;
		else
			l = mid;
	}
	x = xs[i] + l * dx[d];
	y = ys[i] + l * dy[d];

	if (d == 0) {
		--y;
		if (isblack(x, y)) return;
		--x;
		return ;
	}
	if (d == 1) {
		if (isblack(x, y)) return;
		--x;
		return ;
	}
	if (d == 2) {
		if (isblack(x, y)) return;
		--y;
		return ;
	}
	if (d == 3) {
		--x;
		if (isblack(x, y)) return ;
		--y;
		return ;
	}
}

void solve() {
	long long k_used = 0;

	int ans_x = -1, ans_y = -1;

	forn (i, n) {
		int d = dir[i], pd = pdir[i];
		int x1 = min(min(xs[i] - dx[pd], xs[i] + dx[pd]), min(xs[i] + len[i] * dx[d] - dx[pd], xs[i] + len[i] * dx[d] + dx[pd]));
		int x2 = max(max(xs[i] - dx[pd], xs[i] + dx[pd]), max(xs[i] + len[i] * dx[d] - dx[pd], xs[i] + len[i] * dx[d] + dx[pd]));
		int y1 = min(min(ys[i] - dy[pd], ys[i] + dy[pd]), min(ys[i] + len[i] * dy[d] - dy[pd], ys[i] + len[i] * dy[d] + dy[pd]));
		int y2 = max(max(ys[i] - dy[pd], ys[i] + dy[pd]), max(ys[i] + len[i] * dy[d] - dy[pd], ys[i] + len[i] * dy[d] + dy[pd]));

		rect use_now = rect(x1, y1, x2, y2);
		vector<rect> cur = cut(use_now, used);

		long long add_used = 0;
		long long old_k_used = k_used;
		forn (j, cur.size()) {
			add_used = in_rect(cur[j]);
			k_used += add_used;
			if (k_used >= k) break;
		}

		if (k_used >= k) {
			find_ans(i, k - old_k_used, ans_x, ans_y);
			break ;
		}

		used.pb(use_now);
	}	
	if (k_used >= k)
         	cout << ans_x << " " << ans_y << endl;
        else
        	cout << "PLEASE WAIT" << endl;
}

__int main() {
		freopen("internet.in", "rt", stdin);
		freopen("internet.out", "wt", stdout);

        readData();
        solve();
	
	return 0;
}