#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "internet.in"
#define C_OUT_FILE "internet.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>
#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

typedef long long ll;

const int NMAX = 2100;

int n;
ll ans = 0, sumL = 0;
ll k;
ll px[NMAX], py[NMAX], l[NMAX];
int dir[NMAX];
vector<ll> xs, ys;
bool **us[2];

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

bool ansExist;

pair<ll, ll> result;

#define AL(a) (sizeof(a) / sizeof(a[0]))

void outdata() {
	cerr << " N = " << n << ", K = " << k + 1 << ",   : " << ans << endl;
	cout << "num dif points " << ans << endl;
	cout << "sum len " << sumL << endl;
}

long long numSquare(ll lx, ll ly, ll rx, ll ry) {
	if (lx > rx || ly > ry) {
		swap(lx, rx);
		swap(ly, ry);
	}
	ll lf, rg;
	if (lx == rx) {
		lf = ly, rg = ry;
	} else {
		lf = lx, rg = rx;
	}
	if ((lx + ly) % 2 != 0) ++lf;
	if ((rx + ry) % 2 == 0) --rg;
	++rg;
	return (rg - lf + 1) / 2;
}

int sign(ll a) {
	if (a > 0) return 1;
	if (a < 0) return -1;
	return 0;
}

void mark(int px, int py, int dir) {
	int cx = dx[dir], cy = dy[dir], dr;
	if (cx < 0) --px;
	if (cy < 0) --py;
	if (cx == 0) dr = 0; else dr = 1;
	us[dr][px][py] = true;
	if ((dr == 1 && ys[py + 1] - ys[py] == 1)
		|| (dr == 0 && xs[px + 1] - xs[px] == 1)) {
		us[1 - dr][px][py] = true;
	}
}

pair<ll, ll> nthSquare(ll lx, ll ly, ll rx, ll ry, ll n) {
	ll k = numSquare(lx, ly, rx, ry);
	if (lx > rx || ly > ry) {
		swap(lx, rx);
		swap(ly, ry);
		n = k - n - 1;
	}
	ll lf, rg;
	int dx, dy;
	if (lx == rx) {
		lf = ly, rg = ry;
		dx = 0;
		dy = sign(rg - lf);
	} else {
		lf = lx, rg = rx;
		dx = sign(rg - lf);
		dy = 0;
	}
	if ((lx + ly) % 2 != 0) {
		lx += dx; ly += dy;
	}
	if ((rx + ry) % 2 != 0) {
		rx -= dx; ry -= dy;
	}
	return mp(lx + dx * 2 * n, ly + dy * 2 * n);
}

pair<ll, ll> nthUpDownSquare(ll lx, ll ly, ll rx, ll ry, ll n, ll k) {
	if (lx > rx || ly > ry) {
		swap(lx, rx);
		swap(ly, ry);
		n = k - n - 1;
	}
	ll lf, rg;
	int dx, dy;
	if (lx == rx) {
		lf = ly, rg = ry;
		dx = 1;
		dy = 0;
	} else {
		lf = lx, rg = rx;
		dx = 0;
		dy = 1;
	}
	if ((lx + ly) % 2 == 0) {
		if (n % 2 == 0) return nthSquare(lx, ly, rx, ry, n / 2); else 
			return nthSquare(lx - dx, ly - dy, rx - dx, ry - dy, (n - 1) / 2);
	} else {
		if (n % 2 == 0) return nthSquare(lx - dx, ly - dy, rx - dx, ry - dy, n / 2); else 
			return nthSquare(lx, ly, rx, ry, (n - 1) / 2);
	}
}

bool draw_line(ll x, ll y, int dir, ll l) {
	int sx = num(xs, x), sy = num(ys, y);
	int fx = num(xs, x + l * dx[dir]), fy = num(ys, y + l * dy[dir]);
	int dr = (dx[dir] == 0 ? 0 : 1);
	for(; sx != fx || sy != fy; sx += dx[dir], sy += dy[dir]) {
		int cx = sx, cy = sy;
		if (dr == 0) --cx; else --cy;
		ll ku, kd, ka = 0;
		ku = numSquare(xs[sx], ys[sy], xs[sx + dx[dir]], ys[sy + dy[dir]]);
		kd = numSquare(xs[cx], ys[cy], xs[cx + dx[dir]], ys[cy + dy[dir]]);
		int rsx = min(sx, sx + dx[dir]), rsy = min(sy, sy + dy[dir]);
		int rcx = min(cx, cx + dx[dir]), rcy = min(cy, cy + dy[dir]);
		if (!us[dr][rsx][rsy]) ka += ku;
		if (!us[dr][rcx][rcy]) ka += kd;
   		ans += ka;
   		mark(sx, sy, dir);
   		mark(cx, cy, dir);
	}
	return false;
}

void solve() {
	forn(i, n) {
		for(int d = -1; d <= 1; ++d) {
			xs.pb(px[i] + d);
			ys.pb(py[i] + d);
			xs.pb(px[i] + l[i] * dx[dir[i]] + d);
			ys.pb(py[i] + l[i] * dy[dir[i]] + d);
		}
	}
	norm(xs);
	norm(ys);
	forn(q, 2) {
		us[q] = new bool*[xs.size()];
		forv(i, xs) {
			us[q][i] = new bool[ys.size()];
			memset(us[q][i], 0, sizeof(bool) * ys.size());
		}
	}
	ansExist = false;
	forn(i, n) {
		if (draw_line(px[i], py[i], dir[i], l[i])) {
			ansExist = true;
			break;
		}
	}
}

void readdata() {
	scanf("%d", &n);
	cin >> k;
	--k;
	forn(i, n) {
		cin >> px[i] >> py[i];
		char c;
		cin >> c;
		int r = -1;
		switch (c) {
			case 'N' : r = 0; break;
			case 'E' : r = 1; break;
			case 'S' : r = 2; break;
			case 'W' : r = 3; break;
		}
		dir[i] = r;
		assert(dir[i] >= 0 && dir[i] < 4);
		cin >> l[i];
		sumL += l[i];
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
