#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "trees.in"
#define C_OUT_FILE "trees.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>
#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

const int NMAX = 100000;

int n, ans;
int a[NMAX];
int z[2];
int p[NMAX];

void outdata() {
	printf("%d\n", ans);
}

void sift_down(int i) {
	int j = (i << 1) + 1;
	if (j + 1 < n && a[p[j]] < a[p[j + 1]]) ++j;
	while (j < n && a[p[i]] < a[p[j]]) {
		swap(p[i], p[j]);
		i = j;
		j = (i << 1) + 1;
		if (j + 1 < n && a[p[j]] < a[p[j + 1]]) ++j;
	}
}

void make_heap() {
	for(int i = n - 1; i >= 0; --i) sift_down(i);
}

void solve() {
	memset(z, 255, sizeof z);
	ans = 0;
	forn(i, n) p[i] = i;
	make_heap();
	int gr = min(7, n);
	while (1) {
		int ps = -1;
		int mx = 0;
		forn(i, gr) if (p[i] != z[0] && p[i] != z[1]) {
			if (mx < a[p[i]]) {
				mx = a[p[i]];
				ps = i;
			}
		}
		if (ps == -1) break;
		z[ans & 1] = p[ps];
		++ans;
		--a[p[ps]];
		sift_down(ps);
	}
}

void readdata() {
	scanf("%d", &n);
	forn(i, n) scanf("%d", &a[i]);
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
