// binsearch
// sort + p log s

#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:30000000")

#include <iostream>
#include <algorithm>
#include <utility>
#include <cassert>
#include <vector>

using namespace std;

#define cinfile "trees.in"
#define coutfile "trees.out"
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back

typedef pair < int, int > pii;
typedef long long i64;

const int nmax = 100001;

int n, p;
vector < int > a;
vector < i64 > s;

void init() {
	scanf("%d%d", &n, &p);
	a.resize(n);
	forn(i, n) {
		scanf("%d", &a[i]);
	}
	sort(a.rbegin(), a.rend());
	s.resize(n + 1);
	s[n] = 0;
	for (int i = n - 1; i >= 0; --i) {
		s[i] = s[i + 1] + a[i];
	}
}

int good(i64 x) {
	forn(i, p) {
    	if (x*(p - i) > s[i]) return -1;
		if (a[i] <= x) return i;
	}
	return p;
}

void solve() {
	i64 left = 0;
	i64 right = s[0] / p + 2;
    while (left + 1 < right) {
    	i64 t = (left + right) / 2;
    	if (good(t) != -1) left = t; else right = t;
    }
    int k1 = good(left);
    i64 rest = k1 + s[k1] - left*(p - k1);

    cout << left*p + rest;
}

int main() {
	freopen(cinfile, "rt", stdin);
	freopen(coutfile, "wt", stdout);

	init();
	solve();

    return 0;
}
