#include <stdio.h>

#define MAXN        1000

int f[MAXN][MAXN];
int q[MAXN * MAXN];

const int dirx[] = { -1, 0, 0, 1 };
const int diry[] = { 0, -1, 1, 0 };

void draw(int x1, int y1, int x2, int y2) {
    int dx, dy;

    if (x1 == x2) dx = 0; else if (x1 < x2) dx = 1; else dx = -1;
    if (y1 == y2) dy = 0; else if (y1 < y2) dy = 1; else dy = -1;

    while ((x1 != x2) || (y1 != y2)) {
        f[x1][y1] = 1;
        x1 += dx;
        y1 += dy;
    }
    f[x2][y2] = 1;
}

int main() {
    int k, d, w, h, n, i, j;
    int x1, y1, x2, y2, l, r;
    int x, y, xx, yy;
    int sx, sy;

    freopen("digits.in", "r", stdin);
    freopen("digits.out", "w", stdout);

    scanf("%d %d", &k, &d);
    scanf("%d %d", &w, &h);
    scanf("%d", &n);

    for (i = 0; i < n; i++) {
        scanf("%d %d %d %d", &x1, &y1, &x2, &y2);
        draw(k * x1, k * y1, k * x2, k * y2);
    }

    l = r = 0;
    sx = (w - 1) * k;
    sy = (h - 1) * k;
    for (i = 0; i <= sx; i++) {
        for (j = 0; j <= sy; j++) {
            if (f[i][j] != 0) {
                q[r++] = (i << 13) + j;
            }
        }
    }

    while (l < r) {
        x = q[l] >> 13;
        y = q[l] - (x << 13);
        l++;

        if (f[x][y] == d)
            continue;

        for (i = 0; i < 4; i++) {
            xx = x + dirx[i];
            yy = y + diry[i];
            if (xx < 0 || xx > sx || yy < 0 || yy > sy)
                continue;

            if (f[xx][yy] == 0) {
                f[xx][yy] = f[x][y] + 1;
                q[r++] = (xx << 13) + yy;
            }
        }
    }

    for (j = 0; j <= sy; j++) {
        for (i = 0; i <= sx; i++) {
            printf("%c", (f[i][j] > 0) ? '*' : '.');
        }
        printf("\n");
    }

    return 0;
}
