#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "input.txt"
#define OUT_FILE "output.txt"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int NMAX = 30;

int n, k, kp;
int kCircle;
vector< VI > ens;
int g[NMAX][NMAX];
bool cross[NMAX][NMAX];
bool up[NMAX];
int v[NMAX];
VI lines[NMAX];

bool ans;

void outdata() {
    if (ans) printf("YES\n"); else printf("NO\n");
}

bool crossDuga(VI &a, VI &b) {
    if (a.size() + b.size() < 4) return false;
    if (a[0] == b[0] || a[0] == b[1] || a[1] == b[0] || a[1] == b[1]) return false;
    bool f = (b[0] < a[0] && a[0] < b[1]);
    bool c = (b[0] < a[1] && a[1] < b[1]);
    return f ^ c;
}

bool check(vector< VI > & a) {
    forv(i, a) forn(j, i) if (crossDuga(a[i], a[j])) return false;
    return true;
}

bool check() {
    bool cup[NMAX];
    forn(i, k) {
        forn(j, i) {
            if (cross[i][j] && g[i][j] == -1) return false;
            if (cross[i][j]) {
                if (v[i] == -1) v[i] = (int)up[i];
                if (v[i] != (int)up[i]) return false;
            }
        }
    }
    forn(msk, 1 << kp) {
        bool ok = true;
        forn(i, kp) {
            if (msk & (1 << i)) if (v[i + kCircle] != -1) ok = false;
        }
        if (!ok) continue;
        forn(i, kp) {
            bool cbool;
            if (msk & (1 << i)) cbool = true; else cbool = false;
            cup[i + kCircle] = cbool;
        }
        vector< VI > down, upp;
        forn(i, kp) {
            int t = i + kCircle;
            if (v[t] == -1) {
                forv(cu, lines[t]) {
                    forn(cv, cu) {
                        VI x = ens[lines[t][cu] - 1], y = ens[lines[t][cv] - 1];
                        if (cup[t]) {
                            VI z(2);
                            forv(i1, x) forv(i2, y) {
                                z[0] = x[i1]; z[1] = y[i2];
                                upp.pb(z);
                            }
                        } else {
                            VI z(2);
                            forv(i1, x) forv(i2, y) {
                                z[0] = x[i1]; z[1] = y[i2];
                                down.pb(z);
                            }
                        }
                    }
                }
            }
        }
        forn(i, k)
            if (up[i]) upp.pb(ens[i]); else down.pb(ens[i]);
        if (check(upp) && check(down)) return true;
    }
    return false;
}

void solve() {
    VI kn(k, 0);
    ens.clear();
    kCircle = 0;
    ens.resize(k);
    memset(g, 255, sizeof g);
    forn(i, n) {
        int t;
        scanf("%d", &t);
        assert(2 <= t && t <= k);
        VI x(t), y;
        forn(j, t) scanf("%d", &x[j]);
        forn(j, t) assert(0 <= x[j] && x[j] < k);
        lines[i] = x;
            y = x; sort(all(y)); y.erase(unique(all(y)), y.end()); assert(x == y);
        if (x[0] != 0) {
            forn(u, t) ++kn[x[u]];
            forn(u, t) --x[u];
            forn(u, t) forn(v, t) g[x[u]][x[v]] = g[x[v]][x[u]] = i;
        } else {
            ++kCircle;
            forn(u, t) ens[x[u]].pb(i);
        }
    }
    kp = n - kCircle;
    --k;
    ens.erase(ens.begin(), ens.begin() + 1);
    forn(i, k) {
        assert(ens[i].size() <= 2);
        sort(all(ens[i]));
    }
    forn(i, k) {
        assert(kn[i] <= 1);
    }
    ans = false;
    forn(msk, 1 << k) {
        memset(v, 255, sizeof v);
        forn(i, k) {
            if (msk & (1 << i)) up[i] = true; else up[i] = false;
        }
        forn(i, k) {
            forn(j, i) {
                bool cbool = false;
                if ((!up[i] ^ up[j]) && crossDuga(ens[i], ens[j])) cbool = true;
                cross[i][j] = cross[j][i] = cbool;
            }
        }
        if (check()) {
            ans = true;
            check();
            return ;
        }
    }
}

void readdata() {
    string X;
    getline(cin, X);
    sscanf(X.c_str(), "%d", &k);
    assert(1 <= k && k <= 13);
    getline(cin, X);
    sscanf(X.c_str(), "%d", &n);
    assert(1 <= n && n <= 3 * k);
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

