import java.io.*;
import java.util.*;

public class attack_ia implements Runnable {

	private static final int INF = 1000000000;
	private BufferedReader in;
	private PrintWriter out;
	
	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("attack.in"));
		out = new PrintWriter("attack.out");
		String str = in.readLine();
		Scanner scan = new Scanner(str);
		int n = scan.nextInt();
		myAssert((n >= 1) && (n <= 100), "n is not in range [1...100]");
		int maxx = -INF;
		int maxy = -INF;
		int minz = INF;
		for (int i = 0; i < n; i++) {
			str = in.readLine();
			scan = new Scanner(str);
			int x = scan.nextInt();
			int y = scan.nextInt();
			int s = scan.nextInt();
			myAssert((x >= -100000) && (x <= 100000), "|x| is greater than 10^5");
			myAssert((y >= -100000) && (y <= 100000), "|y| is greater than 10^5");
			myAssert((s >= 1) && (s <= 1000), "s is not in range[1..1000]");
			myAssert((x + " " + y + " " + s).equals(str), "Extra spaces in line");
			if (maxx < x) maxx = x;
			if (maxy < y) maxy = y;
			int z = x + y + s;
			if (minz > z) minz = z;			
		}
		
		int a = minz - maxy - maxx;
		
		out.printf("%.3f", (a > 0) ? a * a * 0.5 : 0);
		
		in.close();
		out.close();
	}

	private void myAssert(boolean b, String message) {
		if (!b) {
			message = "Internal error or invalid input file: " + message;
			System.out.println(message);
			out.println(message);
			out.close();
			System.exit(239);
		}
	}

	public static void main(String[] args) {
		new Thread(new attack_ia()).start();
	}

}
