import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class dwarfs_dp_bad1 implements Runnable {

	private PrintWriter out;
	private Scanner in;

	public dwarfs_dp_bad1(String file) {
		try {
			in = new Scanner(new File(file + ".in"));
			out = new PrintWriter(new File(file + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(239);
		}
	}

	public static void main(String[] args) {
		new Thread(new dwarfs_dp_bad1("dwarfs")).start();
	}

	public void run() {
		try {
			int n = in.nextInt();
			Dwarf[] dwarfs = new Dwarf[n];
			for (int i = 0; i < n; i++) {
				dwarfs[i] = new Dwarf(in.nextInt(), in.nextInt());
			}
			Arrays.sort(dwarfs);
			int wakeup = 2100000000;
			int currTime = 0;
			for (Dwarf d: dwarfs) {
				currTime += d.a;
				wakeup = Math.min(wakeup, currTime + d.b);
			}
			if (wakeup > currTime) {
				for (Dwarf d: dwarfs) {
					out.print((d.id + 1) + " ");
				}
			} else {
				out.println(-1);
			}
		} finally {
			out.close();
		}
	}
	
	static class Dwarf implements Comparable<Dwarf> {
		private static int count = 0;
		final int id;
		int a;
		int b;
		
		Dwarf(int aa, int bb) {
			id = count++;
			a = aa;
			b = bb;
		}

		public int compareTo(Dwarf d) {
			return -((a + b) - (d.a + d.b));
		}
	}
}
