#include <stdio.h>
#include <math.h>

#define PROBLEM_ID          "dwarfs"
#define MAXN                100000

int a[MAXN];
int b[MAXN];
int p[MAXN];
int n, tmp;

void qs(int l, int h) {
    int i, j, r;

    r = a[(l + h) / 2] + b[(l + h) / 2];
    i = l;
    j = h;
    while (i < j) {
        while (a[i] + b[i] > r) i++;
        while (a[j] + b[j] < r) j--;
        if (i <= j) {
            tmp = a[i];
            a[i] = a[j];
            a[j] = tmp;

            tmp = b[i];
            b[i] = b[j];
            b[j] = tmp;

            tmp = p[i];
            p[i] = p[j];
            p[j] = tmp;

            i++;
            j--;
        }
    }
    if (l < j) qs(l, j);
    if (i < h) qs(i, h);
}

int main() {
    long long int time, cur;
    int i;

    freopen(PROBLEM_ID".in", "r", stdin);
    freopen(PROBLEM_ID".out", "w", stdout);

    scanf("%d", &n);
    for (i = 0; i < n; i++) {
        scanf("%d", &a[i]);
        p[i] = i;
    }
    for (i = 0; i < n; i++) {
        scanf("%d", &b[i]);
        p[i] = i;
    }

    qs(0, n - 1);
    time = 0;
    for (i = 0; i < n; i++) {
        time = time + a[i];
    }

    cur = 0;
    for (i = 0; i < n; i++) {
        cur = cur + a[i];
        if (cur + b[i] <= time) {
            printf("-1\n");
            return 0;
        }
    }

    for (i = 0; i < n; i++) {
        printf("%s%d", (i > 0) ? " " : "", p[i] + 1);
    }
    printf("\n");

    return 0;
}
