import java.util.Scanner;
import java.io.File;
import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.math.BigInteger;

public class graph_ft {

	static int[] primes = new int[10000];
	static int pCnt = 0;

	static void genPrimes() {
		boolean[] w = new boolean[10001];
		int maxI = 5000;
		for (int i = 2; i <= maxI; i++) {
			if (!w[i]) {
				primes[pCnt++] = i;
				int j = i;
				while (j <= maxI) {
					w[j] = true;
					j += i;
				}
			}
		} 
	}

	static BigInteger restore(int[] a, int[] b) {

		BigInteger N = BigInteger.ONE;
		
		BigInteger ans = BigInteger.ZERO;
		
		for (int i = 0; i < pCnt; i++) {
			N = N.multiply(BigInteger.valueOf(a[i]));
		}
		
		BigInteger mi;
		BigInteger inv;
		BigInteger ci;
		
		for (int i = 0; i < pCnt; i++) {
			mi = N.divide(BigInteger.valueOf(a[i]));
			inv = mi.remainder(BigInteger.valueOf(a[i]));
			inv = inv.modInverse(BigInteger.valueOf(a[i]));
			ci = mi.multiply(inv);
			ans = ans.add(ci.multiply(BigInteger.valueOf(b[i])));
			ans = ans.remainder(N);
		}
		
		ans = ans.remainder(N);
		
		return ans;		
	}

	static int calculate(int n, int m) {
		int[][] c = new int[n + 1][n + 1];
		c[0][0] = 1;
		for (int i = 1; i <= n; i++) {
			c[i][0] = 1;
			for (int j = 1; j <= i; j++) {
				c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % m;
			}
		}
		int[] tp = new int[n * n];
		tp[0] = 1;
		for (int i = 1; i < n * n; i++) {
			tp[i] = (2 * tp[i - 1]) % m;
		}
		int[] ans = new int[n + 1];

		ans[0] = 1;
		for (int i = 1; i <= n; i++) {
			for (int k = 1; k <= i; k++) {
				int tmp = (c[i][k] * tp[k * (i - k)]) % m;
				tmp = (tmp * ans[i - k]) % m;
				if (k % 2 == 1) {
					ans[i] += tmp;
					ans[i] %= m;
				} else {
					ans[i] += m - tmp;
					ans[i] %= m;
				}
			}
		}

		return ans[n];
	}
    
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("graph.in"));
        PrintWriter out = new PrintWriter("graph.out");

        int n = in.nextInt();

        genPrimes();

        int[] answer = new int[pCnt];

        for (int i = 0; i < pCnt; i++) {
			answer[i] = calculate(n, primes[i]);        	
        }

        out.println(restore(primes, answer));
        out.close();
    }

}
