import java.util.Scanner;
import java.io.File;
import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.math.BigInteger;

/**
 * Author: Pavel Mavrin
 */
public class graph_pm {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("graph.in"));
        PrintWriter out = new PrintWriter("graph.out");

        int n = in.nextInt();

        BigInteger[][] c = new BigInteger[n + 1][];
        for (int i = 0; i <= n; i++) {
            c[i] = new BigInteger[i + 1];
            c[i][0] = BigInteger.ONE;
            c[i][i] = BigInteger.ONE;
            for (int j = 1; j < i; j++) {
                c[i][j] = c[i - 1][j - 1].add(c[i - 1][j]);
            }
        }

        BigInteger[][] d = new BigInteger[n + 1][];
        for (int i = 0; i <= n; i++) {
            d[i] = new BigInteger[i + 1];
        }

        d[0][0] = BigInteger.ONE;

        for (int i = 1; i <= n; i++) {
            d[i][0] = BigInteger.ZERO;
            for (int j = 1; j <= i; j++) {
                int ii = i - j;
                //2^j
                BigInteger a = BigInteger.valueOf(2).pow(j);
                //2^j - 1
                BigInteger b = a.subtract(BigInteger.ONE);
                BigInteger s = BigInteger.ZERO;
                for (int jj = 0; jj <= ii; jj++) {
                    //s += d[ii][jj] * (2^j-1)^jj * (2^j)*(ii-jj)
                    s = s.add(d[ii][jj].multiply(b.pow(jj).multiply(a.pow(ii - jj))));
                }
                d[i][j] = s.multiply(c[i][j]);
            }
        }
        BigInteger s = BigInteger.ZERO;
        for (int i = 0; i <= n; i++) {
            s = s.add(d[n][i]);
        }

        out.println(s);
        out.close();

    }

}
