import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class graph_rs implements Runnable {
    private Scanner in;
    private PrintWriter out;
    
    private BigInteger[][] c;
    private BigInteger[] ans;
    
    private void solve() throws IOException {
        in = new Scanner(new File("graph.in"));
        out = new PrintWriter(new File("graph.out"));
        
        int n = in.nextInt();
        c = new BigInteger[n + 1][n + 1];
        for (int i = 0; i <= n; i++) {
            c[i][0] = BigInteger.ONE;
            c[i][i] = BigInteger.ONE;
            for (int j = 1; j < i; j++) {
                c[i][j] = c[i - 1][j - 1].add(c[i - 1][j]);
            }
        }
        
        ans = new BigInteger[n + 1];
        ans[0] = BigInteger.ONE;
        for (int i = 1; i <= n; i++) {
            ans[i] = BigInteger.ZERO;
            for (int j = 1; j <= i; j++) {
                BigInteger cur = c[i][j].multiply(BigInteger.ONE.shiftLeft(j * (i - j))).multiply(ans[i - j]);
                if (j % 2 == 0) {
                    cur = cur.negate();
                }
                ans[i] = ans[i].add(cur);
            }
        }
        
        out.println(ans[n]);
        in.close();
        out.close();
    }
    
    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Thread(new graph_rs()).start();
    }
}
