import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class love_dp implements Runnable {

	private static final double INF = 1e20;
	private PrintWriter out;
	private Scanner in;

	public love_dp(String file) {
		try {
			in = new Scanner(new File(file + ".in"));
			out = new PrintWriter(new File(file + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(239);
		}
	}

	public static void main(String[] args) {
		new Thread(new love_dp("love")).start();
	}

	public void run() {
		try {
			int[] x = new int[4];
			int[] y = new int[4];
			for (int i = 0; i < 4; i++) {
				x[i] = in.nextInt();
				y[i] = in.nextInt();
			}
			int[] vx = new int[2];
			int[] vy = new int[2];
			for (int i = 0; i < 2; i++) {
				vx[i] = in.nextInt();
				vy[i] = in.nextInt();
			}
			double answer = INF;
			answer = Math.min(answer, solve(x[0], y[0], x[1], y[1], x[2], y[2], vx[1] - vx[0], vy[1] - vy[0]));
			answer = Math.min(answer, solve(x[0], y[0], x[1], y[1], x[3], y[3], vx[1] - vx[0], vy[1] - vy[0]));
			answer = Math.min(answer, solve(x[2], y[2], x[3], y[3], x[0], y[0], vx[0] - vx[1], vy[0] - vy[1]));
			answer = Math.min(answer, solve(x[2], y[2], x[3], y[3], x[1], y[1], vx[0] - vx[1], vy[0] - vy[1]));
			if (answer > INF / 2) {
				out.println(-1);
			} else {
				out.format(Locale.US, "%.5f", answer);
			}
		} finally {
			out.close();
		}
	}

	private double solve(int x1, int y1, int x2, int y2, int x, int y, int vx, int vy) {
		int a = -vy;
		int b = vx;
		int c = -(a * x + b * y);
		if (Math.signum(a * x1 + b * y1 + c) * Math.signum(a * x2 + b * y2 + c) > 0) {
			return INF;
		}
		a = y2 - y1;
		b = x1 - x2;
		c = -(a * x1 + b * y1);
		if (a * vx + b * vy == 0) {
			double[] t = new double[2];
			t[0] = 1.0 * (x1 - x) / vx;
			t[1] = 1.0 * (x2 - x) / vx;
			if (t[0] < 0) {
				t[0] = INF;
			}
			if (t[1] < 0) {
				t[1] = INF;
			}
			return Math.min(t[0], t[1]);
		}
		double t = -1.0 * (a * x + b * y + c) / (a * vx + b * vy);
		if (t < 0) {
			return INF;
		}
		return t;
	}
}
