import java.util.*;
import java.io.*;

public class love_ia implements Runnable {
	
	private static final double INF = 1e100;
	private Scanner in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	class Segment {
		Vector a, b;
		
		Segment(Scanner in) {
			a = new Vector(in);
			b = new Vector(in);
		}

		public Segment(Vector v1, Vector v2) {
			a = v1;
			b = v2;
		}
	}
	
	class Vector {
		long x, y;
		
		public Vector(Scanner in) {
			x = in.nextInt();
			y = in.nextInt();
		}

		public Vector() {}
	}
	
	class Line {
		long a, b, c;
		
		public Line(Segment s) {
			a = s.a.y - s.b.y;
			b = s.b.x - s.a.x;
			c = - (a * s.a.x + b * s.a.y);
		}

		public long dist(Vector p) {
			return a * p.x + b * p.y + c;
		}		
	}
	

	private void solve() throws Exception {
		Locale.setDefault(Locale.US);
		in = new Scanner(new FileReader("love.in"));
		out = new PrintWriter("love.out");
		Segment s1 = new Segment(in);
		Segment s2 = new Segment(in);
		Vector v1 = new Vector(in);
		Vector v2 = new Vector(in);
		in.close();
		
		Vector v12 = new Vector();
		v12.x = v1.x - v2.x;
		v12.y = v1.y - v2.y;
		if ((v12.x == 0) && (v12.y == 0)) {
			out.println(-1);
			out.close();
			return;
		}
		
		Vector v21 = new Vector();
		v21.x = -v12.x;
		v21.y = -v12.y;
		
		double t1 = calc(s1.a, s2, v12);
		double t2 = calc(s1.b, s2, v12);
		double t3 = calc(s2.a, s1, v21);
		double t4 = calc(s2.b, s1, v21);
		
		double t = Math.min(Math.min(t1, t2), Math.min(t3, t4));
		if (t == INF) {
			out.println(-1);
		} else {
			out.println(t);
		}
		
		out.close();
	}

	private double calc(Vector p, Segment s, Vector v) {
		Line l = new Line(s);
		long d = l.a * v.x + l.b * v.y;
		if (d == 0) {
			if (l.dist(p) == 0) {
				double t1 = calc1(p, s.a, v);
				double t2 = calc1(p, s.b, v);
				return Math.min(t1, t2);
			} else {
				return INF;
			}
		}
		double t = ((double) (-l.dist(p))) / d;
		if (t < 0) {
			
			return INF;
		}
		
		Vector p2 = new Vector();
		p2.x = p.x + v.x;
		p2.y = p.y + v.y;
		Line l2 = new Line(new Segment(p, p2));
		long d1 = l2.dist(s.a);
		long d2 = l2.dist(s.b);
		if ((d1 != 0) && (d2 != 0) && ((d1 > 0) == (d2 > 0))) {
			return INF;
		} else {
			return t;
		}
	}

	private double calc1(Vector p1, Vector p2, Vector v) {
		double res;
		if (p1.x == p2.x) {
			res = ((double) (p2.y - p1.y)) / v.y;
		} else {
			res = ((double) (p2.x - p1.x)) / v.x;
		}
		return res > 0 ? res : INF;
	}

	public static void main(String[] args) {
		new Thread(new love_ia()).start();
	}

}
