import java.util.Scanner;
import java.io.File;
import java.io.PrintWriter;
import java.io.FileNotFoundException;
import java.awt.geom.Point2D;
import java.awt.geom.Line2D;

/**
 * Author: Pavel Mavrin
 */
public class love_pm {

    public static void main(String[] args) throws FileNotFoundException {

        Scanner in = new Scanner(new File("love.in"));
        PrintWriter out = new PrintWriter("love.out");

        Line2D a = new Line2D.Double(
                new Point2D.Double(in.nextInt(), in.nextInt()),
                new Point2D.Double(in.nextInt(), in.nextInt())
        );

        Line2D b = new Line2D.Double(
                new Point2D.Double(in.nextInt(), in.nextInt()),
                new Point2D.Double(in.nextInt(), in.nextInt())
        );

        Point2D va = new Point2D.Double(in.nextInt(), in.nextInt());
        Point2D vb = new Point2D.Double(in.nextInt(), in.nextInt());

        Point2D vab = new Point2D.Double(va.getX() - vb.getX(), va.getY() - vb.getY());
        Point2D vba = new Point2D.Double(vb.getX() - va.getX(), vb.getY() - va.getY());

        double t = Math.min(
                Math.min(getTime(a.getP1(), vab, b), getTime(a.getP2(), vab, b)),
                Math.min(getTime(b.getP1(), vba, a), getTime(b.getP2(), vba, a)));

        if (t == Double.POSITIVE_INFINITY) {
            out.println(-1);
        } else {
            out.println(t);
        }
        out.close();
    }

    private static double getTime(Point2D a, Point2D v, Line2D b) {
        double r = 1e10;
        double l = 0;
        double m = (l + r) * 0.5;
        if (!intersect(a, v, b, r)) {
            return Double.POSITIVE_INFINITY;
        }
        while (m != l && m != r) {
            if (intersect(a, v, b, m)) {
                r = m;
            } else {
                l = m;
            }
            m = (r + l) * 0.5;
        }
        return r;
    }

    private static boolean intersect(Point2D a, Point2D v, Line2D b, double t) {
        return b.intersectsLine(a.getX(), a.getY(), a.getX() + v.getX() * t, a.getY() + v.getY() * t);
    }

}
