import java.io.*;
import java.util.*;

public class matches_md implements Runnable {
	class Match {
		int x1, y1, x2, y2;
		
		public Match(Scanner in) {
			x1 = in.nextInt();
			y1 = in.nextInt();
			x2 = in.nextInt();
			y2 = in.nextInt();
			if (x1 > x2 || (x1 == x2 && y1 > y2)) {
				int t = x1; x1 = x2; x2 = t;
				t = y1; y1 = y2; y2 = t;
			}
		}

		public Move tryMove(Match that) {
			if (x2 - x1 != that.x2 - that.x1 || y2 - y1 != that.y2 - that.y1)
				return null;
			return new Move(that.x1 - x1, that.y1 - y1);
		}
	}
	
	class Move {
		int dx, dy;
		
		public Move(int dx, int dy) {
			this.dx = dx;
			this.dy = dy;
		}
		
		@Override
		public boolean equals(Object obj) {
			Move that = (Move) obj;
			return dx == that.dx && dy == that.dy;
		}
		
		@Override
		public int hashCode() {
			return (dx << 16) ^ dy;
		}
	}
	
	private Scanner in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new Scanner(new File("matches.in"));
		out = new PrintWriter("matches.out");
		int n = in.nextInt();
		Match[] a = new Match[n];
		Match[] b = new Match[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Match(in);
		}
		for (int i = 0; i < n; i++) {
			b[i] = new Match(in);
		}
		HashMap<Move, Integer> goodMoves = new HashMap<Move, Integer>();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				Move move = a[i].tryMove(b[j]);
				if (move == null)
					continue;
				if (!goodMoves.containsKey(move))
					goodMoves.put(move, 1);
				else
					goodMoves.put(move, goodMoves.get(move) + 1);
			}
		}
		int bestMove = 0;
		for (int v : goodMoves.values()) {
			bestMove = Math.max(bestMove, v);
		}
		out.println(n - bestMove);
		in.close();
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new matches_md()).start();
	}
}
