import java.io.*;
import java.util.*;

public class matches_md_assert implements Runnable {
	class Match {
		int x1, y1, x2, y2;
		
		public Match(Scanner in) {
			x1 = in.nextInt();
			y1 = in.nextInt();
			x2 = in.nextInt();
			y2 = in.nextInt();
			if (x1 > x2 || (x1 == x2 && y1 > y2)) {
				int t = x1; x1 = x2; x2 = t;
				t = y1; y1 = y2; y2 = t;
			}
		}

		public Move tryMove(Match that) {
			if (x2 - x1 != that.x2 - that.x1 || y2 - y1 != that.y2 - that.y1)
				return null;
			return new Move(that.x1 - x1, that.y1 - y1);
		}

		public int getLengthSquared() {
		    return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
		}

		private int orientation(int x3, int y3) {
		    int area = x1 * y2 - x2 * y1 +
		               x2 * y3 - x3 * y2 +
		               x3 * y1 - x1 * y3;
		    if (area < 0)
		        return -1;
		    if (area > 0)
		        return 1;
		    return 0;
		}

		public void checkOverlapping(Match that) {
		    if (orientation(that.x1, that.y1) != 0)
		        return;
		    if (orientation(that.x2, that.y2) != 0)
		        return;
		    int z1 = x1;
		    int z2 = x2;
		    int z3 = that.x1;
		    int z4 = that.x2;
		    if (z1 == z2) {
		        z1 = y1;
		        z2 = y2;
		        z3 = that.y1;
		        z4 = that.y2;
		    }
		    if (z1 > z2) {
		        int t = z1;
		        z1 = z2;
		        z2 = t;
		    }
		    if (z3 > z4) {
		        int t = z3;
		        z3 = z4;
		        z4 = t;
		    }
		    if (Math.min(z2, z4) <= Math.max(z1, z3))
		        return;
		    out.println("ERROR : overlapping matches");
		    out.println(this);
		    out.println(that);
		    out.close();
		    System.exit(1);
		}

		@Override
		public String toString() {
		    return "(" + x1 + ", " + y1 + ") -- (" + x2 + ", " + y2 + ")";
		}
	}
	
	class Move {
		int dx, dy;
		
		public Move(int dx, int dy) {
			this.dx = dx;
			this.dy = dy;
		}
		
		@Override
		public boolean equals(Object obj) {
			Move that = (Move) obj;
			return dx == that.dx && dy == that.dy;
		}
		
		@Override
		public int hashCode() {
			return (dx << 16) ^ dy;
		}
	}
	
	private Scanner in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new Scanner(new File("matches.in"));
		out = new PrintWriter("matches.out");
		int n = in.nextInt();
		Match[] a = new Match[n];
		Match[] b = new Match[n];
		int[] la = new int[n];
		int[] lb = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Match(in);
			la[i] = a[i].getLengthSquared();
		}
		for (int i = 0; i < n; i++) {
			b[i] = new Match(in);
			lb[i] = b[i].getLengthSquared();
		}
		if (in.hasNext()) {
		    out.println("ERROR : extra info in input file");
		    out.close();
		    System.exit(1);
		}
		Arrays.sort(la);
		Arrays.sort(lb);
		if (!Arrays.equals(la, lb)) {
		    out.println("ERROR : sets of matches do not equal");
		    out.close();
		    System.exit(1);
        }
		HashMap<Move, Integer> goodMoves = new HashMap<Move, Integer>();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < i; j++) {
			    a[i].checkOverlapping(a[j]);
			    b[i].checkOverlapping(b[j]);
			}
			for (int j = 0; j < n; j++) {
				Move move = a[i].tryMove(b[j]);
				if (move == null)
					continue;
				if (!goodMoves.containsKey(move))
					goodMoves.put(move, 1);
				else
					goodMoves.put(move, goodMoves.get(move) + 1);
			}
		}
		int bestMove = 0;
		for (int v : goodMoves.values()) {
			bestMove = Math.max(bestMove, v);
		}
		out.println(n - bestMove);
		in.close();
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new matches_md_assert()).start();
	}
}
