import java.util.Scanner;
import java.util.Map;
import java.util.HashMap;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

/**
 * Author: Pavel Mavrin
 */
public class matches_pm {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("matches.in"));
        PrintWriter out = new PrintWriter(new File("matches.out"));

        int n = in.nextInt();
        Segment[] a = new Segment[n];
        Segment[] b = new Segment[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Segment(
                    new Point(in.nextInt(), in.nextInt()),
                    new Point(in.nextInt(), in.nextInt())
            );
        }
        for (int i = 0; i < n; i++) {
            b[i] = new Segment(
                    new Point(in.nextInt(), in.nextInt()),
                    new Point(in.nextInt(), in.nextInt())
            );
        }
        Map<Point, Integer> count = new HashMap<Point, Integer>();
        int max = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                Point v = a[i].vectorTo(b[j]);
                if (v != null) {
                    Integer q = count.get(v);
                    if (q == null) {
                        count.put(v, 1);
                    } else {
                        count.put(v, q + 1);
                    }
                    max = Math.max(max, count.get(v));
                }
            }
        }

        out.println(n - max);
        out.close();
    }

    static class Segment {
        Point a;
        Point b;

        public Segment(Point a, Point b) {
            if (a.x < b.x || (a.x == b.x && a.y < b.y)) {
                this.a = a;
                this.b = b;
            } else {
                this.b = a;
                this.a = b;
            }
        }

        Point vectorTo(Segment s) {
            Point v1 = a.vectorTo(s.a);
            Point v2 = b.vectorTo(s.b);
            if (v1.equals(v2)) {
                return v1;
            } else {
                return null;
            }
        }
    }

    static class Point {
        int x;
        int y;

        public Point(int x, int y) {
            this.x = x;
            this.y = y;
        }

        public Point vectorTo(Point p) {
            return new Point(p.x - x, p.y - y);
        }


        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Point point = (Point) o;

            return x == point.x && y == point.y;

        }

        public int hashCode() {
            int result;
            result = x;
            result = 31 * result + y;
            return result;
        }


        public String toString() {
            return "(" + x + ", " + y + ")";
        }
    }
}
