import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class maze_dp implements Runnable {

	private PrintWriter out;
	private Scanner in;

	public maze_dp(String file) {
		try {
			in = new Scanner(new File(file + ".in"));
			out = new PrintWriter(new File(file + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(239);
		}
	}

	public static void main(String[] args) {
		new Thread(new maze_dp("maze")).start();
	}

	public void run() {
		try {
			int[] dh = new int[] {0, 0, 0, 0, 1};
			int[] dr = new int[] {1, -1, 0, 0, 0};
			int[] dc = new int[] {0, 0, 1, -1, 0};
			
			int hhh = in.nextInt();
			int height = in.nextInt();
			int width = in.nextInt();
			int startH = 0;
			int startR = -1;
			int startC = -1;
			int finishH = hhh - 1;
			int finishR = -1;
			int finishC = -1;
			char[][][] maze = new char[hhh][height][];
			for (int h = 0; h < hhh; h++) {
				in.nextLine();
				for (int r = 0; r < height; r++) {
					maze[h][r] = in.nextLine().trim().toCharArray();
					for (int c = 0; c < width; c++) {
						if (maze[h][r][c] == '1') {
							maze[h][r][c] = '.';
							startR = r;
							startC = c;
						}
						if (maze[h][r][c] == '2') {
							maze[h][r][c] = '.';
							finishR = r;
							finishC = c;
						}
					}
				}
			}
			Queue<Position> queue = new LinkedList<Position>();
			HashMap<Position, Integer> dist = new HashMap<Position, Integer>();
			Position start = new Position(startH, startR, startC);
			queue.add(start);
			dist.put(start, 0);
			while (!queue.isEmpty()) {
				Position p = queue.poll();
				for (int k = 0; k < 5; k++) {
					int h = p.h + dh[k];
					int r = p.r + dr[k];
					int c = p.c + dc[k];
					if (h < 0 || h >= hhh ||
							r < 0 || r >= height ||
							c < 0 || c >= width) {
						continue;
					}
					if (maze[h][r][c] != '.') {
						continue;
					}
					Position p2 = new Position(h, r, c);
					if (dist.get(p2) == null) {
						queue.add(p2);
						dist.put(p2, dist.get(p) + 1);
					}
				}
			}
			Position finish = new Position(finishH, finishR, finishC);
			Integer answer = dist.get(finish);
			if (answer == null) {
				System.exit(239);
			} else {
				out.println(answer * 5);
			}
		} finally {
			out.close();
		}
	}
	
	static class Position {
		int h;
		int r;
		int c;
		
		Position(int hh, int rr, int cc) {
			h = hh;
			r = rr;
			c = cc;
		}
		
		public int hashCode() {
			return Arrays.hashCode(new int[] {h, r, c});
		}
		
		public boolean equals(Object o) {
			Position p = (Position) o;
			return h == p.h && r == p.r && c == p.c;
		}
	}
}
