import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class phones_dp_good_wo43 implements Runnable {

	private PrintWriter out;
	private Scanner in;
	private int ans;
	private String answer;
	private String phone;

	
	private Row[] marks = new Row[] {
		new Row("aa", 2),	
		new Row("aba", 2),	
		new Row("aab", 2),	
		new Row("abb", 2),	
		new Row("aaa", 3),	
		new Row("abac", 2),	
		new Row("baca", 2),	
		new Row("abab", 3),	
//		new Row("aabb", 3),	
		new Row("abba", 4),	
		new Row("baaa", 3),	
		new Row("abaa", 3),	
		new Row("aaba", 3),	
		new Row("aaab", 3),	
		new Row("aaaa", 5)	
	};
	
	public phones_dp_good_wo43(String file) {
		try {
			in = new Scanner(new File(file + ".in"));
			out = new PrintWriter(new File(file + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(239);
		}
	}

	public static void main(String[] args) {
		new Thread(new phones_dp_good_wo43("phones")).start();
	}

	public void run() {
		try {
			phone = in.nextLine();
			ans = -1;
			answer = null;
			relax(2, 2, 3);
			relax(2, 3, 2);
			relax(3, 2, 2);
			relax(3, 4);
			relax(4, 3);
			out.println(answer);
			out.println(ans);
		} finally {
			out.close();
		}
	}
	
	private void relax(int i, int j, int k) {
		String[] str = new String[] {
				phone.substring(0, i),
				phone.substring(i, i + j),
				phone.substring(i + j, i + j + k)
		};
		int tmp = getMarks(str[0]) + getMarks(str[1]) + getMarks(str[2]);
		if (ans < tmp) {
			ans = tmp;
			answer = str[0] + "-" + str[1] + "-" + str[2];
		}
	}

	private void relax(int i, int j) {
		String[] str = new String[] {
				phone.substring(0, i),
				phone.substring(i, i + j)
		};
		int tmp = getMarks(str[0]) + getMarks(str[1]);
		if (ans < tmp) {
			ans = tmp;
			answer = str[0] + "-" + str[1];
		}
	}

	private int getMarks(String string) {
		int result = 0;
		for (Row r: marks) {
			if (r.same(string)) {
				result += r.cost;
			}
		}
		return result;
	}

	static class Position {
		int h;
		int r;
		int c;
		
		Position(int hh, int rr, int cc) {
			h = hh;
			r = rr;
			c = cc;
		}
		
		public int hashCode() {
			return Arrays.hashCode(new int[] {h, r, c});
		}
		
		public boolean equals(Object o) {
			Position p = (Position) o;
			return h == p.h && r == p.r && c == p.c;
		}
	}
	
	static class Row {
		String str;
		int cost;
		
		Row(String s, int c) {
			str = s;
			cost = c;
		}
		
		boolean same(String s) {
			if (str.length() != s.length()) {
				return false;
			}
			for (int i = 0; i < str.length(); i++) {
				for (int j = 0; j < str.length(); j++) {
					char str1 = str.charAt(i);
					char str2 = str.charAt(j);
					char s1 = s.charAt(i);
					char s2 = s.charAt(j);
					if ((str1 == str2 ^ s1 == s2)) {
						return false;
					}
				}
			}
			return true;
		}
	}
}
