#include <iostream>
#include <sstream>
#include <cstdio>
#include <vector>

using namespace std;

#define PB push_back
typedef long long LL;

LL Mul( LL a, LL b, LL p )
{
  LL k = (LL)((long double)a * b / p);
  LL r = a * b - k * p;
  while (r < 0) r += p;
  while (r >= p) r -= p;
  return r;
}

LL Pow( LL x, LL n, LL p )
{
  LL r = 1;
  while (n)
  {
    if (n & 1)
      r = Mul(r, x, p);
    x = Mul(x, x, p);
    n >>= 1;
  }  
  return r;
}

int IsP( LL a )
{
  return Pow(2, a - 1, a) == 1;
}

#define DN 18
int main( void )
{
  freopen ("primesum.in", "rt", stdin);
  freopen ("primesum.out", "wt", stdout);
  LL n, x, p[DN + 1] = {2};
  int i;
  for (x = 10, i = 1; i <= DN; i++)
  {
    p[i] = x;
    while (!IsP(p[i]))
      p[i]++;
    x *= 10;
  }

  vector <LL> res;
  scanf("%I64d", &n);
  while (n > 3)
  {
    i = 0;
    while (i < DN && (p[i + 1] == n || p[i + 1] + 2 <= n))
      i++;
    res.PB(p[i]);
    n -= p[i];
  }
  if (n)
    res.PB(n);    
  printf("%I64d", res[0]);
  for (i = 1; i < res.size(); i++)
    printf("+%I64d", res[i]);
  return 0;
}
