{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program macro;
const MaxN = 8000;  MaxX = 32000;
      PW0 = 8192;  PW1 = 16384;
type segm = record yv : longint; xa, xb : word end;
     psegm = ^segm;
     uarr = array [1..16383] of integer;
     puarr = ^uarr;

var
  U, V   : puarr;
  shift  : longint;
  ts     : integer;

procedure init_model;
begin
  new (U);  fillchar (U^, sizeof(uarr), 0);
  new (V);  fillchar (V^, sizeof(uarr), 0);
end;

function localbest (var x0 : integer) : integer;
var i, b : integer;
begin
  b := V^[1];  i := 1;
{  writeln ('<', ts, ',', V^[1],'>');  write ('LB:', b+ts, ',');}
  localbest := b + ts;
  while i < PW0 do begin
    i := i shl 1;
    if V^[i] < b then begin dec(b, U^[i]); inc (i) end
  end;
  if (b <> 0) and (b <> U^[i]) then runerror (239);
  x0 := ((i + shift) shr 1) - (PW0 div 2 + MaxX);
{  writeln (i,',',x0);}
end;

procedure dump;
var i : longint; s : integer;
begin
  for i := PW0 to PW1-1 do begin
    s := U^[i];
    if s <> 0 then write (i-PW0+shift-MaxX*2,'(',s,') ')
  end;
  writeln
end;

procedure ins_x (x : longint; d : integer);
var t, z : integer;
begin
{  writeln ('ins(',x-MaxX*2:3,',',d:2,')');}
  dec (x, shift);
  if x < 0 then begin inc (ts, d); exit end;
  if x >= PW0 then exit;
  inc (x, PW0);
  inc (U^[x], d);
  if U^[x] > 0 then V^[x] := U^[x] else V^[x] := 0;
  repeat
    x := x shr 1;
    inc (U^[x], d);
    t := U^[x*2] + V^[x*2+1];
    z := V^[x*2];
    if t < z then t := z;
    V^[x] := t
  until x = 1;
{  write ('[',t,']  ');  dump;}
end;

var
  N   : integer;
  S   : array [1..MaxN*2] of psegm;

procedure qsort (a, b : integer);
var h : longint;  i, j : integer; t : psegm;
begin
  if a >= b then exit;
  h := S[(a + b) shr 1]^.yv;
  i := a;  j := b;
  repeat
    while S[i]^.yv < h do inc (i);
    while S[j]^.yv > h do dec (j);
    if i <= j then begin t:=S[i]; S[i]:=S[j]; S[j]:=t; inc(i); dec(j) end
  until i > j;
  qsort (a, i-1);
  qsort (i, b)
end;

var
  i, best, best2, xc, xr  : integer;
  x1, y1, x2, y2, yc, yr  : longint;
begin
  assign (input, 'windows.in');  reset (input);
  assign (output, 'windows.out');  rewrite (output);
  read (N);
  if (N <= 0) or (N > MaxN) then runerror (239);
  for i := 1 to N do begin
    read (x1, y1, x2, y2);
    if (x1 < -MaxX) or (x2 <= x1) or (x2 > MaxX) then runerror (239);
    if (y1 < -MaxX) or (y2 <= y1) or (y2 > MaxX) then runerror (239);
    inc (x1, MaxX);  inc (y1, MaxX);  inc (x2, MaxX);  inc (y2, MaxX);
    new (S[2*i-1]);  new (S[2*i]);
    with S[2*i-1]^ do begin yv:=y1 shl 1;       xa:=x1; xb:=x2 end;
    with S[2*i]^   do begin yv:=succ(y2 shl 1); xa:=x2; xb:=x1 end
  end;
  qsort (1, N shl 1);
  best := -1;
  init_model;
  shift := 0;
  repeat
    yc := -MaxLongInt;
    for i := 1 to N shl 1 do with S[i]^ do begin
      if yc < yv then begin
        if not odd (yc) then begin
          best2 := localbest (xc);
          if best2 > best then begin yr := yc;  xr := xc;  best := best2 end
        end;
        yc := yv
      end;
      x1 := xa;  x2 := xb;
      if x1 < x2 then
           begin ins_x (x1 shl 1, 1);  ins_x (succ(x2 shl 1), -1) end
      else begin ins_x (x2 shl 1, -1); ins_x (succ(x1 shl 1), 1) end;
    end;
    if (ts <> 0) or (V^[1] <> 0) then runerror (239);
    inc (shift, PW0)
  until shift = 131072;
  writeln (best);
  writeln (xr, ' ', (yr shr 1)-MaxX)
end.
