{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program macro;
const MaxN = 8000;  MaxX = 32000;
type segm = record yv : longint; xa, xb : word end;
     psegm = ^segm;
     xarr = array [1..MaxN*2] of longint;
     sarr = array [1..MaxN*2] of integer;

var
  L      : integer;
  Z      : ^xarr;
  W      : ^sarr;

function localbest (var x0 : integer) : integer;
var i, u, b : integer;
begin
  b := -1;  u := 0;
  for i := 1 to L do begin
    inc (u, W^[i]);
    if u < 0 then runerror (239);
    if u > b then begin b := u;
      x0 := (Z^[i] shr 1) - MaxX end
  end;
  if u <> 0 then runerror (239);
  localbest := b
end;

procedure dump;
var i : integer;
begin
  for i := 1 to L do write (Z^[i],'(',W^[i],') '); writeln
end;

procedure ins_x (x : longint; v : integer);
var i, j, k : integer;
begin
{  writeln ('ins(',x:3,',',v:2,')');}
  i := 0;  j := L+1;
  while j - i > 1 do begin
    k := (i + j) shr 1;
    if Z^[k] <= x then i := k else j := k
  end;
  if (i > 0) and (Z^[i] = x) then begin
    inc (W^[i], v);
    if W^[i] = 0 then begin
      {for j := i to L-1 do begin Z^[j] := Z^[j+1];  W^[j] := W^[j+1] end}
      move (Z^[i+1], Z^[i], (L-i) shl 2);
      move (W^[i+1], W^[i], (L-i)*sizeof(integer));
      dec (L)
    end
  end else begin
    {for j := L downto i+1 do begin Z^[j+1] := Z^[j];  W^[j+1] := W^[j] end}
    move (Z^[i+1], Z^[i+2], (L-i) shl 2);
    move (W^[i+1], W^[i+2], (L-i)*sizeof(integer));
    inc (L);  if L > MaxN*2 then runerror (239);
    Z^[i+1] := x;
    W^[i+1] := v
  end;
{  dump;}
end;

var
  N   : integer;
  S   : array [1..MaxN*2] of psegm;

procedure qsort (a, b : integer);
var h : longint;  i, j : integer; t : psegm;
begin
  if a >= b then exit;
  h := S[(a + b) shr 1]^.yv;
  i := a;  j := b;
  repeat
    while S[i]^.yv < h do inc (i);
    while S[j]^.yv > h do dec (j);
    if i <= j then begin t:=S[i]; S[i]:=S[j]; S[j]:=t; inc(i); dec(j) end
  until i > j;
  qsort (a, i-1);
  qsort (i, b)
end;



var
  i, best, best2, xc, xr  : integer;
  x1, y1, x2, y2, yc, yr  : longint;
begin
  assign (input, 'windows.in');  reset (input);
  assign (output, 'windows.out');  rewrite (output);
  read (N);
  if (N <= 0) or (N > MaxN) then runerror (239);
  for i := 1 to N do begin
    read (x1, y1, x2, y2);
    if (x1 < -MaxX) or (x2 <= x1) or (x2 > MaxX) then runerror (239);
    if (y1 < -MaxX) or (y2 <= y1) or (y2 > MaxX) then runerror (239);
    inc (x1, MaxX);  inc (y1, MaxX);  inc (x2, MaxX);  inc (y2, MaxX);
    new (S[2*i-1]);  new (S[2*i]);
    with S[2*i-1]^ do begin yv:=y1 shl 1;       xa:=x1; xb:=x2 end;
    with S[2*i]^   do begin yv:=succ(y2 shl 1); xa:=x2; xb:=x1 end
  end;
  qsort (1, N shl 1);
  best := -1;  yc := -MaxLongInt;
  L := 0;
  new (Z);  new (W);
  for i := 1 to N shl 1 do with S[i]^ do begin
    if yc < yv then begin
      if not odd (yc) then begin
        best2 := localbest (xc);
        if best2 > best then begin yr := yc;  xr := xc;  best := best2 end
      end;
      yc := yv
    end;
    x1 := xa;  x2 := xb;
    if x1 < x2 then
         begin ins_x (x1 shl 1, 1);  ins_x (succ(x2 shl 1), -1) end
    else begin ins_x (x2 shl 1, -1); ins_x (succ(x1 shl 1), 1) end;
  end;
  if L <> 0 then runerror (239);
  writeln (best);
  writeln (xr, ' ', (yr shr 1)-MaxX)
end.
