#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "rect1"

const int MinN = 1, MaxN = 5000, MinC = 0, MaxC = 32000;
int x [MaxN], y [MaxN];

int sp (int x0, int y0, int x1, int y1, int x2, int y2)
{
 return (x1 - x0) * (x2 - x0) + (y1 - y0) * (y2 - y0);
}

bool rect (int i, int j, int k, int l)
{
/*
 printf ("(%d %d), (%d %d), (%d %d), (%d %d)\n",
  x[i], y[i], x[j], y[j], x[k], y[k], x[l], y[l]);
*/
 return sp (x[j], y[j], x[i], y[i], x[k], y[k]) == 0 &&
        sp (x[k], y[k], x[j], y[j], x[l], y[l]) == 0 &&
        sp (x[l], y[l], x[k], y[k], x[i], y[i]) == 0;
}

int main (void)
{
 int i, j, k, l, n, sum;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  for (i = 0; i < n; i++)
  {
   scanf (" %d %d", &x[i], &y[i]);
   assert (x[i] >= MinC && x[i] <= MaxC);
   assert (y[i] >= MinC && y[i] <= MaxC);
  }
  sum = 0;
  for (i = 0; i < n - 3; i++)
   for (j = i + 1; j < n - 2; j++)
    for (k = j + 1; k < n - 1; k++)
     for (l = k + 1; l < n; l++)
      if (rect (i, j, k, l)) sum++;
      else if (rect (i, j, l, k)) sum++;
      else if (rect (i, k, j, l)) sum++;
  printf ("%d\n", sum);
 }
 return 0;
}
