#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "rect1"

const int MinN = 1, MaxN = 4063, MinC = 0, MaxC = 32000,
 MaxH = 16777216, AndH = MaxH - 1, MoveH = 823, MaxRatio = 32197;
const long double Mult2 = 12345123.0;
typedef long long int64;
int x [MaxN], y [MaxN];

int count [MaxH];
short p [MaxH], q [MaxH];

int main (void)
{
 int i, j, n, h, sum;
 int pt, qt, lent, coordt, coordit;
 double coordn;
 bool sign;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  for (i = 0; i < n; i++)
  {
   scanf (" %d %d", &x[i], &y[i]);
   assert (x[i] >= MinC && x[i] <= MaxC);
   assert (y[i] >= MinC && y[i] <= MaxC);
  }
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
    if (x[i] == x[j] && y[i] == y[j])
     assert (false);
  memset (count, 0, sizeof (count));
  for (i = 0; i < n; i++)
   for (j = 0; j < n; j++)
    if (x[i] < x[j] || x[i] == x[j] && y[i] < y[j])
    {
     pt = x[j] - x[i];
     qt = y[j] - y[i];
     lent = pt * pt + qt * qt;
     coordt = x[i] * pt + y[i] * qt;
     coordn = ((double) coordt) * coordt * Mult2;
     sign = coordt < 0;
     coordit = int ((long long) (coordn / lent));
//     printf ("%lf %d %d\n", double (coordn), lent, coordit);
     if (sign) coordit = -coordit;
     h = (pt * MaxRatio + qt + coordit) & AndH;
     while (count[h])
     {
      if (pt == p[h] && qt == q[h])
       break;
      h = (h + MoveH) & AndH;
     }
     count[h]++;
     p[h] = pt;
     q[h] = qt;
    }
  sum = 0;
  for (h = 0; h < MaxH; h++)
   sum += (count[h] * (count[h] - 1)) >> 1;
  sum >>= 1;
  printf ("%d\n", sum);
 }
 return 0;
}
