#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "rect1"

using namespace std;

const int MinN = 1, MaxN = 4063, MinC = 0, MaxC = 32000,
 MaxH = 8388608, AndH = MaxH - 1, MoveH = 823, MaxRatio = 32197;
typedef long long int64;
int x [MaxN], y [MaxN];

vector <int> list [MaxH];
short p [MaxH], q [MaxH];

int main (void)
{
 int i, j, k, n, h, sum;
 int pt, qt, coordt;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  for (i = 0; i < n; i++)
  {
   scanf (" %d %d", &x[i], &y[i]);
   assert (x[i] >= MinC && x[i] <= MaxC);
   assert (y[i] >= MinC && y[i] <= MaxC);
  }
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
    if (x[i] == x[j] && y[i] == y[j])
     assert (false);
  for (i = 0; i < n; i++)
   for (j = 0; j < n; j++)
    if (x[i] < x[j] && y[i] <= y[j])
    {
     pt = x[j] - x[i];
     qt = y[j] - y[i];
     coordt = x[i] * pt + y[i] * qt;
     h = (pt * MaxRatio + qt) & AndH;
     while (list[h].size ())
     {
      if (pt == p[h] && qt == q[h]) break;
      h = (h + MoveH) & AndH;
     }
     list[h].push_back (coordt);
     p[h] = pt;
     q[h] = qt;
    }
  sum = 0;
  for (h = 0; h < MaxH; h++)
  {
   vector <int> & v = list[h];
   j = v.size ();
   if (j <= 1) continue;
   sort (v.begin (), v.end ());
   k = 1;
   for (i = 1; i < j; i++)
   {
    if (v[i - 1] == v[i])
    {
     k++;
    }
    else
    {
     sum += k * (k - 1);
     k = 1;
    }
   }
   sum += k * (k - 1);
  }
  sum >>= 1;
  printf ("%d\n", sum);
 }
 return 0;
}
