#include <iostream>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)

#define NMAX 10000

int n;
typedef pair<int, int> point;

point p[NMAX];
map<point, vector<int> > lists;

#define x first
#define y second

int gcd(int a, int b) {
	return (a ? gcd(b % a, a) : b);
}

void norm(point &p) {
	int g = gcd(p.x, p.y);
	p.x /= g;
	p.y /= g;
	if (p.y < 0 || (p.y == 0 && p.x < 0)) {
		p.x = -p.x;
		p.y = -p.y;
	}
}

int main() {

	freopen("rect1.in", "rt", stdin);
	freopen("rect1.out", "wt", stdout);

	scanf("%d", &n);
	forn (i, n) {
		scanf("%d %d", &p[i].x, &p[i].y);
	}

	sort(p, p + n);

	int ans = 0;

	forn (i, n) if (i > 2) {
		lists.clear();
		forn (j, i) {
			point dir = point(p[i].y - p[j].y, p[j].x - p[i].x);
			norm(dir);						
			vector<int> it = lists[dir];
			forn (k, it.size()) {
				int nm = it[k];
				point last = point(p[j].x + p[nm].x - p[i].x, p[j].y + p[nm].y - p[i].y);								
				if (binary_search(p, p + (i - 1), last)) ++ans;
			}
			dir = point(p[j].x - p[i].x, p[j].y - p[i].y);
			norm(dir);
			lists[dir].push_back(j);
		}	
	}	

	printf("%d\n", ans);

	return 0;
}