#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

struct tpoint {
	int  x, y;
	friend bool operator ==(tpoint &v1, tpoint &v2);
};

struct tvector {
	int  x, y;
	tvector (int _x, int _y) {
		x = _x;
		y = _y;
	}
	friend bool operator ==(tvector &v1, tvector &v2);
};

bool operator ==(tvector &v1, tvector &v2) {
	return (v1.x == v2.x) && (v1.y == v2.y);
}

bool operator ==(tpoint &v1, tpoint &v2) {
	return (v1.x == v2.x) && (v1.y == v2.y);
}


typedef struct tpoint tpoint;
typedef struct tvector tvector;

int n;
long int answer=0;
vector <tpoint> p;

tvector get_vector(tpoint p1, tpoint p2) {
	tvector v(p2.x - p1.x, p2.y - p1.y);
//	printf("(%d %d) (%d %d) => (%d %d)\n", p1.x, p1.y, p2.x, p2.y, v.x, v.y);
	return v;
}

long int skal(tvector v1, tvector v2) {
	return v1.x * v2.x + v1.y * v2.y;
}

bool is_rect(tpoint p1, tpoint p2, tpoint p3, tpoint p4) {
  tvector v1 = get_vector (p1, p2);
  tvector v2 = get_vector (p4, p3);
  tvector v3 = get_vector (p2, p3);
  tvector v4 = get_vector (p1, p4);
	if (v1 == v2 && v3 == v4 && skal(v1, v3) == 0)
		return true;
	else return false;
}

bool get_is_rect(tpoint p1, tpoint p2, tpoint p3, tpoint p4) {
	return (is_rect(p1, p2, p3, p4) ||
		is_rect(p1, p2, p4, p3) ||
		is_rect(p1, p3, p2, p4) ||
		is_rect(p1, p3, p4, p2) ||
		is_rect(p1, p4, p2, p3) ||
		is_rect(p1, p4, p3, p2) ||

		is_rect(p2, p1, p3, p4) ||
		is_rect(p2, p1, p4, p3) ||
		is_rect(p2, p3, p1, p4) ||
		is_rect(p2, p3, p4, p1) ||
		is_rect(p2, p4, p1, p3) ||
		is_rect(p2, p4, p3, p1) ||

		is_rect(p3, p1, p2, p4) ||
		is_rect(p3, p1, p4, p2) ||
		is_rect(p3, p2, p1, p4) ||
		is_rect(p3, p2, p4, p1) ||
		is_rect(p3, p4, p1, p2) ||
		is_rect(p3, p4, p2, p1) ||

		is_rect(p4, p1, p2, p3) ||
		is_rect(p4, p1, p3, p2) ||
		is_rect(p4, p2, p1, p3) ||
		is_rect(p4, p2, p3, p1) ||
		is_rect(p4, p3, p1, p2) ||
		is_rect(p4, p3, p2, p1));
}

int main() {
	freopen("rect1.in", "r", stdin);
	freopen("rect1.out", "w", stdout);

	scanf("%d", &n);
	p.resize(n);

	for(int i=0; i<n; ++i) {
		scanf("%d %d", &p[i].x, &p[i].y);
	}

	for(int i=0; i<n; ++i) {
		for(int j=i+1; j<n; ++j) {
			for(int k=j+1; k<n; ++k) {
				for(int l=k+1; l<n; ++l) {
					if (get_is_rect(p[i], p[j], p[k], p[l])) 
						answer++;
				}
			}
		}
	}

	printf("%ld", answer);

	return 0;
}