#include <cstdio>
#include <cstdlib>
#include <cstring>

struct tree
{
  int x, y, si, cou;
  tree *l, *r;
};

#define maxt 500010
tree tr[maxt];
int tpos = 0;

tree *NewT( int x, int y )
{
  tree *p = &tr[tpos++];
  p->x = x, p->y = y;
  p->l = p->r = 0;
  p->cou = 1;
  return p;
}

int Si( tree *t )
{
  return t ? t->si : 0;
}

void Calc( tree *t )
{
  if (t)
    t->si = t->cou + Si(t->l) + Si(t->r);
}

int Find( tree *t, int x )
{
  if (!t)
    return 0;
  if (t->x == x)
    t->cou++;
  if (t->x == x || Find((x < t->x ? t->l : t->r), x))
  {
    t->si++;
    return 1;
  }
  return 0;
}

void Split( tree *t, tree **l, tree **r, int x )
{
  if (!t)
    *l = *r = 0;
  else if (x < t->x)
    Split(t->l, l, &t->l, x), *r = t;
  else
    Split(t->r, &t->r, r, x), *l = t;
  Calc(t);
}

void Add( tree **t, int x, int y )
{
  while (*t && (*t)->y < y)
  {
    (*t)->si++;
    if (x < (*t)->x)
      t = &(*t)->l;
    else
      t = &(*t)->r;
  }
  tree *p = NewT(x, y);
  Split(*t, &p->l, &p->r, x);
  Calc(*t = p);
}

void AddTree( tree **t, int x )
{
  if (!Find(*t, x))
    Add(t, x, rand() + (rand() << 15));
}      

void Merge( tree **t, tree *l, tree *r )
{
  if (!l || !r)
    *t = r ? r : l;
  else if (l->y < r->y)
    *t = l, Merge(&(*t)->r, (*t)->r, r);
  else
    *t = r, Merge(&(*t)->l, l, (*t)->l);
  Calc(*t);
}

void Del( tree **t, int x )
{
  while ((*t)->x != x)
  {
    (*t)->si--;
    if (x < (*t)->x)
      t = &(*t)->l;
    else
      t = &(*t)->r;
  }
  if ((*t)->cou > 1)
    (*t)->cou--;
  else
    Merge(t, (*t)->l, (*t)->r);
}

int sR, sL;

void TGet( tree *t, int x )
{
  while (t && t->x != x)
    if (x < t->x)
      sR += Si(t->r) + t->cou, t = t->l;
    else
      sL += Si(t->l) + t->cou, t = t->r;
  if (t)
    sR += Si(t->r), sL += Si(t->l);
}

#define maxn 50010
int n1, n2, n, z[maxn];
tree *root[maxn];

void Set( int x, int oz, int nz, int f )
{
  while (x <= n)
  {
    if (f)
      Del(&root[x], oz);
    AddTree(&root[x], nz);
    x |= x + 1;
  }  
}

void Get( int x, int gz, int k )
{
  while (x >= 0)
  {
    sR = sL = 0;
    TGet(root[x], gz);
    n1 += k * sL, n2 += k * sR;
    x &= x + 1, x--;
  }
}

int main( void )
{
  int m, i;
  freopen("rect2.in", "rt", stdin);
  freopen("rect2.out", "wt", stdout);
  scanf("%d", &n);
  memset(root, 0, sizeof(root));
  for (i = 1; i <= n; i++)
  {
    scanf("%d", &z[i]), z[i] *= 2;
    Set(i, -1, z[i], 0);
  }
  scanf("%d", &m);
  while (m--)
  {
    char ch;
    scanf(" %c", &ch);
    if (ch == 'Q')
    {
      int x1, y1, x2, y2, y;
      scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
      y = y1 + y2;
      n1 = n2 = 0;
      Get(x2, y, 1), Get(x1 - 1, y, -1);
      puts(n1 > n2 ? "1" : (n1 < n2 ? "2" : "0"));
    }
    else
    {
      int x, nz;
      scanf("%d%d", &x, &nz), nz *= 2;
      Set(x, z[x], nz, 1);
      z[x] = nz;
    }
  }
  return 0;
}
