#include <fstream>
#include <vector>
#include <iostream>
using namespace std;

const int MAXN = 210;
const int MAXM = MAXN * MAXN;
const int MNOGO = 0x7F7F7F7F;

int n;

class Edge
{
public:
	int be, en, cpc;
};

vector<Edge> edg;
int first[MAXN + 2];
int next[MAXM];

int cost[MAXN];
int ma[MAXN][MAXN];

void AddEdge(int v1, int v2, int cpc)
{
	Edge a;
	a.be = v1;
	a.en = v2;
	a.cpc = cpc;
	edg.push_back(a);
	next[edg.size() - 1] = first[v1];
	first[v1] = edg.size() - 1;
	a.be = v2;
	a.en = v1;
	a.cpc = 0;
	edg.push_back(a);
	next[edg.size() - 1] = first[v2];
	first[v2] = edg.size() - 1;
}

int Inv(int e)
{
	if ((e & 1) == 1) return e - 1;
	else return e + 1;
}

void Load()
{
	edg.clear();
	memset(first, 0xFF, sizeof(first));
	memset(next, 0xFF, sizeof(next));
	scanf("%d", &n);
	int i;
	for (i = 1; i <= n; i++)
	{
		scanf("%d", &cost[i]);
	}
	memset(ma, 0, sizeof(ma));
	for (i = 1; i <= n; i++)
	{
		int num;
		scanf("%d", &num);
		int j;
		for (j = 0; j < num; j++)
		{
			int p;
			scanf("%d", &p);
			if (ma[i][p] == 0) 
			{
				ma[i][p] = 1;
				AddEdge(i, p, MNOGO);
			}
		}
	}
	// generate from-source edges
	for (i = 1; i <= n; i++)
	{
		if (cost[i] > 0)
		{
			AddEdge(n + 1, i, cost[i]);
		}
		else if (cost[i] < 0)
		{
			AddEdge(i, n + 2, -cost[i]);
		}
	}
}

int upbound;
int was[MAXN + 2];

int Dfs(int ver, int &min)
{
	if (ver == n + 2) return 1;
	was[ver] = 1;
	int i;
	for (i = first[ver]; i != -1; i = next[i])
	{
		if (was[edg[i].en] == 1) continue;
		if (edg[i].cpc < upbound) continue;
		int cmin = min;
		if (edg[i].cpc < cmin) cmin = edg[i].cpc;
		if (Dfs(edg[i].en, cmin))
		{
			edg[i].cpc -= cmin;
			edg[Inv(i)].cpc += cmin;
			min = cmin;
			return 1;
		}
	}
	return 0;
}

int GetFlow()
{
	int res = 0;
	upbound = 1 << 20;
	while (upbound > 0)
	{
		int curr = MNOGO;
		memset(was, 0, sizeof(was));
		while (Dfs(n + 1, curr))
		{
			res += curr;
			curr = MNOGO;
			memset(was, 0, sizeof(was));
		}
		upbound >>= 1;
	}
	return res;
}

void Solve()
{
	int ans = 0;
	int i;
	for (i = 1; i <= n; i++)
	{
		if (cost[i] > 0) ans += cost[i];
	}
	ans -= GetFlow();
	printf("%d\n", ans);
}

int main()
{
	freopen("matan.in", "rt", stdin);
	freopen("matan.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}