#include <fstream>            
#include <cstdio>
#include <iostream>
using namespace std;

const int MAXN = 210;

int cost[MAXN];
int n;
int ma[MAXN][MAXN];

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 1; i <= n; i++)
	{
		scanf("%d", &cost[i]);
	}
	memset(ma, 0, sizeof(ma));
	for (i = 1; i <= n; i++)
	{
		int num;
		scanf("%d", &num);
		int j;
		for (j = 1; j <= num; j++)
		{
			int p;
			scanf("%d", &p);
			ma[i][p] = 1;
		}
	}
	int j, k;
	for (k = 1; k <= n; k++)
	{
		for (i = 1; i <= n; i++)
		{
			for (j = 1; j <= n; j++)
			{
				if ((ma[i][k] == 1) && (ma[k][j] == 1))
				{
					ma[i][j] = 1;
				}
			}
		}
	}
}

int has[MAXN];
int bal[MAXN];

void RecountBalances()
{
	int i;
	for (i = 1; i <= n; i++)
	{
		if (has[i] == 1) continue;
		int j;
		bal[i] = 0;
		for (j = 1; j <= n; j++)
		{
			if (j == i) continue;
			if (ma[i][j] == 0) continue;
			if (has[j] == 1) continue;
			bal[i] += cost[j];
		}
		bal[i] += cost[i];
	}
}

void ReAddVer(int ver)
{
	int i;
	for (i = 1; i <= n; i++)
	{
		if (ma[ver][i] == 1)
		{
			has[i] = 1;
		}
	}
	has[ver] = 1;
}

void Solve()
{
	memset(has, 0, sizeof(has));
	int i;
	while (1)
	{
		RecountBalances();
		int mi, max;
		max = -1;
		mi = 0;
		for (i = 1; i <= n; i++)
		{
			if (has[i] == 1) continue;
			if (bal[i] > max)
			{
				max = bal[i];
				mi = i;
			}
		}
		if (mi == 0) break;
		ReAddVer(mi);
	}
	int ans = 0;
	for (i = 1; i <= n; i++) if (has[i] == 1) ans += cost[i];
	cout << ans;
}

int main()
{
	freopen("matan.in", "rt", stdin);
	freopen("matan.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
