import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class roi_pm implements Runnable {
    public static void main(String[] args) {
        new Thread(new roi_pm()).start();
    }

    public void run() {
        try {
            readInput();
            solve(Integer.MAX_VALUE);
            solve(res);
            writeOutput();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    class Segment implements Comparable<Segment> {
        public int delta;
        public int at;

        public Segment(int delta, int at) {
            this.delta = delta;
            this.at = at;
        }

        public int compareTo(Segment o) {
            if (delta != o.delta)
                return o.delta - delta;
            else
                return at - o.at;
        }
    }

    TreeMap<Integer, List<Integer>> p;
    int sx;
    int sy;
    int res;
    int resx;
    int resy;
    TreeMap<Integer, Integer> map;
    TreeSet<Segment> dists;

    private void solve(int limit) {
        res = 0;
        resx = 0;
        resy = 0;
        
        if (sx == 0 || sy == 0) {
            return;
        }

        map = new TreeMap<Integer, Integer>();
        dists = new TreeSet<Segment>();

        map.put(0, 1);
        map.put(sy, 1);
        dists.add(new Segment(Math.min(limit, sy), 0));

        Integer[] xs = p.keySet().toArray(new Integer[0]);

        int left = 0;
        int right = -1;
        while (true) {
            int slx = left - 1 >= 0 ? xs[left - 1] : 0;
            int srx = right + 1 < xs.length ? xs[right + 1] : sx;
            Segment s = dists.first();
            updateRes(slx, s.at, Math.min(s.delta, srx - slx));
            if (s.delta <= srx - slx && left <= right) {
                for (Integer y : p.get(xs[left]))
                    dropPoint(y, limit);
                ++left;
            } else {
                ++right;
                if (right == xs.length)
                    break;
                for (Integer y : p.get(xs[right]))
                    addPoint(y, limit);
            }
        }
    }

    private void dropPoint(int y, int limit) {
        int z = map.get(y) - 1;
        if (z > 0) {
            map.put(y, z);
        } else {
            map.remove(y);
            int y1 = map.headMap(y).lastKey();
            int y2 = map.tailMap(y).firstKey();
            dists.remove(new Segment(Math.min(limit, y - y1), y1));
            dists.remove(new Segment(Math.min(limit, y2 - y), y));
            dists.add(new Segment(Math.min(limit, y2 - y1), y1));
        }
    }

    private void addPoint(int y, int limit) {
        if (map.containsKey(y)) {
            map.put(y, map.get(y) + 1);
        } else {
            int y1 = map.headMap(y).lastKey();
            int y2 = map.tailMap(y).firstKey();
            map.put(y, 1);
            dists.remove(new Segment(Math.min(limit, y2 - y1), y1));
            dists.add(new Segment(Math.min(limit, y - y1), y1));
            dists.add(new Segment(Math.min(limit, y2 - y), y));
        }
    }

    private void updateRes(int x, int y, int size) {
        if (size > res || size == res && x < resx || size == res && x == resx && y < resy) {
            res = size;
            resx = x;
            resy = y;
        }
    }

    private void readInput() throws FileNotFoundException {
        p = new TreeMap<Integer, List<Integer>>();

        Scanner scanner = new Scanner(new File("roi.in"));
        sx = scanner.nextInt();
        sy = scanner.nextInt();
        int n = scanner.nextInt();
        for (int i = 0; i < n; ++i) {
            int x = scanner.nextInt();
            int y = scanner.nextInt();
            if (!p.containsKey(x))
                p.put(x, new ArrayList<Integer>());
            p.get(x).add(y);
        }
    }

    private void writeOutput() throws FileNotFoundException {
        PrintWriter writer = new PrintWriter("roi.out");

        writer.println(res);
        writer.println(resx + " " + resy);

        writer.close();
    }

}
