#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

ifstream in("cross.in");
ofstream out("cross.out");

int n, m;
vector <int> pr[100100];
int edg[300100][2];
int dst[100100];
int rt;

int par[100100];
int eid[100100];

void Load()
{
	in >> n >> m;
	int i, p, q;
	for (i = 0; i < m; i++)
	{
		in >> p >> q;
		p--; q--;
		pr[q].push_back(p);
		edg[i][0] = p; edg[i][1] = q;
	}
}


int f(int v)
{
	if (v == rt) return 0;
	if (dst[v] > 0) return dst[v];
	for (int i = 0; i < pr[v].size(); i++)
	{
		if (f(pr[v][i]) + 1 > dst[v])
			dst[v] = dst[pr[v][i]] + 1;
	}
	return dst[v];
}


int beg[100100], end[100100];
int Time;
void dfs(int v)
{
	beg[v] = Time++;
	int i;
	for (i = 0; i < pr[v].size(); i++)
	{
		dfs(pr[v][i]);
	}
	end[v] = Time++;	
}

void Solve()
{
	int i;
	rt = -1;
	
	for (i = 0; i < n; i++)
	{
		if (pr[i].size() == 0)
		{
			if (rt == -1) rt = i;
			else {
				out << -1;
				return;
			}
		}
	}

	for (i = 0; i < n; i++)
	{
		dst[i] = f(i);
	}


	int q, p;
	for (i = 0; i < n; i++) pr[i].clear();
	for (i = 0; i < m; i++)
	{
		p = edg[i][0]; q = edg[i][1];
		if (dst[p] == dst[q] - 1 && eid[q] == 0) {
			eid[q] = i;
			pr[p].push_back(q);
		}	
	}

	dfs(rt);

	for (i = 0; i < m; i++)
	{
		p = edg[i][0]; q = edg[i][1];
		if (beg[p] > beg[q] || end[p] < end[q])
		{
			out << -1;
			return;
		}	
	}
	out << n-1 << "\n";
	for (i = 0; i < m; i++)
	{
		p = edg[i][0]; q = edg[i][1];
		if (eid[q] == i) out << i + 1 << " "; 
	}
}

int main()
{
	Load();
	Solve();
	return 0;	
}

