#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "letter.in"
#define C_OUT_FILE "letter.out"

const int NMAX = 15;
const int LMAX = 110;

int n, len;
long long k;
char c[NMAX][LMAX];
int l[NMAX];
char pref[NMAX * LMAX];

void outdata() {
}

long long fac[NMAX + 1];
long long d[1 << NMAX][2];

long long number(int lpref) {
	memset(d, 0, sizeof d);
	d[0][1] = true;
	long long ans = 0;
	forn(msk, 1 << n) {
		int spos = 0, ks = 0;
		forn(j, n) {
			if (msk & (1 << j)) {
				spos += l[j];
				++ks;
			}
		}
		if (spos >= lpref) {
			ans += fac[n - ks] * (d[msk][0] + d[msk][1]);
			continue;
		}
		forn(j, n) if ((msk & (1 << j)) == 0) {
			 int srlen = min(l[j], lpref - spos);
			 swap(pref[spos + srlen], pref[NMAX * LMAX - 1]);
			 swap(c[j][srlen], c[j][LMAX - 1]);
			 int x = strcmp(c[j], pref + spos);
			 d[msk ^ (1 << j)][0] += d[msk][0];
			 if (x < 0) {
				 d[msk ^ (1 << j)][0] += d[msk][1];
			 }
			 if (x == 0) {
				 d[msk ^ (1 << j)][1] += d[msk][1];
			 }
			 swap(pref[spos + srlen], pref[NMAX * LMAX - 1]);
			 swap(c[j][srlen], c[j][LMAX - 1]);
		}
	}
	return ans;
}

void solve() {
	fac[0] = 1;
	forn(i, NMAX) fac[i + 1] = (i + 1) * fac[i];
	assert(k <= fac[n] & k > 0);
	memset(pref, 0, sizeof pref);
	forn(i, len) {
		char l = 'a', r = 'z';
		while (l < r) {
			char m = (l + r) / 2;
			pref[i] = m;
			if (number(i + 1) < k) l = m + 1; else r = m;
		}
		pref[i] = l;
	}
	printf("%s\n", pref);
}

void readdata() {
	scanf("%d", &n);
	assert(1 <= n && n <= 14);
	cin >> k;
	len = 0;
	memset(c, 0, sizeof c);
	forn(i, n) {
		scanf("%s", c[i]);
		l[i] = strlen(c[i]);
		len += l[i];
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
