#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include "chains.h"
#include "global.h"
#include "types.h"

char s [MaxL];
int a [MaxL];
int x [MaxL], y [MaxL], z [MaxL], dir [MaxL];
int xr [MaxL], yr [MaxL], zr [MaxL], dirr [MaxL];
int n;
int res, cur;

bool load (int test)
{
 FILE * f;
 char buf [MaxBuf];
 int i;
 char ch;
 sprintf (buf, "dat/%02d", test);
 if ((f = fopen (buf, "rt")) == NULL) return false;
 fscanf (f, " %s", s);
 n = strlen (s);
 for (i = 0; i < n; i++)
  a[i] = s[i] - '0';
 fclose (f);
 sprintf (buf, "dat/%02d.a", test);
 if ((f = fopen (buf, "rt")) == NULL) return false;
 fscanf (f, " %d", &res);
 dir[0] = 1;
 for (i = 1; i < n; i++)
 {
  fscanf (f, " %c", &ch);
  dir[i] = ch - '0';
 }
 for (i = 0; i < n; i++)
  fscanf (f, " %d", &x[i]);
 for (i = 0; i < n; i++)
  fscanf (f, " %d", &y[i]);
 for (i = 0; i < n; i++)
  fscanf (f, " %d", &z[i]);
 fclose (f);
 return true;
}

bool load_ans (int test)
{
 char buf [MaxL], t [MaxL];
 int i;
 FILE * f;
 sprintf (buf, "dat/%02d.in", test);
 if ((f = fopen (buf, "rt")) == NULL) return false;
 fscanf (f, " %s", s);
 n = strlen (s);
 fclose (f);
 for (i = 0; i < n; i++)
  a[i] = s[i] - '0';
 sprintf (buf, "dat/%02d.out", test);
 if ((f = fopen (buf, "rt")) == NULL) return false;
 fscanf (f, " %s", t);
 fclose (f);
 x[0] = y[0] = z[0] = 0;
 dir[0] = 1;
 for (i = 1; i < n; i++)
 {
  dir[i] = t[i - 1] - '0';
  x[i] = x[i - 1] + dx[dir[i]];
  y[i] = y[i - 1] + dy[dir[i]];
  z[i] = z[i - 1] + dz[dir[i]];
 }
 return true;
}

void report (FILE * f)
{
 int i;
 for (i = 1; i < n; i++)
  fprintf (f, "%d", dir[i]);
 fprintf (f, "\n");
 for (i = 0; i < n; i++)
  fprintf (f, " %3d", x[i]);
 fprintf (f, "\n");
 for (i = 0; i < n; i++)
  fprintf (f, " %3d", y[i]);
 fprintf (f, "\n");
 for (i = 0; i < n; i++)
  fprintf (f, " %3d", z[i]);
 fprintf (f, "\n");
 fflush (f);
}

void canonize (void)
{
 int i, min;

 min = MaxC;
 for (i = 0; i < n; i++)
  if (min > x[i])
   min = x[i];
 for (i = 0; i < n; i++)
  x[i] -= min;

 min = MaxC;
 for (i = 0; i < n; i++)
  if (min > y[i])
   min = y[i];
 for (i = 0; i < n; i++)
  y[i] -= min;

 min = MaxC;
 for (i = 0; i < n; i++)
  if (min > z[i])
   min = z[i];
 for (i = 0; i < n; i++)
  z[i] -= min;
}

void centerize (void)
{
 int i, min, max;

 min = MaxC; max = -MaxC;
 for (i = 0; i < n; i++)
 {
  if (min > x[i])
   min = x[i];
  if (max < x[i])
   max = x[i];
 }
 min = (min + max) >> 1;
 for (i = 0; i < n; i++)
  x[i] -= min;

 min = MaxC; max = -MaxC;
 for (i = 0; i < n; i++)
 {
  if (min > y[i])
   min = y[i];
  if (max < y[i])
   max = y[i];
 }
 min = (min + max) >> 1;
 for (i = 0; i < n; i++)
  y[i] -= min;

 min = MaxC; max = -MaxC;
 for (i = 0; i < n; i++)
 {
  if (min > z[i])
   min = z[i];
  if (max < z[i])
   max = z[i];
 }
 min = (min + max) >> 1;
 for (i = 0; i < n; i++)
  z[i] -= min;
}
