import java.util.*;

public class pimg_pm_bt {
    public static void main(String[] args) {
        int n = Integer.parseInt(args[0]);
        int res = 0;
        for (int i = 0; i < (1 << (n * (n - 1) / 2)); ++i) {
            //System.out.println(i);
            List<List<Integer>> edges = new ArrayList<List<Integer>>();
            for (int j = 0; j < n; ++j)
                edges.add(new ArrayList<Integer>());
            int k = 0;
            for (int a = 0; a < n; ++a)
                for (int b = a + 1; b < n; ++b) {
                    if (((i >> k) & 1) != 0) {
                        edges.get(a).add(b);
                        edges.get(b).add(a);
                    }
                    ++k;
                }
            if (verify(n, edges)) {
                int[][] g = new int[n][n];
                k = 0;
                for (int a = 0; a < n; ++a)
                    for (int b = a + 1; b < n; ++b) {
                        if (((i >> k) & 1) != 0) {
                            g[a][b] = g[b][a] = 1;
                        }
                        ++k;
                    }
                for (int a = 0; a < n; ++a) {
                    for (int b = 0; b < n; ++b)
                        System.out.print(g[a][b]);
                    System.out.println();
                }
                System.out.println();
                ++res;
            }
        }
        System.out.println(res);
    }

    static Set<List<Integer>> dfsOrders;
    static Set<List<Integer>> bfsOrders;
    static int n;
    static List<List<Integer>> edges;
    static List<Integer> bfsOrder;
    static List<Integer> dfsOrder;

    private static boolean verify(int _n, List<List<Integer>> _edges) {
        dfsOrders = new HashSet<List<Integer>>();
        bfsOrders = new HashSet<List<Integer>>();
        n = _n;
        edges = _edges;

        if (!doBfs())
            return false;

        tryAll(0, 0);

        return bfsOrders.containsAll(dfsOrders);
    }

    private static void tryAll(int start, int at) {
        if (start >= n) {
            doBfs();
            doDfs();
            return;
        }
        if (at >= edges.get(start).size() - 1)
            tryAll(start + 1, 0);
        else {
            for (int j = at; j < edges.get(start).size(); ++j) {
                int t = edges.get(start).get(at);
                edges.get(start).set(at, edges.get(start).get(j));
                edges.get(start).set(j, t);
                tryAll(start, at + 1);
                t = edges.get(start).get(at);
                edges.get(start).set(at, edges.get(start).get(j));
                edges.get(start).set(j, t);
            }
        }
    }

    private static void doDfs() {
        dfsOrder = new ArrayList<Integer>();
        boolean[] visited = new boolean[n];
        dfs(0, visited, dfsOrder);
        if (dfsOrder.size() == n)
            dfsOrders.add(dfsOrder);
    }

    private static void dfs(int at, boolean[] visited, List<Integer> dfsOrder) {
        if (visited[at])
            return;
        visited[at] = true;
        dfsOrder.add(at);
        for (int x : edges.get(at))
            dfs(x, visited, dfsOrder);
    }

    private static boolean doBfs() {
        bfsOrder = new ArrayList<Integer>();
        Queue<Integer> queue = new LinkedList<Integer>();
        boolean[] visited = new boolean[n];
        queue.add(0);
        visited[0] = true;
        while (queue.size() > 0) {
            int cur = queue.poll();
            bfsOrder.add(cur);
            for (int x : edges.get(cur))
                if (!visited[x]) {
                    queue.add(x);
                    visited[x] = true;
                }
        }
        if (bfsOrder.size() == n) {
            bfsOrders.add(bfsOrder);
            return true;
        } return false;
    }
}
