#include <cstdio>
#include <cstring>

#define mlen 1700
#define base (int)1e8
#define blen 8
typedef __int64 LL;
typedef LL num[mlen];

#define maxn 503
int n, l[maxn], ltmp, lc, lp2;
num f[maxn], tmp, c, p2;

void Out( num &a )
{
  int i;
  for (i = mlen - 1; i && !a[i]; i--)
    ;
  printf("%I64d", a[i--]);
  while (i >= 0)
    printf("%0*I64d", blen, a[i--]);
}

void Copy( num &a, num &b )
{
  memcpy(a, b, sizeof(num));
}

void MulD( num &a, int &la, int k )
{
  int i;
  for (i = 0; i < la; i++)
    a[i] *= k;
  for (i = 0; i < la; i++)
    if (a[i] >= base)
      a[i + 1] += a[i] / base, a[i] %= base;
  if (a[la])
    la++;
}

void MulBigD( num &a, int &la, int p2 )
{
  while (p2 > 20)
    MulD(a, la, 1 << 20), p2 -= 20;
  MulD(a, la, 1 << p2);
}

void DivD( num &a, int &la, int k )
{
  for (int i = la - 1; i > 0; i--)
    a[i - 1] += (a[i] % k) * base, a[i] /= k;
  a[0] /= k;
  while (la && !a[la - 1])
    la--;
}

void AddD( num &a, int &la, int d )
{
  int i;
  a[0] += d;
  for (i = 0; a[i] >= base; i++)
    a[i + 1]++, a[i] -= base;
  if (a[la])
    la++;
}

void Add( num &a, int &la, num &b, int &lb )
{
  int i;
  if (lb > la)
    la = lb;
  for (i = 0; i < lb; i++)
    a[i] += b[i];
  for (i = 0; i < la; i++)
    if (a[i] >= base)
      a[i + 1]++, a[i] -= base;
  if (a[la])
    la++;
}

void Mul( num &c, int &lc, num &b, int &lb )
{
  num a;
  int la, i, j;
  Copy(a, c), la = lc;
  memset(c, 0, sizeof(c)), lc = la + lb;
  for (i = 0; i < la; i++)
    for (j = 0; j < lb; j++)
      c[i + j] += a[i] * b[j];
  for (i = 0; i < lc; i++)
    if (c[i] >= base)
      c[i + 1] += c[i] / base, c[i] %= base;
  if (c[lc])
    lc++;
  while (lc && !c[lc - 1])
    lc--;
}

void Solve1( int n )
{
  memset(f, 0, sizeof(f));
  memset(l, 0, sizeof(l));
  f[1][0] = 1, l[1] = 1;

  for (int i = 2; i < n; i++)
  {
    f[i][0] = 2, l[i] = 1;
    memset(p2, 0, sizeof(p2));
    p2[0] = 1, lp2 = 1;
    memset(c, 0, sizeof(c));
    c[0] = i, lc = 1;
    for (int j = 1; j < i; j++)
    {
      memcpy(tmp, f[i - j], sizeof(LL) * l[i - j]), ltmp = l[i - j];
      Mul(tmp, ltmp, c, lc);
      Mul(tmp, ltmp, p2, lp2);
      Add(f[i], l[i], tmp, ltmp);
      MulD(p2, lp2, 2);
      AddD(p2, lp2, 1);
      MulD(c, lc, i - j);
      DivD(c, lc, 1 + j);
    }
  }
}

void Solve2( int n )
{
  memset(f, 0, sizeof(f));
  memset(l, 0, sizeof(l));
  f[1][0] = 1, l[1] = 1;

  memset(tmp, 0, sizeof(tmp));
  tmp[0] = 1, ltmp = 1;

  for (int i = 2; i < n; i++)
  {
    Copy(f[i], f[i - 1]), l[i] = l[i - 1];
    MulD(f[i], l[i], i);
    MulBigD(tmp, ltmp, i - 1);
    Add(f[i], l[i], tmp, ltmp);
  }
}

void Solve3( int n )
{
  memset(f, 0, sizeof(f));
  memset(l, 0, sizeof(l));
  f[1][0] = 1, l[1] = 1;

  for (int i = 2; i < n; i++)
  {
    Copy(f[i], f[i - 1]), l[i] = l[i - 1];
    MulD(f[i], l[i], i);
    AddD(f[i], l[i], 2);
  }
}

int main( void )
{
  int n;
  scanf("%d", &n);
  if (n == 1)
  {
    puts("1 1 1");
    return 0;
  }

  Solve1(n), Out(f[n - 1]), putc('\n', stdout);
  Solve2(n), Out(f[n - 1]), putc('\n', stdout);
  Solve3(n), Out(f[n - 1]), putc('\n', stdout);
  return 0;
}
