#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstring>

typedef double real;
const int MBIG = 1000000000, MSEED = 161803398;
const real FAC = 1.0 / MBIG;

int inext, inextp;
int ra [56];

int nextrand (void)
{
 int j;
 if (++inext == 56) inext = 1;
 if (++inextp == 56) inextp = 1;
 j = ra[inext] - ra[inextp];
 if (j < 0) j += MBIG;
 ra[inext] = j;
 return j;
}

bool initrand (int seed)
{
 int i, j, k, l;
 l = MSEED - seed;
 if (l < 0) l = -l;
 l %= MBIG;
 ra[55] = l;
 k = 1;
 for (i = 1, j = 0; i <= 54; i++)
 {
  j += 21;
  if (j > 55) j -= 55;
  ra[j] = k;
  k = l - k;
  if (k < 0) k += MBIG;
  l = ra[j];
 }
 for (k = 1; k <= 4; k++)
  for (i = 1, j = 31; i <= 55; i++, j >= 55 ? j = 1 : j++)
  {
   ra[i] -= ra[j];
   if (ra[i] < 0) ra[i] += MBIG;
  }
 inext = 0;
 inextp = 31;
 return true;
}

real rndvalue (void)
{
 return nextrand () * FAC;
}

int rndvalue (int k)
{
 return (int) floor (rndvalue () * k);
}

const int MaxN = 102;

int a [MaxN] [MaxN], l [MaxN] [MaxN];
int c [MaxN] [MaxN];
bool b [MaxN];
int d [MaxN];
int h, n;

bool ff (int v)
{
 int i;
 if (b[v]) return false;
 if (v == h) return true;
 b[v] = true;
 for (i = 0; i < n; i++)
  if (c[v][i] && ff (i))
  {
   c[v][i]--;
   c[i][v]++;
   return true;
  }
 return false;
}

int main (void)
{
 int i, j, k, m;
 initrand (101);
 while (scanf (" %d %d", &n, &h) != EOF)
 {
  assert (h >= 1 && h <= n);
  h--;
  memset (a, 0, sizeof (a));
  for (i = 0; i < n; i++)
  {
   scanf (" %d", &d[i]);
   for (j = 0; j < d[i]; j++)
   {
    m = rndvalue (j + 1); l[i][j] = l[i][m];
    scanf (" %d", &l[i][m]);
    assert (l[i][m] >= 1 && l[i][m] <= n);
    l[i][m]--;
    assert (!a[i][l[i][m]]);
    a[i][l[i][m]] = true;
   }
  }

  k = MaxN;
  for (i = 0; i < n; i++) if (i != h)
  {
   memmove (c, a, sizeof (c));
   m = 0;
   while (1)
   {
    memset (b, 0, sizeof (b));
    if (ff (i)) m++;
    else break;
   }
   if (k > m)
    k = m;
  }
  printf ("%d\n", k);

  for (i = 0; i < n; i++) if (i != h)
  {
   memmove (c, a, sizeof (c));
   for (m = 0; m < k; m++)
   {
    memset (b, 0, sizeof (b));
    if (!ff (i)) assert (false);
   }
   for (j = 0; j < n; j++)
    if (c[i][j] == a[i][j])
     a[i][j] = 0;
  }

  for (j = 0; j < k; j++)
  {
   for (i = 0; i < n; i++)
    printf ("%d%c", (i == h) ? 0 : l[i][j] + 1, i + 1 < n ? ' ' : '\n');
  }                  
 }
 return 0;
}
