#include <fstream>
#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

const long double PI = 3.1415926535897932384626433832795;
const long double eps = 1e-12;

class Point
{
public:
	long double x, y;
};

int n;
Point pnt[110000];

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 1; i <= n; i++)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		pnt[i].x = x;
		pnt[i].y = y;
	}
}

inline long double sqr(long double x)
{	
	return x * x;
}

long double GetLen(long double vx, long double vy)
{
	return sqrt(sqr(vx) + sqr(vy));
}

long double GetAng(long double cs)
{
	long double ang = acos(cs);
	return ang;
}

long double GetBonus(int p1, int p2)
{
	long double v1x, v2x, v1y, v2y, ang1, ang2;
	v1x = pnt[p1 - 1].x - pnt[p1].x;
	v1y = pnt[p1 - 1].y - pnt[p1].y;
	v2x = pnt[p2].x - pnt[p1].x;
	v2y = pnt[p2].y - pnt[p1].y;
	ang1 = GetAng((v1x * v2x + v1y * v2y) / GetLen(v1x, v1y) / GetLen(v2x, v2y));
	v2x = -v2x;
	v2y = -v2y;
	v1x = pnt[p2 + 1].x - pnt[p2].x;
	v1y = pnt[p2 + 1].y - pnt[p2].y;
	ang2 = GetAng((v1x * v2x + v1y * v2y) / GetLen(v1x, v1y) / GetLen(v2x, v2y));
	ang1 = ang1 / PI * 180;
	ang2 = ang2 / PI * 180;
	return ang1 * ang2;
}

int lkill;
long double res[110000][2];

long double CountResult()
{
	if (lkill == 0)
	{
		res[n][0] = GetBonus(n, n + 1);
		res[n][1] = 0;
	}
	else
	{
		res[n][0] = res[n][1] = 0;
	}
	int i;
	for (i = n - 1; i >= 2; i--)
	{
		res[i][0] = max(res[i + 1][0], GetBonus(i, i + 1) + res[i + 1][1]);
		res[i][1] = max(res[i + 1][0], res[i + 1][1]);
	}
	return res[2][lkill];
}

void Solve()
{
	if (n == 1)
	{
		printf("0.000");
		return;
	}
	long double res = 0;
	pnt[0] = pnt[n];
	pnt[n + 1] = pnt[1];
	pnt[n + 2] = pnt[2];
	// we will kill first segment
	long double cres;
	cres = GetBonus(1, 2);
	lkill = 1;
	cres += CountResult();
	if (cres > res) res = cres;
	// we will not kill first segment
	lkill = 0;
	cres = CountResult();
	if (cres > res) res = cres;
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << res;
}

int main()
{
	freopen("road.in", "rt", stdin);
	freopen("road.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}