#include <fstream>
#include <cmath>
#include <iostream>
using namespace std;

const long double eps = 1e-12;
const long double PI = 3.1415926535897932384626433832795;
const int MAXN = 10;

class Point
{
public:
	long double x, y;
};

int n;
Point pnt[MAXN + 1];

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 1; i <= n; i++)
	{
	 	int x, y;
	 	scanf("%d%d", &x, &y);
	 	pnt[i].x = x;
	 	pnt[i].y = y;
	}
}

long double mres;
int was[MAXN + 1];
int cp[MAXN + 1];
int alive[MAXN + 1];
int nxt[MAXN + 1];
int prv[MAXN + 1];

long double GetBonus(int pos)
{
	long double v1x, v1y, v2x, v2y, ang1, ang2;
	v1x = pnt[prv[pos]].x - pnt[pos].x;
	v1y = pnt[prv[pos]].y - pnt[pos].y;
	v2x = pnt[nxt[pos]].x - pnt[pos].x;
	v2y = pnt[nxt[pos]].y - pnt[pos].y;
	ang1 = atan2(v1x * v2y - v1y * v2x, v1x * v2x + v1y * v2y);
	if (ang1 < -eps) ang1 += 2 * PI;
	if (ang1 - PI > eps) ang1 = 2 * PI - ang1;
	ang1 = ang1 / PI * 180;
	v1x = pnt[nxt[nxt[pos]]].x - pnt[nxt[pos]].x;
	v1y = pnt[nxt[nxt[pos]]].y - pnt[nxt[pos]].y;
	v2x = -v2x;
	v2y = -v2y;
	ang2 = atan2(v1x * v2y - v1y * v2x, v1x * v2x + v1y * v2y);
	if (ang2 < -eps) ang2 += 2 * PI;
	if (ang2 - PI > eps) ang2 = 2 * PI - ang2;
	ang2 = ang2 / PI * 180;
	return ang1 * ang2;
}

void Check()
{
	memset(alive, 0, sizeof(alive));
	int i;
	long double res = 0;
	for (i = 1; i <= n; i++)
	{
		alive[cp[i]] = 1;
		if ((alive[prv[cp[i]]] == 1) || (alive[nxt[cp[i]]] == 1)) continue;
		res += GetBonus(cp[i]);
	}
	if (res > mres) mres = res;
}

void GenP(int pos)
{
	if (pos == n + 1)
	{
		Check();
		return;
	}
	int i;
	for (i = 1; i <= n; i++)
	{
		if (was[i] == 1) continue;
		was[i] = 1;
		cp[pos] = i;
		GenP(pos + 1);
		was[i] = 0;
	}
}

void Solve()
{
	int i;
	for (i = 1; i <= n; i++)
	{
		if (i == 1) prv[i] = n;
		else prv[i] = i - 1;
		if (i == n) nxt[i] = 1;
		else nxt[i] = i + 1;
	}
	mres = 0;
	memset(was, 0, sizeof(was));
	GenP(1);
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << mres;
}

int main()
{
	freopen("road.in", "rt", stdin);
	freopen("road.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}