#include <cstdio>
#include <cstring>
#include "gameunit.h"

#define H 20
#define W 10
typedef bool TField[H * W];

#define N 7
int F[N][4][4][4], FL[N][4], FH[N][4][4];

int fig;
TField m, m2;
int mh[H];

bool Get( int x, int y )
{
  return m[(H - y - 1) * W + x];
}

int main( void )
{
  memset(F, 0, sizeof(F));
  F[0][0][0][0] = F[0][0][1][0] = F[0][0][2][0] = F[0][0][3][0] = 1;
  F[1][0][0][0] = F[1][0][1][0] = F[1][0][2][0] = F[1][0][0][1] = 1;
  F[2][0][0][0] = F[2][0][1][0] = F[2][0][2][0] = F[2][0][2][1] = 1;
  F[3][0][0][1] = F[3][0][1][0] = F[3][0][1][1] = F[3][0][2][0] = 1;
  F[4][0][0][0] = F[4][0][1][0] = F[4][0][1][1] = F[4][0][2][1] = 1;
  F[5][0][0][0] = F[5][0][1][0] = F[5][0][1][1] = F[5][0][2][0] = 1;
  F[6][0][0][0] = F[6][0][0][1] = F[6][0][1][0] = F[6][0][1][1] = 1;

  int i, j, x, y;
  for (i = 0; i < N; i++)
    for (j = 1; j < 4; j++)
    {
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          F[i][j][y][x] = F[i][j - 1][x][3 - y];
      while (1)
      {
        for (y = 0; y < 4; y++)
          if (F[i][j][y][0])
            break;
        if (y == 4)
        {
          for (y = 0; y < 4; y++)
            for (x = 1; x < 4; x++)
              F[i][j][y][x - 1] = F[i][j][y][x];
          for (y = 0; y < 4; y++)
            F[i][j][y][3] = 0;
          continue;
        }
        for (x = 0; x < 4; x++)
          if (F[i][j][0][x])
            break;
        if (x == 4)
        {
          for (x = 0; x < 4; x++)
            for (y = 1; y < 4; y++)
              F[i][j][y - 1][x] = F[i][j][y][x];
          for (x = 0; x < 4; x++)
            F[i][j][3][x] = 0;
          continue;
        }
        break;
      }
    }
  memset(FL, 0, sizeof(FL));
  for (i = 0; i < N; i++)
    for (j = 0; j < 4; j++)
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          if (F[i][j][y][x])
            FL[i][j] >?= x + 1;            
  for (i = 0; i < N; i++)
    for (j = 0; j < 4; j++)
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          if (F[i][j][y][x])
            FH[i][j][x] >?= y + 1;

  fig = Initialize();
  while (1)
  {
    GetField(0, m);
    GetField(1, m2);
    memset(mh, 0, sizeof(mh));
    for (y = 0; y < H; y++)
      for (x = 0; x < W; x++)
        if (Get(x, y) && mh[x] < y + 1)
          mh[x] = y + 1;
    for (x = 0; x < W; x++)
      fprintf(stderr, "%d ", mh[x]);
    fprintf(stderr, "\n");
    
    int resI, resX, resH = H + 1, resMin = (int)1e9;
    for (i = 0; i < 4; i++)
      for (x = 0; x + FL[fig][i] <= W; x++)
      {
        int h = 0, sum = 0;
        for (j = 0; j < FL[fig][i]; j++)
          h >?= mh[x + j] + FH[fig][i][j];
        for (j = 0; j < FL[fig][i]; j++)
          sum += h - FH[fig][i][j] - mh[x + j];
        if ((resH > H && h <= H) || (h <= H && (resH > h + 5 || (h < resH + 5 && sum < resMin) || (sum == resMin && h < resH))))
          resH = h, resI = i, resX = x, resMin = sum;
      }
    fprintf(stderr, "I=%d X=%d Min=%d\n", resI, resX, resMin);
    fig = Drop(resI, resX);
  }
  return 0;
}
