#include <cstdio>
#include <cstdlib>
#include <cstring>
#include "gameunit.h"

#define inf (int)1e9

#define H 20
#define W 10
typedef bool TField[H * W];

#define N 7
int F[N][4][4][4], FL[N][4], FH[N][4][4];

int fig;
TField m, m2, mc;
int mh[H], mhc[H];

bool Get( TField &m, int x, int y )
{
  return m[(H - y - 1) * W + x];
}

void Set( TField &m, int x, int y, bool f )
{
  m[(H - y - 1) * W + x] = f;
}

int MyDrop( int fig, int i, int x, int out_put )
{
  int h = 0, j, a, b, y;
  for (j = 0; j < FL[fig][i]; j++)
    h >?= mh[x + j] + FH[fig][i][j];
  if (h > H)
    return -inf;

  memcpy(mc, m, sizeof(m));
  for (a = 0; a < 4; a++)
    for (b = 0; b < 4; b++)
      if (F[fig][i][a][b])
        Set(mc, x + b, h - a - 1, 1);

  if (out_put)
  {
    for (a = H - 1; a >= 0; a--)
    {
      for (b = 0; b < W; b++)
        putc(Get(mc, b, a) ? '#' : '.', stdout);
      puts("");
    }
    puts("");
  }

  int str_num = 0;
  while (1)
  {
    for (a = 0; a < H; a++)
    {
      for (b = 0; b < W; b++)
        if (!Get(mc, b, a))
          break;
      if (b == W)
        break;
    }
    if (a == H)
      break;
    for (y = a; y + 1 < H; y++)
      for (b = 0; b < W; b++)
        Set(mc, b, y, Get(mc, b, y + 1));
    for (b = 0; b < W; b++)
      Set(mc, b, H - 1, 0);
    str_num++;
  }

  int maxh = 0;
  memset(mhc, 0, sizeof(mhc));
  for (a = 0; a < H; a++)
    for (b = 0; b < W; b++)
      if (Get(mc, b, a))
        maxh >?= a + 1, mhc[b] >?= a + 1;
  
  int holl_num = 0;
  for (a = 0; a < H; a++)
    for (b = 0; b < W; b++)
      if (!Get(mc, b, a) && a + 1 < mhc[b])
        holl_num++;

  int dh = 0;
  for (b = 1; b < W; b++)
    dh += abs(mhc[b - 1] - mhc[b]);

  if (out_put)
  {
    printf("str_num=%d\n", str_num);
    printf("maxh=%d\n", maxh);
    printf("holl_num=%d\n", holl_num);
    printf("dh=%d\n", dh);
    puts("");
  }

  if (str_num == 4)
    return inf;
  if (str_num == 3)
    return inf / 2;

  int res = 0;

  if (str_num == 2)
    res += 150;
  res -= dh * 30;
  res -= h;
  res -= holl_num * 100;

  return res;
}

int main( void )
{
  memset(F, 0, sizeof(F));
  F[0][0][0][0] = F[0][0][1][0] = F[0][0][2][0] = F[0][0][3][0] = 1;
  F[1][0][0][0] = F[1][0][1][0] = F[1][0][2][0] = F[1][0][0][1] = 1;
  F[2][0][0][0] = F[2][0][1][0] = F[2][0][2][0] = F[2][0][2][1] = 1;
  F[3][0][0][1] = F[3][0][1][0] = F[3][0][1][1] = F[3][0][2][0] = 1;
  F[4][0][0][0] = F[4][0][1][0] = F[4][0][1][1] = F[4][0][2][1] = 1;
  F[5][0][0][0] = F[5][0][1][0] = F[5][0][1][1] = F[5][0][2][0] = 1;
  F[6][0][0][0] = F[6][0][0][1] = F[6][0][1][0] = F[6][0][1][1] = 1;

  int i, j, x, y;
  for (i = 0; i < N; i++)
    for (j = 1; j < 4; j++)
    {
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          F[i][j][y][x] = F[i][j - 1][x][3 - y];
      while (1)
      {
        for (y = 0; y < 4; y++)
          if (F[i][j][y][0])
            break;
        if (y == 4)
        {
          for (y = 0; y < 4; y++)
            for (x = 1; x < 4; x++)
              F[i][j][y][x - 1] = F[i][j][y][x];
          for (y = 0; y < 4; y++)
            F[i][j][y][3] = 0;
          continue;
        }
        for (x = 0; x < 4; x++)
          if (F[i][j][0][x])
            break;
        if (x == 4)
        {
          for (x = 0; x < 4; x++)
            for (y = 1; y < 4; y++)
              F[i][j][y - 1][x] = F[i][j][y][x];
          for (x = 0; x < 4; x++)
            F[i][j][3][x] = 0;
          continue;
        }
        break;
      }
    }
  memset(FL, 0, sizeof(FL));
  for (i = 0; i < N; i++)
    for (j = 0; j < 4; j++)
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          if (F[i][j][y][x])
            FL[i][j] >?= x + 1;            
  for (i = 0; i < N; i++)
    for (j = 0; j < 4; j++)
      for (y = 0; y < 4; y++)
        for (x = 0; x < 4; x++)
          if (F[i][j][y][x])
            FH[i][j][x] >?= y + 1;

  fig = Initialize();
  while (1)
  {
    GetField(0, m);
    GetField(1, m2);
    memset(mh, 0, sizeof(mh));
    for (y = 0; y < H; y++)
      for (x = 0; x < W; x++)
        if (Get(m, x, y) && mh[x] < y + 1)
          mh[x] = y + 1;
    for (x = 0; x < W; x++)
      fprintf(stderr, "%d ", mh[x]);
    fprintf(stderr, "\n");
    
    int f, resI, resX, resFunc = -2 * inf;
    for (i = 0; i < 4; i++)
      for (x = 0; x + FL[fig][i] <= W; x++)
        if (resFunc < (f = MyDrop(fig, i, x, 0)))
          resFunc = f, resI = i, resX = x;
    MyDrop(fig, resI, resX, 1);
    fprintf(stderr, "I=%d X=%d Min=%d\n", resI, resX, resFunc);
    fig = Drop(resI, resX);
  }
  return 0;
}
