#include <fstream>
#include <algorithm>
#include <vector>
#include <iostream>
#include <cstdio>
using namespace std;

#define int64 __int64

#pragma comment(linker, "/STACK:20000000")

const int MAXSTATE = 500010;

int64 k;
char s[MAXSTATE + 1];
int n;

void Load()
{
	cin >> k;
	char c = getchar();
	n = 0;
	while (c != EOF)
	{
		if ((c >= 'a') && (c <= 'z'))
		{
			s[n] = c - 'a';
			n++;
		}
		c = getchar();
	}
}

class Edge
{
public:
	int en;
	char c;
};

vector<Edge> edg;
vector<int> next;
int first[MAXSTATE + 1];
int suf[MAXSTATE + 1];
int len[MAXSTATE + 1];
int numstate, last;
int64 res1[MAXSTATE + 1], res2[MAXSTATE + 1];
int ctop;

void AddEdge(int v1, int v2, char c)
{
	Edge a;
	a.en = v2;
	a.c = c;
	edg.push_back(a);
	next.push_back(first[v1]);
	first[v1] = edg.size() - 1;
}

int GetGo(int v, char c)
{
	int i;
	for (i = first[v]; i != -1; i = next[i])
	{
		if (edg[i].c == c) return edg[i].en;
	}
	return 0;
}

void SetGo(int v, char c, int nv)
{
	int i;
	for (i = first[v]; i != -1; i = next[i])
	{
		if (edg[i].c == c)
		{
			edg[i].en = nv;
			return;
		}
	}
	AddEdge(v, nv, c);
}

void Dfs(int ver)
{
	suf[ver] = 1;
	int i;
	for (i = first[ver]; i != -1; i = next[i])
	{
		if (suf[edg[i].en] == 0) Dfs(edg[i].en);
	}
	len[ctop] = ver;
	ctop--;
}

class CVer
{
public:
	int ns, no;
};

bool operator<(const CVer &a, const CVer &b)
{
	if (a.no < b.no) return true;
	if (a.no > b.no) return false;
	if (a.ns < b.ns) return true;
	return false;
}

vector<CVer> vers;

void Solve()
{
	edg.clear();
	next.clear();
	memset(first, 0xFF, sizeof(first));
	memset(suf, 0, sizeof(suf));
	numstate = 1;
	suf[1] = len[1] = 0;
	int i;
	last = 1;
	for (i = 0; i < n; i++)
	{
		char csym = s[i];
		numstate++;
		int cst = numstate;
		len[cst] = i + 1;
		int cur = last;
		while ((cur != 0) && (GetGo(cur, csym) == 0))
		{
			SetGo(cur, csym, cst);
			cur = suf[cur];
		}
		if (cur == 0) suf[cst] = 1;
		else
		{
			int nxt = GetGo(cur, csym);
			if (len[nxt] == len[cur] + 1)
			{
				suf[cst] = nxt;
			}
			else
			{
				numstate++;
				int j;
				for (j = first[nxt]; j != - 1; j = next[j])
				{
					AddEdge(numstate, edg[j].en, edg[j].c);
				}
				suf[numstate] = suf[nxt];
				suf[nxt] = suf[cst] = numstate;
				len[numstate] = len[cur] + 1;
				while ((cur != 0) && (GetGo(cur, csym) == nxt))
				{
					SetGo(cur, csym, numstate);
					cur = suf[cur];
				}
			}
		}    
		last = cst;
	}
	memset(res2, 0, sizeof(res2));
	for (i = last; i != 0; i = suf[i]) res2[i] = 1;
	ctop = numstate;
	memset(suf, 0, sizeof(suf));
	Dfs(1);
	for (i = numstate; i > ctop; i--)
	{
		int j;
		for (j = first[len[i]]; j != -1; j = next[j])
		{
			res2[len[i]] += res2[edg[j].en];
		}
	}
	memset(res1, 0, sizeof(res1));
	res1[1] = 1;
	for (i = ctop + 1; i <= numstate; i++)
	{
		int j;
		for (j = first[len[i]]; j != -1; j = next[j])
		{
			res1[edg[j].en] += res1[len[i]];
		}
	}
	res1[1] = res2[1] = 0;
	vers.clear();
	for (i = ctop + 1; i <= numstate; i++)
	{
		CVer a;
		a.no = res2[len[i]];
		a.ns = res1[len[i]];
		vers.push_back(a);
	}
	sort(vers.begin(), vers.end());
	int64 ans = 0;
	for (i = vers.size() - 1; i >= 0; i--)
	{
		int64 cdec;
		cdec = vers[i].ns;
		if (cdec > k) cdec = k;
		ans += cdec * vers[i].no;
		k -= cdec;
	}
	if (k != 0) printf("-1");
	else cout << ans;
	int64 numm1t = 0;
	for (i = 1; i <= numstate; i++)
	{
		if (res2[i] > 1)
		{
			numm1t += res1[i];
		}
	}
	cerr << numm1t;
}

int main()
{
	//freopen("award.in", "rt", stdin);
	//freopen("award.out", "wt", stdout);
    Load();
    Solve();
	return 0;
}