#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

const int MaxN = 100, MaxK = 15, MaxL = 1 << MaxK;

int a [MaxK + 1], b [MaxN];
signed char f [MaxL], g [MaxL];
short prev [MaxL], perm [MaxL];
int cur [MaxK + 1], ans [MaxK];

int main (void)
{ 
 int i, j, k, m, n, p, q, s;
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  for (i = 0; i < k; i++)
   scanf (" %d", &a[i]);
  for (j = 0; j < n; j++)
   scanf (" %d", &b[j]);
  
  assert (n >= 1 && n <= MaxN);
  assert (k >= 1 && k <= MaxK);
  for (i = 0; i < k; i++)
   assert (a[i] >= 0 && a[i] <= 1000000);
  s = 0;
  for (i = 0; i < n; i++)
  {
   assert (b[i] >= 0 && b[i] <= 2147483647);
   s += b[i];
   assert (s >= 0 && s <= 2147483647);
  }
  

  for (i = 0; i < n; i++) perm[i] = i;
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
    if (b[i] < b[j])
    {
     p = b[i]; b[i] = b[j]; b[j] = p;
     p = perm[i]; perm[i] = perm[j]; perm[j] = p;
    }

  m = 1 << k;
  memset (f, -1, sizeof (f));
  f[0] = 0;
  for (j = 0; j < k; j++) // Could take only the k largest sacks, not n
  {
   memmove (g, f, sizeof (g));
   int capacity = b[j];

   for (p = 0; p < m; p++)
    if (g[p] >= 0)
    {
     s = 0;
     for (q = 0; q < m; q = ((q | p) + 1) & ~p)
     {
      if (!(p & q))
      {
       if (s <= capacity)
        if (f[p | q] == -1)
         f[p | q] = j,
         prev[p | q] = q;
      }
      for (i = 0; (q | p) & (1 << i); i++)
       if (q & (1 << i)) s -= a[i];
      s += a[i];
     }
    }

   if (f[m - 1] >= 0) break;
  }

  p = m - 1;
  if (f[p] >= 0)
  {
   printf ("YES\n");
   memset (ans, -1, sizeof (ans));
   while (p > 0)
   {
    for (i = 0; i < k; i++)
     if (prev[p] & (1 << i))
      ans[i] = f[p];
    p -= prev[p];
   }
   for (i = 0; i < k; i++)
    printf ("%d%c", perm[ans[i]] + 1, i + 1 < k ? ' ' : '\n');
  }
  else
  {
   printf ("NO\n");
  }
 }
 return 0;
}
