#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

const int MaxN = 100, MaxK = 15;

int a [MaxK], a0 [MaxK], q [MaxK], s [MaxK];
int b [MaxN], b0 [MaxN], p [MaxN];
int k, n;

int main (void)
{
//  freopen("pool.in", "rt", stdin);
//  freopen("pool.out", "wt", stdout);
 
 int i, j, t;
 int test, tests;
 srand (1280);

 tests = 1000;
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  for (i = 0; i < k; i++)
   scanf (" %d", &a[i]);
  for (j = 0; j < n; j++)
   scanf (" %d", &b[j]);

  for (i = 0; i < k; i++) q[i] = i;
  for (i = 0; i < k - 1; i++)
   for (j = i + 1; j < k; j++)
    if (a[q[i]] < a[q[j]])
    {
     t = q[i]; q[i] = q[j]; q[j] = t;
    }

  for (i = 0; i < n; i++) p[i] = i;
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
    if (b[i] < b[j])
    {
     t = b[i]; b[i] = b[j]; b[j] = t;
     t = p[i]; p[i] = p[j]; p[j] = t;
    }

  memmove (a0, a, sizeof (a0));
  memmove (b0, b, sizeof (b0));

  for (test = 0; test < tests; test++)
  {
   /* i+, j+ */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (i = 0; i < k; i++)
    for (j = 0; j < n; j++)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* j+, i+ */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (j = 0; j < n; j++)
    for (i = 0; i < k; i++)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* i+, j- */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (i = 0; i < k; i++)
   for (j = n - 1; j >= 0; j--)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* j-, i+ */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (j = n - 1; j >= 0; j--)
    for (i = 0; i < k; i++)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }
   
   /* i-, j+ */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (i = k - 1; i >= 0; i--)
    for (j = 0; j < n; j++)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* j+, i- */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (j = 0; j < n; j++)
    for (i = k - 1; i >= 0; i--)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* i-, j- */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (i = k - 1; i >= 0; i--)
    for (j = n - 1; j >= 0; j--)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   /* j-, i- */
   memmove (a, a0, sizeof (a));
   memmove (b, b0, sizeof (b));
   memset (s, -1, sizeof (s));
   for (j = n - 1; j >= 0; j--)
    for (i = k - 1; i >= 0; i--)
     if (a[q[i]] <= b[j])
     {
      s[i] = j;
      b[j] -= a[q[i]];
      break;
     }
   for (i = 0; i < k; i++)
    if (s[i] == -1)
     break;
   if (i == k)
   {
    printf ("YES\n");
    for (i = 0; i < k; i++)
     printf ("%d%c", p[s[q[i]]] + 1, i + 1 < k ? ' ' : '\n');
    break;
   }

   for (i = 0; i < k - 1; i++)
    for (j = i + 1; j < k; j++)
     if (rand () % 3 == 0)
     {
      t = q[i]; q[i] = q[j]; q[j] = t;
     }

   for (i = 0; i < n - 1; i++)
    for (j = i + 1; j < n; j++)
     if (rand () % 3 == 0)
     {
      t = b[i]; b[i] = b[j]; b[j] = t;
      t = p[i]; p[i] = p[j]; p[j] = t;
     }
  }

  if (test == tests)
   printf ("NO\n");
 }
 return 0;
}
