#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

const int MinN = 1, MaxS = 2, MaxN = 5000, MaxL = 128;

enum CODE {CODE_TO0, CODE_TO1, CODE_FROM0, CODE_FROM1, CODE_NUM};

char NAME [CODE_NUM] [MaxL] = {"to A", "to B", "from A", "from B"};

int a [MaxN], b [MaxN], p [MaxN], q [MaxN];
int ans_code [MaxN << 1], ans_num [MaxN << 1];
int s [MaxS] [MaxN];
int len [MaxS];
int n, ans_len;

int main (void)
{
 int i, j, k;
 bool ok;
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  for (i = 0; i < n; i++)
   scanf (" %d", &a[i]);
  for (i = 0; i < n; i++)
   a[i]--;
  memset (p, -1, sizeof (p));
  for (i = 0; i < n; i++)
   p[a[i]] = i;
  for (i = 0; i < n; i++)
   if (p[i] == -1)
    break;
  assert (i == n);

  for (i = 0; i < n; i++)
   scanf (" %d", &b[i]);
  for (i = 0; i < n; i++)
   b[i]--;
  memset (q, -1, sizeof (q));
  for (i = 0; i < n; i++)
   q[b[i]] = i;
  for (i = 0; i < n; i++)
   if (q[i] == -1)
    break;
  assert (i == n);

  for (i = 0; i < n; i++)
   p[i] = q[a[i]];
  for (i = 0; i < n; i++)
   q[p[i]] = i;

  ans_len = 0;
  k = 0;
  for (i = 0; i < MaxS; i++)
   len[i] = 0;
  for (i = 0; i < MaxS; i++)
   s[i][len[i]] = n;

   for (j = 0; j < n; j++)
    printf ("%d%c", q[j], j + 1 < n ? ' ' : '\n');

  ok = true;
  for (i = 0; i < n && ok; i++)
  {
   printf ("i = %d\n", i);
   printf ("stack0: ");
   for (j = 0; j <= len[0]; j++)
    printf ("%d%c", s[0][j], j < len[0] ? ' ' : '\n');
   printf ("stack1: ");
   for (j = 0; j <= len[1]; j++)
    printf ("%d%c", s[1][j], j < len[1] ? ' ' : '\n');
   while (k < q[i])
   {
    bool allow0 = p[k] < s[0][len[0]];
    bool allow1 = p[k] < s[1][len[1]];
    if (!allow0 && !allow1) {ok = false; break;}
    if (allow0 && allow1) j = (s[0][len[0]] < s[1][len[1]]);
    else if (allow0) j = 0;
    else j = 1;
    len[j]++;
    s[j][len[j]] = p[k];
    ans_code[ans_len] = j;
    ans_num[ans_len] = k;
    printf ("move %d %s\n", a[ans_num[ans_len]] + 1, NAME[ans_code[ans_len]]);
    ans_len++;
    k++;
   }
   if (k < q[i]) {ok = false; break;}
   printf ("stack0: ");
   for (j = 0; j <= len[0]; j++)
    printf ("%d%c", s[0][j], j < len[0] ? ' ' : '\n');
   printf ("stack1: ");
   for (j = 0; j <= len[1]; j++)
    printf ("%d%c", s[1][j], j < len[1] ? ' ' : '\n');
   for (j = 0; j < MaxS; j++)
    if (s[j][len[j]] == i)
     break;
   printf ("[%d %d]\n", s[0][len[0]], s[1][len[1]]);
   printf ("j = %d\n", j);
   if (j == MaxS)
   {
    if (k == q[i])
    {
     j = 0;
     len[j]++;
     s[j][len[j]] = i;
     ans_code[ans_len] = j;
     ans_num[ans_len] = q[i];
     printf ("move %d %s\n", a[ans_num[ans_len]] + 1, NAME[ans_code[ans_len]]);
     ans_len++;
     k++;
    }
    else {ok = false; break;}
   }
   ans_code[ans_len] = j + MaxS;
   ans_num[ans_len] = q[i];
   printf ("move %d %s\n", a[ans_num[ans_len]] + 1, NAME[ans_code[ans_len]]);
   ans_len++;
   len[j]--;
  }
  if (ok)
  {
   for (i = 0; i < ans_len; i++)
    printf ("move %d %s\n", a[ans_num[i]] + 1, NAME[ans_code[i]]);
  }
  else
  {
   printf ("impossible\n");
  }
 }

 return 0;
}
