#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <vector>

using namespace std;

#define inpfile "2stacks.in"
#define outfile "2stacks.out"

const int NMAX = 100005;
const int tl = (int)(1.7*CLOCKS_PER_SEC);

enum MoveType {
	TO_A,
	TO_B,
	FROM_A,
	FROM_B
};

struct Move {
	MoveType type;
	int x;
};

struct EDGE {
	int x, next;
};

Move moves[2*NMAX];
int perm[NMAX];
int num[NMAX];
int a[NMAX];
int b[NMAX];
int col[NMAX];
int an, bn;
int n;

int p[NMAX];
vector<EDGE> edges;
int maxx[NMAX];

void Init()
{
	freopen(inpfile, "r", stdin);
	freopen(outfile, "w", stdout);
}

void Out(bool ok)
{
	if (ok) {
		for (int i = 1; i <= 2*n; i++)
		{
			switch (moves[i].type)
			{
			case TO_A:
				printf("move %d to A\n", num[moves[i].x]);
				break;

			case TO_B:
				printf("move %d to B\n", num[moves[i].x]);
				break;

			case FROM_A:
				printf("move %d from A\n", num[moves[i].x]);
				break;
			case FROM_B:
				printf("move %d from B\n", num[moves[i].x]);
				break;
			}
		}
	} 
	else
		printf("impossible\n");

	exit(0);
}

void Inp()
{
	int q[NMAX];
	int x;
	
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &x);
		q[x] = i;
		num[i] = x;
	}

	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &x);
		perm[i] = q[x];
	}
}

void Dfs(int x, int cc)
{
	if (col[x]) {
		if (col[x] != cc) Out(false);
		return;
	}
	col[x] = cc;
	
	for (int i = p[x]; i; i = edges[i].next)
		Dfs(edges[i].x, 3 - cc);
}

void Solve()
{
	double start = clock();
	
	maxx[1] = perm[1];
	for (int i = 2; i <= n; i++)
		if (perm[i] > maxx[i - 1])
			maxx[i] = perm[i];
		else
			maxx[i] = maxx[i - 1];

	EDGE edge;
	
	edge.x = 0;
	edge.next = 0;
	edges.push_back(edge);

	memset(p, 0, sizeof(p));

	for (int i = n; i > 0; i--)
	{
		if (clock() - start > tl)
			break;

		for (int j = i - 1; j > 0; j--)
		{
			if (perm[i] > maxx[j]) break;
			if (perm[j] < perm[i])
			{
				edge.x = perm[j];
				edge.next = p[perm[i]];
				p[perm[i]] = edges.size();
				edges.push_back(edge);

				edge.x = perm[i];
				edge.next = p[perm[j]];
				p[perm[j]] = edges.size();
				edges.push_back(edge);
			}
		}
	}

	memset(col, 0, sizeof(col));
	for (int i = 1; i <= n; i++)
		if (col[i] == 0)
			Dfs(i, 1);

	an = 0;
	bn = 0;
	int x = 1;
	int k = 1;

	for (int i = 1; i <= 2*n; i++)
	{
		if (perm[k] == a[an])
		{
			moves[i].type = FROM_A;
			moves[i].x = perm[k];
			an--;
			k++;
		} else
		if (perm[k] == b[bn])
		{
			moves[i].type = FROM_B;
			moves[i].x = perm[k];
			bn--;
			k++;
		} else
		if (x <= n) {
			if (col[x] == 1)
			{
				moves[i].type = TO_A;
				moves[i].x = x;
				an++;
				a[an] = x;
			} else {
				moves[i].type = TO_B;
				moves[i].x = x;
				bn++;
				b[bn] = x;
			}
			x++;
		} else
			Out(false);
	}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out(true);
	return 0;
}
