#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "2stacks.in"
#define outfile "2stacks.out"

const int NMAX = 100005;

enum MoveType {
	TO_A,
	TO_B,
	FROM_A,
	FROM_B
};

struct Move {
	MoveType type;
	int x;
};

Move moves[2*NMAX];
int perm[NMAX];
int a[NMAX];
int b[NMAX];
int c[NMAX];
int col[NMAX];
int movesn;
int an, bn;
int n;

void Init()
{
	freopen(inpfile, "r", stdin);
	freopen(outfile, "w", stdout);
}

void Out(bool ok)
{
	if (ok) {
		for (int i = 1; i <= 2*n; i++)
		{
			switch (moves[i].type)
			{
			case TO_A:
				printf("move %d to A\n", c[moves[i].x]);
				break;

			case TO_B:
				printf("move %d to B\n", c[moves[i].x]);
				break;

			case FROM_A:
				printf("move %d from A\n", c[moves[i].x]);
				break;
			case FROM_B:
				printf("move %d from B\n", c[moves[i].x]);
				break;
			}
		}
	} 
	else
		printf("impossible\n");

	exit(0);
}

void Inp()
{
	int num[NMAX];
	int x;

	scanf("%d", &n);
	for (int i = 1; i <= n; i++) 
	{
		scanf("%d", &x);
		num[x] = i;
		c[i] = x;
	}

	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &x);
		perm[i] = num[x];
	}
}

void Solve()
{
	int rperm[NMAX];
	for (int i = 1; i <= n; i++)
		rperm[perm[i]] = i;
	
	int max = 0;

	a[0] = 0;
	b[0] = 0;
	
	an = 0; 
	bn = 0;
	movesn = 0;

	for (int i = 1; i <= n; i++)
		if (perm[i] == a[an])
		{
			movesn++;
			moves[movesn].type = FROM_A;
			moves[movesn].x = perm[i];
			an--;
		}
		else if (perm[i] == b[bn])
		{
			movesn++;
			moves[movesn].type = FROM_B;
			moves[movesn].x = perm[i];
			bn--;
		}
		else if (perm[i] < max)
			Out(false);
		else 
		{
			bool u[2];

			for (int j = max + 1; j < perm[i]; j++)
			{
				memset(u, 0, sizeof(u));

				for (int k = i + 1; k < rperm[j]; k++)
				{
					if (perm[k] < j)
						u[col[perm[k]]] = true;
				}

				if (!u[0])
				{
					col[j] = 0;

					an++;
					a[an] = j;

					movesn++;
					moves[movesn].type = TO_A;
					moves[movesn].x = j;
				} else if (!u[1])
				{
					col[j] = 1;

					bn++;
					b[bn] = j;

					movesn++;
					moves[movesn].type = TO_B;
					moves[movesn].x = j;
				} else
					Out(0);
			}

			movesn++;
			moves[movesn].type = TO_A;
			moves[movesn].x = perm[i];

			movesn++;
			moves[movesn].type = FROM_A;
			moves[movesn].x = perm[i];

			max = perm[i];
		}

}

int main()
{
	Init();
	Inp();
	Solve();
	Out(true);
	return 0;
}
