#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define inpfile "2stacks.in"
#define outfile "2stacks.out"

const int NMAX = 100005;

enum MoveType {
	TO_A,
	TO_B,
	FROM_A,
	FROM_B
};

struct Move {
	MoveType type;
	int x;
};

Move moves[2*NMAX];
int perm[NMAX];
int num[NMAX];
int a[NMAX];
int b[NMAX];
int col[NMAX];
int an, bn;
int n;

int max[NMAX];

void Init()
{
	freopen(inpfile, "r", stdin);
	freopen(outfile, "w", stdout);
}

void Out(bool ok)
{
	if (ok) {
		for (int i = 1; i <= 2*n; i++)
		{
			switch (moves[i].type)
			{
			case TO_A:
				printf("move %d to A\n", num[moves[i].x]);
				break;

			case TO_B:
				printf("move %d to B\n", num[moves[i].x]);
				break;

			case FROM_A:
				printf("move %d from A\n", num[moves[i].x]);
				break;
			case FROM_B:
				printf("move %d from B\n", num[moves[i].x]);
				break;
			}
		}
	} 
	else
		printf("impossible\n");

	exit(0);
}

void Inp()
{
	int q[NMAX];
	int x;
	
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &x);
		q[x] = i;
		num[i] = x;
	}

	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &x);
		perm[i] = q[x];
	}
}

void Solve()
{
	max[1] = perm[1];
	for (int i = 2; i <= n; i++)
		if (perm[i] > max[i - 1])
			max[i] = perm[i];
		else
			max[i] = max[i - 1];

	for (int i = n; i > 0; i--)
		if (col[perm[i]] == 0)
		{
			col[perm[i]] = 1;
			for (int j = i - 1; j > 0; j--)
				if ((perm[j] < perm[i]) && (perm[i] < max[j]))
					col[perm[j]] = 3 - col[perm[i]];
		}

	an = 0;
	bn = 0;
	int x = 1;
	int k = 1;

	for (int i = 1; i <= 2*n; i++)
	{
		if (perm[k] == a[an])
		{
			moves[i].type = FROM_A;
			moves[i].x = perm[k];
			an--;
			k++;
		} else
		if (perm[k] == b[bn])
		{
			moves[i].type = FROM_B;
			moves[i].x = perm[k];
			bn--;
			k++;
		} else
		if (x <= n) {
			if (col[x] == 1)
			{
				moves[i].type = TO_A;
				moves[i].x = x;
				an++;
				a[an] = x;
			} else {
				moves[i].type = TO_B;
				moves[i].x = x;
				bn++;
				b[bn] = x;
			}
			x++;
		} else
			Out(false);
	}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out(true);
	return 0;
}
