#include <cassert>
#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define maxn 3000
#define maxe 3000
#define maxw 1e6
#define inf 1e20

struct edge
{
  int a, b;
  double w;
};
edge e[maxe * 2];
double koef, d[maxn + 1][maxn];
int n, m, st, en, path[maxn + 1], la[maxn + 1][maxn];

double Calc( int plen, double s )
{
  int i, j;
  double newd;
  for (i = 0; i <= plen; i++)
    for (j = 0; j < n; j++)
      d[i][j] = inf;
  d[0][st] = 0;
  for (i = 0; i < plen; i++)
    for (j = 0; j < m; j++)
      if (d[i + 1][e[j].b] > (newd = d[i][e[j].a] + max(0.0, e[j].w - s * koef)))
      {
        d[i + 1][e[j].b] = newd;
        la[i + 1][e[j].b] = e[j].a;
      }
  if (d[plen][en] < inf)
  {
    i = plen, j = en;
    while (i >= 0)
      path[i] = j, j = la[i--][j];
  }
  return s + d[plen][en];
}

int main( void )
{
  freopen("discount.in", "rt", stdin);
  freopen("discount.out", "wt", stdout);
  
  int i;
  scanf("%d%d", &n, &m);
  assert(1 <= n && n <= maxn);
  assert(0 <= m && m <= maxe);
  for (i = 0; i < m; i++)
  {
    scanf("%d%d%lf", &e[i].a, &e[i].b, &e[i].w);
    assert(1 <= e[i].a && e[i].a <= n);
    assert(1 <= e[i].b && e[i].b <= n);
    assert(0.0 <= e[i].w && e[i].w <= maxw);
    e[i].a--, e[i].b--;
  }
  for (i = 0; i < m; i++)
    e[i + m] = e[i], swap(e[i].a, e[i].b);
  m *= 2;

  scanf("%d%d%lf", &st, &en, &koef);
  assert(1 <= st && st <= n);
  assert(1 <= en && en <= n);
  assert(0.0 <= koef && koef <= 1.0);
  st--, en--;

  double ansf = inf, anss, f;
  int ansk;
  for (int k = 0; k <= n; k++)
  {
    double mi = 0, ma = maxw * maxn, a, b;
    while (ma - mi > 1e-9)
    {
      a = mi + 1 * (ma - mi) / 3;
      b = mi + 2 * (ma - mi) / 3;
      if (Calc(k, a) < Calc(k, b))
        ma = b;
      else
        mi = a;
    }
    if ((f = Calc(k, a)) < ansf)
      ansf = f, anss = mi, ansk = k;
  }

  assert(ansf < inf);
  printf("%.9lf %.9lf\n", anss, ansf);
  Calc(ansk, anss);
  for (i = 0; i <= ansk; i++)
    printf("%d ", path[i] + 1);
  return 0;
}
