#include <cassert>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define maxn 3000
#define maxe 3000
#define maxw 1e6
#define inf 1e20

struct edge
{
  int a, b;
  double w;
};
vector <edge> c[maxn];
double koef, d[maxn];
int n, st, en, pn, path[maxn + 1], la[maxn], u[maxn];

double Calc( double s )
{
  int i, j, mi;
  double newd;
  for (j = 0; j < n; j++)
    d[j] = inf, u[j] = 0;
  d[mi = st] = 0;
  while (mi != -1)
  {
    u[mi] = 1;
    for (i = 0; i < c[mi].size(); i++)
      if (d[j = c[mi][i].b] > (newd = d[mi] + max(0.0, c[mi][i].w - s * koef)))
        d[j] = newd, la[j] = mi;
    mi = -1;
    for (i = 0; i < n; i++)
      if (!u[i] && (mi == -1 || d[mi] > d[i]))
        mi = i;
  }
  if (d[en] < inf)
  {
    j = en, pn = 0;
    while (j != st)
      path[pn++] = j, j = la[j];
    path[pn++] = st;
  }
  return s + d[en];
}

int main( void )
{
  freopen("discount.in", "rt", stdin);
  freopen("discount.out", "wt", stdout);
  
  int i, m;
  scanf("%d%d", &n, &m);
  assert(1 <= n && n <= maxn);
  assert(0 <= m && m <= maxe);
  while (m--)
  {
    edge e;
    scanf("%d%d%lf", &e.a, &e.b, &e.w);
    assert(1 <= e.a && e.a <= n);
    assert(1 <= e.b && e.b <= n);
    assert(0.0 <= e.w && e.w <= maxw);
    e.a--, e.b--;
    c[e.a].push_back(e);
    swap(e.a, e.b);
    c[e.a].push_back(e);
  }

  scanf("%d%d%lf", &st, &en, &koef);
  assert(1 <= st && st <= n);
  assert(1 <= en && en <= n);
  assert(0.0 <= koef && koef <= 1.0);
  st--, en--;

  double mi = 0, ma = maxw * maxn, a, b;
  while (ma - mi > 1e-9)
  {
    a = mi + 1 * (ma - mi) / 3;
    b = mi + 2 * (ma - mi) / 3;
    if (Calc(a) < Calc(b))
      ma = b;
    else
      mi = a;
  }

  assert(Calc(mi) < inf);
  printf("%.9lf %.9lf\n", mi, Calc(mi));
  Calc(mi);
  while (pn--)
    printf("%d ", path[pn] + 1);
  return 0;
}
