// something + dijkstra

#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES
#pragma comment (linker, "/STACK:30000000")

#include <algorithm>
#include <iostream>
#include <cassert>
#include <sstream>
#include <utility>
#include <string>
#include <memory>
#include <vector>
#include <cstdio>
#include <cmath>
#include <set>
#include <map>

using namespace std;
//using namespace stdext;

#define cinfile "large.in"
#define coutfile "large.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define tr(a, it) for (typeof((a).begin()) it = (a).begin(), it != (a).end(); ++it)
#define f0(a) memset((a), 0, sizeof(a))
#define ff(a) memset((a), -1, sizeof(a))
#define fv(a, value) tr(a, it) { (*it) = value; }
#define present(a, x) ((a).find(x) != (a).end())
#define sz(a) (int)((a).size())

typedef vector < int > VI;
typedef vector < VI > VII;
typedef pair < int, int > pii;
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

typedef long long i64;

const int inf = (int)1e+9;
const double eps = (double)1e-9;
const int nmax = 10001;
const int mmax = 20001;
const int kmax = 51;

struct tedge {
	int y;
	int cost;
	tedge() {}
	tedge(int yy, int cc) { y = yy; cost = cc; }
} edge[mmax];

int n, m, k, t, source, sink;
int cost[kmax];
int head[nmax];
int next[mmax];

set < pii > use;
int d[nmax];
int way[nmax];

int ans = inf;
VI answay;

void init() {
	ff(head);
	int x, y, z;
	scanf("%d%d%d%d", &n, &m, &k, &t);
	forn(i, t) { scanf("%d", &cost[i]); }
    forn(i, m) {
    	scanf("%d%d%d", &x, &y, &z);
		x--, y--, z--;

        edge[2*i] = tedge(y, cost[z]);
        next[2*i] = head[x];
        head[x] = 2*i;

        edge[2*i + 1] = tedge(x, cost[z]);
        next[2*i + 1] = head[y];
        head[y] = 2*i + 1;
    }
    scanf("%d%d", &source, &sink);
	source--, sink--;
}

void solve() {
	cost[t] = 0;
	sort(cost, cost + t + 1);
	forn(p, t + 1) {
        use.clear();
        ff(way);
        forn(i, n) { d[i] = inf; }
        use.insert(mp(0, source));
        d[source] = 0;

        while (!use.empty()) {
        	int j = use.begin()->second;
            use.erase(use.begin());

            int cur = head[j];
            while (cur != -1) {
            	int i = edge[cur].y;
                if (d[i] > d[j] + max(edge[cur].cost - cost[p], 0)) {
                	if (d[i] != inf) use.erase(use.find(mp(d[i], i)));

                	d[i] = d[j] + max(edge[cur].cost - cost[p], 0);
                	use.insert(mp(d[i], i));
                	way[i] = j;
                }
                cur = next[cur];
            }
        }

        if (ans > d[sink] + k*cost[p]) {
        	ans = d[sink] + k*cost[p];
        	answay.clear();
        	int cur = sink;
        	do {
        		answay.insert(answay.begin(), cur);
        		cur = way[cur];
        	} while (cur != -1);
        }
	}
}

void writeanswer() {
	printf("%d\n", ans);
}

int main() {
	freopen(cinfile, "rt", stdin);
	freopen(coutfile, "wt", stdout);

	init();
	solve();
	writeanswer();

	return 0;
}
