{$APPTYPE CONSOLE}
{$R+,Q+,S+,I+,H+,O-}

uses
  Math, SysUtils;

Const
  TaskID='large';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=10000;
  MaxM=10000;
  MaxK=50;
  MaxT=50;
  Inf=MaxLongInt Div 2;

Var
  N,M,K,T,Res,RLen,Start,Finish:Integer;
  RPath:Array[1..MaxM]Of Integer;
  Cost:Array[0..MaxT]Of Integer;
  EDest,ENext,EType:Array[1..2*MaxM]Of Integer;
  EFirst:Array[1..MaxN]Of Integer;
  Len,Prev:Array[1..MaxN]Of Integer;
  Mark:Array[1..MaxN]Of Boolean;
  NHeap:Integer;
  Heap,HeapAt:Array[1..MaxN]Of Integer;

Procedure Load;
Var
  I,NE,A,B,C:Integer;
Begin
  ReSet(Input,InFile);
  Read(N,M,K,T);
  Assert((N>=1) And (N<=MaxN));
  Assert((M>=1) And (M<=MaxM));
  Assert((K>=1) And (K<=MaxK));
  Assert((T>=1) And (T<=MaxT));
  For I:=1 To T Do Read(Cost[I]);
  NE:=0;
  FillChar(EFirst,SizeOf(EFirst),0);
  For I:=1 To M Do Begin
    Read(A,B,C);
    Inc(NE);
    ENext[NE]:=EFirst[A];
    EDest[NE]:=B;
    EType[NE]:=C;
    EFirst[A]:=NE;
    Inc(NE);
    ENext[NE]:=EFirst[B];
    EDest[NE]:=A;
    EType[NE]:=C;
    EFirst[B]:=NE;
  End;
  Read(Start,Finish);
  Close(Input);
End;

Procedure HeapSwap(A,B:Integer);
Var
  T:Integer;
Begin
  T:=Heap[A];
//  WriteLn(A,' ',B);
  Heap[A]:=Heap[B];
  Heap[B]:=T;
  HeapAt[Heap[A]]:=A;
  HeapAt[Heap[B]]:=B;
End;

Procedure HeapUp(At:Integer);
Begin
  While (At>1) And (Len[Heap[At Div 2]]>Len[Heap[At]]) Do Begin
    HeapSwap(At,At Div 2);
    At:=At Div 2;
  End;
End;

Procedure HeapDown(At:Integer);
Var
  I:Integer;
Begin
  While True Do Begin
    I:=At;
    If (2*At<=NHeap) And (Len[Heap[2*At]]<Len[Heap[I]]) Then I:=2*At;
    If (2*At+1<=NHeap) And (Len[Heap[2*At+1]]<Len[Heap[I]]) Then I:=2*At+1;
    If I=At Then Break;
    HeapSwap(At,I);
    At:=I;
  End;
End;

Function Evaluate(Split:Integer):Integer;
Var
  Tmp,I,J,CECost,CE,Cur,CLen,SI,L,R,ML,MR:Integer;
Begin
    For I:=1 To N Do Len[I]:=Inf;
    Len[Finish]:=0;
    FillChar(Mark,SizeOf(Mark),False);

    NHeap:=N;
    For I:=1 To N Do Begin
      Heap[I]:=I;
      HeapAt[I]:=I;
    End;
    HeapUp(HeapAt[Finish]);

    While Not Mark[Start] Do Begin
      Cur:=Heap[1];
      CLen:=Len[Cur];
      If CLen>=Inf Then Break;
      Mark[Cur]:=True;
      HeapSwap(1,NHeap);
      Dec(NHeap);
      HeapDown(1);

      CE:=EFirst[Cur];
      While CE>0 Do Begin
        CECost:=Cost[EType[CE]]-Split;
        If CECost<0 Then CECost:=0;
        If Not Mark[EDest[CE]] And (CLen+CECost<Len[EDest[CE]]) Then Begin
          Len[EDest[CE]]:=CLen+CECost;
          Prev[EDest[CE]]:=Cur;
          HeapUp(HeapAt[EDest[CE]]);
        End;
        CE:=ENext[CE];
      End;
    End;

    If Mark[Start] Then Begin
      Result:=Len[Start]+K*Split;
    End Else RunError(57);
End;

Procedure Solve;
Var
  Tmp,I,J,CECost,CE,Cur,CLen,SI,Split,L,R,ML,MR:Integer;
  P:Array[0..MaxT]Of Integer;
Begin
  Cost[0]:=0;
  For I:=0 To T Do P[I]:=I;
  For I:=0 To T Do
    For J:=T DownTo I+1 Do
      If Cost[P[J-1]]>Cost[P[J]] Then Begin
        Tmp:=P[J-1];
        P[J-1]:=P[J];
        P[J]:=Tmp;
      End;
  Res:=Inf;
  L:=0;
  R:=T;
  While True Do Begin
    ML:=(2*L+R) Div 3;
    MR:=(2*R+L) Div 3;
    If Evaluate(Cost[P[ML]])<Evaluate(Cost[P[MR]]) Then Begin
      If R<=MR Then Break Else R:=MR;
    End Else Begin
      If L>=ML Then Break Else L:=ML;
    End;
  End;
  For I:=L To R Do Res:=Min(Res,Evaluate(Cost[P[I]]));
End;

Procedure Save;
Var
  I:Integer;
Begin
  ReWrite(Output,OutFile);
  WriteLn(Res);
  Close(Output);
End;

begin
  Load;
  Solve;
  Save;
end.
