#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "large.in"
#define C_OUT_FILE "large.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>
#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

int n, m, k, t, ans;

struct edge {
	int v, w;
	edge() {}
	edge(int v, int w) {
		this->v = v;
		this->w = w;
	}
};

const int NMAX = 10000;
const int TMAX = 50;

int b, e;
int cost[TMAX];
vector<edge> g[NMAX];
vector<int> d, p, rp;

void outdata() {
	if (ans >= INF) {
		printf("No solution\n");
	} else {
		vector<int> res;
		printf("%d\n", ans);
/*		int v = e;
		while (v != -1) {
			res.pb(v);
			v = rp[v];
		}
		reverse(all(res));
		printf("%d\n", res.size());
		forv(i, res) {
			if (i > 0) printf(" ");
			printf("%d", 1 + res[i]);
		}
		printf("\n");*/
	}
}

int dijkstra(int mcost) {
	d = vector<int>(n, INF);
	d[b] = 0;
	p = vector<int>(n, -1);
	set< pair<int, int> > ds;
	ds.insert( mp(0, b) );
	while ( !ds.empty() ) {
		int v = ds.begin()->second;
		if (v == e) break;
		ds.erase(ds.begin());
		forv(i, g[v]) {
			edge u = g[v][i];
			u.w = max(u.w - mcost, 0);
			if (d[u.v] > d[v] + u.w) {
				ds.erase( mp(d[u.v], u.v) );
				d[g[v][i].v] = d[v] + u.w;
				ds.insert( mp(d[u.v], u.v) );
				p[u.v] = v;
			}
		}
	}
	return d[e] + mcost * k;
}

void solve() {
	ans = dijkstra(0);
	rp = p;
	forn(i, t) {
		int cr = dijkstra(cost[i]);
		if (ans > cr) {
			ans = cr;
			rp = p;
		}
	}
}

void readdata() {
	scanf("%d%d%d%d", &n, &m, &k, &t);
	forn(i, t) {
		scanf("%d", &cost[i]);
	}
	forn(i, m) {
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		c = cost[c - 1];
		--a, --b;
		g[a].pb(edge(b, c));
		g[b].pb(edge(a, c));
	}
	scanf("%d%d", &b, &e);
	--b, --e;
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

