#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

#define N 8

int loose_num = 0, win_num = 0, vertex_num = 0, edge_num = 0, eat_num = 0;

#define MP make_pair
#define X first
#define Y second
typedef pair <int, int> PII;

PII operator + ( PII a, PII b ) { return MP(a.X + b.X, a.Y + b.Y); }
PII operator - ( PII a, PII b ) { return MP(a.X - b.X, a.Y - b.Y); }

#define BIT(a, i) (((a) >> (i)) & 1)
#define SETB(a, i, x) (a) = ((a) & ~(1 << (i))) | ((x) << (i))
#define SGN(a) ((a) > 0 ? 1 : ((a) < 0 ? -1 : 0))

void SwapBits( char &a, int i, int j )
{
  int b1 = BIT(a, i), b2 = BIT(a, j);
  SETB(a, i, b2), SETB(a, j, b1);
}

char Code( PII p, char c )
{
  return (c << 5) + (p.Y << 2) + (p.X >> 1);
}

PII De( char c )
{
  if (c == -1)
    return MP(-1, -1);
  c &= 31;
  return MP(((c & 3) << 1) + ((c >> 2) & 1), c >> 2);
}

char Col( char c )
{
  if (c == -1)
    return -1;
  return BIT(c, 5);
}

#define BLACK 0
#define WHITE 1
typedef pair <int, char> HREN;

struct State
{
  char p[4], q;
  State() {}
  State( char p0, char p1, char p2, char p3, char _q ) 
  { 
    p[0] = p0, p[1] = p1, p[2] = p2, p[3] = p3, q = _q;
  }
  void Cor()
  {
    int i, j;
    for (i = 0; i < 4; i++)
      if (p[i] == -1)
        SETB(q, i, 0);
    for (i = 0; i < 4; i++)
      for (j = 0; j < 4; j++)
        if (i != j && p[i] < p[j])
          swap(p[i], p[j]), SwapBits(q, i, j);
  }
  HREN hREN()
  {
    return MP(*((int *)(p)), q);
  }
  void Out( int space )
  {
    char m[N][N + 1];
    int i, j;
    for (i = 0; i < N; i++)
      for (j = 0; j <= N; j++)
        m[i][j] = (j == N ? 0 : '.');
    for (i = 0; i < 4; i++)
      if (p[i] != -1)
        m[De(p[i]).Y][De(p[i]).X] = (Col(p[i]) == WHITE ? (BIT(q, i) ? 'Q' : 'P') : (BIT(q, i) ? 'q' : 'p'));
    for (i = N - 1; i >= 0; i--)
      printf("%*s%s\n", space, "", m[i]);
    puts("");
  }
};

bool operator == ( State a, State b ) { return a.hREN() == b.hREN(); }
bool operator < ( State a, State b ) { return a.hREN() < b.hREN(); }

int InvY( int y ) 
{ 
  return N - y - 1;
}

void InvC( char &c )
{ 
  if (c != -1)
  {
    PII p = De(c);
    c = Code(MP(InvY(p.X), InvY(p.Y)), 1 - Col(c));
  }
}

void Inv( State &p )
{
  for (int i = 0; i < 4; i++)
    InvC(p.p[i]);
  p.Cor();
}

#define DRAW  0
#define WIN   1
#define LOOSE 2

#define maxh 10000010
#define maxe 45000010
State hS[maxh];
char Eat[maxh], Res[maxh], inDeg[maxh];
int lN = 0, lHe[maxh], lNe[maxe], lTo[maxe];
int mN = 0, mHe[maxh], mNe[maxe], mTo[maxe];

#define maxq 7000010
int qSt = 0, qEn = 0, q[maxq];

void PushQ( int h )
{
  q[qEn++] = h;
  if (qEn == maxq)
    qEn = 0;
}

int PopQ( void )
{
  int r = q[qSt++];
  if (qSt == maxq)
    qSt = 0;
  return r;
} 

int Hash( State p )
{
  unsigned h = p.q;
  for (int i = 0; i < 4; i++)
    h = h * 239 + p.p[i];
  h %= maxh;
  while (hS[h].q != -1 && !(hS[h] == p))
    if (++h == maxh)
      h = 0;
  return h;
}

#define COR(p) (0 <= (p).X && (p).X < N && 0 <= (p).Y && (p).Y < N)
#define EMPTY(p) (COR(p) && m[(p).Y][(p).X] == -1)
char m[N][N];

void AddP( char c )
{
  if (c != -1)
    m[De(c).Y][De(c).X] = Col(c);
}

void BuildM( State p )
{
  memset(m, -1, sizeof(m));
  for (int i = 0; i < 4; i++)
    AddP(p.p[i]);
}

int Beat( PII st, int q, PII en )
{
  PII d = en - st;
  d.Y = SGN(d.Y), d.X = SGN(d.X);
  if (!q)
    return abs(en.Y - st.Y) == 1 && abs(en.X - st.X) == 1 && EMPTY(en + d);
  if (!(abs(en.Y - st.Y) == abs(en.X - st.X) && EMPTY(en + d)))
    return 0;
  for (st = st + d; st != en; st = st + d)
    if (!EMPTY(st))
      return 0;
  return 1;
}

void CalcEat( State p )
{
  int i, j, h = Hash(p);
  if (hS[h].q != -1)
    return;
  BuildM(p);
  vertex_num++;
  hS[h] = p;
  for (i = 0; i < 4; i++)
    if (Col(p.p[i]) == WHITE)
      for (j = 0; j < 4; j++)
        if (Col(p.p[j]) == BLACK && Beat(De(p.p[i]), BIT(p.q, i), De(p.p[j])))
          Eat[h] = 1;
  eat_num += Eat[h];
}

#define max_moves 999
int mn, moves[max_moves];

void TryMove( State p, int eat );

void Go( State p, int eat, PII d )
{
  PII pos = De(p.p[0]) + d;
  if (!COR(pos))
    return;
  BuildM(p);
  if (m[pos.Y][pos.X] == BLACK)
  {
    int i;
    for (i = 0; i < 4; i++)
      if (pos == De(p.p[i]))
        break;
    p.p[i] = -1;
    pos = pos + d;
    if (!EMPTY(pos))
      return;
    p.p[0] = Code(pos, WHITE);
    if (pos.Y == N - 1)
      SETB(p.q, 0, 1);

    State t = p; t.Cor();
    int h = Hash(t);
    if (Eat[h])
      TryMove(p, 1), BuildM(p);
    else
      moves[mn++] = h;
  }
  else if (!eat && EMPTY(pos))
  {
    p.p[0] = Code(pos, WHITE);
    if (pos.Y == N - 1)
      SETB(p.q, 0, 1);
    p.Cor();
    moves[mn++] = Hash(p);
  }
}

void Go2( State p, int eat, PII d )
{
  PII pos = De(p.p[0]) + d;

  BuildM(p);
  while (COR(pos))
  {
    if (m[pos.Y][pos.X] == BLACK)
    {
      State t = p, t2;
      int i;
      for (i = 0; i < 4; i++)
        if (pos == De(p.p[i]))
          break;
      t.p[i] = -1;

      PII cpos = pos + d;
      int fEat = 0, ftmp;
      while (EMPTY(cpos))
      {
        t.p[0] = Code(cpos, WHITE);
        t2 = t, t2.Cor();
        fEat |= Eat[Hash(t2)];
        cpos = cpos + d;
      }
      cpos = pos + d;
      while (EMPTY(cpos))
      {
        t.p[0] = Code(cpos, WHITE);
        t2 = t, t2.Cor();
        if ((ftmp = Eat[Hash(t2)]) || !fEat)
          if (ftmp)
            TryMove(t, 1), BuildM(p);
          else
            moves[mn++] = Hash(t2);
        cpos = cpos + d;
      }
    }
    else if (!eat && EMPTY(pos))
    {
      State t = p;
      t.p[0] = Code(pos, WHITE);
      t.Cor();
      moves[mn++] = Hash(t);
    }
    if (!EMPTY(pos))
      break;
    pos = pos + d;
  }  
}

void TryMove( State p, int eat )
{
  if (p.p[0] == -1 || Col(p.p[0]) != WHITE)
    return;
  if (BIT(p.q, 0))
  {
    Go2(p, eat, MP(-1, -1));
    Go2(p, eat, MP(1, -1));
    Go2(p, eat, MP(1, 1));
    Go2(p, eat, MP(-1, 1));
  }
  else
  {
    Go(p, eat, MP(-1, 1));
    Go(p, eat, MP(1, 1));
    if (eat)
    {
      Go(p, eat, MP(-1, -1));
      Go(p, eat, MP(1, -1));
    }
  }
}

void ProcessState( State p, int eat )
{
  int i;
  mn = 0;
  for (i = 0; i < 4; i++)
  {
    swap(p.p[0], p.p[i]), SwapBits(p.q, 0, i);
    TryMove(p, eat);
    swap(p.p[0], p.p[i]), SwapBits(p.q, 0, i);
  }
  sort(moves, moves + mn);

  int hp = Hash(p);
  if (mn == 0)
  {
    Res[hp] = WIN;
    PushQ(hp);
    win_num++;
    return;
  }

/*
  if (Hash(p) == 2739589)
  {
    p.Out();
    for (i = 0; i < mn; i++)
      vTmp.push_back(moves[i]);
  }
*/

  for (i = 0; i < mn; i++)
    if (!i || !(moves[i - 1] == moves[i]))
    {
      State q = hS[moves[i]];
      Inv(q);
      int hq = Hash(q);
      
      lNe[lN] = lHe[hq], lTo[lN] = hp, lHe[hq] = lN;
      lN++;
      
      mNe[mN] = mHe[hp], mTo[mN] = hq, mHe[hp] = mN;
      mN++;
 
      inDeg[hp]++;
      edge_num++;
    }
}

void dfs( int v, State &p )
{
  int i;
  if (v == 4)
  {
    int sumc = 0, num = 0;
    for (i = 0; i < 4; i++)
      if (p.p[i] != -1)
        sumc += (Col(p.p[i]) == WHITE), num++;
    if (sumc > 3 || num - sumc > 3)
      return;
    for (p.q = 0; p.q < (1 << 4); p.q++)
    {
      for (i = 0; i < 4; i++)
      {
        if (BIT(p.q, i) && p.p[i] == -1)
          break;
        if (!BIT(p.q, i) && p.p[i] != -1 &&
           ((Col(p.p[i]) == WHITE && De(p.p[i]).Y == N - 1) ||
            (Col(p.p[i]) == BLACK && De(p.p[i]).Y == 0)))
          break;
      }
      if (i < 4)
        continue;
      CalcEat(p);
    }
    return;
  }
  for (p.p[v] = (v ? p.p[v - 1] : -1); p.p[v] < 64; p.p[v]++)
  {
    int i;
    for (i = 0; i < v; i++)
      if (p.p[i] != -1 && De(p.p[i]) == De(p.p[v]))
        break;
    if (i < v)
      continue;
    dfs(v + 1, p);
  }
}

void OutTree( int h, int dep, int space )
{
//  fprintf(stderr, "OutTree: h=%d dep=%d space=%d\n", h, dep, space);
  if (!dep)
    return;
//  if (Res[h] == LOOSE)
  printf("%*sResult = %s\n", space, "", (Res[h] == DRAW ? "DRAW" : (Res[h] == WIN ? "WIN" : "LOSE")));
  hS[h].Out(space);
  for (int e = mHe[h]; e != -1; e = mNe[e])
    OutTree(mTo[e], dep - 1, space + 5);
}

int main( void )
{
  int i, j;
  memset(hS, -1, sizeof(hS));
  memset(Eat, 0, sizeof(Eat));
  memset(Res, DRAW, sizeof(Res));
  memset(lHe, -1, sizeof(lHe));
  memset(mHe, -1, sizeof(mHe));
  memset(inDeg, 0, sizeof(inDeg));

  fprintf(stderr, "Start...\n");

  State p;
  dfs(0, p);

  fprintf(stderr, "vertex_num = %d\n", vertex_num);
  fprintf(stderr, "eat_num = %d\n", eat_num);

  int cou = 0;

  for (i = 0; i < maxh; i++)
    if (hS[i].q != -1)
    {
      if (++cou % 100000 == 0)
        fprintf(stderr, "%d\n", cou);
      ProcessState(hS[i], Eat[i]);
    }
                                 
  fprintf(stderr, "edge_num = %d (lN = %d)\n", edge_num, lN);
  fprintf(stderr, "win_num = %d\n", win_num);
  fprintf(stderr, "qSt = %d, qEn = %d\n", qSt, qEn);

  while (qSt != qEn)
  {
    if (++cou % 100000 == 0)
      fprintf(stderr, "%d\n", cou);
    int e, h = PopQ();
    for (e = lHe[h]; e != -1; e = lNe[e])
      if (Res[i = lTo[e]] == DRAW)
      {
        if (Res[h] == LOOSE)
          Res[i] = WIN, PushQ(i), win_num++;
        else if (--inDeg[i] == 0)
          Res[i] = LOOSE, PushQ(i), loose_num++;
      }
  }


  fprintf(stderr, "win_num = %d\n", win_num);
  fprintf(stderr, "loose_num = %d\n", loose_num);

/*
  fprintf(stderr, "OutTree:\n");
  OutTree(2739589, 4, 0);
  fprintf(stderr, "OutTree: ok\n");
*/

  int test_n;
  scanf("%d\n", &test_n);
  while (test_n--)
  {
    char s[N][N + 1];
    for (i = N - 1; i >= 0; i--)
      gets(s[i]);
    State p(-1, -1, -1, -1, 0);
    int k = 0;
    for (i = 0; i < N; i++)
      for (j = 0; j < N; j++)
        if (s[i][j] == 'P' || s[i][j] == 'Q')
          p.p[k] = Code(MP(j, i), WHITE), SETB(p.q, k, s[i][j] == 'Q'), k++;
        else if (s[i][j] == 'p' || s[i][j] == 'q')
          p.p[k] = Code(MP(j, i), BLACK), SETB(p.q, k, s[i][j] == 'q'), k++;
    p.Cor();
    int r = Res[Hash(p)];
    printf("hash=%d eat=%d\n", Hash(p), Eat[Hash(p)]);
    puts(r == WIN ? "White" : (r == LOOSE ? "Black" : "Draw"));
    gets(s[0]);
  }
  return 0;
}
