#define ProcessPawnAttacks(attackF, DIR) \
		if (attackF(pos, my, opp)) { \
			attack = true;        \
			int take = DIR(pos);   \
			int npos = DIR(take);  \
		 	int bmask = opp ^ (1 << take); \
			attacks[ka] = Board(wP & bmask, wQ & bmask, bP ^ (1 << pos) ^ (1 << npos), bQ, move ^ 1); \
			if (pawnAttack(npos, attacks[ka].bP | attacks[ka].bQ, attacks[ka].wP | attacks[ka].wQ)) attacks[ka].move ^= 1; \
			++ka; \
		} 

#define ProcessQueenMoves(attackF, CANDIR, DIR)	\
		{                        \
			int dest = attackF(pos, my, opp);  \
			int busy = my | opp;                 \
			attack = false;                 \
			if (dest != -1) {                    \
				int can_move = 0;            \
				int can_attack = 0;          \
				int take = DIR(dest);         \
				int bmask = opp ^ (1 << take);  \
				                                                             \
				Board tk(wP & bmask, wQ & bmask, bP, bQ ^ (1 << pos), move); \
				int x = take;                                                \
				while (1) {                                                  \
					if (!(CANDIR & (1 << x))) break;                      \
					x = DIR(x);                                           \
					if (busy & (1 << x)) break;                          \
					flipbit(can_move, x);                                \
					if (queenAttack(x, tk.bP | tk.bQ, tk.wP | tk.wQ)) flipbit(can_attack, x); \
				}                                                                                 \
				if (can_attack || attack) can_move = 0, attack = true;                            \
				                                                                                  \
				FOREACH(x, can_move) attacks[ka++] = Board(wP & bmask, wQ & bmask, bP, bQ ^ (1 << pos) ^ (1 << x), move ^ 1); \
				FOREACH(x, can_attack) attacks[ka++] = Board(wP & bmask, wQ & bmask, bP, bQ ^ (1 << pos) ^ (1 << x), move);   \
			} else if (!attack) {                                                                                               \
				int x = pos;                                                                                                \
				while (1) {                                                                                                 \
					if (!(CANDIR & (1 << x))) break;                                                                     \
					x = DIR(x);                                                                                          \
					if (busy & (1 << x)) break;                                                                         \
					moves[km++] = Board(wP, wQ, bP, bQ ^ (1 << pos) ^ (1 << x), move ^ 1);                              \
				}                                                                                                           \
			}                                                                                                                   \
		}		


void Board :: genBlackMoves() {
	int my = bP | bQ;
	int opp = wP | wQ;
	bool attack = false;
	int clear = ~(my | opp);

	FOREACH(pos, bP) {

		ProcessPawnAttacks(attackUp, UP);
		ProcessPawnAttacks(attackDown, DOWN);
		ProcessPawnAttacks(attackLeft, LEFT);
		ProcessPawnAttacks(attackRight, RIGHT);

		if (attack) continue;

		if ((CANDOWN & (1 << pos)) && (clear & (1 << DOWN(pos)))) {
			int npos = DOWN(pos);
			moves[km++] = Board(wP, wQ, bP ^ (1 << pos) ^ (1 << npos), bQ, move ^ 1);
		}
		if ((CANRIGHT & (1 << pos)) && (clear & (1 << RIGHT(pos)))) {
			int npos = RIGHT(pos);
			moves[km++] = Board(wP, wQ, bP ^ (1 << pos) ^ (1 << npos), bQ, move ^ 1);
		}
	}	

	FOREACH(pos, bQ) {
		ProcessQueenMoves(qAttackUp, CANUP, UP);
		ProcessQueenMoves(qAttackDown, CANDOWN, DOWN);
		ProcessQueenMoves(qAttackLeft, CANLEFT, LEFT);
		ProcessQueenMoves(qAttackRight, CANRIGHT, RIGHT);
	}

	if (ka != 0) km = 0;
}

#undef ProcessPawnAttacks
#undef ProcessQueenMoves