struct Board {  	                                	
	int wP, bP, wQ, bQ;
	char move;
	Board(int wP, int wQ, int bP, int bQ, char move) {
		int wpq = wP & WPQ;
		if (wpq) {
			wP ^= wpq;
			wQ ^= wpq;
		}

		int bpq = bP & BPQ;
		if (bpq) {
			bP ^= bpq;
			bQ ^= bpq;
		}

		this -> wP = wP;
		this -> bP = bP;
		this -> wQ = wQ;
		this -> bQ = bQ;
		this -> move = move;
	}
	Board() {
		wP = bP = wQ = bQ = 0;
		move = 0;
	}
	void genWhiteMoves();
	void genBlackMoves();
	void genMoves();
	void dump();

	int hash() {
		int result = 0;
		FOREACH(pos, wP) result = result * 39 + pos;
		FOREACH(pos, wQ) result = result * 41 + pos;
		FOREACH(pos, bP) result = result * 43 + pos;
		FOREACH(pos, bQ) result = result * 47 + pos;
		return (result << 1) | move;
	}

	int wamount() {
		int result = 0;
		FOREACH(pos, wP) ++result;
		FOREACH(pos, wQ) ++result;
		return result;
	}
	int bamount() {
		int result = 0;
		FOREACH(pos, bP) ++result;
		FOREACH(pos, bQ) ++result;
		return result;
	}
};

bool operator == (const Board &b1, const Board &b2) {
	return (b1.wP == b2.wP && b1.wQ == b2.wQ && b1.bP == b2.bP && b1.bQ == b2.bQ && b1.move == b2.move);
}

int km;
Board moves[64 * 64];
int ka;
Board attacks[64 * 64];

#define clear (~(my | opp))
inline bool attackUp(int x, int my, int opp) {
	if (!(CANUP & (1 << x))) return false;
	x = UP(x);
	if (my & (1 << x)) return false;
	if (opp & (1 << x)) {
		if ((CANUP & (1 << x)) && ((1 << UP(x)) & clear)) return true;
		return false;
	}
	return false;
}

inline bool attackDown(int x, int my, int opp) {
	if (!(CANDOWN & (1 << x))) return false;
	x = DOWN(x);
	if (my & (1 << x)) return false;
	if (opp & (1 << x)) {
		if ((CANDOWN & (1 << x)) && ((1 << DOWN(x)) & clear)) return true;
		return false;
	}
	return false;
}

inline bool attackLeft(int x, int my, int opp) {
	if (!(CANLEFT & (1 << x))) return false;
	x = LEFT(x);
	if (my & (1 << x)) return false;
	if (opp & (1 << x)) {
		if ((CANLEFT & (1 << x)) && ((1 << LEFT(x)) & clear)) return true;
		return false;
	}
	return false;
}
inline bool attackRight(int x, int my, int opp) {
	if (!(CANRIGHT & (1 << x))) return false;
	x = RIGHT(x);
	if (my & (1 << x)) return false;
	if (opp & (1 << x)) {
		if ((CANRIGHT & (1 << x)) && ((1 << RIGHT(x)) & clear)) return true;
		return false;
	}
	return false;
}

#undef clear

#define busy (my | opp)
inline int qAttackUp(int pos, int my, int opp) {
	for (int x = pos; CANUP & (1 << x); NULL) {
		if (attackUp(x, my, opp)) return x;
		x = UP(x);
		if (busy & (1 << x)) break;
	}
	return -1;
}

inline int qAttackDown(int pos, int my, int opp) {
	for (int x = pos; CANDOWN & (1 << x); NULL) {
		if (attackDown(x, my, opp)) return x;
		x = DOWN(x);
		if (busy & (1 << x)) break;
	}
	return -1;
}

inline int qAttackLeft(int pos, int my, int opp) {
	for (int x = pos; CANLEFT & (1 << x); NULL) {
		if (attackLeft(x, my, opp)) return x;
		x = LEFT(x);
		if (busy & (1 << x)) break;
	}
	return -1;
}

inline int qAttackRight(int pos, int my, int opp) {
	for (int x = pos; CANRIGHT & (1 << x); NULL) {
		if (attackRight(x, my, opp)) return x;
		x = RIGHT(x);
		if (busy & (1 << x)) break;
	}
	return -1;
}
#undef busy


bool queenAttack(int pos, int my, int opp) {
	return (qAttackLeft(pos, my, opp) != -1) || (qAttackRight(pos, my, opp) != -1) || (qAttackUp(pos, my, opp) != -1) || (qAttackDown(pos, my, opp) != -1);
}

inline bool pawnAttack(int pos, int my, int opp) {
	return attackUp(pos, my, opp) || attackLeft(pos, my, opp) || attackDown(pos, my, opp) || attackRight(pos, my, opp);
}

void Board :: genMoves() {
	km = ka = 0;
	if (move == 0)	
		genWhiteMoves();
	else
		genBlackMoves();
}

void Board :: dump() {
	for (int i = 7; i >= 0; --i) {
		for (int j = 0; j < 8; ++j) {
			int ptr = i * 8 + j;
			int f = __rotate[ptr];
			if (f == -1) fprintf(stdout, "."); else
			if (wP & (1 << f)) fprintf(stdout, "P"); else
			if (wQ & (1 << f)) fprintf(stdout, "Q"); else
			if (bP & (1 << f)) fprintf(stdout, "p"); else
			if (bQ & (1 << f)) fprintf(stdout, "q"); else
			fprintf(stdout, ".");
		}
		fprintf(stdout, "\n");
	}
	fprintf(stdout, "\n");
}

#include "wmoves.h"
#include "bmoves.h"
