#include <iostream>
#include <vector>
#include <queue>
#include "macro.h"
#include "const.h"
#include "board.h"
#include "hash.h"

using namespace std;

vector<int> g[POSITIONS];
char res[POSITIONS];
int deg[POSITIONS];
int dist[POSITIONS];

Hash hash;

int M = 0;
int N;

void buildGraph(Board start) {
	int v = hash.number(start);
	queue<int> q;
	q.push(v);
	res[v] = 1;

	while (!q.empty()) {
	        v = q.front();
	        q.pop();
		hash.v[v].board.genMoves();

		forn (i, km) {
			int w = hash.number(moves[i]);
			g[w].pb(v);
			++M;
			if (!res[w]) {
				res[w] = 1;
				q.push(w);
			}
		}
		forn (i, ka) {
			int w = hash.number(attacks[i]);
			g[w].pb(v);
			++M;
			if (!res[w]) {
				res[w] = 1;
				q.push(w);
			}
		}
	}
}

void solve() {
    N = hash.kv;
	Hash :: Record * vert = hash.v;

	cerr << N << endl;
	cerr << M << endl;

	queue<int> q;
	memset(res, 0, sizeof(res));
	memset(deg, 0, sizeof(deg));
	memset(dist, 0, sizeof(dist));

	forn (i, N)
		forn (j, g[i].size()) deg[g[i][j]]++;


	forn (i, N) {
		if ((vert[i].board.wP | vert[i].board.wQ) == 0 && (vert[i].board.bP | vert[i].board.bQ) != 0) {
			res[i] = 1;
			q.push(i);					
		} else
		if ((vert[i].board.wP | vert[i].board.wQ) != 0 && (vert[i].board.bP | vert[i].board.bQ) == 0) {
			res[i] = 2;
			q.push(i);					
		} else
		if (deg[i] == 0) {
			if (vert[i].board.move == 0)
				res[i] = 2;
			else
				res[i] = 1;
			q.push(i);	
		}
	}

	while (!q.empty()) {
		int cur = q.front();
		char winner = res[cur];
		int cdist = dist[cur];
		q.pop();

		forn (i, g[cur].size()) {
			int v = g[cur][i];

			if (res[v] != 0) continue;

			if (winner == vert[v].board.move + 1) {
				res[v] = winner;
				q.push(v);				
				dist[v] = cdist + 1;
			} else {
				deg[v]--;
				if (deg[v] == 0) {
					res[v] = winner;
					q.push(v);
					dist[v] = cdist + 1;
				}
			}
		}
	}
}


int main() {

	freopen("checkers.in", "rt", stdin);
	freopen("checkers.out", "wt", stdout);	

	init();

	vector<Board> input;
	Board board;
	memset(res, 0, sizeof(res));

	int tst;
	scanf("%d", &tst);
	forn (it, tst) {
		Board board;
		for (int i = 7; i >= 0; --i)
			forn (j, 8) {
				int c = getchar();
				while (c <= ' ') c = getchar();
				int ptr = i * 8 + j;
				if (c == 'p') flipbit(board.bP, __rotate[ptr]);
				if (c == 'P') flipbit(board.wP, __rotate[ptr]);
				if (c == 'q') flipbit(board.bQ, __rotate[ptr]);
				if (c == 'Q') flipbit(board.wQ, __rotate[ptr]);
			}
		buildGraph(board);
		input.pb(board);
		board.dump();
	}

	solve();

	forn (i, input.size()) {
		int v = hash.number(input[i]);
		if (res[v] == 1) cout << "White" << endl;
		if (res[v] == 2) cout << "Black" << endl;
		if (res[v] == 0) cout << "Draw" << endl;
		if (res[v] != 0) cout << dist[v] << endl;
	}

	return 0;
}