#define ProcessPawnAttacks(attackF, DIR) \
		if (attackF(pos, my, opp)) { \
			attack = true;        \
			int take = DIR(pos);   \
			int npos = DIR(take);  \
		 	int bmask = opp ^ (1 << take); \
			attacks[ka] = Board(wP ^ (1 << pos) ^ (1 << npos), wQ, bP & bmask, bQ & bmask, move ^ 1); \
			if (pawnAttack(npos, attacks[ka].wP | attacks[ka].wQ, attacks[ka].bP | attacks[ka].bQ)) attacks[ka].move ^= 1; \
			++ka; \
		} 

#define ProcessQueenMoves(attackF, CANDIR, DIR)	\
		{                        \
			int dest = attackF(pos, my, opp);  \
			int busy = my | opp;                 \
			attack = false;                 \
			if (dest != -1) {                    \
				int can_move = 0;            \
				int can_attack = 0;          \
				int take = DIR(dest);         \
				int bmask = opp ^ (1 << take);  \
				                                                             \
				Board tk(wP, wQ ^ (1 << pos), bP & bmask, bQ & bmask, move); \
				int x = take;                                                \
				while (1) {                                                  \
					if (!(CANDIR & (1 << x))) break;                      \
					x = DIR(x);                                           \
					if (busy & (1 << x)) break;                          \
					flipbit(can_move, x);                                \
					if (queenAttack(x, tk.wP | tk.wQ, tk.bP | tk.bQ)) flipbit(can_attack, x); \
				}                                                                                 \
				if (can_attack || attack) can_move = 0, attack = true;                            \
				                                                                                  \
				FOREACH(x, can_move) attacks[ka++] = Board(wP, wQ ^ (1 << pos) ^ (1 << x), bP & bmask, bQ & bmask, move ^ 1); \
				FOREACH(x, can_attack) attacks[ka++] = Board(wP, wQ ^ (1 << pos) ^ (1 << x), bP & bmask, bQ & bmask, move);   \
			} else if (!attack) {                                                                                               \
				int x = pos;                                                                                                \
				while (1) {                                                                                                 \
					if (!(CANDIR & (1 << x))) break;                                                                     \
					x = DIR(x);                                                                                          \
					if (busy & (1 << x)) break;                                                                         \
					moves[km++] = Board(wP, wQ ^ (1 << pos) ^ (1 << x), bP, bQ, move ^ 1);                              \
				}                                                                                                           \
			}                                                                                                                   \
		}		


void Board :: genWhiteMoves() {
	int my = wP | wQ;
	int opp = bP | bQ;
	bool attack = false;
	int clear = ~(my | opp);

	FOREACH(pos, wP) {

		ProcessPawnAttacks(attackUp, UP);
		ProcessPawnAttacks(attackDown, DOWN);
		ProcessPawnAttacks(attackLeft, LEFT);
		ProcessPawnAttacks(attackRight, RIGHT);

		if (attack) continue;

		if ((CANUP & (1 << pos)) && (clear & (1 << UP(pos)))) {
			int npos = UP(pos);
			moves[km++] = Board(wP ^ (1 << pos) ^ (1 << npos), wQ, bP, bQ, move ^ 1);
		}
		if ((CANLEFT & (1 << pos)) && (clear & (1 << LEFT(pos)))) {
			int npos = LEFT(pos);
			moves[km++] = Board(wP ^ (1 << pos) ^ (1 << npos), wQ, bP, bQ, move ^ 1);
		}
	}	

	FOREACH(pos, wQ) {
		ProcessQueenMoves(qAttackUp, CANUP, UP);
		ProcessQueenMoves(qAttackDown, CANDOWN, DOWN);
		ProcessQueenMoves(qAttackLeft, CANLEFT, LEFT);
		ProcessQueenMoves(qAttackRight, CANRIGHT, RIGHT);
	}

	if (ka != 0) km = 0;
}

#undef ProcessPawnAttacks
#undef ProcessQueenMoves