#include <fstream>
#include <vector>
#include <iostream>
#include <cstdio>
using namespace std;

#pragma comment (linker, "/STACK:40000000")

const int MAXVER = 110000;
const int MAXEDG = 810000;

class Edge
{
public:
	int be, en, clr, id;
};

int first[MAXVER + 1];
int inv[MAXEDG];
int next[MAXEDG];
int n, m;
vector<Edge> edg;

void AddEdge(int v1, int v2, int c, int id)
{
	Edge a;
	a.be = v1;
	a.en = v2;
	a.clr = c;
	a.id = id;
	edg.push_back(a);
	next[edg.size() - 1] = first[v1];
	first[v1] = edg.size() - 1;
}

void Load()
{
	memset(first, 0xFF, sizeof(first));
	memset(next, 0xFF, sizeof(next));
	edg.clear();
	scanf("%d%d", &n, &m);
	int i;
	for (i = 0; i < m; i++)
	{
		int v1, v2, c;
		scanf("%d%d%d", &v1, &v2, &c);
		AddEdge(v1, v2, c, i + 1);
		AddEdge(v2, v1, c, i + 1);
		inv[edg.size() - 1] = edg.size() - 2;
		inv[edg.size() - 2] = edg.size() - 1;
	}
}

int ne[MAXVER + 1];
vector<int> path;
int was[MAXEDG + 1];

void Dfs(int ver, int bye)
{
    int i;
    for (i = first[ver]; i != -1; i = next[i])
    {	
    	if (was[i] == 0)
    	{
    		was[i] = 1;
			was[inv[i]] = 1;
    		first[ver] = next[i];
    		Dfs(edg[i].en, i);
    	}
		else
		{			
	    	was[i] = 1;
			was[inv[i]] = 1;
    		first[ver] = next[i];
		}
    }
	if (bye != -1) path.push_back(edg[bye].id);
}

void Solve()
{
	memset(ne, 0, sizeof(ne));
	memset(was, 0, sizeof(was));
	int i;
	for (i = 0; i < m; i++)
	{
		ne[edg[i].be]++;
		ne[edg[i].en]++;
	}
	path.clear();
	for (i = 1; i <= n; i++)
	{
		if (ne[i] != 0)
		{
			Dfs(i, -1);
			break;
		}
	}
	for (i = path.size() - 1; i >= 0; i--)
	{
		printf("%d ", path[i]); 
	}
}

int main()
{
	freopen("stripes.in", "rt", stdin);
	freopen("stripes.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}