#include <iostream>
#include <fstream>

#include <vector>

using namespace std;


int n, m;
int a[500000], b[500000], c[500000]; // edges ends and color

int was[500000];  // is edge in main cycle

int cur[128000];  // some edge in current vertex, included in main cycle (index in edg list)

vector <int> edg[128000]; // list of edges numbers in current vertex
int twina[500000];
int twinb[500000];
int cnt[128000];
vector <int> job; // stack of not completed vertexes in main cycle
int pres[128000]; // is current vertex presented in job list;

#define DEBUG2 // read from file

#ifdef DEBUG2
ifstream in("stripes.in");
ofstream out("stripes.out");
#else
#define in cin
#define out cout
#endif


void Qsort(vector <int> &a, int be, int en)
{
	int l = be, r = en, t, x, x2;
	t = l+rand() % (r + 1);
	x = cnt[c[a[t]]];
	x2 = c[a[t]];
	while (l < r)
	{
		while (cnt[c[a[l]]] < x || (cnt[c[a[l]]] == x && c[a[l]] < x2)) l++;
		while (cnt[c[a[r]]] > x || (cnt[c[a[r]]] == x && c[a[r]] > x2)) r--;
		if (l <= r)
		{
			t = a[l]; a[l] = a[r]; a[r] = t;
			l++; r--;			
		}
	}
	if (l < en) Qsort(a, l, en);
	if (r > be) Qsort(a, be, r);
}


int jump(int e, int v)
{
	return a[e] == v ? b[e] : a[e];
}


void AddTwin(int e1, int v, int e2)
{
	if (v == a[e1]) twina[e1] = e2;
	else twinb[e1] = e2;
	if (v == a[e2]) twina[e2] = e1;
	else twinb[e2] = e1;	
}

int GetTwin(int e, int v)
{
	if (v == a[e]) return twina[e];
	else return twinb[e];
}



void Load()
{

	in >> n >> m;
	int i;
	for (i = 1; i <= m; i++)
	{
		in >> a[i] >> b[i] >> c[i];
	}
}       



int fst[128000];
int nxt[500000];
pair <int, int> dai[500000]; // cnt + color

void MapAll(int v)
{

	int i, j, k = 0;

	memset(fst, 0, sizeof(fst));
	for (i = 0; i < edg[v].size(); i++)
	{
		nxt[edg[v][i]] = fst[c[edg[v][i]]];
		fst[c[edg[v][i]]] = edg[v][i];
	}
	for (i = 0; i < edg[v].size(); i++)
	{
		if (i == 0 || c[edg[v][i]] != c[edg[v][i-1]] )
		{
			dai[k++] = make_pair(cnt[c[edg[v][i]]], c[edg[v][i]]);
		}			
	}



	pair <int, int> tmp;

	j = 0;
	while (dai[k-1].first > edg[v].size() - j - dai[k-1].first)
	{
		AddTwin(fst[dai[k-1].second], v, nxt[fst[dai[k-1].second]]);
		fst[dai[k-1].second] = nxt[fst[dai[k-1].second]]; dai[k-1].first--;
		fst[dai[k-1].second] = nxt[fst[dai[k-1].second]]; dai[k-1].first--;
		j += 2;
	}

	while (k > 1 && dai[k-2].first > 0)
	{
		
		AddTwin(fst[dai[k-2].second], v, fst[dai[k-1].second]);
		fst[dai[k-2].second] = nxt[fst[dai[k-2].second]]; dai[k-2].first--;
		fst[dai[k-1].second] = nxt[fst[dai[k-1].second]]; dai[k-1].first--;
		if (k > 2)
		{
			for (i = k-3; i >= 0 && dai[i].first > dai[k-2].first; i--);
			i++;
	
			if (dai[i].first > dai[k-2].first)
			{
				tmp = dai[k-2]; dai[k-2] = dai[i]; dai[i] = tmp;
			}
			for (i = k-2; i >= 0 && dai[i].first > dai[k-1].first; i--);
			i++;

			if (dai[i].first > dai[k-1].first)
			{
				tmp = dai[k-1]; dai[k-1] = dai[i]; dai[i] = tmp;
			}
		}			
	
	}
	while (dai[k-1].first > 0) {
		AddTwin(fst[dai[k-1].second], v, nxt[fst[dai[k-1].second]]);
		fst[dai[k-1].second] = nxt[fst[dai[k-1].second]]; dai[k-1].first--;
		fst[dai[k-1].second] = nxt[fst[dai[k-1].second]]; dai[k-1].first--;
	}
}


void AddC(int v, int e) // vertex & edge index in edg; must & mark was, cur, pres, job
{
	int ce = e, cv = v;
	
	do
	{
		was[ce] = 1;
		cur[cv] = ce;
		if (pres[cv] == 0)
		{
			pres[cv] = 1;
			job.push_back(cv);
		}
		cv = jump(ce, cv);
		ce = GetTwin(ce, cv);
	}
	while (cv != v || ce != e);

}


void Merge(int v, int e1, int e3)
{

	int e2, e4;
	e2 = GetTwin(e1, v);
	e4 = GetTwin(e3, v);
	int c1 = 0, c2 = 0;
	if (c[e1] != c[e3]) c1++;
	if (c[e2] != c[e4]) c1++;
	if (c[e1] != c[e4]) c2++;
	if (c[e2] != c[e3]) c2++;
	if (c1 > c2)
	{
		AddTwin(e1, v, e3);
		AddTwin(e2, v, e4);
	}
	else
	{
		AddTwin(e1, v, e4);
		AddTwin(e2, v, e3);
	}
}


int Compare(const int &a, const int &b)
{
	if (cnt[c[a]] < cnt[c[b]]) return 1;
	if (cnt[c[a]] > cnt[c[b]]) return 0;
	if (c[a] < c[b]) return 1;
	return 0;
}

void Solve()
{
	int i, j, gd;
	for (i = m; i >= 1; i--)
	{
	        edg[a[i]].push_back(i);
	        edg[b[i]].push_back(i);
	}
	for (i = 1; i <= n; i++)
	{
		if (edg[i].size() == 0) continue;
		memset(cnt, 0, sizeof(cnt));
		for (j = 0; j < edg[i].size(); j++)
			cnt[ c[ edg[i][j]] ]++;
		sort(edg[i].begin(),edg[i].end(), Compare);
		MapAll(i);
	}

	int beg = -1;
	for (i = 0; i < n; i++)
	{
		if (edg[i].size() > 0)  beg = i;
	}
	if (beg == -1) return;

	AddC(beg, edg[beg][0]);
	while (job.size() > 0)
	{
		i = job.back();
		job.pop_back();
		gd = cur[i];

		for (j = 0; j < edg[i].size(); j++)
		{
			if (was[edg[i][j]] == 0)
			{
				AddC(i, edg[i][j]); // vertex & edge; must mark was, cur, pres, job
				Merge(i, gd, edg[i][j]); // merge two cysles e1->e2 & e3->e4
                       	}
		}
	}
	//restore answer.
	if (job.size() > 0) job.clear();
	i = beg;
	j = edg[i][0];
	do
	{
	                      	
		job.push_back(j);
		i = jump(j, i);	
		j = GetTwin(j, i);
	
	}
	while (j != edg[beg][0] || i != beg);

	for (i = 0; i < job.size(); i++)
	{
		out << job[i] << " ";
	}

}


int main()
{
	Load();
	Solve();
	return 0;
}
