{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-,O-}

const
 StreamIn='primesum.in';
 StreamOut='primesum.out';
 DMAX=18;
 PMAX=1000;


type
 Int64Vect=array [0..PMAX] of int64;
 IntVect=array [0..DMAX] of integer;

var Prime:Int64Vect;
    msk1,msk2:IntVect;
    pnum,tt:integer;


procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure MakeMask(a:int64; var msk:IntVect);
begin
 msk[0]:=0;
 repeat
  inc(msk[0]);
  msk[msk[0]]:=a mod 10;
  a:=a div 10
 until a=0
end;

function Less(a,b:int64):boolean;
begin
 MakeMask(a,msk1);
 MakeMask(b,msk2);
 while (msk1[0]>0) and (msk2[0]>0) and (msk1[msk1[0]]=msk2[msk2[0]]) do begin
   dec(msk1[0]);
   dec(msk2[0])
  end;
 Result:=(msk1[0]=0) or ((msk2[0]<>0) and (msk1[msk1[0]]<msk2[msk2[0]]))
end;

procedure CheckAndAdd(x:int64);
var i:integer;
    y:extended;
begin
 y:=x;
 y:=sqrt(y);
 for i:=2 to integer(trunc(y)) do
  if x mod i=0 then Exit;
 inc(pnum);
 Prime[pnum]:=x
end;

procedure FormBank;
var i,j:integer;
    x:int64;
begin
 pnum:=1;
 Prime[1]:=2;
 i:=3;
 while pnum<15 do begin
   j:=1;
   while (j<=pnum) and (i mod Prime[j]<>0) do inc(j);
   if j>pnum then begin
     inc(pnum);
     Prime[pnum]:=i
    end;
   inc(i)
  end;
 x:=1;
 for i:=1 to DMAX-2 do begin
   x:=x*10;
   for j:=1 to 9 do
    if (j mod 2<>0) and (j mod 5<>0) then CheckAndAdd(x+j)
  end;
 inc(pnum);
 Prime[pnum]:=10000000000037;
 inc(pnum);
 Prime[pnum]:=100000000000031;
 inc(pnum);
 Prime[pnum]:=1000000000000037;
 for i:=1 to pnum-1 do
  for j:=i+1 to pnum do
   if Less(Prime[j],Prime[i]) then begin
     x:=Prime[i];
     Prime[i]:=Prime[j];
     Prime[j]:=x
    end
end;

procedure SolveAndSave;
var n:int64;
    i:integer;
begin
 read(n);
 while n>0 do
  if n<=3 then begin
    write(n);
    n:=0
   end
  else begin
    i:=1;
    while (i<=pnum) and ((n-Prime[i])<2) and (n<>Prime[i]) do inc(i);
    write(Prime[i]);
    dec(n,Prime[i]);
    if n<>0 then write('+')
   end
end;

begin
 OpenFiles;
 FormBank;
 SolveAndSave;
 CloseFiles
end.

