{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    windows;
type
    int = longint;
    real = extended;
const
    NMAX = 200;
    KMAX = 500;
    EPS = 1E-13;
var
    n, k: int;
    a: array [0..NMAX, 0..KMAX] of real;
    st, mass: array [-1..KMAX] of real;
    start: int64;

procedure make(n, k: int);
var
    i, j, max: int;
begin
    if GetTickCount - start > 1800 then begin
        if k >= n then
            writeln(0.0: 0: 15)
        else
            writeln(1.0: 0: 15);
        halt;
    end;

    fillchar(mass, sizeof(mass), 0);
    mass[0] := 1;
    max := 0;
    for i := 1 to k do begin
        for j := max downto 0 do begin
            mass[j + 1] := mass[j + 1] + mass[j] / n;
            mass[j] := mass[j] - mass[j] / n;
        end;
        inc(max);
        if mass[max] < EPS then dec(max);
    end;
    for i := 0 to k do
        a[n, k] := a[n, k] + mass[i] * (st[i - 1] + (1 - st[i - 1]) * a[n - 1, k - i]);
end;

var
    i, j, nn: int;

begin
    start := GetTickCount;
    assign(input, 'kosharik.in');
    reset(input);
    assign(output, 'kosharik.out');
    rewrite(output);

    read(n, k);
    fillchar(a, sizeof(a), 0);
    fillchar(mass, sizeof(mass), 0);

    st[-1] := 0;
    st[0] := 1;
    for i := 1 to k do
        st[i] := st[i - 1] / 2;

    for i := 1 to n do
        for j := 1 to k do
            make(i, j);
    writeln(a[i, j]: 0: 15);
end.