#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned __int64 huge;

huge random ()
{
  huge x = rand () % 1000;
  x = x * 1000 + (rand () % 1000);
  x = x * 1000 + (rand () % 1000);
  x = x * 1000 + (rand () % 1000);
  x = x * 1000 + (rand () % 1000);
  x = x * 1000 + (rand () % 1000);
  return x;
}

struct hugem
{
  unsigned int n[4];
};

inline huge shift (huge a, int n, huge p)
{
  for (int i = 0; i < n; i++)
    a = (a << 12) % p;
  return a;
}
huge mmult (huge a, huge b, huge n)
{
  return ((a % n) * (b % n)) % n;
}
huge smult (huge a, huge b, huge n)
{        
  huge oa = a, ob = b;
  int an[6];
  int bn[6];
  for (int i = 0; i < 6; i++)
  {
    an[i] = a & 0xfff;
    bn[i] = b & 0xfff;
    a >>= 12;
    b >>= 12;
  }
  huge tm = 0;
  for (int i = 0; i < 6; i++)
    for (int j = 0; j < 6; j++)
      tm = (tm + shift (an[i] * bn[j], i + j, n)) % n;   
  return tm;
}
bool sprime (huge n)
{
  int s = 0;
  huge d = n - 1;
  while (!(d & 1))
    s++, d >>= 1;
  for (int i = 0; i < 40; i++)
  {
    huge a = (random () % (n - 1)) + 1;
    huge oa = a;
    huge b = 1;
    huge p = d;
    while (p)
    {
      if (p & 1)
        b = smult (a, b, n);
      a = smult (a, a, n);
      p >>= 1;
    }
    if (b != 1)
    {
      bool found = false;
      for (int r = 0; r < s && !found; r++)
      {
        if (b == n - 1)
          found = true;
        b = smult (b, b, n);
      }
      if (!found)
      {                
        return false;
      }
    }
  }
  return true;
}

huge num[131072];
int cnt = 0;

huge get_next (huge a)
{
  huge num = 1;
  while (a)
  {
    a /= 10;
    num *= 10;
  }
  return num;
}

int main ()
{
  freopen ("primesum.in", "rt", stdin);
  freopen ("primesum.out", "wt", stdout);

  num[cnt++] = 3;
  num[cnt++] = 2;

  huge j;
  huge lim = 1000000;
  lim *= 1000000;
  lim *= 9000000;
  for (j = 10; clock () < 2 * CLOCKS_PER_SEC; j++)
  {
    if (sprime (j))
    {
      num[cnt++] = j;
      j = get_next (j);
    }
  }
  printf ("last: %I64d\n", j);
  for (int i = cnt - 1; i >= 0; i--)
    printf ("\"%I64d\",\n", num[i]);
/*  {
    if (i == 0)
      printf ("{");
    else if ((i % 100) == 0)
      printf (",\n ");
    else
      printf (", ");
    printf ("%d", num[i].n);
  }
  printf ("};\n");*/
}
