#include <cstdio>

template <class t>
  class point
  {
    private:
      t x, y;
    public:
      point( void )
      {
        x = y = 0;
      }
      point( const t& sx, const t& sy )
      {
        x = sx, y = sy;
      }
      point operator - ( point b )
      {
        return point <t> (x - b.x, y - b.y);
      }
      int operator * ( point b )
      {
        return x * b.x + y * b.y;
      }
      int operator ^ ( point b )
      {
        return x * b.y - y * b.x;
      }
  };

#define maxn 4100

int x[maxn], y[maxn];
point <int> p[maxn];

int main( void )
{
  freopen("rect1.in", "r", stdin);
  freopen("rect1.out", "w", stdout);

  int n;

  scanf("%d", &n);
  for (int i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]), p[i] = point<int>(x[i], y[i]);

  int ans = 0;

  for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++)
      for (int k = 0; k < n; k++)
        for (int l = 0; l < n; l++)
        {
          if ((p[l] - p[i]) * (p[j] - p[i]) != 0)
            continue;
          if ((p[i] - p[j]) * (p[k] - p[j]) != 0)
            continue;
          if ((p[j] - p[k]) * (p[l] - p[k]) != 0)
            continue;
          if ((p[k] - p[l]) * (p[i] - p[l]) != 0)
            continue;
          if (((p[l] - p[i]) ^ (p[j] - p[i])) == 0)
            continue;
          if (((p[i] - p[j]) ^ (p[k] - p[j])) == 0)
            continue;
          if (((p[j] - p[k]) ^ (p[l] - p[k])) == 0)
            continue;
          if (((p[k] - p[l]) ^ (p[i] - p[l])) == 0)
            continue;
          ans++;
        }

  printf("%d\n", ans / 8);

  return 0;
}
