{$MODE DELPHI}
{$M 64000000,64000000,64000000}

uses Math;

const
 StreamIn='rect3.in';
 StreamOut='rect3.out';
 NMAX=110000;

type
 IntVect=array [0..NMAX] of integer;

var x1,y1,z1,x2,y2,z2:IntVect;
    n:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n);
 for i:=1 to n do
  read(x1[i],y1[i],z1[i],x2[i],y2[i],z2[i])
end;

function CrSegm(x1,y1,x2,y2:integer):boolean;
var vx1,vy1,vx2,vy2:integer;
begin
 vx1:=Min(x1,y1);
 vy1:=Max(x1,y1);
 vx2:=Min(x2,y2);
 vy2:=Max(x2,y2);
 Result:=(vx1<=vy2) and (vy1>=vx2)
end;

procedure SolveAndSave;
var i,j,Ans:integer;
begin
 Ans:=0;
 for i:=1 to n-1 do
  for j:=i+1 to n do
   if CrSegm(x1[i],x2[i],x1[j],x2[j]) and
      CrSegm(y1[i],y2[i],y1[j],y2[j]) and
      CrSegm(z1[i],z2[i],z1[j],z2[j])
   then inc(Ans);
 writeln(Ans)
end;


begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
