#include <fstream>
#include <iostream>
#include <cstdlib>
using namespace std;

int GetRand()
{
	int a;
	a = rand();
	a = a << 10;
	a += rand();
	return a;                  
}

template <class T>
class CartTree;

//  - 設 ⮢ ॢ
template <class T>
class Node
{
	T data;                 // 
	Node *lft, *rgt;        //   ࠢ 뭮
    int num;                // ⢮ 設  ॢ
    int hkey;				//   
public:
    Node()
    {
    	lft = rgt = NULL;
    	num = 0;
    }
    friend class CartTree<T>;
};

template <class T>
class CartTree
{
	// ⥫  ७ ॢ
	Node<T>* tree;
	// 뢠 ⢮ 設  ॢ,
	// ,   뭮  ⠭
	void UpdateNum(Node<T>* tree)
	{
		if (!tree) return;
		tree->num = 1;
		if (tree->lft) tree->num += tree->lft->num;
		if (tree->rgt) tree->num += tree->rgt->num;
	}
	//   ⮢ ॢ *tree  2.
	//  ॢ *ll    <= key,
	//  ॢ *rr    > key.
	void Split(Node<T> *tree, Node<T> **ll, Node<T> **rr, const T& key)
	{
		// ⮥ ॢ ࠧ 祬
		if (tree == NULL)
		{
			*ll = NULL;
			*rr = NULL;
			return;
		}
		// ᫨    設  key
		if (tree->data > key)
		{
			//  ࠧ 襣  뭠  ⮬ 
			// ,  ll 襬 १ ⮣ ࠧ -  ,
			//  ࠢ  ᤥ  뭮 襩 ࠢ 
			*rr = tree;
			Split(tree->lft, ll, & ((*rr)->lft), key);
        }
        else
        {
        	*ll = tree;
        	Split(tree->rgt, & ((*ll)->rgt), rr, key);
        }
        //  ⥫ ଠ
        UpdateNum(*ll);
		UpdateNum(*rr);
	}
	// ꥤ  ⮢ ॢ,  ᫮,  
	//   ll <=  祩  rr
	// 頥 㪠⥫  ७ ⮣,  
	Node<T>* Merge(Node<T>* ll, Node<T> *rr)
	{
		// ᫨   ॢ쥢  - ୥ 㣮
		if (rr == NULL) return ll;
		if (ll == NULL) return rr;
		//  ᮡ ᢮⢠  ७ ꥤ - 
		// -  設,  ன    
		if (ll->hkey <= rr->hkey)
		{
			rr->lft = Merge(ll, rr->lft);
			UpdateNum(rr);
			return rr;
		}
		else
		{
			ll->rgt = Merge(ll->rgt, rr);
			UpdateNum(ll);
			return ll;
		}
	}
	//   nnode  ॢ. 頥 ७ ⮣,
	//  
	Node<T>* AddTree(Node<T> *tree, Node<T> *nnode)
	{
		//  ⮥ ॢ  
		if (tree == NULL) return nnode;
		//  ࠭ ᢮⢠  ᫨   設 
		// 祬  , ⮣ ࠧ塞 ॢ    
		// 設 ୥
		if (tree->hkey < nnode->hkey)
		{
			Split(tree, &(nnode->lft), &(nnode->rgt), nnode->data);
			UpdateNum(nnode);
			return nnode;
		}
		//  塞    ࠢ ॢ
		if (nnode->data <= tree->data) 
		{
			tree->lft = AddTree(tree->lft, nnode);
		}
		else
		{
			tree->rgt = AddTree(tree->rgt, nnode);
		}
		UpdateNum(tree);
		return tree;
	}
	//     箬  ॢ.  頥 
	// ७ १. ᫨ ⮢  ⠪ 箬 ᪮쪮,
	// 㤠 ⮫쪮 .
	Node<T>* DeleteTree(Node<T>* tree, const T& val)
	{
		//  ⮣ ॢ 祣  㤠
		if (tree == NULL) return NULL;
		// 諨 - 㤠塞
		if (tree->data == val)
		{
			Node<T> *ll, *rr;
			ll = tree->lft;
			rr = tree->rgt;
			delete tree;
			return Merge(ll, rr);
        }
        //     ࠢ
        if (val < tree->data) tree->lft = DeleteTree(tree->lft, val);
        else tree->rgt = DeleteTree(tree->rgt, val);
		UpdateNum(tree);
        return tree;
	}
	// 믮   ॢ
	// ୥ 1, ᫨ ⠪  , 0 ᫨ 
	int FindTree(Node<T>* tree, const T& val)
	{
		if (tree == NULL) return 0;
		if (tree->data == val) return 1;
		if (val < tree->data) return FindTree(tree->lft, val);
		else return FindTree(tree->rgt, val);
	}
public:
    //䥩 㭪樨 
	CartTree()
	{
		tree = NULL;
	}
	~CartTree()
	{
		while (tree != NULL) tree = DeleteTree(tree, tree->data);
	}
	void Insert(const T& val)
	{
		Node<T> *nnode = new Node<T>;
		nnode->num = 1;
		nnode->data = val;
		nnode->hkey = GetRand();
		tree = AddTree(tree, nnode);
	}
	void Delete(const T & val)
	{
		tree = DeleteTree(tree, val);
	}
	int Find(const T& val)
	{
		return FindTree(tree, val);
	}
	int Size()
	{
		if (tree) return tree->num;
		else return 0;
	}
	int GetLesser(const T& val)
	{
		Node<T> *curnode = tree;
		int res = 0;
		while (curnode != NULL)
		{
			if (val <= curnode->data) curnode = curnode->lft;
			else
			{
				if (curnode->lft) res += curnode->lft->num;
				res++;
				curnode = curnode->rgt;
			}
		}
		return res;
	}
	int GetMore(const T& val)
	{
		Node<T> *curnode = tree;
		int res = 0;
		while (curnode != NULL)
		{
			
			if (val >= curnode->data) curnode = curnode->rgt;
			else
			{
				if (curnode->rgt) res += curnode->rgt->num;
				res++;
				curnode = curnode->lft;
			}
		}
		return res;
	}
};

const int TSIZE = 65536;
int ver[2 * TSIZE + 10];
int otr[2 * TSIZE + 10][2];
CartTree<int> trees[2 * TSIZE + 10];
int n;

void GenT(int ver)
{
	if (ver >= TSIZE)
	{
		otr[ver][0] = otr[ver][1] = ver - TSIZE + 1;
		return;
	}
	GenT(2 * ver);
	GenT(2 * ver + 1);
	otr[ver][0] = otr[2 * ver][0];
	otr[ver][1] = otr[2 * ver + 1][1];
}

int hgt[110000];

void Load()
{
	GenT(1);
	int i;
	scanf("%d", &n);
	for (i = 1; i <= n; i++)
	{
		int p;
		scanf("%d", &p);
		p *= 2;
		int cver = i + TSIZE - 1;
		while (cver != 0)
		{
			trees[cver].Insert(p);
			cver >>= 1;
		}
		hgt[i] = p;
	}
}

void GetLB(int ver, int be, int en, int val, int &less, int &more)
{
	if ((otr[ver][0] == be) && (otr[ver][1] == en))
	{
		less += trees[ver].GetLesser(val);
		more += trees[ver].GetMore(val);
		return;
	}
	if (otr[ver][0] == otr[ver][1])
	{
		less += trees[ver].GetLesser(val);
		more += trees[ver].GetMore(val);
		return;
	}
	if (be <= otr[(ver << 1)][1])
	{
		GetLB(ver << 1, be, min(otr[ver << 1][1], en), val, less, more);
	}
	if (en >= otr[(ver << 1) + 1][0])
	{
		GetLB((ver << 1) + 1, max(otr[(ver << 1) + 1][0], be), en, val, less, more);
	}
}

void Solve()
{
	int m;
	scanf("%d", &m);
	int i;
	for (i = 0; i < m; i++)
	{
		char c = getchar();
		while (! ((c == 'C') || (c == 'Q')) )
		{
			c = getchar();
		}
		if (c == 'C')
		{
		}
		else
		{
			int x1, x2, y1, y2;
			scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
			int ypos = y1 + y2;
			int less, more;
			less = more = 0;
			GetLB(1, x1, x2, ypos, less, more);
			if (less < more)
			{
				printf("2\n");
			}
			else if (more < less)
			{
				printf("1\n");
			}
			else 
			{
				printf("0\n");
			}
		}
	}
}

int main()
{
	freopen("rect2.in", "rt", stdin);
	freopen("rect2.out", "wt", stdout);
	srand(25897);
	Load();
	Solve();
	return 0;
}