{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
type
    int = longint;
const
    NMAX = 50001;
    BASE = 601;
    EPS = 1E-3;

function get(k: int): int;
begin
    result := ((k - 1) div BASE) + 1;
end;

procedure swap(var a, b: int);
var
    c: int;
begin
    c := a;
    a := b;
    b := c;
end;

var
    a, o: array [1..(NMAX div BASE) + 2, 0..BASE] of int;
    z, num: array [1..NMAX] of int;
    n, m, max: int;

function bin_search1(k: int; key: extended): int;
var
    l, r, m: int;
begin
    l := 0;
    r := num[k];
    while r - l > 1 do begin
        m := (l + r) div 2;
        if a[k, m] < key then
            l := m
        else
            r := m;
    end;
    if a[k, r] < key then result := r
        else result := l;
end;

function bin_search2(k: int; key: extended): int;
var
    l, r, m: int;
begin
    if a[k, num[k]] < key then begin
        result := 0;
        exit;
    end;
    l := 0;
    r := num[k];
    while r - l > 1 do begin
        m := (l + r) div 2;
        if a[k, m] < key then
            l := m
        else
            r := m;
    end;
    if a[k, l] > key then result := num[k] - l + 1
        else result := num[k] - r + 1;
end;

procedure update;
var
    x, y, i, j, ind: int;
begin
    read(x, y);
    z[x] := y;
    ind := get(x);
    for i := 1 to num[ind] do
        if o[ind, i] = x then begin
            dec(num[ind]);
            for j := i to num[ind] do begin
                a[ind, j] := a[ind, j + 1];
                o[ind, j] := o[ind, j + 1];
            end;
            break;
        end;

    for i := 1 to num[ind] do
        if a[ind, i] > y then begin
            for j := num[ind] downto i do begin
                a[ind, j + 1] := a[ind, j];
                o[ind, j + 1] := o[ind, j];
            end;
            a[ind, i] := y;
            o[ind, i] := x;
            inc(num[ind]);
            exit;
        end;
    inc(num[ind]);
    a[ind, num[ind]] := y;
    o[ind, num[ind]] := x;
end;

procedure answer;
var
    mid: extended;
    first, second: int;

procedure outdata;
begin
    if first > second then writeln(1);
    if first = second then writeln(0);
    if first < second then writeln(2);
end;

procedure make(x: int);
begin
    if z[x] < mid - EPS then
        inc(first);
    if z[x] > mid + EPS then
        inc(second);
end;

var
    i, x, y, x1, y1, x2, y2, l, r: int;
    ch: char;

begin
    read(ch);
    while ord(ch) <= 32 do
        read(ch);
    if ch = 'C' then begin
        update;
        exit
    end;

    read(x1, y1, x2, y2);
    mid := (y1 + y2) / 2;
    l := get(x1);
    r := get(x2);
    first := 0;
    second := 0;

    if l = r then begin
        for i := x1 to x2 do
            make(i);
        outdata;
        exit;
    end;

    for i := x1 to l * BASE do
        make(i);
    for i := (r - 1) * BASE + 1 to x2 do
        make(i);
    for i := l + 1 to r - 1 do begin
        inc(first, bin_search1(i, mid - EPS));
        inc(second, bin_search2(i, mid + EPS));
    end;
    outdata;
end;

var
    i, j, f: int;

begin
    assign(input, 'rect2.in');
    reset(input);
    assign(output, 'rect2.out');
    rewrite(output);

    read(n);
    for i := 1 to n do
        read(z[i]);
    max := get(n);
    for i := 1 to max do begin
        num[i] := 0;
        a[i, 0] := 0;
        for j := (i - 1) * BASE + 1 to i * BASE do
            if j <= n then begin
                inc(num[i]);
                a[i, num[i]] := z[j];
                o[i, num[i]] := j;
            end;
        for j := 1 to num[i] do
            for f := j + 1 to num[i] do
                if a[i, j] > a[i, f] then begin
                    swap(a[i, j], a[i, f]);
                    swap(o[i, j], o[i, f]);
                end
    end;

    read(m);
    for i := 1 to m do
        answer;
end.