{$DELPHI MODE}
{$M 16000000, 16000000, 16000000}
{$O-}

type
  point = record
    x, y: Int64;
  end;

  circle = record
    x, y, s: Int64;
  end;

var
  t, n, i, j, res, l: Integer;
  arr: array [1..5000] of point;
  mas: array [1..9000000] of circle;

procedure add(x, y, x1, y1: Int64);
begin
  t := t + 1;
  mas[t].x := x;
  mas[t].y := y;
  mas[t].s := (x - x1) * (x - x1) + (y - y1) * (y - y1);
end;

function sravn(c1, c2: circle): Integer;
begin
  if (c1.x > c2.x) then
  begin
    sravn := 1;
  end
  else
  if (c1.x < c2.x) then
  begin
    sravn := -1;
  end
  else
  begin
    if (c1.y > c2.y) then
    begin
      sravn := 1;
    end
    else
    if (c1.y < c2.y) then
    begin
      sravn := -1;
    end
    else
    begin
      if (c1.s > c2.s) then
      begin
        sravn := 1;
      end
      else
      if (c1.s < c2.s) then
      begin
        sravn := -1;
      end
      else
      begin
        sravn := 0;
      end;
    end;
  end;
end;

function maxs(k, n: Integer): Integer;
begin
  if (k * 2 + 1 > n) then
  begin
    maxs := k * 2;
  end
  else
  begin
    if (sravn(mas[k * 2], mas[k * 2 + 1]) = 1) then
    begin
      maxs := k * 2;
    end
    else
    begin
      maxs := k * 2 + 1;
    end;
  end;
end;

procedure heapify(k, n: Integer);
var
  o: circle;
  e: Integer;
begin
  if (k * 2 <= n) then
  begin
    e := maxs(k, n);
    if (sravn(mas[e], mas[k]) = 1) then
    begin
      o := mas[e];
      mas[e] := mas[k];
      mas[k] := o;
      heapify(e, n);
    end;
  end;
end;

procedure sort(n: Integer);
var
  o: circle;
  i: Integer;
begin
  for i := n downto 1 do
  begin
    heapify(i, n);
  end;
  for i := n downto 2 do
  begin
    o := mas[1];
    mas[1] := mas[i];
    mas[i] := o;
    heapify(1, i - 1);
  end;
end;

begin
  assign(input, 'rect1.in');
  assign(output, 'rect1.out');
  reset(input);
  rewrite(output);
  readln(n);
  for i := 1 to n do
  begin
    readln(arr[i].x, arr[i].y);
  end;
  res := 0;
  t := 0;
  for i := 1 to n do
  begin
    for j := i + 1 to n do
    begin
      add((arr[i].x + arr[j].x), (arr[i].y + arr[j].y), 2 * arr[i].x, 2 * arr[i].y);
    end;
  end;
  sort(t);
  l := 1;
  for i := 2 to t do
  begin
    if (sravn(mas[i], mas[i - 1]) = 0) then
    begin
      l := l + 1;
    end
    else
    begin
      res := res + (l * (l - 1)) div 2;
      l := 1;
    end;
  end;
  writeln(res);
  close(output);
end.
