//{$DEFINE DEBUG}
{$IFDEF DEBUG}
  {$D+,L+,I+,Q+,R+,S+,O-}
{$ELSE}
  {$D-,L-,I-,Q-,R-,S-,O+}
  {$M 1000000,2097152}
{$ENDIF DEBUG}

const eps:extended=1e-10;

type coor=record
     x,y:longint;
     end;

type line=record
     p1,p2:coor;
     k,l:extended;
     end;

var n,l,m,i,j,x:longint;
    a:array[1..4063] of coor;
    b:array[1..8251953{8000}] of line;

procedure initial;
 begin
 randomize;
 l:= 0;
 x:= 0;
 end;

procedure indata;
var i:longint;
 begin
 assign(input,'rect1.in');
 reset(input);
 readln(n);
 for i:= 1 to n do
  with a[i] do
   readln(x,y);
 close(input);
 end;

procedure outdata;
 begin
 assign(output,'rect1.out');
 rewrite(output);
 writeln(x);
 close(output);
 end;

procedure putline(i,j:longint);
 begin
 inc(l);
 if a[i].x<a[j].x then
  begin
  b[l].p1:= a[i];
  b[l].p2:= a[j];
  end
 else
  if a[i].x>a[j].x then
   begin
   b[l].p1:= a[j];
   b[l].p2:= a[i];
   end
  else
   if a[i].y<a[j].y then
    begin
    b[l].p1:= a[i];
    b[l].p2:= a[j];
    end
   else
    begin
    b[l].p1:= a[j];
    b[l].p2:= a[i];
    end;
 if a[i].x<>a[j].x then
  b[l].k:= (a[i].y-a[j].y)/(a[i].x-a[j].x)
 else
  b[l].k:= 100000.0;
 b[l].l:= sqrt(sqr(a[i].y-a[j].y)+sqr(a[i].x-a[j].x));
 end;

function ext_eq(const a,b:extended):boolean;
 begin
 ext_eq:= abs(a-b)<=eps;
 end;

function ext_less(const a,b:extended):boolean;
 begin
 ext_less:= (b-a)>eps;
 end;

function eq(const a,b:line):boolean;
 begin
 eq:= ext_eq(a.k,b.k) and ext_eq(a.l,b.l);
 end;

function less(const a,b:line):boolean;
 begin
 if not ext_eq(a.k,b.k) then
  less:= ext_less(a.k,b.k)
 else
  less:= ext_less(a.l,b.l);
 end;

procedure qsort(l,r:longint);
var i,j:longint;x,y:line;
 begin
 while l<r do
  begin
  i:= l;
  j:= r;
  x:= b[random(r-l+1)+l];
  repeat
   while less(b[i],x) do inc(i);
   while less(x,b[j]) do dec(j);
   if i<=j then
    begin
    y:= b[i];
    b[i]:= b[j];
    b[j]:= y;
    inc(i);
    dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  l:= i;
  end;
 end;

{function eqcoor(const a,b:coor):boolean;
 begin
 eqcoor:= (a.x=b.x)and(a.y=b.y);
 end;}

function rect(a,b:line):boolean;
var v1,v2:coor;
 begin
{ if eqcoor(a.p1,b.p1)or eqcoor(a.p1,b.p2)or eqcoor(a.p2,b.p1) or eqcoor(a.p2,b.p2) then
  begin
  rect:= false;
  exit;
  end;}
 v1.x:= a.p1.x-b.p1.x;
 v1.y:= a.p1.y-b.p1.y;
 v2.x:= a.p1.x-a.p2.x;
 v2.y:= a.p1.y-a.p2.y;
 rect:= ((v1.x*v2.x)+(v1.y*v2.y))=0;
 end;

begin
initial;
indata;
m:= n-1;
for i:= 1 to m do
 for j:= i+1 to n do
  putline(i,j);
qsort(1,l);
for i:= 1 to l do
 begin
 j:= i+1;
 while j<=l do
  begin
  if not eq(b[i],b[j]) then
   break;
  if rect(b[i],b[j]) then
   inc(x);
  inc(j);
  end;
 end;
x:= x div 2;
outdata;
end.
