//
//    *     *
//     ____
//    /    \

#include <cstdio>
#define MAXN 4100
using namespace std;
#include <set>
#include <map>
#include <vector>
#include <algorithm>
struct point{
	int x, y;
	friend bool operator <(point a, point b){
		return (a.x < b.x) || ((a.x == b.x) && (a.y < b.y));
	}                      
};

point Middle(point a, point b){
	point c;
	c.x = (a.x + b.x) / 2;
	c.y = (a.y + b.y) / 2;
	return c;
}

long long dst(point a, point b){
	long long rez1, rez2;
	rez1 = (a.x - b.x);
	rez2 = (a.y - b.y);
	return rez1 * rez1 + rez2 * rez2;
}


int n;
point p[MAXN];
map<long long, int> m;
long long IZVR[MAXN * MAXN];
int col;

long long hash(point a, long long b){
	b = lower_bound(IZVR, IZVR + col, b) - IZVR;
	long long tmp = a.y * 64000 + a.x;
	return b + tmp * MAXN * MAXN;
}

void izvr(){
	col = 0;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++){
			IZVR[col] = dst(p[i], p[j]);
			col++;
	    }
   sort(IZVR, IZVR + col);
}

int main(){                          
	freopen("rect1.in", "rt", stdin);
	freopen("rect1.out", "wt", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++){
		scanf("%d%d", &p[i].x, &p[i].y);
		p[i].x *= 2;
		p[i].y *= 2;
	}
	izvr();
	m.clear();
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++){
			m[hash(Middle(p[i], p[j]), dst(p[i], p[j]))]++;
		}         
	long long rez = 0;
    for (map<long long, int>::iterator t = m.begin(); t != m.end(); t++){
//    	printf("(%d %d)(%I64d) - %d\n", ((*t).first).first.x, ((*t).first).first.y, (*t).first.second, (*t).second);
    	rez += (*t).second * ((*t).second - 1) / 2;
    }
    printf("%I64d", rez);
//    printf("%I64d", hash(p[1], dst(p[0], p[3])));
}
