#include <stdio.h>
#include <memory.h>

#define MAXN 101100

struct point
{
       int x, y, z;
};

struct list
{
       int v;
       int next;
};

struct point a[MAXN];
struct point b[MAXN];
struct list p[3][MAXN];
int kk[3];
__int64 res;
int n;

void init()
{
     freopen("rect3.in", "r", stdin);
     freopen("rect3.out", "w", stdout);
     memset(a, 0, sizeof(a));
     memset(p, 0, sizeof(p));
     kk[0] = kk[1] = kk[2] = 1000;
     res = 0;
}

int min(int a, int b)
{
    if(a<=b)
      return a;
    return b;
}

int max(int a, int b)
{
    if(a>=b)
      return a;
    return b;
}

int pcross(int x11, int y11, int x12, int y12, int x21, int y21, int x22, int y22)
{
    struct point pmin1, pmax1, pmin2, pmax2;
    pmin1.x = min(x11, x12); pmin1.y = min(y11, y12);
    pmax1.x = max(x11, x12); pmax1.y = max(y11, y12);
    pmin2.x = min(x21, x22); pmin2.y = min(y21, y22);
    pmax2.x = max(x21, x22); pmax2.y = max(y21, y22);
    if((pmax1.x >= pmin2.x)&&(pmax1.y>=pmin2.y)&&(pmax2.x>=pmin1.x)&&(pmax2.y>=pmin1.y))
     return 1;
    return 0;
}

int cross(int p1, int p2)
{
    if(!pcross(a[p1].x, a[p1].y, b[p1].x, b[p1].y, a[p2].x, a[p2].y, b[p2].x, b[p2].y))
      return 0;
    if(!pcross(a[p1].y, a[p1].z, b[p1].y, b[p1].z, a[p2].y, a[p2].z, b[p2].y, b[p2].z))
      return 0;
    if(!pcross(a[p1].x, a[p1].z, b[p1].x, b[p1].z, a[p2].x, a[p2].z, b[p2].x, b[p2].z))
      return 0;
    return 1;
}

void add(int v, int k, int t)
{
     p[k][kk[k]].next = p[k][t].next;
     p[k][kk[k]].v = v;
     p[k][t].next = kk[k];
     kk[k]++;
}

void readdata()
{
     int i;
     scanf("%d", &n);
     for(i=0;i<n;i++)
     {
         scanf("%d%d%d", &a[i].x, &a[i].y, &a[i].z);
         scanf("%d%d%d", &b[i].x, &b[i].y, &b[i].z);
         if(a[i].x == b[i].x)
            add(i, 0, a[i].x);
         if(a[i].y == b[i].y)
            add(i, 1, a[i].y);
         if(a[i].z == b[i].z)
            add(i, 2, a[i].z);
     }
}

void solve()
{
     int i, j, k, i2, j2;
     for(k=0;k<3;k++)
       for(j=1;j<=999;j++)
       {
         i = p[k][j].next;
         while(i != 0)
         {
           i2 = p[k][i].next;
           while(i2 != 0)
           {
             if(cross(p[k][i].v, p[k][i2].v))
               res++;
             i2 = p[k][i2].next;
           }
           i = p[k][i].next;
         }
       }
     for(j=1;j<=999;j++)
     {
       i = p[0][j].next;
       while(i != 0)
       {
         for(k=min(a[p[0][i].v].y, b[p[0][i].v].y);k<=max(a[p[0][i].v].y, b[p[0][i].v].y);k++)
         {
           i2 = p[1][k].next;
           while(i2 != 0)
           {
             if(cross(p[0][i].v, p[1][i2].v))
               res++;
             i2 = p[1][i2].next;
           }
         }
         for(k=min(a[p[0][i].v].z, b[p[0][i].v].z);k<=max(a[p[0][i].v].z, b[p[0][i].v].z);k++)
         {
           i2 = p[2][k].next;
           while(i2 != 0)
           {
             if(cross(p[0][i].v, p[2][i2].v))
               res++;
             i2 = p[2][i2].next;
           }                                   
         }
         i = p[0][i].next;
       }
     }
     for(j=1;j<=999;j++)
     {
       i = p[1][j].next;
       while(i != 0)
       {
         for(k=min(a[p[1][i].v].z, b[p[1][i].v].z);k<=max(a[p[1][i].v].z, b[p[1][i].v].z);k++)
         {
           i2 = p[2][k].next;
           while(i2 != 0)
           {
             if(cross(p[1][i].v, p[2][i2].v))
               res++;
             i2 = p[2][i2].next;
           }
         }
         i = p[1][i].next;
       }
     }     
}

void writedata()
{
    printf("%I64d", res);
}

int main()
{
    init();
    readdata();
    solve();
    writedata();
    return 0;
}
