{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math,SysUtils;

const
 StreamIn='rect2.in';
 StreamOut='rect2.out';
 NMAX=150000;
 ROOT=1;

type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 Link=^Node;
 Node=record
   u1,u2,uh,count:integer;
   vl,vr:Link
  end;
 RmqVect=array [0..NMAX] of Link;

var n:integer;
    z:IntVect;
    Rmq:RmqVect;


procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n);
 for i:=1 to n do read(z[i])
end;

procedure Split(t:Link; x1,x2:integer; var l,r:Link);
begin
 if t=Nil then begin
   l:=Nil;
   r:=Nil
  end
 else
  if (x1<t^.u1) or ((x1=t^.u1) and (x2<t^.u2)) then begin
    Split(t^.vl,x1,x2,l,t^.vl);
    r:=t;
    r^.count:=1;
    if r^.vl<>Nil then inc(r^.count,r^.vl^.count);
    if r^.vr<>Nil then inc(r^.count,r^.vr^.count);
    if l<>Nil then begin
      l^.count:=1;
      if l^.vl<>Nil then inc(l^.count,l^.vl^.count);
      if l^.vr<>Nil then inc(l^.count,l^.vr^.count)
     end
   end
  else begin
    Split(t^.vr,x1,x2,t^.vr,r);
    l:=t;
    l^.count:=1;
    if l^.vl<>Nil then inc(l^.count,l^.vl^.count);
    if l^.vr<>Nil then inc(l^.count,l^.vr^.count);
    if r<>Nil then begin
      r^.count:=1;
      if r^.vl<>Nil then inc(r^.count,r^.vl^.count);
      if r^.vr<>Nil then inc(r^.count,r^.vr^.count)
     end
   end
end;

procedure Add(var t:Link; const x1,x2,xh:integer);
var Temp:Link;
begin
 if (t=Nil) or (t^.uh<xh) then begin
   New(Temp);
   Temp^.u1:=x1;
   Temp^.u2:=x2;
   Temp^.uh:=xh;
   Split(t,x1,x2,Temp^.vl,Temp^.vr);
   Temp^.count:=1;
   if Temp^.vl<>Nil then inc(Temp^.count,Temp^.vl^.count);
   if Temp^.vr<>Nil then inc(Temp^.count,Temp^.vr^.count);
   t:=Temp
  end
 else begin
   if (x1<t^.u1) or ((x1=t^.u1) and (x2<t^.u2))
   then Add(t^.vl,x1,x2,xh)
   else Add(t^.vr,x1,x2,xh);
   if t<>Nil then begin
     t^.count:=1;
     if t^.vl<>Nil then inc(t^.count,t^.vl^.count);
     if t^.vr<>Nil then inc(t^.count,t^.vr^.count)
    end
  end
end;

function Merge(l,r:Link):Link;
begin
 if l=Nil then Result:=r
 else
  if r=Nil then Result:=l
  else
   if l^.uh>r^.uh then begin
     l^.vr:=Merge(l^.vr,r);
     l^.count:=1;
     if l^.vl<>Nil then inc(l^.count,l^.vl^.count);
     if l^.vr<>Nil then inc(l^.count,l^.vr^.count);
     if r<>Nil then begin
       r^.count:=1;
       if r^.vl<>Nil then inc(r^.count,r^.vl^.count);
       if r^.vr<>Nil then inc(r^.count,r^.vr^.count)
      end;
     Result:=l
    end
   else begin
     r^.vl:=Merge(l,r^.vl);
     r^.count:=1;
     if r^.vl<>Nil then inc(r^.count,r^.vl^.count);
     if r^.vr<>Nil then inc(r^.count,r^.vr^.count);
     if l<>Nil then begin
       l^.count:=1;
       if l^.vl<>Nil then inc(l^.count,l^.vl^.count);
       if l^.vr<>Nil then inc(l^.count,l^.vr^.count)
      end;
     Result:=r
    end
end;

procedure Delt(var t:Link; x1,x2:integer);
var Temp:Link;
begin
 if (x1<t^.u1) or ((x1=t^.u1) and (x2<t^.u2))
 then begin
   Delt(t^.vl,x1,x2);
   if t<>Nil then begin
     t^.count:=1;
     if t^.vl<>Nil then inc(t^.count,t^.vl^.count);
     if t^.vr<>Nil then inc(t^.count,t^.vr^.count)
    end
  end
 else
  if (x1>t^.u1) or ((x1=t^.u1) and (x2>t^.u2))
  then begin
    Delt(t^.vr,x1,x2);
    if t<>Nil then begin
      t^.count:=1;
      if t^.vl<>Nil then inc(t^.count,t^.vl^.count);
      if t^.vr<>Nil then inc(t^.count,t^.vr^.count)
     end
   end
  else begin
    Temp:=t;
    t:=Merge(t^.vl,t^.vr);
    Dispose(Temp)
   end
end;

procedure MakeRmq(Vert,l,r:integer);
var i:integer;
begin
 if l<>r then begin
   MakeRmq(2*Vert,l,(l+r) div 2);
   MakeRmq(2*Vert+1,(l+r) div 2+1,r);
  end;
 Rmq[Vert]:=Nil;
 for i:=l to r do Add(Rmq[Vert],z[i],i,random(maxint))
end;

procedure RepairRmq(Vert,l,r,q,Delta:integer);
begin
 if l<>r then
  if q<=(l+r) div 2 then RepairRmq(2*Vert,l,(l+r) div 2,q,Delta)
  else RepairRmq(2*Vert+1,(l+r) div 2+1,r,q,Delta);
 Delt(Rmq[Vert],z[q],q);
 Add(Rmq[Vert],Delta,q,random(maxint))
end;

function ViewTreeMore(Vert:Link; const Delta:integer):integer;
begin
 Result:=0;
 if Vert<>Nil then
  if Vert^.u1>Delta then begin
    Result:=1;
    if Vert^.vr<>Nil then inc(Result,Vert^.vr^.count);
    inc(Result,ViewTreeMore(Vert^.vl,Delta))
   end
  else Result:=ViewTreeMore(Vert^.vr,Delta)
end;

function CalcMore(Vert,l,r,x1,x2,Delta:integer):integer;
begin
 Result:=0;
 if (l<=x2) and (r>=x1) then
  if (l>=x1) and (r<=x2)
  then Result:=ViewTreeMore(Rmq[Vert],Delta)
  else Result:=CalcMore(2*Vert,l,(l+r) div 2,x1,x2,Delta)+
               CalcMore(2*Vert+1,(l+r) div 2+1,r,x1,x2,Delta)

end;

function ViewTreeLess(Vert:Link; const Delta:integer):integer;
begin
 Result:=0;
 if Vert<>Nil then
  if Vert^.u1<Delta then begin
    Result:=1;
    if Vert^.vl<>Nil then inc(Result,Vert^.vl^.count);
    inc(Result,ViewTreeLess(Vert^.vr,Delta))
   end
  else Result:=ViewTreeLess(Vert^.vl,Delta)
end;

function CalcLess(Vert,l,r,x1,x2,Delta:integer):integer;
begin
 Result:=0;
 if (l<=x2) and (r>=x1) then
  if (l>=x1) and (r<=x2) then Result:=ViewTreeLess(Rmq[Vert],Delta)
  else Result:=CalcLess(2*Vert,l,(l+r) div 2,x1,x2,Delta)+
               CalcLess(2*Vert+1,(l+r) div 2+1,r,x1,x2,Delta)
end;

procedure SolveAndSave;
var i,m,p1,p2,x1,y1,x2,y2:integer;
    Query:char;
begin
 randomize;
 MakeRmq(ROOT,1,n);
 read(m);
 for i:=1 to m do begin
   read(Query);
   while not (Query in ['A'..'Z']) do read(Query);
   if Query='C' then begin
     read(p1,p2);
     RepairRmq(ROOT,1,n,p1,p2);
     z[p1]:=p2
    end
   else begin
     read(x1,y1,x2,y2);
     p1:=CalcMore(ROOT,1,n,x1,x2,(y1+y2) div 2);
     p2:=CalcLess(ROOT,1,n,x1,x2,(y1+y2+1) div 2);
     if p1<p2 then writeln(1)
     else
      if p1>p2 then writeln(2)
      else writeln(0)
    end
  end
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
