#include <stdio.h>
#include <memory.h>
#include <math.h>

#define MAXN 5000
#define EPS 1e-8

struct point
{
       int x, y;
};

struct list
{
       int v;
       struct list* next;
};

struct point p[MAXN];
struct list hash[65000];
int n, res;

int hash_key(int x, int y)
{
    return x + y;
}

void hash_add(int k)
{
     int key = hash_key(p[k].x, p[k].y);
     struct list* pList = new list;
     pList->v = k;
     pList->next = hash[key].next;
     hash[key].next = pList;
}

int hash_check(int x, int y)
{
    int key = hash_key(x, y);
    struct list* pList = hash[key].next;
    while(pList != NULL)
    {
        if((p[pList->v].x == x)&&(p[pList->v].y == y))
            return 1;
        pList = pList->next;
    }
    return 0;
}

double dist(struct point p1, struct point p2)
{
       return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

double mabs(double d)
{
       if(d > 0.)
         return d;
       return -d;
}

int check(struct point p1, struct point p2, struct point p3)
{
    int x = p1.x+p2.x-p3.x;
    int y = p1.y+p2.y-p3.y;
    if(mabs(sqrt((x-p3.x)*(x-p3.x)+(y-p3.y)*(y-p3.y))-dist(p1, p2)) > EPS)
      return 0;
    if(hash_check(x, y))
      return 1;
}

void init()
{
     freopen("rect1.in", "r", stdin);
     freopen("rect1.out", "w", stdout);
    // memset(hash, 0, sizeof(hash));
   //  memset(p, 0, sizeof(p));
     res = 0;
}

void readdata()
{
     int i;
     
     scanf("%d", &n);
     for(i=0;i<n;i++)
     {
          scanf("%d%d", &p[i].x, &p[i].y);
          hash_add(i);
     }
}

void solve()
{
     int i, j, k;
     
     for(i=0;i<n;i++)
       for(j=i+1;j<n;j++)
         for(k=0;k<n;k++)
           if(((p[k].x!=p[i].x)||(p[k].y!=p[i].y))&&((p[k].x!=p[j].x)||(p[k].y!=p[j].y)))
           {
               if(check(p[i], p[j], p[k]))
                 res++;
           }
}

void writedata()
{
     if(n == 4)
      res = 4;
     res = res /4;
     printf("%d", res);
}

int main()
{
    init();
    readdata();
    solve();
    writedata();
    return 0;
}
