{$DELPHI MODE}
{$M 16000000, 16000000, 16000000}
{$O-}

type
  rect = record
    x1, y1, z1, x2, y2, z2, p1, p2, p3: Integer;
  end;

var
  n, i, j: Integer;
  res: Int64;
  mas: array [1..100001] of rect;

function crosseg(x1, x2, x3, x4: Integer): boolean;
begin
  crosseg := (((x1 <= x3) and (x1 >= x4)) or ((x1 <= x4) and (x1 >= x3)) or
  ((x2 <= x3) and (x2 >= x4)) or ((x2 <= x4) and (x2 >= x3)) or
  ((x3 <= x1) and (x3 >= x2)) or ((x3 <= x2) and (x3 >= x1)) or
  ((x4 <= x1) and (x4 >= x2)) or ((x4 <= x2) and (x4 >= x1)));
end;

function crossonx(r1, r2: rect): Integer;
begin
  if (crosseg(r1.y1, r1.y2, r2.y1, r2.y2) and crosseg(r1.z1, r1.z2, r2.z1, r2.z2)) then
    crossonx := 1
  else
    crossonx := 0;
end;

function crossony(r1, r2: rect): Integer;
begin
  if (crosseg(r1.x1, r1.x2, r2.x1, r2.x2) and crosseg(r1.z1, r1.z2, r2.z1, r2.z2)) then
    crossony := 1
  else
    crossony := 0;
end;

function crossonz(r1, r2: rect): Integer;
begin
  if (crosseg(r1.y1, r1.y2, r2.y1, r2.y2) and crosseg(r1.x1, r1.x2, r2.x1, r2.x2)) then
    crossonz := 1
  else
    crossonz := 0;
end;

function cross(r1, r2: rect): Integer;
begin
  if (r1.p1 = r2.p1) and (r1.p1 <> -1) then
  begin
    cross := crossonx(r1, r2);
  end
  else
  if (r1.p1 <> r2.p1) and (r1.p1 <> -1) and (r2.p1 <> -1) then
  begin
    cross := 0;
  end
  else
  if (r1.p2 = r2.p2) and (r1.p2 <> -1) then
  begin
    cross := crossony(r1, r2);
  end
  else
  if (r1.p2 <> r2.p2) and (r1.p2 <> -1) and (r2.p2 <> -1) then
  begin
    cross := 0;
  end
  else
  if (r1.p3 = r2.p3) and (r1.p3 <> -1) then
  begin
    cross := crossonz(r1, r2);
  end
  else
  if (r1.p3 <> r2.p3) and (r1.p3 <> -1) and (r2.p3 <> -1) then
  begin
    cross := 0;
  end
  else
  if (r1.p1 <> -1) and (r2.p2 <> -1) then
  begin
    if ((r2.x1 <= r1.x1) and (r2.x2 >= r1.x1)) or ((r2.x2 <= r1.x1) and (r2.x1 >= r1.x1)) then
    begin
      cross := crossonx(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end
  else
  if (r1.p1 <> -1) and (r2.p3 <> -1) then
  begin
    if ((r2.x1 <= r1.x1) and (r2.x2 >= r1.x1)) or ((r2.x2 <= r1.x1) and (r2.x1 >= r1.x1)) then
    begin
      cross := crossonx(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end
  else
  if (r1.p2 <> -1) and (r2.p1 <> -1) then
  begin
    if ((r2.y1 <= r1.y1) and (r2.y2 >= r1.y1)) or ((r2.y2 <= r1.y1) and (r2.y1 >= r1.y1)) then
    begin
      cross := crossony(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end
  else
  if (r1.p2 <> -1) and (r2.p3 <> -1) then
  begin
    if ((r2.y1 <= r1.y1) and (r2.y2 >= r1.y1)) or ((r2.y2 <= r1.y1) and (r2.y1 >= r1.y1)) then
    begin
      cross := crossony(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end
  else
  if (r1.p3 <> -1) and (r2.p1 <> -1) then
  begin
    if ((r2.z1 <= r1.z1) and (r2.z2 >= r1.z1)) or ((r2.z2 <= r1.z1) and (r2.z1 >= r1.z1)) then
    begin
      cross := crossonz(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end
  else
  if (r1.p3 <> -1) and (r2.p2 <> -1) then
  begin
    if ((r2.z1 <= r1.z1) and (r2.z2 >= r1.z1)) or ((r2.z2 <= r1.z1) and (r2.z1 >= r1.z1)) then
    begin
      cross := crossonz(r1, r2);
    end
    else
    begin
      cross := 0;
    end;
  end;
end;

begin
  assign(input, 'rect3.in');
  assign(output, 'rect3.out');
  reset(input);
  rewrite(output);
  readln(n);
  for i := 1 to n do
  begin
    readln(mas[i].x1, mas[i].y1, mas[i].z1, mas[i].x2, mas[i].y2, mas[i].z2);
    if (mas[i].x1 = mas[i].x2) then
    begin
      mas[i].p1 := mas[i].x1;
    end
    else
    begin
      mas[i].p1 := -1;
    end;
    if (mas[i].y1 = mas[i].y2) then
    begin
      mas[i].p2 := mas[i].y1;
    end
    else
    begin
      mas[i].p2 := -1;
    end;
    if (mas[i].z1 = mas[i].z2) then
    begin
      mas[i].p3 := mas[i].z1;
    end
    else
    begin
      mas[i].p3 := -1;
    end;
  end;
  res := 0;
  for i := 1 to n do
  begin
    for j := i + 1 to n do
    begin
      res := res + cross(mas[i], mas[j]);
    end;
  end;
  writeln(res);
  close(output);
end.
