program global;
{$MODE DELPHI}
{ $DEFINE DEBUG}const taskname = 'rect3'; type integer = longint;

procedure Swap (var a,b :integer); register;
var t :integer;
begin t := a; a := b; b := t; end;

//////////////////////////////////////////////////////////

type
  TFTree = class
    a :array [0..1023, 0..1023] of integer;

    procedure add (x,y, v :integer);
    function sum (x,y :integer) :integer;
    constructor Create;
  end;

procedure TFTree.add;
  procedure addy (y :integer);
  begin
    while y<1000 do
      begin
        inc(a[x,y],v);
        y := y or (y+1);
      end;
  end;
begin
  while x<1000 do
    begin
      addy(y);
      x := x or (x+1);
    end;
end;

function TFTree.sum;
  function sumy (y :integer) :integer;
  begin
    result := 0;
    while y>=0 do
      begin
        inc(result,a[x,y]);
        y := y and (y+1) - 1;
      end;
  end;
begin
  result := 0;
  while x>=0 do
    begin
      inc(result,sumy(y));
      x := x and (x+1) - 1;
    end;
end;

constructor TFTree.Create;
begin
  fillchar(a,sizeof(a),0);
end;

//////////////////////////////////////////////////////////////

type
  TPlain = class
    rs, re :TFTree;
    res :integer;
    constructor Create;
    procedure Add (x1,y1,x2,y2 :integer);
    procedure Delete (x1,y1,x2,y2 :integer);
  end;

constructor TPlain.Create;
begin
  rs := TFTree.Create;
  re := TFTree.Create;
  res := 0;
end;

procedure TPlain.Add;
var
  s1,s2,s3,s4 :integer;
begin
  s1 := rs.sum(x2,y2);
  s2 := re.sum(x1-1,y2);
  s3 := re.sum(x2,y1-1);
  s4 := re.sum(x1-1,y1-1);
  inc(res, s1-s2-s3+s4);

  rs.add(x1,y1,1);
  re.add(x2,y2,1);
end;

procedure TPlain.Delete;
begin
  rs.add(x1,y1,-1);
  re.add(x2,y2,-1);
end;

//////////////////////////////////////////////////////////////

type
  TBox = record x1,y1,x2,y2,z,t :integer; end;
  TBoxSeq = array [1..200000] of TBox;
  TBoxSet = record
    seq :TBoxSeq;
    count :integer;
  end;

procedure ReadBox (var box1, box2 :TBox);
var
  x1 :integer absolute box1.x1;
  y1 :integer absolute box1.y1;
  z1 :integer absolute box1.z;
  t1 :integer absolute box1.t;

  x2 :integer absolute box1.x2;
  y2 :integer absolute box1.y2;
  z2 :integer absolute box2.z;
  t2 :integer absolute box2.t;
begin
  read(x1,y1,z1,x2,y2,z2);

  if x1>x2 then swap(x1,x2);
  if y1>y2 then swap(y1,y2);
  if z1>z2 then swap(z1,z2);

  t1 := 1; t2 := -1;

  box2.x1 := x1; box2.x2 := x2;
  box2.y1 := y1; box2.y2 := y2;
end;

procedure QuickSort (var bs :TBoxSet);
var
  a :TBoxSeq absolute bs.seq;
  procedure swap (a,b :integer);
  begin
    global.swap(bs.seq[a].x1, bs.seq[b].x1);
    global.swap(bs.seq[a].y1, bs.seq[b].y1);
    global.swap(bs.seq[a].x2, bs.seq[b].x2);
    global.swap(bs.seq[a].y2, bs.seq[b].y2);
    global.swap(bs.seq[a].z, bs.seq[b].z);
    global.swap(bs.seq[a].t, bs.seq[b].t);
  end;
  function less (i,j :integer) :boolean;
  begin
    //appear before disappear
    result := (a[i].z<a[j].z) or ((a[i].z=a[j].z)and(a[i].t>=a[j].t));
  end;
  procedure qs (l,r :integer);
  var i,j :integer;
  begin
    if l>=r then exit;
    j := random(r-l+1)+l;
    swap(j,r);
    j := l-1;
    for i := l to r do
      if less(i,r) then
        begin
          inc(j);
          swap(i,j);
        end;
    qs(l,j-1);
    qs(j+1,r);
  end;
begin
  qs (1,bs.count);
end;

//////////////////////////////////////////////////////////////

var
  bs :TBoxSet;
  n  :integer absolute bs.count;
  seq:TBoxSeq absolute bs.seq;

  plain :TPlain;

procedure run;
var
  i :integer;
begin
  read(n);
  for i := 1 to n do
    ReadBox (seq[2*i-1],seq[2*i]);
  n := n*2;
  QuickSort (bs);

  plain.res := 0;
  for i := 1 to n do
    with seq[i] do
      if t=1
        then plain.add(x1,y1,x2,y2)
        else plain.delete(x1,y1,x2,y2);
  writeln (plain.res);
end;

begin
  randomize;
  plain := TPlain.Create;
    assign(input,taskname+'.in'); reset(input);
  {$IFNDEF DEBUG}
    assign(output,taskname+'.out'); rewrite(output);
  {$ELSE}
    while not seekeof do
  {$ENDIF}
  run;
  close(input); close(output);
end.
