{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

const
 StreamIn='rect1.in';
 StreamOut='rect1.out';
 NMAX=4100;
 HMAX=110000;
 k1=17433;
 k2=28377;

type
 integer=longint;
 Cord=record
   x,y:integer
  end;
 IntList=array of integer;
 StrHash=array [0..HMAX] of IntList;
 CordVect=array [0..NMAX] of Cord;

var P:CordVect;
    Hash:StrHash;
    n:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n);
 for i:=1 to n do read(P[i].x,P[i].y)
end;

function GetVect(const p1,p2:Cord):Cord;
begin
 with Result do begin
   x:=p2.x-p1.x;
   y:=p2.y-p1.y
  end
end;

function VectMul(const v1,v2:Cord):integer;
begin
 Result:=v1.x*v2.y-v1.y*v2.x
end;

function Turn(const v:Cord):Cord;
begin
 with Result do begin
   x:=-v.y;
   y:=v.x
  end
end;

function GetHashCode(x,y:integer):integer;
begin
 Result:=(x*k1+y*k2) mod HMAX
end;

function Find(fx,fy:integer):integer;
var hcode,i:integer;
begin
 Result:=0;
 if (fx<0) or (fy<0) then Exit;
 hcode:=GetHashCode(fx,fy);
 if length(Hash[hcode])>0 then
  for i:=0 to High(Hash[hcode]) do
   if (P[Hash[hcode,i]].x=fx) and (P[Hash[hcode,i]].y=fy)
   then begin
     Result:=Hash[hcode,i];
     Exit
    end
end;

procedure SolveAndSave;
var num,hcode,i,j,k,fx,fy,Ans:integer;
    v1,v2:Cord;
begin
 randomize;
 for i:=0 to HMAX do setlength(Hash[i],0);
 for i:=1 to n do begin
   hcode:=GetHashCode(P[i].x,P[i].y);
   setlength(Hash[hcode],length(Hash[hcode])+1);
   Hash[hcode,High(Hash[hcode])]:=i
  end;
 Ans:=0;
 for i:=1 to n do
  for j:=1 to n do
   if i<>j then begin
      v1:=GetVect(P[i],P[j]);
      for k:=1 to n do
       if (i<>k) and (j<>k) then begin
         v2:=GetVect(P[i],P[k]);
         if VectMul(v1,Turn(v2))=0 then begin
           fx:=P[j].x+v2.x;
           fy:=P[j].y+v2.y;
           num:=Find(fx,fy);
           if num>0 then inc(Ans)
          end
        end
    end;
 writeln(Ans div 8)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
