#include <stdio.h>
#include <string.h>

#include <algorithm>
using namespace std;

int n;
int x[4096];
int y[4096];
struct vector
{
  short a, b;
};
inline bool operator == (vector const& a, vector const& b)
{
  return x[a.a] == x[b.a] && y[a.a] == y[b.a] && x[a.b] == x[b.b] && y[a.b] == y[b.b];
}
bool match (vector const& a, vector const& b)
{
  int dx0 = x[a.b] - x[a.a];
  int dy0 = y[a.b] - y[a.a];
  int dx1 = x[b.b] - x[b.a];
  int dy1 = y[b.b] - y[b.a];
  if (dx0 != dx1) return false;
  if (dy0 != dy1) return false;
  int p0 = x[a.a] * dx0 + y[a.a] * dy0;
  int p1 = x[b.a] * dx0 + y[b.a] * dy0;
  return p0 == p1;
}
bool operator < (vector const& a, vector const& b)
{
  int dx0 = x[a.b] - x[a.a];
  int dy0 = y[a.b] - y[a.a];
  int dx1 = x[b.b] - x[b.a];
  int dy1 = y[b.b] - y[b.a];
  if (dx0 != dx1) return dx0 < dx1;
  if (dy0 != dy1) return dy0 < dy1;
  int p0 = x[a.a] * dx0 + y[a.a] * dy0;
  int p1 = x[b.a] * dx0 + y[b.a] * dy0;
  if (p0 != p1) return p0 < p1;
  p0 = x[a.a] * dy0 - y[a.a] * dx0;
  p1 = x[b.a] * dy0 - y[b.a] * dx0;
  return p0 < p1;
}
vector vec[8388608];
int numv = 0;

int main ()
{
  freopen ("rect1.in", "rt", stdin);
  freopen ("rect1.out", "wt", stdout);

  scanf ("%d", &n);
  for (int i = 0; i < n; i++)
  {
    scanf ("%d %d", &x[i], &y[i]);
    for (int j = 0; j < i; j++)
    {
      if (x[i] > x[j] || (x[i] == x[j] && y[i] > y[j]))
        vec[numv].a = j, vec[numv].b = i, numv++;
      else
        vec[numv].a = i, vec[numv].b = j, numv++;
    }
  }
  sort (vec, vec + numv);

  __int64 cnt = 0;
  __int64 streak = 0;
  for (int i = 0; i < numv; i++)
  {
//    printf ("%d %d -> %d %d\n", x[vec[i].a], y[vec[i].a], x[vec[i].b], y[vec[i].b]);
    if (i > 0 && match (vec[i], vec[i - 1]))
    {
      if (vec[i] == vec[i - 1])
        continue;
      streak++;
    }
    else
    {
      cnt += streak * (streak - 1) / 2;
      streak = 1;
    }
  }
  printf ("%I64d", cnt / 2);

  return 0;
}
