#include <stdio.h>
#include <memory.h>

#define MAXN 5000
#define MAXHASH 70000

struct point
{
       int x, y;
};

struct list
{
       int v;
       int next;
};

struct point p[MAXN];
struct list hash[MAXHASH];
struct list hash2[MAXHASH];
int n, res, kk;

int hash_key(int x, int y)
{
    return x + y;
}

void hash_add(int k)
{
     int key = hash_key(p[k].x, p[k].y);
     hash2[kk].v = k;
     hash2[kk].next = hash[key].next;
     hash[key].next = kk;
     kk ++;
}

int hash_check(int x, int y)
{
    int key = hash_key(x, y);
    int i = hash[key].next;
    while(i != -1)
    {
        if((p[hash2[i].v].x == x)&&(p[hash2[i].v].y == y))
            return 1;
        i = hash2[i].next;
    }
    return 0;
}

int dist2(struct point p1, struct point p2)
{
       return ((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}


int check(struct point p1, struct point p2, struct point p3)
{
    int x = p1.x+p2.x-p3.x;
    int y = p1.y+p2.y-p3.y;
    if((x-p3.x)*(x-p3.x)+(y-p3.y)*(y-p3.y) != dist2(p1, p2))
      return 0;
    if(hash_check(x, y))
      return 1;
    return 0;
}

void init()
{
     int i;
     freopen("rect1.in", "r", stdin);
     freopen("rect1.out", "w", stdout);
     for(i=0;i<MAXHASH;i++)
       hash[i].next = -1;
     memset(p, 0, sizeof(p));
     res = 0;
     kk = 0;
}

void readdata()
{
     int i;
     
     scanf("%d", &n);
     for(i=0;i<n;i++)
     {
          scanf("%d%d", &p[i].x, &p[i].y);
          hash_add(i);
     }
}

void solve()
{
     int i, j, k;
     
     for(i=0;i<n;i++)
       for(j=i+1;j<n;j++)
         for(k=0;k<n;k++)
           if(((p[k].x!=p[i].x)||(p[k].y!=p[i].y))&&((p[k].x!=p[j].x)||(p[k].y!=p[j].y)))
           {
               if((k == 4)&&(i==1))
               {
                    res++;
                    res--;
               }
               if(check(p[i], p[j], p[k]))
               {
                 res++;
                 res++;
                 res--;
               }
           }
}

void writedata()
{
     res = res / 4;
     printf("%d", res);
}

int main()
{
    init();
    readdata();
    solve();
    writedata();
    return 0;
}
