program taska; 

{$MODE DELPHI}
{$Q-,R-,S-,I-}

const
  MAXN = 4100;
  HMOD = 750019;

var
  n, i, j, k, c, ans: Integer;
  x, y, hx, hy, next: array [1..MAXN] of Integer;
  h: array [0..HMOD] of Integer;

function scmul(ax, ay, bx, by: Integer): Integer;
begin
  Result := ax * bx + ay * by;
end;

function key(x, y: Integer): Integer;
begin
  Result := 101*x + 179*y;
end;

procedure add(x, y: Integer);
var
  k, u: Integer;
begin
  k := key(x, y);
  u := h[k];
  while u > 0 do
    begin
      if (hx[u] = x) and (hy[u] = y) then
        exit;
      u := next[u];
    end;
  inc(c);
  hx[c] := x;
  hy[c] := y;
  next[c] := h[k];
  h[k] := c;
end;

function query(x, y: Integer): Boolean;
var
  k, u: Integer;
begin
  k := key(x, y);
  u := h[k];
  Result := false;
  while u > 0 do
    begin
      if (hx[u] = x) and (hy[u] = y) then
        begin
          Result := true;
          exit;
        end;
      u := next[u];
    end;
end;

begin
  Assign(input, 'rect1.in');
  Assign(output, 'rect1.out');
  Reset(input); Rewrite(output);

  Read(n);
  fillchar(h, sizeof(h), 0);
  c := 0;
  for i := 1 to n do
    begin
      Read(x[i], y[i]);
      add(x[i], y[i]);
    end;

  ans := 0;

  for j := 1 to n do
    for i := 1 to n-1 do
      for k := i+1 to n do
        if ((x[i] <> x[j]) or (y[i] <> y[j])) and ((x[j] <> x[k]) or (y[j] <> y[k])) and ((x[i] <> x[k]) or (y[i] <> y[k])) and
           (scmul(x[j]-x[i], y[j]-y[i], x[k]-x[j], y[k]-y[j]) = 0) and query(x[i]+x[k]-x[j], y[i]+y[k]-y[j]) then
          inc(ans);

  Write(ans div 4);

  Close(input);
  Close(output);
end.