#include <iostream>
#include <cstdio>
//#include <ext\hash_map>
#include <map>
#include <set>
#include <vector>
#include <ctime>
#include <algorithm>
using namespace std;
#define int64 long long
struct Point{
	int x,y;
	Point(int xx,int yy){
		x = xx;
		y = yy;
	}
	Point(){};
};
bool operator < (Point a,Point b){
	if (a.x!=b.x) return a.x<b.x;
	return a.y<b.y;	
}             

int gcd(int x,int y){
	if (x==0)return y;
	return gcd(y%x,x);
}

struct Segment{
	Point a,b;
	pair<int,int> k;
	Segment(Point& aa,Point& bb){
		a = aa;
		b = bb;
		int ku = a.y-b.y;
		int kd = a.x - b.x;
		if (ku==0)kd = 1;
		if (kd==0){
			ku = 1;
		}else{
			int d = gcd(ku,kd);
			ku /= d;
			kd /= d;
		}
		k = make_pair(ku,kd);
	}
	bool isOk(){
		return (k.first>=0) && (k.second>0);		
	}
	int length(){
		return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
	}
};

int length(Point &a,Point &b){
	return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

bool operator < (Segment a,Segment b){
	if (a.k.first!=b.k.first)return a.k.first<b.k.first;
	return a.k.second<b.k.second;
}
typedef map<pair<int,int>,vector<Segment> > smap;
typedef vector<Segment> vs;

int main(){
	freopen("rect1.in","r",stdin);
	freopen("rect1.out","w",stdout);
	int n;
	cin >> n;
	n = 1800;
	vector<Point> p;
	set<Point> sp;
	for(int i = 0;i < n;i++){
		int x,y;
		//cin >> x >> y;
		x = rand()%32000;
		y = rand()%32000;
		Point pp = Point(x,y);
		if (sp.find(pp)==sp.end()){
			sp.insert(pp);
			p.push_back(pp);
		}
	}
	sort(p.begin(),p.end());
//	cerr << "sort ok" <<clock()<<endl;
//	vector<Segment> vv;
	smap m;
	for(int i = 0; i < n;i++){
		for(int j = i+1; j<n; j++){
			Segment s(p[i],p[j]);
	//		vv.push_back(s);
			if (!s.isOk())continue;
			smap::iterator it = m.find(s.k);
			if (it!=m.end()){
				it->second.push_back(s);
			}else{
				m.insert(make_pair(s.k,vector<Segment>()));
				m.find(s.k)->second.push_back(s);
			}
  	}
	}
//	cerr << "create segment ok" <<clock()<<endl;
	int64 res = 0;
	for(smap::iterator it = m.begin(); it!=m.end(); it++){
		vs v = it->second;
		for(vs::iterator i = v.begin();i!=v.end();i++){
			for(vs::iterator j = i+1;j!=v.end();j++){
				if (i->length()!=j->length() || length(i->a,j->a)==0)continue;
				//i->a i->b j->a;
				if ((i->b.x-i->a.x)*(j->a.x-i->a.x)+(i->b.y-i->a.y)*(j->a.y-i->a.y)!=0)continue;
				//cout <<"("<< i->a.x <<","<< i->a.y <<") - ("<< i->b.x <<","<< i->b.y <<")  "<<i->k.first<<","<<i->k.second<<endl;
				//cout <<"("<< j->a.x <<","<< j->a.y <<") - ("<< j->b.x <<","<< j->b.y <<")  "<<j->k.first<<","<<j->k.second<<endl<<endl;
				res++;
			}
		}
	}
	cout << res;
//	cerr<<"ok" <<clock()<<endl;
	flush(cout);
//	while(1);
	return 0;
}
