program taskc;

{$MODE DELPHI}
{$Q-,R-,S-,I-}

const
  MAXN   = 200000;
  MAXZ   = 1000;
  MAXK   = MAXZ;
  ADD    = +1;
  REMOVE = -1;

type
  TArr  = array [0..MAXN] of Integer;
  TMap  = array [0..MAXZ, 0..MAXZ] of Int64;
  TLine = array [0..MAXZ] of Int64;

procedure order(var x, y: Integer);
var
  tmp: Integer;
begin
  if x > y then
    begin
      tmp := x; x := y; y := tmp;
    end;
end;

procedure QSort(var a, b, c, d, e: TArr; n: Integer);

procedure sort(l, r: Integer);
var
  i, j, x, tmp: Integer;
begin
  i := l; j := r;
  x := a[l + Random(r-l+1)];
  while i <= j do
    begin
      while a[i] < x do inc(i);
      while x < a[j] do dec(j);
      if i <= j then
        begin
          tmp := a[i]; a[i] := a[j]; a[j] := tmp;
          tmp := b[i]; b[i] := b[j]; b[j] := tmp;
          tmp := c[i]; c[i] := c[j]; c[j] := tmp;
          tmp := d[i]; d[i] := d[j]; d[j] := tmp;
          tmp := e[i]; e[i] := e[j]; e[j] := tmp;
          inc(i); dec(j);
        end;
    end;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
end;

begin
  sort(1, n);
end;

procedure QSort2(var a, b, c, d, e, f: TArr; n: Integer);

procedure sort(l, r: Integer);
var
  i, j, x, ax, bx, tmp: Integer;
begin
  i := l; j := r;
  x := l + Random(r-l+1);
  ax := a[x]; bx := b[x];
  while i <= j do
    begin
      while (a[i] < ax) or ((a[i] = ax) and (b[i] = ADD) and (bx = REMOVE)) do inc(i);
      while (ax < a[j]) or ((ax = a[j]) and (bx = ADD) and (b[j] = REMOVE)) do dec(j);
      if i <= j then
        begin
          tmp := a[i]; a[i] := a[j]; a[j] := tmp;
          tmp := b[i]; b[i] := b[j]; b[j] := tmp;
          tmp := c[i]; c[i] := c[j]; c[j] := tmp;
          tmp := d[i]; d[i] := d[j]; d[j] := tmp;
          tmp := e[i]; e[i] := e[j]; e[j] := tmp;
          tmp := f[i]; f[i] := f[j]; f[j] := tmp;
          inc(i); dec(j);
        end;
    end;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
end;

begin
  sort(1, n);
end;

procedure QSort3(var a, b, c, d: TArr; n: Integer);

procedure sort(l, r: Integer);
var
  i, j, x, ax, bx, tmp: Integer;
begin
  i := l; j := r;
  x := l + Random(r-l+1);
  ax := a[x]; bx := b[x];
  while i <= j do
    begin
      while (a[i] < ax) or ((a[i] = ax) and (b[i] = ADD) and (bx = REMOVE)) do inc(i);
      while (ax < a[j]) or ((ax = a[j]) and (bx = ADD) and (b[j] = REMOVE)) do dec(j);
      if i <= j then
        begin
          tmp := a[i]; a[i] := a[j]; a[j] := tmp;
          tmp := b[i]; b[i] := b[j]; b[j] := tmp;
          tmp := c[i]; c[i] := c[j]; c[j] := tmp;
          tmp := d[i]; d[i] := d[j]; d[j] := tmp;
          inc(i); dec(j);
        end;
    end;
  if l < j then sort(l, j);
  if i < r then sort(i, r);
end;

begin
  sort(1, n);
end;

function query(var b: TMap; x, y: Integer): Int64;
var
  k: Integer;
begin
  Result := 0;
  while x > 0 do
    begin
      k := y;
      while k > 0 do
        begin
          inc(Result, b[x,k]);
          k := k and (k+1) - 1;
        end;
      x := x and (x+1) - 1;
    end;
end;

function get(var b: TMap; x1, y1, x2, y2: Integer): Int64;
begin
  Result := query(b, x2, y2) - query(b, x1-1, y2) - query(b, x2, y1-1) + query(b, x1-1, y1-1);
end;

procedure update(var b: TMap; x, y, d: Integer);
var
  k: Integer;
begin
  while x <= MAXZ do
    begin
      k := y;
      while k <= MAXZ do
        begin
          inc(b[x,k], d);
          k := k or (k+1);
        end;
      x := x or (x+1);
    end;
end;

function lquery(var b: TLine; x: Integer): Int64;
begin
  Result := 0;
  while x > 0 do
    begin
      inc(Result, b[x]);
      x := x and (x+1) - 1;
    end;
end;

function lget(var b: TLine; x1, x2: Integer): Int64;
begin
  Result := lquery(b, x2) - lquery(b, x1-1);
end;

procedure lupdate(var b: TLine; x, d: Integer);
begin
  while x <= MAXZ do
    begin
      inc(b[x], d);
      x := x or (x+1);
    end;
end;

var
  n, k, x1t, y1t, z1t, x2t, y2t, z2t, c, i, j, kk, cc, kx: Integer;
  z, x1, y1, x2, y2, zs, ev, ex1, ey1, ex2, ey2, ex, lx, rx, yx: TArr;
  l, r, d, u: TMap;
  bl, br: TLine;
  ans: Int64;

begin
  Assign(input, 'rect3.in');
  Assign(output, 'rect3.out');
  Reset(input); Rewrite(output);
  RandSeed := 158308;

  Read(n);
  k := 0;
  c := 0;
  for i := 1 to n do
    begin
      Read(x1t, y1t, z1t, x2t, y2t, z2t);
      order(x1t, x2t);
      order(y1t, y2t);
      order(z1t, z2t);
      if z1t = z2t then
        begin
          inc(k);
          z[k] := z1t;
          x1[k] := x1t; x2[k] := x2t;
          y1[k] := y1t; y2[k] := y2t;
        end
      else
        begin
          inc(c);
          zs[c] := z1t;
          ev[c] := ADD;
          ex1[c] := x1t; ey1[c] := y1t;
          ex2[c] := x2t; ey2[c] := y2t;
          inc(c);
          zs[c] := z2t;
          ev[c] := REMOVE;
          ex1[c] := x1t; ey1[c] := y1t;
          ex2[c] := x2t; ey2[c] := y2t;
        end;
    end;

  QSort(z, x1, y1, x2, y2, k);
  QSort2(zs, ev, ex1, ey1, ex2, ey2, c);

  fillchar(l, sizeof(l), 0);
  fillchar(r, sizeof(r), 0);
  fillchar(d, sizeof(d), 0);
  fillchar(u, sizeof(u), 0);
  kk := 1;
  cc := 1;
  ans := 0;
  for i := 1 to MAXZ do
    begin

      // ADD
      while (cc <= c) and (zs[cc] = i) and (ev[cc] = ADD) do
        begin
          if ex1[cc] = ex2[cc] then // vertical
            begin
              inc(ans, get(l, 1, ey1[cc], MAXK, ey2[cc]) - get(r, 1, ey1[cc], ex1[cc]-1, ey2[cc]) -
                       get(l, ex2[cc]+1, ey1[cc], MAXK, ey2[cc]));
              inc(ans, get(d, ex1[cc], 1, ex2[cc], MAXK) - get(u, ex1[cc], 1, ex2[cc], ey1[cc]-1) -
                       get(d, ex1[cc], ey2[cc]+1, ex2[cc], MAXK));
              update(d, ex1[cc], ey1[cc], +1);
              update(u, ex2[cc], ey2[cc], +1);
            end
          else  // horizontal
            begin
              inc(ans, get(l, 1, ey1[cc], MAXK, ey2[cc]) - get(r, 1, ey1[cc], ex1[cc]-1, ey2[cc]) -
                       get(l, ex2[cc]+1, ey1[cc], MAXK, ey2[cc]));
              inc(ans, get(d, ex1[cc], 1, ex2[cc], MAXK) - get(u, ex1[cc], 1, ex2[cc], ey1[cc]-1) -
                       get(d, ex1[cc], ey2[cc]+1, ex2[cc], MAXK));
              update(l, ex1[cc], ey1[cc], +1);
              update(r, ex2[cc], ey2[cc], +1);
            end;
          inc(cc);
        end;

      // Count OXY-rectangles
      kx := 0;
      while (kk <= k) and (z[kk] = i) do
        begin
          inc(ans, get(l, 1, y1[kk], MAXK, y2[kk]) - get(r, 1, y1[kk], x1[kk]-1, y2[kk]) -
                   get(l, x2[kk]+1, y1[kk], MAXK, y2[kk]));
          inc(ans, get(d, x1[kk], 1, x2[kk], MAXK) - get(u, x1[kk], 1, x2[kk], y1[kk]-1) -
                   get(d, x1[kk], y2[kk]+1, x2[kk], MAXK));

          inc(kx);
          yx[kx] := y1[kk];
          ex[kx] := ADD;
          lx[kx] := x1[kk];
          rx[kx] := x2[kk];
          inc(kx);
          yx[kx] := y2[kk];
          ex[kx] := REMOVE;
          lx[kx] := x1[kk];
          rx[kx] := x2[kk];

          inc(kk);
        end;

      QSort3(yx, ex, lx, rx, kx);
      fillchar(bl, sizeof(bl), 0);
      fillchar(br, sizeof(br), 0);
      for j := 1 to kx do
        if ex[j] = ADD then
          begin
            inc(ans, lget(bl, 1, MAXK) - lget(br, 1, lx[j]-1) - lget(bl, rx[j]+1, MAXK));
            lupdate(bl, lx[j], +1);
            lupdate(br, rx[j], +1);
          end
        else
          begin
            lupdate(bl, lx[j], -1);
            lupdate(br, rx[j], -1);
          end;

      // REMOVE
      while (cc <= c) and (zs[cc] = i) do
        begin
          if ex1[cc] = ex2[cc] then // vertical
            begin
              update(d, ex1[cc], ey1[cc], -1);
              update(u, ex2[cc], ey2[cc], -1);
            end
          else // horizontal
            begin
              update(l, ex1[cc], ey1[cc], -1);
              update(r, ex2[cc], ey2[cc], -1);
            end;
          inc(cc);
        end;
    end;

  Write(ans);

  Close(input);
  Close(output);
end.
