{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math,SysUtils;

const
 StreamIn='rect1.in';
 StreamOut='rect1.out';
 NMAX=4100;
 HMAX=110000;
 k1=17433;
 k2=28377;
 EPS=1e-7;

type
 integer=longint;
 real=extended;
 Cord=record
   x,y:integer
  end;
 IntList=array of integer;
 StrHash=array [0..HMAX] of IntList;
 CordVect=array [0..NMAX] of Cord;
 IntVect=array [0..NMAX] of integer;
 ExtVect=array [0..NMAX] of real;

var P:CordVect;
    Hash:StrHash;
    Tmp:IntVect;
    Val:ExtVect;
    EVect:Cord;
    n:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n);
 for i:=1 to n do read(P[i].x,P[i].y)
end;

function GetVect(const p1,p2:Cord):Cord;
begin
 with Result do begin
   x:=p2.x-p1.x;
   y:=p2.y-p1.y
  end
end;

function VectMul(const v1,v2:Cord):integer;
begin
 Result:=v1.x*v2.y-v1.y*v2.x
end;

function ScalMul(const v1,v2:Cord):integer;
begin
 Result:=v1.x*v2.x+v1.y*v2.y
end;

function Turn(const v:Cord):Cord;
begin
 with Result do begin
   x:=-v.y;
   y:=v.x
  end
end;

function Modul(const v:Cord):real;
begin
 Result:=sqrt(sqr(v.x)+sqr(v.y))
end;

function Angle(v1,v2:Cord):real;
var a:real;
begin
 a:=ScalMul(v1,v2);
 Result:=ArcCos(a/(Modul(v1)*Modul(v2)))
end;

function GetHashCode(x,y:integer):integer;
begin
 Result:=(x*k1+y*k2) mod HMAX
end;

function Find(fx,fy:integer):integer;
var hcode,i:integer;
begin
 Result:=0;
 if (fx<0) or (fy<0) then Exit;
 hcode:=GetHashCode(fx,fy);
 if length(Hash[hcode])>0 then
  for i:=0 to High(Hash[hcode]) do
   if (P[Hash[hcode,i]].x=fx) and (P[Hash[hcode,i]].y=fy)
   then begin
     Result:=Hash[hcode,i];
     Exit
    end
end;

function VAng(a1,a2:real):real;
begin
 if a1<(a2+EPS) then Result:=a2-a1
 else Result:=2*pi-a1+a2
end;

procedure QSort(l,r:integer);
var i,j,k:integer;
    q,qq:real;
begin
 i:=l;
 j:=r;
 q:=Val[l+random(r-l+1)];
 repeat
  while Val[i]<q do inc(i);
  while Val[j]>q do dec(j);
  if i<=j then begin
    k:=Tmp[i];
    Tmp[i]:=Tmp[j];
    Tmp[j]:=k;
    qq:=Val[i];
    Val[i]:=Val[j];
    Val[j]:=qq;
    inc(i);
    dec(j)
   end
 until i>j;
 if i<r then QSort(i,r);
 if l<j then QSort(l,j)
end;

procedure SolveAndSave;
var num,hcode,l,r,i,j,k,fx,fy,Ans:integer;
    v1,v2:Cord;
begin
 randomize;
 for i:=0 to HMAX do setlength(Hash[i],0);
 for i:=1 to n do begin
   hcode:=GetHashCode(P[i].x,P[i].y);
   setlength(Hash[hcode],length(Hash[hcode])+1);
   Hash[hcode,High(Hash[hcode])]:=i
  end;
 if n<=500 then begin
   Ans:=0;
   for i:=1 to n do
    for j:=1 to n do
     if i<>j then begin
        v1:=GetVect(P[i],P[j]);
        for k:=1 to n do
         if (i<>k) and (j<>k) then begin
           v2:=GetVect(P[i],P[k]);
           if VectMul(v1,Turn(v2))=0 then begin
             fx:=P[j].x+v2.x;
             fy:=P[j].y+v2.y;
             num:=Find(fx,fy);
             if num>0 then inc(Ans)
            end
          end
      end;
   writeln(Ans div 8);
   Halt(0)
  end;
 with EVect do begin
   x:=1;
   y:=0;
  end;
 Ans:=0;
 for i:=1 to n do begin
   Tmp[0]:=0;
   for j:=1 to n do
    if i<>j then begin
      inc(Tmp[0]);
      Tmp[Tmp[0]]:=j;
      Val[Tmp[0]]:=Angle(EVect,GetVect(P[i],P[j]));
      if P[j].y<P[i].y then Val[Tmp[0]]:=2*pi-Val[Tmp[0]]
     end;
   if Tmp[0]>0 then QSort(1,Tmp[0]);
   l:=1;
   for j:=1 to Tmp[0] do begin
     while VAng(Val[j],Val[l])+EPS<pi/2 do begin
       inc(l);
       if l>Tmp[0] then l:=1
      end;
     r:=l;
     if abs(VAng(Val[j],Val[l])-(pi/2))<EPS
     then
      while VectMul(GetVect(P[i],P[Tmp[j]]),Turn(GetVect(P[i],P[Tmp[l]])))=0
      do begin
        v1:=GetVect(P[i],P[Tmp[l]]);
        fx:=P[Tmp[j]].x+v1.x;
        fy:=P[Tmp[j]].y+v1.y;
        num:=Find(fx,fy);
        if num>0
        then begin
          inc(Ans);
         end;
        inc(l);
        if l>Tmp[0] then l:=1;
        if abs(VAng(Val[j],Val[l])-(pi/2))>EPS then Break
       end;
     l:=r
    end
  end;
 writeln(Ans div 4)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
