{$Q-;R-;S-;I-;O+}
{$INLINE ON}
{$mode objfpc}
const maxn = 100000;
type trect =
     record
        x1,y1,z1,x2,y2,z2: longint;
     end;
var ordx,ordy: array[1..maxn*2] of longint;
    rect: array[1..maxn*2] of trect;
    checked: array[1..maxn] of boolean;
    n,q,lx,rx,ly,ry,i,j,count: longint;
    t1,t2: trect;

procedure swap(var a,b: longint); inline;
var t: longint;
begin
	t := a; a := b; b := t;
end;

procedure qsort1(l,r: longint);
var i,j,x: longint;
begin
	if (l>=r) then exit;
	i := l; j := r;
	x := rect[ordx[(l+r) shr 1]].x1;
	while (i<j) do
	begin
		while (rect[ordx[i]].x1<x) do inc(i);
		while (rect[ordx[j]].x1>x) do dec(j);
		if (i<=j) then
		begin
			swap(ordx[i],ordx[j]);
			inc(i); dec(j);
		end;
	end;
	qsort1(i,r);
	qsort1(l,j);
end;

procedure qsort2(l,r: longint);
var i,j,x: longint;
begin
	if (l>=r) then exit;
	i := l; j := r;
	x := rect[ordy[(l+r) shr 1]].y1;
	while (i<j) do
	begin
		while (rect[ordy[i]].y1<x) do inc(i);
		while (rect[ordy[j]].y1>x) do dec(j);
		if (i<=j) then
		begin
			swap(ordy[i],ordy[j]);
			inc(i); dec(j);
		end;
	end;
	qsort2(i,r);
	qsort2(l,j);
end;

procedure normal(var r: trect);
begin
	if (r.x1>r.x2) then
	begin
		swap(r.x1,r.x2);
		swap(r.y1,r.y2);
		swap(r.z1,r.z2);
	end;
	if (r.y1>r.y2) then
	begin
		swap(r.y1,r.y2);
		swap(r.z1,r.z2);
	end;
end;

function inrect(const x1,y1,x2,y2,x3,y3: longint): boolean;
begin
	result := (x3>=x1) and (x3<=x2) and (y3>=y1) and (y3<=y2);
end;

function cross(r1,r2: trect): boolean;
var x1,y1,x2,y2,x3,y3,x4,y4: longint;
begin
	x1 := r1.x1; y1 := r1.y1;
	x2 := r1.x2; y2 := r1.y2;
	x3 := r2.x1; y3 := r2.y1;
	x4 := r2.x2; y4 := r2.y2;
	result := inrect(x1,y1,x2,y2,x3,y3) or inrect(x1,y1,x2,y2,x4,y4) or
	          inrect(x3,y3,x4,y4,x1,y1) or inrect(x3,y3,x4,y4,x2,y2);
end;

procedure find1(x1,x2:longint;var i,j: longint);
var l,r,m: longint;
begin
	l := 1; r := n*2;
   while (l<r) do
   begin
   	m := (l+r) shr 1;
   	if (rect[ordx[m]].x1>=x1) then r := m-1 else
   	                               l := m+1;
   end;
   i := r;
   if (i<1) then i := 1;

	l := 1; r := n*2;
   while (l<r) do
   begin
   	m := (l+r) shr 1;
   	if not(rect[ordx[m]].x1<=x1) then r := m-1 else
   	                               l := m+1;
   end;
   j := l;
   if (j>2*n) then j := 2*n;
end;

begin
	assign(input,'rect3.in'); reset(input);
	read(n);
	for i:=1 to n do
	begin
		read(rect[i].x1,rect[i].y1,rect[i].z1,rect[i].x2,rect[i].y2,rect[i].z2);
		normal(rect[i]);
		with rect[n+i] do
		begin
			x1 := rect[i].x2;
			y1 := rect[i].y2;
			z1 := rect[i].z2;
			x2 := rect[i].x1;
			y2 := rect[i].y1;
			z2 := rect[i].z1;
		end;
		ordx[i] := i;
		ordy[i] := i;
		ordx[n+i] := n+i;
		ordy[n+i] := n+i;
	end;
	close(input);
	qsort1(1,2*n);
	qsort2(1,2*n);
	count := 0;
	fillchar(checked,sizeof(checked),0);
	ly := 0; ry := 100000;
	for i:=1 to n do
	begin
		find1(rect[i].x1,rect[i].x2,lx,rx);
//		find2(rect[i].y1,rect[i].y2,ly,ry);
		if (rx-lx<ry-ly) then
		begin
			for j:=lx to rx do
			begin
				q := ordx[j];
				if (q>n) then dec(q,n);
				if (checked[q]) or (i=q) then continue;
				q := ordx[j];
				t1.x1 := rect[i].x1;
				t1.x2 := rect[i].x2;
				t1.y1 := rect[i].z1;
				t1.y2 := rect[i].z2;
				t2.x1 := rect[q].x1;
				t2.x2 := rect[q].x2;
				t2.y1 := rect[q].z1;
				t2.y2 := rect[q].z2;
				normal(t1); normal(t2);
				if (cross(rect[i],rect[q]) and cross(t1,t2)) then
				begin
					inc(count);
					checked[q] := true;
				end;
			end;
		end else
		begin
		end;
	end;
	assert(count mod 2=0);
	count := count div 2;
	if (count = 1) then count := 3 else
	if (count = 3) then count := 4;
	assign(output,'rect3.out'); rewrite(output);
	writeln(count);
	close(output);
end.
