program ARect1;
{$MODE DELPHI}
{$O-,Q+,R+}

uses
        math;

const eps = 1E-9;

var
        N:Longint;
        X, Y:Array[1..4063] Of Longint;
        nX, nY:Array[1..4063] Of Longint;

procedure MergeSort(S, E, T:Longint);
var
        M, P1, P2, P3, nP:Longint;
begin
if (S >= E) then exit;
M := (S + E) div 2;
MergeSort (S, M, T);
MergeSort (M + 1, S, T);

P1 := S; P2 := M + 1;
for P3 := S to E do begin
        if (P1 <= M) then begin
                if (P2 <= E) then begin
                        case T of
                        1:if X[P1] <= X[P2] then begin
                                nP := P1;
                                inc (P1, 1);
                          end else begin
                                nP := P2;
                                inc (P2, 1);
                          end;
                        2:if Y[P1] <= Y[P2] then begin
                                nP := P1;
                                inc (P1, 1);
                          end else begin
                                nP := P2;
                                inc (P2, 1);
                          end;
                        end;
                end else begin
                        nP := P1;
                        inc (P1, 1);
                end;
        end else begin
                nP := P2;
                inc (P2, 1);
        end;
        nX[P3] := X[nP];
        nY[P3] := Y[nP];
end;

for P3 := S to E do begin
        X[P3] := nX[P3];
        Y[P3] := nY[P3];
end;
end;

function a90(A, B, C:Longint):Boolean;
var
        A1, A2, AR:Real;
        X1, Y1, X2, Y2:Longint;
        D1, D2:Real;
begin
X1 := X[A] - X[B];
Y1 := Y[A] - Y[B];
D1 := sqrt(X1 * X1 + Y1 * Y1);

X2 := X[C] - X[B];
Y2 := Y[C] - Y[B];
D2 := sqrt(X2 * X2 + Y2 * Y2);

A1 := arccos(X1 / D1);
if arcsin(Y1 / D1) < 0 then A1 := -A1;

A2 := arccos(X2 / D2);
if arcsin(Y2 / D2) < 0 then A2 := -A2;

AR := A2 - A1; if AR < 0 then AR := -AR;

result := false;
if abs(AR - (pi / 2)) < eps then result := true;
if abs(AR - (pi * 1.5)) < eps then result := true;
end;

{
function HavePoint(nX, nY:Longint):Boolean;
var
        I:Longint;
begin
result := true;
for I := 1 to N do
        if (X[I] = nX) and (Y[I] = nY) then exit;
result := false;
end;
}
function HavePoint(nX, nY:Longint):Boolean;
var
        L, R, M:Longint;
        sL, sR:Longint;
begin
result := false;

if Y[1] <> nY then begin
        L := 1; R := N;
        while (L + 1 < R) do begin
                M := (L + R) div 2;
                if Y[M] < nY then
                        L := M
                else
                        R := M;
        end;

        if Y[R] <> nY then exit;
        sL := R;
end else
        sL := 1;


if Y[N] <> nY then begin
        L := 1; R := N;
        while (L + 1 < R) do begin
                M := (L + R) div 2;
                if Y[M] <= nY then
                        L := M
                else
                        R := M;
        end;

        if Y[L] <> nY then exit;
        sR := L;
end else
        sR := N;

L := sL; R := sR;
if X[L] = nX then begin
        result := true;
        exit;
end;
if X[R] = nX then begin
        result := true;
        exit;
end;

while (L  + 1 < R) do begin
        M := (L + R) div 2;
        if X[M] = nX then begin
                result := true;
                exit;
        end;
        if X[M] < nX then
                L := M
        else
                R := M;
end;
result := false;
end;

var
        I, I2, I3:Longint;
        Vx, Vy:Longint;
        Ans:Longint;
begin
assign (input, 'rect1.in');
reset (input);
readln (input, N);
for I := 1 to N do
        readln (X[I], Y[I]);
close (input);

MergeSort (1, N, 1);
MergeSort (1, N, 2);

Ans := 0;
for I := 1 to N do
        for I2 := I + 1 to N do
                for I3 := I2 + 1 to N do begin
                        if a90(I, I2, I3) then begin
                                Vx := X[I] - X[I2];
                                Vy := Y[I] - Y[I2];
                                if HavePoint(X[I3] + Vx, Y[I3] + Vy) then
                                        Inc (Ans, 1);
                        end;

                        if a90(I2, I3, I) then begin
                                Vx := X[I2] - X[I3];
                                Vy := Y[I2] - Y[I3];
                                if HavePoint(X[I] + Vx, Y[I] + Vy) then
                                        Inc (Ans, 1);
                        end;

                        if a90(I3, I, I2) then begin
                                Vx := X[I3] - X[I];
                                Vy := Y[I3] - Y[I];
                                if HavePoint(X[I2] + Vx, Y[I2] + Vy) then
                                        Inc (Ans, 1);
                        end;
                end;

assign (output, 'rect1.out');
rewrite (output);
writeln (Ans div 4);
close (output);
end.
