#include <stdio.h>
#include <memory.h>
#include <stdlib.h>

#define MAXN 100000

struct ev
{
  int x;
  int type;
};

struct ev a[MAXN];
int n;

int min(int a, int b)
{
  if(a<=b)
    return a;
  return b;
}

int max(int a, int b)
{
  if(a>=b)
    return a;
  return b;
}

void init()
{
  freopen("segments.in", "r", stdin);
  freopen("segments.out", "w", stdout);
  memset(a, 0, sizeof(a));
}

void readdata()
{
  int i, x, y;
  scanf("%d", &n);
  for(i=0;i<n;i++)
  {
    scanf("%d%d", &x, &y);
    a[2*i].x = min(x, y);
    a[2*i].type = 1;
    a[2*i+1].x = max(x, y);
    a[2*i+1].type = 2;
  }
}

int mycomp(const void* a, const void* b)
{
  struct ev* pa = (struct ev*)a;
  struct ev* pb = (struct ev*)b;
  if(pa->x != pb->x)
    return pa->x-pb->x;
  return pa->type-pb->type;
}

void solve()
{
  int i, max, x, c;
  max = 0;
  x = 0;
  c = 0;
  qsort(a, 2*n, sizeof(struct ev), mycomp);
  for(i = 0;i<2*n;i++)
  {
    if(a[i].type == 1)
    {
      c++;
      if(c > max)
      {
        max = c;
        x = a[i].x;
      }
    }
    else
      c--;
  }
  printf("%d %d", max, x);
}

int main()
{
  init();
  readdata();
  solve();
  return 0;
}