#include <stdio.h>
#include <stdlib.h>

#define OFFSET 65536
#define MAXN 10000

struct rect
{
  int x1, y1;
  int x2, y2;
};

struct el
{
  int x, t;
  int type;
};

struct rect a[MAXN];
struct el p[20000];
int c[131072];
int add[131072];
int n;

void init()
{
  freopen("windows.in", "r", stdin);
  freopen("windows.out", "w", stdout);
  memset(c, 0, sizeof(c));
}

void readdata()
{
  int i; 
  scanf("%d", &n);
  for(i=0;i<n;i++)
  {
    scanf("%d%d%d%d", &a[i].x1, &a[i].y2, &a[i].x2, &a[i].y1);
    a[i].x1 += 32000;  a[i].y1 += 32000;
    a[i].x2 += 32000;  a[i].y2 += 32000;
    p[2*i].x = a[i].x1;
    p[2*i].type = 1;
    p[2*i].t = i;
    p[2*i+1].x = a[i].x2;
    p[2*i+1].type = 2;
    p[2*i+1].t = i;
  }
}

int mycomp(const void* a, const void* b)
{
  struct el* pa = (struct el*)a;
  struct el* pb = (struct el*)b;
  if(pa->x != pb->x)
    return pa->x-pb->x;
  return pa->type-pb->type;
}

int min(int a, int b)
{
  if(a<=b)
    return a;
  return b;
}
int max(int a, int b)
{
  if(a>=b)
    return a;
  return b;
}

int get_left(int k)
{
  while(k < OFFSET)
    k = k << 1;
  return k;
}

int get_right(int k)
{
  while(k < OFFSET)
    k = 2*k+1;
  return k;
}

void update(int k, int l, int r, int s)
{
  c[k]+=s;
  if(k >= OFFSET)
    return;
  if(add[k] != 0)
  {
    c[k] += add[k];
    add[2*k] += add[k];
    add[2*k+1] += add[k];
    add[k] = 0;
  }
  if((get_left(k) == l)&&(get_right(k) == r))
  {
    add[2*k] += s;
    add[2*k+1] += s;
    return;
  }
  if(get_left(2*k+1)<=r)
    update(2*k+1, max(get_left(2*k+1), l), r, s);
  if(get_right(2*k)>=l)
    update(2*k, l, min(r, get_right(2*k)), s);
}

int get_max_c(int k)
{
  if(k >= OFFSET)
    return k;
  if(add[k] != 0)
  {
    c[k] += add[k];
    add[2*k] += add[k];
    add[2*k+1] += add[k];
    add[k] = 0;
  }
  if(c[2*k]+add[2*k] == c[k])
    return get_max_c(2*k);
  return get_max_c(2*k+1);
}

void solve()
{
  int i, max, x, y;
  qsort(p, 2*n, sizeof(struct el), mycomp);
  for(i=0;i<2*n;i++)
  { 
    if(p[i].type == 1)
    {
      update(1, a[p[i].t].y2+OFFSET, a[p[i].t].y1+OFFSET, 1);
      if(c[1] > max)
      {
        max = c[1];
        x = p[i].x;
        y = get_max_c(1)-OFFSET;
      }
    }
    else
      update(1, a[p[i].t].y2+OFFSET, a[p[i].t].y1+OFFSET,-1);
  }
  printf("%d\n", max);
  printf("%d %d", x-32000, y-32000);
}

int main()
{
  init();
  readdata();
  solve();
  return 0;
}