{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
type
    int = longint;
const
    NMAX = 100001;
var
    x, y, p: array [1..NMAX] of int;
    n, xx, yy, k: int;

function find(d: int; var ans_x, ans_y: int): boolean;
var
    i, j, l, r, now: int;
begin
    for i := 1 to k do begin
        l := p[i];
        r := p[i] + d;
        if r > xx then break;
        now := 0;
        for j := 1 to n do
            if (x[j] > l) and (x[j] < r) then begin
                if y[j] - now >= d then begin
                    ans_x := l;
                    ans_y := now;
                    result := true;
                    exit;
                end;
                now := y[j];
            end;
        if yy - now >= d then begin
            ans_x := l;
            ans_y := now;
            result := true;
            exit;
        end;
    end;
    result := false;
end;

procedure swap(var a, b: int);
var
    c: int;
begin
    c := a;
    a := b;
    b := c;
end;

procedure qsort(l, r: int);
var
    i, j, xx: int;
begin
    i := l;
    j := r;
    xx := y[(l + r) div 2];
    while i <= j do begin
        while y[i] < xx do
            inc(i);
        while y[j] > xx do
            dec(j);
        if i <= j then begin
            swap(x[i], x[j]);
            swap(y[i], y[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort(i, r);
    if l < j then qsort(l, j);
end;

procedure qsort2(l, r: int);
var
    i, j, xx: int;
begin
    i := l;
    j := r;
    xx := p[(l + r) div 2];
    while i <= j do begin
        while p[i] < xx do
            inc(i);
        while p[j] > xx do
            dec(j);
        if i <= j then begin
            swap(p[i], p[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort2(i, r);
    if l < j then qsort2(l, j);
end;

var
    l, r, m, i, ans_x, ans_y: int;

begin
    assign(input, 'roi.in');
    reset(input);
    assign(output, 'roi.out');
    rewrite(output);

    read(xx, yy, n);
    for i := 1 to n do begin
        read(x[i], y[i]);
        p[i] := x[i];
    end;
    qsort(1, n);
    p[n + 1] := 0;
    qsort2(1, n + 1);

    k := 0;
    for i := 1 to n + 1 do
        if (i = 1) or (p[i] <> p[i - 1]) then begin
            inc(k);
            p[k] := p[i];
        end;

    l := 1;
    r := min(xx, yy);
    while r - l > 1 do begin
        m := (l + r) div 2;
        if find(m, ans_x, ans_y) then
            l := m
        else
            r := m;
    end;
    if find(r, ans_x, ans_y) then begin
        writeln(r);
        writeln(ans_x, ' ', ans_y);
        exit;
    end;
    find(r, ans_x, ans_y);
    writeln(l);
    writeln(ans_x, ' ', ans_y);
end.