{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

const
 StreamIn='list.in';
 StreamOut='list.out';
 NMAX=510000;
 VMAX=4*NMAX;
 INFVAL=-1;
 ROOT=1;


type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 RmqTree=array [0..VMAX] of integer;
 BoolVect=array [0..NMAX] of boolean;

var next,prev,val,inf:IntVect;
    Rmq:RmqTree;
    Mark:BoolVect;
    n,m,Head:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure OperA(a,b:integer);
begin
 if next[a]<>INFVAL then prev[next[a]]:=prev[a];
 if prev[a]<>INFVAL then next[prev[a]]:=next[a];
 if prev[b]<>INFVAL then next[prev[b]]:=a;
 prev[a]:=prev[b];
 next[a]:=b;
 prev[b]:=a
end;

procedure OperB(a,b:integer);
begin
 if next[a]<>INFVAL then prev[next[a]]:=prev[a];
 if prev[a]<>INFVAL then next[prev[a]]:=next[a];
 if next[b]<>INFVAL then prev[next[b]]:=a;
 next[a]:=next[b];
 next[b]:=a;
 prev[a]:=b
end;

procedure LoadData;
var i,a,b:integer;
    Query:char;
begin
 read(n,m);
 for i:=1 to n do begin
   next[i]:=i+1;
   prev[i]:=i-1
  end;
 prev[1]:=INFVAL;
 next[n]:=INFVAL;
 for i:=1 to m do begin
   read(Query);
   while not (Query in ['A','B']) do read(Query);
   read(a,b);
   if Query='A' then OperA(a,b)
   else OperB(a,b)
  end;
 Head:=1;
 while prev[Head]<>INFVAL do Head:=prev[Head]
end;

procedure GetExtr(Vert,l,r,gr:integer; var extr:integer);
begin
 if l<=gr then
  if r<=gr then begin
    if Rmq[Vert]<>0 then
     if val[extr]<val[Rmq[Vert]] then extr:=Rmq[Vert]
   end
  else begin
    GetExtr(2*Vert,l,(l+r) div 2,gr,extr);
    GetExtr(2*Vert+1,(l+r) div 2+1,r,gr,extr)
   end
end;

procedure Add(Vert,l,r:integer; const elem:integer);
begin
 if val[elem]>val[Rmq[Vert]] then Rmq[Vert]:=elem;
 if l<>r then
  if elem<=(l+r) div 2 then Add(2*Vert,l,(l+r) div 2,elem)
  else Add(2*Vert+1,(l+r) div 2+1,r,elem)
end;

procedure SolveAndSave;
var i,Temp,Elem:integer;
begin
 val[0]:=0;
 fillchar(Rmq,sizeof(Rmq),0);
 Temp:=Head;
 while Head<>INFVAL do begin
   inf[Head]:=0;
   GetExtr(ROOT,1,n,Head,inf[Head]);
   val[Head]:=val[inf[Head]]+1;
   Add(ROOT,1,n,Head);
   Head:=next[Head]
  end;
 Head:=Temp;
 Temp:=0;
 for i:=1 to n do
  if val[i]>Temp then begin
    Temp:=val[i];
    Elem:=i
   end;
 fillchar(Mark,sizeof(Mark),True);
 while Elem<>0 do begin
   Mark[Elem]:=False;
   Elem:=inf[Elem]
  end;
 writeln(n-Temp);
 for i:=1 to n do
  if Mark[i] then
   if i=1 then begin
     writeln('A ',i,' ',Head);
     OperA(i,Head)
    end
   else begin
     writeln('B ',i,' ',i-1);
     OperB(i,i-1)
    end
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
