{$DELPHI MODE}
{$M 16000000, 16000000, 16000000}
{$O-}

var
  rank, parent, col, och, mres, newcost, cost: array [1..205] of longint;
  n, ttime, i, j, k, p, u, res: longint;
  graph, newgraph, d: array [1..205, 1..205] of Boolean;

procedure makeset(k: Integer);
begin
  rank[k] := 1;
  parent[k] := k;
end;

function find(k: Integer): Integer;
begin
  if (parent[k] = k) then
  begin
    find := k;
  end
  else
  begin
    parent[k] := find(parent[k]);
    find := parent[k];
  end;
end;

procedure link(p, q: Integer);
begin
  if (rank[p] < rank[q]) then
  begin
    parent[p] := q;
  end
  else
  if (rank[p] > rank[q]) then
  begin
    parent[q] := p;
  end
  else
  begin
    parent[q] := p;
    rank[p] := rank[p] + 1;
  end;
end;

procedure union(p, q: Integer);
begin
  if (find(p) <> find(q)) then
  begin
    link(find(p), find(q));
  end;
end;

procedure dfs(k: Integer);
var
  i: Integer;
begin
  col[k] := 1;
  for i := 1 to n do
  begin
    if (col[i] = 0) and (newgraph[k, i]) then
    begin
      dfs(i);
    end;
  end;
  och[ttime] := k;
  ttime := ttime + 1;
end;

function dfsmod(k: Integer): Integer;
var
  i: Integer;
begin
  dfsmod := 0;
  mres[k] := 1;
  for i := 1 to n do
  begin
    if (mres[i] = 0) and (newgraph[k, i]) then
    begin
      dfsmod := dfsmod + dfsmod(i);
    end;
  end;
  dfsmod := dfsmod + newcost[k];
end;

begin
  assign(input, 'matan.in');
  assign(output, 'matan.out');
  reset(input);
  rewrite(output);
  read(n);
  ttime := 1;
  for i := 1 to n do
  begin
    for j := 1 to n do
    begin
      graph[i, j] := false;
      newgraph[i, j] := false;
      d[i, j] := false;
    end;
  end;
  for i := 1 to n do
  begin
    cost[i] := 0;
    newcost[i] := 0;
    col[i] := 0;
    mres[i] := 0;
    rank[i] := 0;
    och[i] := 0;
  end;
  for i := 1 to n do
  begin
    read(cost[i]);
  end;
  for j := 1 to n do
  begin
    read(p);
    for i := 1 to p do
    begin
      read(k);
      graph[j, k] := true;
    end;
  end;
  for i := 1 to n do
  begin
    for j := 1 to n do
    begin
      d[i, j] := graph[i, j];
    end;
  end;
  for i := 1 to n do
  begin
    d[i, i] := true;
  end;
  for k := 1 to n do
  begin
    for i := 1 to n do
    begin
      for j := 1 to n do
      begin
        d[i, j] := d[i, j] or (d[i, k] and d[k, j]);
      end;
    end;
  end;
  for i := 1 to n do
  begin
    makeset(i);
  end;
  for i := 1 to n do
  begin
    for j := 1 to n do
    begin
      if (d[i, j] and d[j, i]) then
      begin
        union(i, j);
      end;
    end;
  end;
  for i := 1 to n do
  begin
    u := find(i);
    if (i <> u) then
    begin
      newcost[i] := -1000000;
      newcost[u] := newcost[u] + cost[i];
    end
    else
    begin
      newcost[u] := newcost[u] + cost[u];
    end;
  end;
  for i := 1 to n do
  begin
    for j := i + 1 to n do
    begin
      if (graph[i, j]) then
      begin
        newgraph[find(i), find(j)] := true;
      end
      else
      if (graph[j, i]) then
      begin
        newgraph[find(j), find(i)] := true;
      end;
    end;
  end;
  for i := 1 to n do
  begin
    if (col[i] = 0) then
      dfs(i);
  end;
  res := 0;
  for i := 1 to n do
  begin
    for j := 1 to n do
    begin
      if (mres[j] = 1) then
        mres[j] := 0;
    end;
    p := dfsmod(och[i]);
    if (p >= 0) then
    begin
      for j := 1 to n do
      begin
        if mres[j] = 1 then
          mres[j] := 2;
      end;
      res := res + p;
    end;
  end;
  writeln(res);
  close(output);
end.