#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#define MAXN 201000

struct point
{
       int x, y;
};

struct point a[MAXN];
int xc[MAXN];
int yc[MAXN];
int n, x, y;

void init()
{
     freopen("roi.in", "r", stdin);
     freopen("roi.out", "w", stdout);
}

void readdata()
{
     int i;
     scanf("%d%d", &x, &y);
     scanf("%d", &n);
     for(i=0;i<n;i++)
     {
       scanf("%d%d", &a[i].x, &a[i].y);
       xc[i] = a[i].x;
       yc[i] = a[i].y;
     }
     xc[n] = yc[n] = 0;
     xc[n+1] = x;
     yc[n+1] = y;
}

int mycmp(const void* a, const void* b)
{
    return (*(int*)a)-(*(int*)b);
}

int min(int a, int b)
{
    if(a<=b)
      return a;
    return b;
}

int is_ok(int xc, int yc, int s)
{
    int i;
    if((xc+s > x)||(yc+s > y))
      return 0;
    for(i=0;i<n;i++)
    {
      if((a[i].x>xc)&&(a[i].x<xc+s)&&(a[i].y>yc)&&(a[i].y<yc+s))
        return 0;
    }
    return 1;
}

int check(int s, int* tx, int* ty)
{
    int i, j;
    for(i=0;i<n+2;i++)
    {
      for(j=0;j<n+2;j++)
        if(is_ok(xc[i], yc[j], s))
        {
          *tx = xc[i];
          *ty = yc[j];
          return 1;
        }
    }
    return 0;
}

void solve()
{
     int rx = 0, ry = 0;
     int tx, ty;
     int up = min(x, y);
     int down = 1;
     int m;
     
     qsort(xc, n+2, sizeof(int), mycmp);
     qsort(yc, n+2, sizeof(int), mycmp);     
     while(up-down > 1)
     {
       m = (up+down)/2;
       if(check(m, &tx, &ty))
       {
         down = m;
         rx =  tx;
         ry = ty;
       }
       else
         up = m;
     }
     printf("%d\n%d %d", (up+down)/2, rx, ry);
}

void writedata()
{

}

int main()
{
    init();
    readdata();
    solve();
    writedata();
    return 0;
}
