Program prg;

{$H+}

type
  integer = longint;

const
  taskname = 'matan';

var
  n: integer;
  pol: array[0..201] of integer;

  i, j, k, l: integer;

  arr: array[0..201, 0..201] of integer;

  good: boolean;

  cycle, ts, prev: array[0..201] of integer;
  was, e_out: array[0..201] of boolean;

  enter: array[0..201] of integer;

  t1, t2, t3: integer;

  res: integer;
  now: integer;
  max, maxi: integer;

  pred: array[0..201, 0..201] of boolean;

procedure topsort(v: integer);
  var
    i: integer;

  begin
    was[v] := true;
    for i := 1 to arr[v][0] do begin
      if (not was[arr[v][i]]) then begin
        topsort(arr[v][i]);
      end;
    end;
    inc(ts[0]);
    ts[ts[0]] := v;
  end;


function dfs(v: integer; pr: array of boolean): boolean;
  var
    i: integer;

  begin
    was[v] := true;
    pr[v] := true;
    for i := 1 to arr[v][0] do begin
      if (pr[arr[v][i]]) then begin
        cycle[0] := 1;
        cycle[1] := v;
        dfs := true;
        exit;
      end else if not was[arr[v][i]] then begin
        if (dfs(arr[v][i], pr)) then begin
          inc(cycle[0]);
          cycle[cycle[0]] := v;
          dfs := true;
          exit;
        end;
      end;
    end;
    dfs := false;
  end;

begin
  assign(input, taskname + '.in');
  assign(output, taskname + '.out');
  reset(input);
  rewrite(output);

  read(n);
  for i := 1 to n do begin
    read(pol[i]);
  end;

  for i := 1 to n do begin
    read(k);
    for j := 1 to k do begin
      read(t1);
      inc(arr[t1][0]);
      arr[t1][arr[t1][0]] := i;
    end;
  end;

  good := false;
  while not good do begin
    good := true;
    fillchar(was, sizeof(was), false);
    for i := 1 to n do if (not was[i]) then begin
      fillchar(e_out, sizeof(e_out), false);
      if (dfs(i, e_out)) then begin
        good := false;
        break;
      end;
    end;
    if (good) then break;

    fillchar(was, sizeof(was), false);
    fillchar(e_out, sizeof(e_out), false);
    arr[201][0] := 0;

    t1 := 0;
    for i := 1 to cycle[0] do begin
      was[cycle[i]] := true;
      inc(t1, pol[cycle[i]]);
      for j := 1 to arr[cycle[i]][0] do begin
        e_out[arr[cycle[i]][j]] := true;
      end;
    end;
    for i := 1 to n do
      if (e_out[i]) and (not was[i]) then begin
        inc(arr[201][0]);
        arr[201][arr[201][0]] := i;
      end;

    for i := 1 to 200 do if (was[i]) then begin
      k := i;
      break;
    end;


    for i := 1 to n do begin
      fillchar(e_out, sizeof(e_out), false);
      for j := 1 to arr[i][0] do begin
        if (was[arr[i][j]]) then begin
          e_out[k] := true;
        end else begin
          e_out[arr[i][j]] := true;
        end;
      end;
      arr[i][0] := 0;
      for j := 1 to n do begin
        if (e_out[j]) then begin
          inc(arr[i][0]);
          arr[i][arr[i][0]] := j;
        end;
      end;
    end;
    for i := 1 to n do
      if (was[i]) then begin
        arr[i][0] := 0;
        pol[i] := -1;
      end;

    arr[k] := arr[201];
    pol[k] := t1;
  end;

  for i := 1 to n do begin
    for j := 1 to arr[i][0] do begin
      inc(enter[arr[i][j]]);
    end;
  end;

  fillchar(was, sizeof(was), false);
  for i := 1 to n do begin
    if (enter[i] = 0) then begin
      ts[0] := 0;
      fillchar(was, sizeof(was), false);
      topsort(i);
    end;
  end;
    inc(ts[0]);
    ts[ts[0]] := 0;
    arr[0][0] := 0;
    for i := 1 to n do if (enter[i] = 0) then begin
      inc(arr[0][0]);
      arr[0][arr[0][0]] := i;
      pol[0] := 0;
    end;


      fillchar(pred, sizeof(pred), false);
      for j := ts[0] downto 1 do begin
        pred[ts[j]][ts[j]] := true;
        for k := 1 to arr[ts[j]][0] do begin
          for l := 1 to n do begin
            pred[arr[ts[j]][k]][l] := pred[arr[ts[j]][k]][l] or pred[ts[j]][l];
          end;
        end;
      end;

      fillchar(prev, sizeof(prev), 0);
      for j := 1 to ts[0] do begin
        for k := 1 to arr[ts[j]][0] do begin
          if (prev[arr[ts[j]][k]] = 0) then begin
            prev[arr[ts[j]][k]] := ts[j];
          end;
        end;
      end;

      now := 0;
      max := 0;
      maxi := 0;
      for j := ts[0] downto 1 do begin
        if (pred[ts[j], maxi]) then begin
          inc(now, pol[ts[j]]);
        end else begin
          if (pred[maxi, prev[ts[j]]]) then begin
            now := max + pol[ts[j]];
          end else begin
            inc(now, pol[ts[j]]);
          end;
        end;
        if (now > max) then begin
          max := now;
          maxi := ts[j];
        end;
      end;

      inc(res, max);

  writeln(res);

  close(input);
  close(output);
end.
