{$MODE DELPHI}
{$M 64000000,64000000,64000000}

const
 StreamIn='matan.in';
 StreamOut='matan.out';
 NMAX=210;

type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 IntGrid=array [0..NMAX] of IntVect;

var Val,Nvl,List,Order,Mark,qmrk:IntVect;
    G,H:IntGrid;
    n,Cmp,Ans,Temp,vsk:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i,j,v,m:integer;
begin
 read(n);
 for i:=1 to n do read(Val[i]);
 fillchar(G,sizeof(G),0);
 for i:=1 to n do begin
   read(m);
   for j:=1 to m do begin
     read(v);
     G[i,v]:=1
    end
  end
end;

procedure DFS1(Vert:integer);
var i:integer;
begin
 Mark[Vert]:=1;
 for i:=1 to n do
  if (Mark[i]=0) and (G[Vert,i]=1) then DFS1(i);
 inc(List[0]);
 List[List[0]]:=Vert
end;

procedure Gen(lev,upp:integer);
var i,j,vrt,Res:integer;
    Flag:boolean;
begin
 if (lev>upp) or (lev>List[0]) then begin
   inc(vsk);
   qmrk:=Mark;
   Res:=Temp;
   for i:=1 to n do begin
     vrt:=Order[i];
     if (qmrk[vrt]=0) and (Nvl[vrt]>0) then begin
       Flag:=True;
       for j:=1 to n do
        if G[vrt,j]=1 then
         if qmrk[j]=0 then begin
           Flag:=false;
           break
          end;
       if Flag then begin
         inc(Res,Nvl[vrt]);
         qmrk[vrt]:=1
        end
      end
    end;
   if Res>Ans then Ans:=Res
  end
 else begin
   Gen(lev+1,upp);
   Mark[List[lev]]:=1;
   Temp:=Temp+Nvl[List[lev]];
   Gen(lev+1,upp);
   Temp:=Temp-Nvl[List[lev]];
   Mark[List[lev]]:=0
  end
end;

procedure DFS2(Vert:integer);
var i:integer;
begin
 Mark[Vert]:=Cmp;
 for i:=1 to n do
  if (Mark[i]=0) and (H[Vert,i]=1) then DFS2(i)
end;

procedure SolveAndSave;
var i,j,k,vrt,Count:integer;
begin
 List[0]:=0;
 fillchar(Mark,sizeof(Mark),0);
 for i:=1 to n do
  if Mark[i]=0 then DFS1(i);
 for i:=1 to n do
  for j:=1 to n do
   if G[i,j]=1 then H[j,i]:=1;
 fillchar(Mark,sizeof(Mark),0);
 Cmp:=0;
 for i:=n downto 1 do
  if Mark[List[i]]=0 then begin
    inc(Cmp);
    DFS2(List[i])
   end;
 fillchar(H,sizeof(H),0);
 fillchar(Nvl,sizeof(Nvl),0);
 for i:=1 to n do inc(Nvl[Mark[i]],Val[i]);
 for i:=1 to n do
  for j:=1 to n do
   if G[i,j]=1 then
    if Mark[i]<>Mark[j] then H[Mark[i],Mark[j]]:=1;
 n:=Cmp;
 for k:=1 to n do
  for i:=1 to n do
   for j:=1 to n do
    if (H[i,k]=1) and (H[k,j]=1) then H[i,j]:=1;
 for i:=1 to n do
  for j:=1 to n do G[i,j]:=H[i,j];
 List[0]:=0;
 for i:=1 to n do Mark[i]:=0;
 for i:=1 to n do
  if Mark[i]=0 then DFS1(i);
 Ans:=0;
 fillchar(Mark,sizeof(Mark),0);
 for i:=1 to n do begin
   vrt:=List[i];
   Count:=0;
   for j:=1 to n do
    if (G[vrt,j]=1) and (Nvl[j]<0) then inc(Count,-Nvl[j]);
   if Count<=Nvl[vrt] then begin
     inc(Ans,Nvl[vrt]);
     for j:=1 to n do
      if G[vrt,j]=1 then begin
        inc(Ans,Nvl[j]);
        for k:=1 to n do
         if k<>vrt then G[k,j]:=0;
        Mark[j]:=1
       end;
     for k:=1 to n do G[k,vrt]:=0;
     Mark[vrt]:=1
    end
  end;
 Order:=List;
 List[0]:=0;
 for i:=1 to n do
  if (Mark[i]=0) and (Nvl[i]<0) then begin
    Count:=0;
    for j:=1 to n do
     if (G[j,i]=1) and (Nvl[j]>0) then inc(Count,Nvl[j]);
    if Abs(Nvl[i])<Count then begin
      inc(List[0]);
      List[List[0]]:=i;
      Val[List[0]]:=Count-Abs(Nvl[i])
     end
   end;
 for i:=1 to List[0]-1 do
  for j:=i+1 to List[0] do
   if Val[List[j]]>Val[List[i]] then begin
     k:=List[i];
     List[i]:=List[j];
     List[j]:=k
    end;
 Temp:=Ans;
 vsk:=0;
 Gen(1,9);
 writeln(Ans)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
