#include <vector>
#include <cstdio>

using namespace std;

int n, m, ans;

const int NMAX = 100000;
const int MMAX = 100000;

vector<int> gu, gv, w, t[NMAX];
int p[NMAX], r[NMAX];

int leader(int v) {
   if (p[v] == v) {
      return v;
   } else {
      return p[v] = leader(p[v]);
   }
}

void unionIt(int a, int b) {
   a = leader(a);
   b = leader(b);
   if (rand() & 1) p[a] = b; else p[b] = a;
}

void outdata() {
   printf("%d\n", ans);
}

void solve() {
   for(int i = 0; i < n; ++i) p[i] = i;
   int edge = 0;
   ans = 0;
   while (edge < n - 1) {
      memset(r, 255, sizeof(r[0]) * n);
      for(int i = 0; i < m; ++i) {
         int x = gu[i], y = gv[i], z = w[i];
         int px = leader(x), py = leader(y);
         if (px != py) {
            if (r[px] == -1 || w[r[px]] > z) r[px] = i;
            if (r[py] == -1 || w[r[py]] > z) r[py] = i;
         }
      }
      int dec = 0, dece = 0;
      for(int v = 0; v < n; ++v) if (p[v] == v) {
         int e = r[v];
         // take edge e
         int u = leader(gu[e]) + leader(gv[e]) - v;
		 unionIt(u, v);
         if (r[u] == r[v]) {
            dec += w[r[v]];
            ++dece;
         }
         ans += w[r[v]];
         ++edge;
      }
      ans -= dec / 2;
      edge -= dece / 2;
   }
}

void readdata() {
   scanf("%d%d", &n, &m);
   for(int i = 0; i < n; ++i) {
      int x, y, z;
      scanf("%d%d%d", &x, &y, &z);
      --x, --y;
      gu.push_back(x);
      gv.push_back(y);
      w.push_back(z);
   }
}

int main() {
   readdata();
   solve();
   outdata();
   return 0;
}
