{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math,Windows;

const
 StreamIn='roi.in';
 StreamOut='roi.out';
 NMAX=210000;

type
 IntVect=array [0..NMAX] of integer;

var x,y,dx,dy,sv,state:IntVect;
    qx,qy,n,tt:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(qx,qy);
 read(n);
 for i:=1 to n do read(x[i],y[i])
end;

procedure qsort(var a:IntVect; l,r:integer);
var i,j,q,k:integer;
begin
 i:=l;
 j:=r;
 q:=a[l+random(r-l+1)];
 repeat
  while a[i]<q do inc(i);
  while a[j]>q do dec(j);
  if i<=j then begin
    k:=a[i];
    a[i]:=a[j];
    a[j]:=k;
    inc(i);
    dec(j)
   end
 until i>j;
 if i<r then qsort(a,i,r);
 if l<j then qsort(a,l,j)
end;

procedure normz(var a:IntVect; var m:integer);
var i:integer;
begin
 m:=1;
 for i:=2 to n do
  if a[i]<>a[i-1] then begin
    inc(m);
    a[m]:=a[i]
   end
end;

procedure SolveAndSave;
var i,j,k,l,r,n1,n2,Ans,Ax,Ay,q,mh,Temp:integer;
begin
 tt:=gettickcount;
 randomize;
 inc(n);
 x[n]:=0; y[n]:=0;
 inc(n);
 x[n]:=qx; y[n]:=qy;
 for i:=1 to n do dx[i]:=x[i];
 for i:=1 to n do dy[i]:=y[i];
 qsort(dx,1,n);
 qsort(dy,1,n);
 normz(dx,n1);
 normz(dy,n2);
 for i:=1 to n do begin
   l:=0;
   r:=n2;
   while (l+1)<r do begin
     q:=(l+r) div 2;
     if dy[q]<y[i] then l:=q else r:=q
    end;
   sv[i]:=r
  end;
 Ans:=0;
 for i:=1 to n1-1 do begin
   for j:=1 to n2 do state[j]:=qx;
   for j:=1 to n do
    if x[j]>dx[i] then state[sv[j]]:=min(state[sv[j]],x[j]);
   for j:=1 to n2-1 do begin
     mh:=qx;
     for k:=j+1 to n2 do begin
       Temp:=Min(dy[k]-dy[j],mh-dx[i]);
       if Temp>Ans then begin
         Ans:=Temp;
         Ax:=dx[i];
         Ay:=dy[j]
        end;
       mh:=min(mh,state[k])
      end;
     if (gettickcount-tt)>1900 then begin
       writeln(Ans);
       writeln(Ax,' ',Ay);
       Halt(0)
      end
    end
  end;
 writeln(Ans);
 writeln(Ax,' ',Ay)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
