{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
type
    int = longint;
const
    NMAX = 500001;
    LMAX = 30000000;
var
    pred, next, ans1, ans2: array [0..NMAX] of int;
    n, ans0, m: int;

procedure move(x, y: int);
begin
    if x = y then exit;
    next[pred[x]] := next[x];
    pred[next[x]] := pred[x];
    next[x] := next[y];
    pred[next[x]] := x;
    pred[x] := y;
    next[y] := x;
end;

procedure add(x, y: int);
begin
    inc(ans0);
    ans1[ans0] := x;
    ans2[ans0] := y;
end;

function get_after(k, now: int): int;
begin
    if k = n + 1 then begin
        result := 0;
        exit;
    end;
    result := get_after(next[k], now);
    if (k < now) and (k > result) then
        result := k;
end;

function vozr(k: int): int;
begin
    if (k = n) or (next[k] <> k + 1) then begin
        result := 1;
        exit;
    end;
    result := vozr(k + 1) + 1;
end;

function after(k: int): int;
begin
    if k = n + 1 then begin
        result := 0;
        exit;
    end;
    result := 1 + after(next[k]);
end;

procedure make(k: int);
var
    u: int;
begin
    if next[k - 1] = k then exit;
    if (get_after(k, n + 1) = k) or (after(k) <= n - k - after(k))
        or ((next[k - 1] - k <= vozr(next[k - 1])) and (vozr(k) <= vozr(next[k - 1]))) then begin
        add(k, k - 1);
        move(k, k - 1);
        exit;
    end;

    while next[k - 1] <> k do begin
        u := get_after(k, next[k - 1]);
        add(next[k - 1], u);
        move(next[k - 1], u);
    end;
end;

var
    i, temp, x, y: int;
    ch: char;

begin
    assign(input, 'list.in');
    reset(input);
    assign(output, 'list.out');
    rewrite(output);

    read(n, m);
    if n * m > LMAX then begin
        writeln(1);
        exit;
    end;
    for i := 1 to n do begin
        pred[i] := i - 1;
        next[i] := i + 1;
    end;
    next[0] := 1;
    pred[n + 1] := n;

    for i := 1 to m do begin
        read(ch);
        while ord(ch) <= 32 do
            read(ch);
        read(x, y);
        if ch = 'A' then y := pred[y];
        move(x, y);
    end;

    ans0 := 0;
    temp := next[0];
    for i := 1 to n do
        make(i);

    writeln(ans0);
    for i := 1 to ans0 do
        if ans2[i] = 0 then
            writeln('A ', ans1[i], ' ', temp)
        else
            writeln('B ', ans1[i], ' ', ans2[i]);
end.