#include <stdio.h>
#include <string.h>

struct block;
struct item
{
  int next;
  int prev;
  block* bl;
};
item items[524288];
int first;
int last;
int N;
struct block
{
  int i;
  int a, b;
  block* next;
  block* prev;
  block* p;
};
block blall[262144];
int nblall = 0;
block* fbl;
block* lbl;
void add_block (int a)
{
  block* x = &blall[nblall];
  x->i = nblall++;
  x->a = a;
  x->b = a;
  x->p = NULL;
  x->prev = lbl;
  x->next = NULL;
  if (lbl)
    lbl->next = x;
  else
    fbl = x;
  lbl = x;
}
void inc_block (int a)
{
  lbl->b = a;
}

void move_a (int a, int b)
{
  if (items[a].prev >= 0)
    items[items[a].prev].next = items[a].next;
  else
    first = items[a].next;
  if (items[a].next >= 0)
    items[items[a].next].prev = items[a].prev;
  else
    last = items[a].prev;
  items[a].next = b;
  items[a].prev = items[b].prev;
  if (items[a].prev >= 0)
    items[items[a].prev].next = a;
  else
    first = a;
  items[b].prev = a;
}
void move_b (int a, int b)
{
  if (items[a].prev >= 0)
    items[items[a].prev].next = items[a].next;
  else
    first = items[a].next;
  if (items[a].next >= 0)
    items[items[a].next].prev = items[a].prev;
  else
    last = items[a].prev;
  items[a].prev = b;
  items[a].next = items[b].next;
  if (items[a].next >= 0)
    items[items[a].next].prev = a;
  else
    last = a;
  items[b].next = a;
}
   
block* get_root (block* b)
{
  if (b->p == NULL) return b;
  return b->p = get_root (b->p);
}
inline block* get_block (int i)
{
  if (i < 0 || i >= N)
    return NULL;
  return get_root (items[i].bl);
}
bool less_than (block const* a, block const* b)
{
  if (b == NULL)
    return true;
  if (a == NULL)
    return false;
  if ((a->b - a->a) != (b->b - b->a))
    return (a->b - a->a) < (b->b - b->a);
  int ra = 0;
  block* bb = get_block (a->a - 1);
  if (bb && bb->b - bb->a > ra) ra = bb->b - bb->a;
  bb = get_block (a->b + 1);
  if (bb && bb->b - bb->a > ra) ra = bb->b - bb->a;
  int rb = 0;
  bb = get_block (b->a - 1);
  if (bb && bb->b - bb->a > rb) rb = bb->b - bb->a;
  bb = get_block (b->b + 1);
  if (bb && bb->b - bb->a > rb) rb = bb->b - bb->a;
  return ra > rb;
}   

class tree
{
  enum {maxt = 262144};
  block* bl[maxt + maxt];
  int nbl;
public:
  void build ();
  void update (block* b);
  block* get ();
} tr;
void tree::build ()
{
  memset (bl, 0, sizeof bl);
  for (int i = 0; i < nblall; i++)
    bl[i + maxt] = &blall[i];
  for (int i = maxt - 1; i > 0; i--)
    if (less_than (bl[i + i], bl[i + i + 1]))
      bl[i] = bl[i + i];
    else
      bl[i] = bl[i + i + 1];
  nbl = nblall;
}
void tree::update (block* b)
{           
  for (int i = (b->i + maxt) >> 1; i > 0; i >>= 1)
    if (less_than (bl[i + i], bl[i + i + 1]))
      bl[i] = bl[i + i];
    else
      bl[i] = bl[i + i + 1];
}
block* tree::get ()
{
  int l = maxt;
  int r = nbl - 1 + maxt;
  block* res = bl[l];
  if (less_than (bl[r], res))
    res = bl[r];
  while (l < r - 1)
  {
    if (!(l & 1))
      if (less_than (bl[l + 1], res))
        res = bl[l + 1];
    if (r & 1)
      if (less_than (bl[r - 1], res))
        res = bl[r - 1];
    l >>= 1;
    r >>= 1;
  }
  return res;
}

void merge (block* b)
{
  b->b = b->next->b;
  b->next->b = 10000000;
  b->next->p = b;
  tr.update (b->next);
  tr.update (b);
  b->next = b->next->next;
  if (b->next)
    b->next->prev = b;
  else
    lbl = b;
}

int act_a[131072];
int act_b[131072];
char act_c[131072];
int num_act = 0;

void move_block_a (block* a, block* b)
{
  int _prev = b->a;
  for (int i = a->b; i >= a->a; i--)
  {
    act_a[num_act] = i;
    act_b[num_act] = _prev;
    act_c[num_act++] = 'A';
    _prev = i;
  }
  if (a->next)
    a->next->prev = a->prev;
  else
    lbl = a->prev;
  if (a->prev)
    a->prev->next = a->next;
  else
    fbl = a->next;
  if (a->next && a->prev && a->prev->b == a->next->a - 1)
    merge (a->prev);
  a->next = b;
  a->prev = b->prev;
  if (a->prev)
    a->prev->next = a;
  else
    fbl = a;
  b->prev = a;
  if (a->next && a->b == a->next->a - 1)
    merge (a);
  if (a->prev && a->prev->b == a->a - 1)
    merge (a->prev);
}
void move_block_b (block* a, block* b)
{
  int _prev = b->b;
  for (int i = a->a; i <= a->b; i++)
  {
    act_a[num_act] = i;
    act_b[num_act] = _prev;
    act_c[num_act++] = 'B';
    _prev = i;
  }
  if (a->next)
    a->next->prev = a->prev;
  else
    lbl = a->prev;
  if (a->prev)
    a->prev->next = a->next;
  else
    fbl = a->next;
  if (a->next && a->prev && a->prev->b == a->next->a - 1)
    merge (a->prev);
  a->prev = b;
  a->next = b->next;
  if (a->next)
    a->next->prev = a;
  else
    lbl = a;
  b->next = a;
  if (a->next && a->b == a->next->a - 1)
    merge (a);
  if (a->prev && a->prev->b == a->a - 1)
    merge (a->prev);
}

int main ()
{
  freopen ("list.in", "rt", stdin);
  freopen ("list.out", "wt", stdout);

  int op;
  scanf ("%d %d", &N, &op);
  for (int i = 0; i < N; i++)
  {
    items[i].prev = i - 1;
    items[i].next = i + 1;
  }
  first = 0;
  last = N - 1;
  items[last].next = -1;

  for (int i = 0; i < op; i++)
  {
    char c[3];
    int a, b;
    scanf ("%s %d %d", c, &a, &b);
    if (c[0] == 'A')
      move_a (a - 1, b - 1);
    else
      move_b (a - 1, b - 1);
  }

  fbl = NULL;
  lbl = NULL;
  int cur = first;
  while (cur >= 0)
  {
    if (items[cur].prev < 0 || items[cur].prev != cur - 1)
      add_block (cur);
    else
      inc_block (cur);
    items[cur].bl = lbl;
    cur = items[cur].next;
  }

  tr.build ();

  while (fbl != lbl)
  {
    block* b = tr.get ();
    block* left = get_block (b->a - 1);
    block* right = get_block (b->b + 1);
    if (!left && !right)
      break;
    if (!left)
      move_block_a (b, right);
    else if (!right)
      move_block_b (b, left);
    else if (less_than (left, right))
      move_block_a (b, right);
    else
      move_block_b (b, left);
  }
  
  printf ("%d\n", num_act);
  for (int i = 0; i < num_act; i++)
    printf ("%c %d %d\n", act_c[i], act_a[i] + 1, act_b[i] + 1);

  return 0;
}
