{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
type
    int = longint;
    list = ^node;
    node = record
        inf, num: int;
        next: list;
    end;
const
    NMAX = 100001;
    MMAX = 300001;
var
    g: array [1..NMAX] of list;
    used: array [1..NMAX] of boolean;
    used_edge: array [1..MMAX] of boolean;
    c, u, o, mesto: array [0..NMAX] of int;
    n, m, l: int;

procedure swap(var a, b: int);
var
    c: int;
begin
    c := a;
    a := b;
    b := c;
end;

procedure qsort(l, r: int);
var
    i, j, x: int;
begin
    i := l;
    j := r;
    x := u[(l + r) div 2];
    while i <= j do begin
        while mesto[u[i]] < mesto[x] do
            inc(i);
        while mesto[u[j]] > mesto[x] do
            dec(j);
        if i <= j then begin
            swap(u[i], u[j]);
            swap(o[i], o[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort(i, r);
    if l < j then qsort(l, j);
end;

procedure write_no;
begin
    writeln(-1);
    halt;
end;

procedure dfs(k: int);
var
    t: list;
begin
    used[k] := true;
    t := g[k];
    while t <> nil do begin
        if used[t^.inf] then
            write_no;
        t := t^.next;
    end;

    t := g[k];
    while t <> nil do begin
        if not used[t^.inf] then begin
            used_edge[t^.num] := true;
            dfs(t^.inf);
        end;
        t := t^.next;
    end;
end;

procedure tp(k: int);
var
    t: list;
begin
    if used[k] then exit;
    used[k] := true;
    t := g[k];
    while t <> nil do begin
        tp(t^.inf);
        t := t^.next;
    end;
    dec(l);
    c[l] := k;
    mesto[k] := l;
end;

procedure add(x, y, d: int);
var
    t: list;
begin
    new(t);
    t^.inf := y;
    t^.num := d;
    t^.next := g[x];
    g[x] := t;
end;

procedure make(k: int);
var
    i: int;
begin
    u[0] := 0;
    while g[k] <> nil do begin
        inc(u[0]);
        u[u[0]] := g[k]^.inf;
        o[u[0]] := g[k]^.num;
        g[k] := g[k]^.next;
    end;
    qsort(1, u[0]);
    for i := u[0] downto 1 do
        add(k, u[i], o[i]);
end;

var
    i, x, y: int;

begin
    assign(input, 'cross.in');
    reset(input);
    assign(output, 'cross.out');
    rewrite(output);

    read(n, m);
    for i := 1 to m do begin
        read(x, y);
        add(x, y, i);
    end;

    fillchar(used, sizeof(used), 0);
    l := n + 1;
    for i := 1 to n do
        tp(i);

    for i := 1 to n do
        make(i);

    fillchar(used_edge, sizeof(used_edge), 0);
    fillchar(used, sizeof(used), 0);
    dfs(c[1]);
    for i := 1 to n do
        if not used[i] then
            write_no;

    writeln(n - 1);
    for i := 1 to m do
        if used_edge[i] then
            write(i, ' ');
end.