{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

const
 StreamIn='model.in';
 StreamOut='model.out';
 NMAX=61;

type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 BoolVect=array [0..NMAX] of boolean;

var v1,v2,w,Val:IntVect;
    Mark:BoolVect;
    n,m,weight:integer;
    tree,sum:extended;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var t,i:integer;
begin
 read(n,m);
 t:=0;
 for i:=1 to m do begin
   inc(t);
   read(v1[i],v2[i],w[i]);
   if v2[i]=1 then dec(t)
  end;
 m:=t
end;

function Calc(a:integer):integer;
begin
 Result:=0;
 while a>0 do begin
   inc(Result,a and 1);
   a:=a div 2
  end
end;

procedure Gen(lev,num:integer);
var i,t:integer;
begin
 if num=0 then begin
   tree:=tree+1;
   sum:=sum+Calc(weight)
  end
 else begin
   t:=m-num+1;
   for i:=lev to m-num+1 do begin
     dec(Val[v2[i]]);
     if not Mark[v2[i]] then begin
       inc(weight,w[i]);
       Mark[v2[i]]:=True;
       Gen(i+1,num-1);
       dec(weight,w[i]);
       Mark[v2[i]]:=False;
       if Val[v2[i]]=0 then begin
         t:=i;
         Break
        end
      end
    end;
   for i:=lev to t do inc(Val[v2[i]])
  end
end;

procedure SolveAndSave;
var i:integer;
begin
 fillchar(Val,sizeof(Val),0);
 for i:=1 to m do inc(Val[v2[i]]);
 fillchar(Mark,sizeof(Mark),False);
 Mark[1]:=True;
 tree:=0;
 sum:=0;
 weight:=0;
 Gen(1,n-1);
 if tree=0 then writeln(0)
 else writeln(sum/tree:0:8)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
