{$MODE DELPHI}
{ $DEFINE DEBUG}const taskname = 'cross'; type integer = longint;

type
  pnode = ^tnode;
  tnode = record
    data1,data2,data3 :integer;
    next  :pnode;
  end;

  tlist = record
    r1,r2 :integer;
    tail :pnode;
    head :pnode;
  end;

  comparator = function (a,b :pnode) :boolean;

  list = class
    class procedure Init (var l :tlist);
    class procedure Add  (var l :tlist; n :pnode);
    class function Enum (var c :pnode) :boolean;
    class procedure Sort (var l :tlist; less :comparator);
    class function empty (var l :tlist) :boolean;
  end;

class procedure list.Init;
begin
  with l do
    begin
      head := nil;
      tail := pnode(@l); //tail.next = l.head
    end;
end;

class procedure list.Add;
begin
  with l do
    begin
      tail.next := n; //head := l if list is empty
      tail := n;
    end;
end;

class function list.Enum;
begin
  c := c.next;
  result := c<>nil;
end;

class function list.Empty;
begin result := l.head=nil; end;

class procedure list.Sort;
  function delf (var l :tlist) :pnode;
  begin
    result := l.head;
    l.head := result.next;
    result.next := nil;
  end;

  procedure merge (var l1,l2,l :tlist);
  var n :pnode;
  begin
    init(l);
    while (l1.head<>nil)and(l2.head<>nil) do
      begin
        if less(l1.head,l2.head)
          then n := delf(l1)
          else n := delf(l2);
        add(l,n);
      end;
    if l1.head<>nil then
      begin
        l.tail.next := l1.head;
        l.tail := l1.tail;
      end;
    if l2.head<>nil then
      begin
        l.tail.next := l2.head;
        l.tail := l2.tail;
      end;
  end;

  procedure ms (var l :tlist);
  var
    l1,l2 :tlist;
    f :boolean;
  begin
    if (l.head=nil) or (l.head=l.tail) then exit; //ok
    init(l1); init(l2);
    while l.head<>nil do
      begin
        if f
          then add(l1,delf(l))
          else add(l2,delf(l));
        f := not f;
      end;
    ms(l1);
    ms(l2);
    merge(l1,l2,l);
  end;
begin
  ms(l);
end;

////////////////////////////////////////////////////////////////

type
  pvertex = ^tvertex;
  pear = ^tear;

  tvertex = record
    rank :integer;
    flag :longbool;
    stime:integer;
    ears :tlist;
  end;

  tear = record
    n :integer;
    f :longbool;
    v :pvertex;
    next :pear;
  end;

procedure AddEar (var l :tlist; n :integer; f :longbool; v :pvertex);
var
  t :pear;
begin
  new(t);
  t.n := n;
  t.f := f;
  t.v := v;
  list.add(l,pnode(t));
end;

procedure dfs1 (v :pvertex);
var n :pear;
begin
  if v.flag then exit;
  v.flag := true;

  n := pear(@v.ears);
  while list.enum(pnode(n)) do
    begin
      dfs1(n.v);
      if n.v.rank>=v.rank then v.rank := n.v.rank+1;
    end;
end;

var
  ansn :integer;
  ansl :tlist;

function rankc (a,b :pear) :boolean;
begin
  result := a.v.rank>b.v.rank;
end;

var
  time :integer;

procedure dfs2 (lt :integer; v :pvertex);
var n :pear;
begin
  if v.stime<>0 then
    begin
      if v.stime<=lt then ansn := -maxlongint;
      exit;
    end;
  inc(time); v.stime := time;

  list.sort(v.ears,@rankc);
  n := pear(@v.ears);
  while list.enum(pnode(n)) do
    begin
      if n.v.stime=0 then
        begin
          inc(ansn);
          AddEar(ansl,n.n,n.f,n.v);
        end;
      dfs2(v.stime, n.v);
    end;
end;

var
  v :array [1..100{000{}] of tvertex;

function sorder (a,b :pear) :boolean;
begin
  result := a.n<b.n;
end;

procedure run;
var
  n,m,i,a,b :integer;
  p :pear;
begin
  fillchar(v,sizeof(v),0);
  read(n,m);
  for i := 1 to n do list.init(v[i].ears);
  for i := 1 to m do
    begin
      read(a,b);
      AddEar(v[a].ears,i,false,@v[b]);
    end;

  time := 0;
  ansn := 0;
  list.init(ansl);

  for i := 1 to n do
    dfs1(@v[i]);
  for i := 1 to n do
    dfs2(0,@v[i]);

  list.sort(ansl,@sorder);
  if ansn<0 then writeln(-1) else
    begin
      writeln(ansn);
      p := pear(@ansl);
      while list.enum(pnode(p)) do
        write(p.n,' ');
      writeln;
    end;
end;

begin
  {$IFNDEF DEBUG}
    assign(input,taskname+'.in'); reset(input);
    assign(output,taskname+'.out'); rewrite(output);
  {$ELSE}
    while not seekeof do
  {$ENDIF}
  run;
  close(input); close(output);
end.
