{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math;

const
 StreamIn='barns.in';
 StreamOut='barns.out';
 NMAX=55000;

type
 IntVect=array [0..NMAX] of integer;
 BoolVect=array [0..NMAX] of boolean;
 IntList=array of integer;
 Graph=array [0..NMAX] of IntList;

var G:Graph;
    Dat1,Dat2:IntVect;
    Ans:BoolVect;
    n,k,maxlen,count:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure AddEdge(v1,v2:integer);
begin
 inc(G[v1,0]);
 if G[v1,0]=length(G[v1]) then
  setlength(G[v1],2*length(G[v1]));
 G[v1,G[v1,0]]:=v2
end;

procedure LoadData;
var i,v1,v2:integer;
begin
 read(n,k);
 for i:=1 to n do begin
   setlength(G[i],1);
   G[i,0]:=0
  end;
 for i:=1 to n-1 do begin
   read(v1,v2);
   AddEdge(v1,v2);
   AddEdge(v2,v1)
  end
end;

procedure DFS(vrt,prev:integer);
var i,p1,p2:integer;
begin
 for i:=1 to G[vrt,0] do
  if G[vrt,i]<>prev then DFS(G[vrt,i],vrt);
 p1:=-1;
 p2:=maxint;
 for i:=1 to G[vrt,0] do
  if G[vrt,i]<>prev then begin
    p1:=Max(p1,Dat1[G[vrt,i]]);
    p2:=Min(p2,Dat2[G[vrt,i]])
   end;
 if vrt=1 then begin
   if (p2=maxint) or ((p1+2+p2)>maxlen) then begin
     Ans[vrt]:=True;
     inc(Count)
    end;
   Exit
  end;
 if (p1+1)=maxlen then begin
   Dat1[vrt]:=-1;
   Dat2[vrt]:=0;
   Ans[vrt]:=True;
   inc(count)
  end
 else
  if (p2<>maxint) and ((p1+2+p2)<=maxlen) then begin
    Dat1[vrt]:=-1;
    if p2=maxint then Dat2[vrt]:=maxint
    else Dat2[vrt]:=p2+1
   end
  else begin
    Dat1[vrt]:=p1+1;
    if p2=maxint then Dat2[vrt]:=maxint
    else Dat2[vrt]:=p2+1
   end
end;

procedure SolveAndSave;
var l,r,i:integer;
begin
 if k=n then begin
   writeln(0);
   for i:=1 to n do write(i,' ');
   Halt(0)
  end;
 l:=0;
 r:=n+1;
 while (l+1)<r do begin
   maxlen:=(l+r) div 2;
   fillchar(Ans,sizeof(Ans),False);
   count:=0;
   DFS(1,1);
   if count>k then l:=maxlen else r:=maxlen
  end;
 maxlen:=r;
 fillchar(Ans,sizeof(Ans),False);
 count:=0;
 DFS(1,1);
 writeln(r);
 k:=k-count;
 for i:=1 to n do
  if (not Ans[i]) and (k>0) then begin
    Ans[i]:=True;
    dec(k)
   end;
 for i:=1 to n do
  if Ans[i] then write(i,' ')
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
