#include <cstdio>
#define MAXN 100000
using namespace std;
#include <vector>
#include <queue>
#include <algorithm>

int n, m;                       
vector<pair<int, int> > v[MAXN];
vector<int> unv[MAXN];
vector<int> vv[MAXN];
int col[MAXN]; 
int last[MAXN];
vector<int> ans;
queue<int> q;
bool indfs[MAXN];

bool dfs(int i){
	indfs[i] = true;
	for (int j = 0; j < unv[i].size(); j++)
		if (!indfs[unv[i][j]]){
//			printf("BUG in %d(%d isn't parent)\n", i + 1, unv[i][j] + 1);
			return false;
		}
	for (int j = 0; j < vv[i].size(); j++)
		if (!dfs(vv[i][j]))
			return false;
	indfs[i] = false;
	return true;
}

int main(){                          
	freopen("cross.in", "rt", stdin);
	freopen("cross.out", "wt", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++){
		int a, b;
		scanf("%d%d", &a, &b);
		a--;
		b--;                                     
		v[a].push_back(pair<int, int>(b, i + 1));
		unv[b].push_back(a);
		col[b]++;
	}
	for (int i = 0; i < n; i++)
		if (col[i] == 0)
			q.push(i);
	for (int i = 0; i < n; i++)
		last[i] = -1;
	ans.resize(n);
	while (!q.empty()){
		int tmp = q.front();
		q.pop();                
		for (int i = 0; i < v[tmp].size(); i++){
			col[v[tmp][i].first]--;
			ans[v[tmp][i].first] = v[tmp][i].second;
			last[v[tmp][i].first] = tmp;
			if (col[v[tmp][i].first] == 0)
				q.push(v[tmp][i].first);
		}
	}
	int root = -1;
	for (int i = 0; i < n; i++)
		if (last[i] == -1){
			if (root == -1)
				root = i;
		    else{
		    	printf("-1");
		    	return 0;
		    }
		}
		else
			vv[last[i]].push_back(i);
	for (int i = 0; i < n; i++)
		indfs[i] = false;
	if (!dfs(root))
		printf("-1");
	else{
		sort(ans.begin(), ans.end());
	    printf("%d\n", ans.size() - 1);
	    for (int i = 1; i < ans.size(); i++)
	    	printf("%d ", ans[i]);
	}
}
