program taska;

{$MODE DELPHI}
{$M 16000000}

const
  MAXN = 100000;

var
  n, k, i, u, v, v0, l, r, x: Integer;
  h, a, next: array [0..MAXN] of Integer;
  b, ans, leaf: array [1..MAXN] of Boolean;

procedure dfs(v: Integer);
var
  u: Integer;
begin
  b[v] := true;
  u := h[v];
  while u > 0 do
    begin
      if b[a[u]] then
        a[u] := 0
      else
        dfs(a[u]);
      u := next[u];
    end;
end;

function mink(d: Integer): Integer;

var
  res: Integer;

function f(v: Integer): Integer;
var
  u, t, m1, m2: Integer;
begin
  if leaf[v] then
    begin
      ans[v] := false;
      Result := d;
      exit;
    end;

  m1 := -1;
  m2 := -1;
  u := h[v];
  while u > 0 do
    begin
      if a[u] > 0 then
        begin
          t := f(a[u]);
          if t > m1 then
            begin
              m2 := m1;
              m1 := t
            end
          else
            if t > m2 then
              m2 := t;
        end;
      u := next[u];
    end;

  if (m1 + m2 + 2 > 2*d) or (m1 + 1 + ord(v <> v0) > 2*d) then
    begin
      inc(res);
      ans[v] := true;
      Result := 0;
    end
  else
    begin
      ans[v] := false;
      Result := m1 + 1;
    end;
end;

begin // MinK
  res := 0;
  f(v0);
  Result := res;
end;

begin
  Assign(input, 'barns.in');
  Assign(output, 'barns.out');
  Reset(input); Rewrite(output);

  Read(n, k);
  if n = k then
    begin
      WriteLn(0);
      for i := 1 to n do
        Write(i, ' ');
    end
  else begin

    fillchar(h, sizeof(h), 0);
    for i := 1 to n-1 do
      begin
        Read(u, v);
        a[2*i-1] := v;
        next[2*i-1] := h[u];
        h[u] := 2*i-1;
        a[2*i] := u;
        next[2*i] := h[v];
        h[v] := 2*i;
      end;

    v0 := 1;
    for i := 1 to n do
      begin
        leaf[i] := next[h[i]] = 0;
        if not leaf[i] then
          v0 := i;
      end;

    fillchar(b, sizeof(b), 0);
    dfs(v0);

    l := 1; r := n-1;
    while l < r do
      begin
        x := (l + r) div 2;
        if mink(x) <= k then
          r := x
        else
          l := x+1;
      end;

    x := mink(l);
    for i := 1 to n do
      if (x < k) and not ans[i] then
        begin
          inc(x);
          ans[i] := true;
        end;

    WriteLn(l);
    for i := 1 to n do
      if ans[i] then
        Write(i, ' ');

  end;
  Close(input);
  Close(output);
end.
