#include <stdio.h>
#include <string.h>

#include <vector>
#include <algorithm>
using namespace std;

const int N = 65536;
vector<pair<int, int> > e[N];
vector<int> inc[N];
vector<pair<int, int> > e2[N];

bool acc_a[N];
bool acc_b[N];
int edg[N];
int nedg;

void dfs1 (int v, bool* t)
{
  if (t[v]) return;
  t[v] = true;
  for (int i = 0; i < inc[v].size (); i++)
    dfs1 (inc[v][i], t);
}
void dfs2 (int v)
{
  acc_a[v] = true;
  for (int i = 0; i < e2[v].size (); i++)
    if (!acc_a[e2[v][i].first])
    {
      edg[nedg++] = e2[v][i].second;
      dfs2 (e2[v][i].first);
    }
}

int main ()
{
  freopen ("cross.in", "rt", stdin);
  freopen ("cross.out", "wt", stdout);

  int n, m;
  scanf ("%d %d", &n, &m);
  for (int i = 0; i < m; i++)
  {
    int a, b;
    scanf ("%d %d", &a, &b), a--, b--;
    e[a].push_back (make_pair (b, i + 1));
    inc[b].push_back (a);
  }

  int super = -1;
  for (int i = 0; i < n; i++)
  {
    if (inc[i].size () == 0)
      super = i;
    memset (acc_a, 0, sizeof acc_a);
    dfs1 (i, acc_a);
    for (int j = 0; j < e[i].size (); j++)
    {
      int v = e[i][j].first;
      memset (acc_b, 0, sizeof acc_b);
      dfs1 (v, acc_b);
      bool valid = true;
      for (int k = 0; k < n && valid; k++)
        if (k != v && acc_b[k] && !acc_a[k])
          valid = false;
      if (valid)
        e2[i].push_back (e[i][j]);
    }
  }
  if (super < 0)
  {
    printf ("-1");
    return 0;
  }
  memset (acc_a, 0, sizeof acc_a);
  dfs2 (super);
  if (nedg != n - 1)
  {
    printf ("-1");
    return 0;
  }
  printf ("%d\n", nedg);
  for (int i = 0; i < nedg; i++)
    printf ("%d ", edg[i]);

  return 0;
}
