{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

const
 StreamIn='cross.in';
 StreamOut='cross.out';
 NMAX=310000;
 SMAX=21;
 VMAX=110000;


type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 BoolVect=array [0..NMAX] of boolean;
 IntList=array of integer;
 Graph=array [0..VMAX] of IntList;
 LiftTable=array [0..VMAX,0..SMAX] of integer;

var G:Graph;
    v1,v2,List,time1,time2,prev,Count:IntVect;
    Lift:LiftTable;
    Mark,Used:BoolVect;
    n,m,gtime:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure AddEdge(v,e:integer);
begin
 inc(G[v,0]);
 if G[v,0]=length(G[v]) then
  setlength(G[v],2*G[v,0]);
 G[v,G[v,0]]:=e
end;

procedure LoadData;
var i:integer;
begin
 read(n,m);
 for i:=1 to n do begin
   setlength(G[i],1);
   G[i,0]:=0
  end;
 for i:=1 to m do begin
   read(v1[i],v2[i]);
   AddEdge(v1[i],i)
  end
end;

procedure DFS1(v:integer);
var i:integer;
begin
 Mark[v]:=True;
 for i:=1 to G[v,0] do
  if not Mark[v1[G[v,i]]+v2[G[v,i]]-v] then DFS1(v1[G[v,i]]+v2[G[v,i]]-v);
 inc(List[0]);
 List[List[0]]:=v
end;

procedure DFS2(v:integer);
var i:integer;
begin
 inc(gtime);
 time1[v]:=gtime;
 Mark[v]:=True;
 for i:=1 to G[v,0] do
  if not Mark[v1[G[v,i]]+v2[G[v,i]]-v] then begin
    prev[v1[G[v,i]]+v2[G[v,i]]-v]:=G[v,i];
    Lift[v1[G[v,i]]+v2[G[v,i]]-v,0]:=v;
    DFS2(v1[G[v,i]]+v2[G[v,i]]-v);
    Used[G[v,i]]:=True
   end;
 inc(gtime);
 time2[v]:=gtime
end;

function IsPrev(a,b:integer):boolean;
begin
 Result:=(time1[a]<=time1[b]) and (time2[a]>=time2[b])
end;

function Lca(a,b:integer):integer;
var k:integer;
begin
 if IsPrev(a,b) then Result:=a
 else begin
   for k:=SMAX downto 0 do
    if not IsPrev(Lift[a,k],b) then a:=Lift[a,k];
   Result:=Lift[a,0]
  end
end;

procedure SolveAndSave;
var i,j,temp,Root:integer;
begin
 List[0]:=0;
 fillchar(Mark,sizeof(Mark),False);
 for i:=1 to n do
  if not Mark[i] then DFS1(i);
 fillchar(Mark,sizeof(Mark),False);
 DFS1(List[n]);
 for i:=1 to n do
  if not Mark[i] then begin
    writeln(-1);
    Exit
   end;
 Root:=List[n];
 Lift[Root,0]:=Root;
 gtime:=0;
 fillchar(Mark,sizeof(Mark),False);
 fillchar(Used,sizeof(Used),False);
 DFS2(Root);
 for j:=1 to SMAX do
  for i:=1 to n do
   Lift[i,j]:=Lift[Lift[i,j-1],j-1];
 for i:=1 to m do
  if not (IsPrev(v1[i],v2[i]) or IsPrev(v2[i],v1[i])) then inc(Count[v2[i]]);
 for i:=1 to n do
  if Count[i]>1 then begin
    writeln(-1);
    Exit
   end;
 for i:=1 to m do
  if not (IsPrev(v1[i],v2[i]) or IsPrev(v2[i],v1[i])) then begin
    temp:=Lca(v1[i],v2[i]);
    if Lift[v2[i],0]=temp then begin
      Used[i]:=True;
      Used[prev[v2[i]]]:=False
     end
    else begin
      writeln(-1);
      Exit
     end
   end;
 writeln(n-1);
 for i:=1 to m do
  if Used[i] then write(i,' ')
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
