#include <stdio.h>
#include <memory.h>

#define MAXN 50
#define MAXM 100
#define INF 100000000

int ma[MAXN][MAXN];
char vert[MAXM];
char vert2[MAXN];
int x[MAXM];
int y[MAXM];
int z[MAXM];
int n, m, res, sum;

void init()
{
     freopen("model.in", "r", stdin);
     freopen("model.out", "w", stdout);
     memset(ma, 0, sizeof(ma));
     res = 0;
     sum = 0;
}

void readdata()
{
     int i;
     scanf("%d%d", &n,&m);
     for(i=0;i<m;i++)
       scanf("%d%d%d", &x[i], &y[i], &z[i]);
}

int get_n(int k)
{
    int res = 0;
    while(k > 0)
    {
      res += k & 1;
      k = k / 2;
    }
    return res;
}

void dfs(int v)
{
     int i;
     vert2[v] = 0;
     for(i=1;i<=n;i++)
       if(ma[v][i] && vert2[i])
         dfs(i);
}

int check()
{
    int i;
    memset(vert2, 1, sizeof(vert2));
    dfs(1);
    for(i=1;i<=n;i++)
      if(vert2[i])
        return 0;
    return 1;    
}

void gen(int i0, int k, int s)
{
     int i;
     if(k == 0)
     {
          if(check())
          {
            sum += get_n(s);
            res++;
          }
          return;
     }
     for(i=i0;i<m-k+1;i++)
     {
       vert[i] = 0;
       ma[x[i]][y[i]] = 1;
       gen(i+1, k-1, s+z[i]);
       ma[x[i]][y[i]] = 0;       
       vert[i] = 1;
     }
}

void solve()
{
     memset(vert, 1, sizeof(vert));
     gen(0, n-1, 0);
}

void writedata()
{
     printf("%0.7Lf", ((double)(sum))/res);
}

int main()
{
  init();
  readdata();
  solve();
  writedata();
  return 0;
}
