{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
type
    int = longint;
    list = ^node;
    node = record
        inf: int;
        next: list;
    end;
const
    NMAX = 50001;
var
    g: array [1..NMAX] of list;
    used: array [1..NMAX] of boolean;
    way, temp, h, tree: array [0..NMAX] of int;
    n, k, best: int;

procedure remove(x, y: int);
var
    z, t: list;
begin
    if g[x]^.inf = y then begin
        g[x] := g[x]^.next;
        exit;
    end;
    t := g[x];
    while t^.inf <> y do begin
        z := t;
        t := t^.next;
    end;
    z^.next := t^.next;
end;

procedure add(x, y: int);
var
    t: list;
begin
    new(t);
    t^.inf := y;
    t^.next := g[x];
    g[x] := t;
end;

procedure search(v: int; var u: int);
var
    max, i: int;

procedure dfs(k, pr, d: int);
var
    t: list;
begin
    used[k] := true;
    h[k] := d;
    tree[k] := pr;
    t := g[k];
    while t <> nil do begin
        if not used[t^.inf] then
            dfs(t^.inf, k, d + 1);
        t := t^.next;
    end;
end;

procedure make_way(k: int);
begin
    if k = v then begin
        way[0] := 1;
        way[1] := v;
        exit;
    end;
    make_way(tree[k]);
    inc(way[0]);
    way[way[0]] := k;
end;

begin
    fillchar(used, sizeof(used), 0);
    dfs(v, v, 0);
    max := 0;
    u := v;
    for i := 1 to n do
        if used[i] and (max < h[i]) then begin
            max := h[i];
            u := i;
        end;
    make_way(u);
end;

procedure make(v: int; var dist, u: int);
begin
    search(v, v);
    search(v, v);
    search(v, u);
    u := (way[0] + 1) div 2;
    dist := max(u - 1, way[0] - u);
    u := way[u];
end;

var
    x1, y1, x2, y2, ans1, ans2: int;
    i, x, y, l, r, m: int;

begin
    assign(input, 'barns.in');
    reset(input);
    assign(output, 'barns.out');
    rewrite(output);

    read(n, k);
    if n = k then begin
        writeln(0);
        for i := 1 to n do
            write(i, ' ');
            exit;
    end;

    for i := 1 to n - 1 do begin
        read(x, y);
        add(x, y);
        add(y, x);
    end;

    if k = 1 then begin
        make(1, x, y);
        writeln(x);
        writeln(y);
        exit;
    end;
    if k = 2 then begin
        search(1, x);
        search(x, x);
        search(x, y);
        best := n + 1;
        ans1 := 0;
        ans2 := 0;
        temp := way;
        for i := max((temp[0] - 5) div 2, 1) to min((temp[0] + 5) div 2, temp[0] - 1) do begin
            remove(temp[i], temp[i + 1]);
            remove(temp[i + 1], temp[i]);
            make(temp[i], x1, y1);
            make(temp[i + 1], x2, y2);
            add(temp[i], temp[i + 1]);
            add(temp[i + 1], temp[i]);
            if best > max(x1, x2) then begin
                best := max(x1, x2);
                ans1 := y1;
                ans2 := y2;
            end;
        end;
        writeln(best);
        if ans1 > ans2 then begin
            x := ans1;
            ans1 := ans2;
            ans2 := x;
        end;
        writeln(ans1, ' ', ans2);
        exit;
    end;

end.