#include <stdio.h>
#include <string.h>

#include <vector>
#include <algorithm>
using namespace std;

const int N = 65536;
vector<pair<int, int> > e[N];
vector<bool> valid[N];
int inc[N];

bool vis[N];
int edg[N];
int nedg;

void dfs1 (int v)
{
  if (vis[v]) return;
  vis[v] = true;
  for (int i = 0; i < e[v].size (); i++)
    dfs1 (e[v][i].first);
}
void dfs2 (int v)
{
  vis[v] = true;
  for (int i = 0; i < e[v].size (); i++)
    if (valid[v][i] && !vis[e[v][i].first])
    {
      edg[nedg++] = e[v][i].second;
      dfs2 (e[v][i].first);
    }
}

int main ()
{
  freopen ("cross.in", "rt", stdin);
  freopen ("cross.out", "wt", stdout);

  int n, m;
  scanf ("%d %d", &n, &m);
  memset (inc, 0, sizeof inc);
  for (int i = 0; i < m; i++)
  {
    int a, b;
    scanf ("%d %d", &a, &b), a--, b--;
    e[a].push_back (make_pair (b, i + 1));
    valid[a].push_back (true);
    inc[b]++;
  }

  int super = -1;

  for (int i = 0; i < n; i++)
  {
    if (inc[i] == 0)
      super = i;
    memset (vis, 0, sizeof vis);
    dfs1 (i);
    for (int j = 0; j < n; j++)
    {
      if (vis[j]) continue;
      for (int k = 0; k < e[j].size (); k++)
        if (e[j][k].first != i && vis[e[j][k].first])
          valid[j][k] = false;
    }
  }
  if (super < 0)
  {
    printf ("-1");
    return 0;
  }
  memset (vis, 0, sizeof vis);
  dfs2 (super);
  if (nedg != n - 1)
  {
    printf ("-1");
    return 0;
  }
  printf ("%d\n", nedg);
  sort (edg, edg + nedg);
  for (int i = 0; i < nedg; i++)
    printf ("%d ", edg[i]);

  return 0;
}
