#include <stdio.h>
#include <string.h>

#include <vector>
using namespace std;

const int N = 65536;

int n, k, l;

vector<int> e[N];

int count;
int barns[N];

int dfs (int v, int p = -1)
{
  int min = 0;
  int max = 0;
  for (int i = 0; i < e[v].size (); i++)
  {
    if (e[v][i] == p) continue;
    int r = dfs (e[v][i], v);
    if (r < min)
      min = r;
    if (r > max)
      max = r;
  }
  if (min + max < 0)
    return min + 1;
  if (max == l)
  {
    barns[count++] = v;
    return -l;
  }
  return max + 1;
}

int q[N];
int d[N];

bool bfs ()
{
  int head = 0, tail = 0;
  for (int i = 0; i < n; i++)
    d[i] = 1000000;
  for (int i = 0; i < count; i++)
    q[head++] = barns[i], d[barns[i]] = 0;
  while (tail < head)
  {
    int v = q[tail++];
    for (int i = 0; i < e[v].size (); i++)
    {
      if (d[v] < d[e[v][i]] - 1)
        d[e[v][i]] = d[v] + 1, q[head++] = e[v][i];
    }
  }
  for (int i = 0; i < n; i++)
    if (d[i] > l)
      return false;
  return true;
}

bool used[N];

int main ()
{
  freopen ("barns.in", "rt", stdin);
  freopen ("barns.out", "wt", stdout);

  scanf ("%d %d", &n, &k);
  for (int i = 1; i < n; i++)
  {
    int a, b;
    scanf ("%d %d", &a, &b), a--, b--;
    e[a].push_back (b);
    e[b].push_back (a);
  }

  int _l = 0;
  int _r = n;
  while (_l < _r)
  {
    l = (_l + _r) / 2;
    count = 0;
    dfs (0);
    if (!bfs ())
      barns[count++] = 0;
    if (count > k)
      _l = l + 1;
    else
      _r = l;
  }
  l = _l;
  printf ("%d\n", _l);
  count = 0;
  dfs (0);
  if (!bfs ())
    barns[count++] = 0;
  memset (used, 0, sizeof used);
  for (int i = 0; i < count; i++)
    used[barns[i]] = true;
  for (int i = 0; i < n; i++)
  {
    if (!used[i] && count < k)
      barns[count++] = i, used[i] = true;
    if (used[i])
      printf ("%d ", i + 1);
  }

  return 0;
}
