#include <cstdio>
#include <cstring>

int _stklen = 50 << 20;

#define MAXD 500
#define BASE 10000
#define LGBASE 4

typedef int Long[MAXD];

int n;
Long I, M, Cur;

void lput(Long a, int b)
{
	memset(a, 0, sizeof(a));
	while (b)
	{
		a[++a[0]] = b % BASE;
		b /= BASE;
	}
}

void lmul(Long a, int b)
{
	int os = 0;
	for (int i = 1; i <= a[0]; i++)
	{
		int temp = a[i] * b + os;
		a[i] = temp % BASE;
		os = temp / BASE;
	}
	while (os)
	{
		a[++a[0]] = os % BASE;
		os /= BASE;
	}
}

void ladd(Long a, Long b)
{
	a[0] >?= b[0];
	int os = 0;
	for (int i = 1; i <= a[0]; i++)
	{
		int temp = a[i] + b[i] + os;
		a[i] = temp % BASE;
		os = temp / BASE;
	}
	while (os)
	{
		a[++a[0]] = os % BASE;
		os /= BASE;
	}
}

void lprint(Long a)
{
	printf("%d", a[a[0]]);
	for (int i = a[0] - 1; i >= 1; i--)
		printf("%0*d", LGBASE, a[i]);
}

int main()
{
	scanf("%d", &n);
	if (n == 1)
	{
		printf("1 1 1\n");
		return 0;
	}
	lput(I, 0);
	lput(M, 0);
	for (int i = 2; i <= n; i++)
	{
		lput(Cur, 1);
		for (int j = 2; j < i; j++)
			lmul(Cur, n - j + 1);
		ladd(M, Cur);
		if (i != n) ladd(M, Cur);
		int comb = (n - i + 1) * (n - i) / 2;
		for (int j = 0; j < comb; j++)
			lmul(Cur, 2);
		ladd(I, Cur);
	}
	printf("0 ");
	lprint(I);
	printf(" ");
	lprint(M);
	printf("\n");
	return 0;
}
