{$UNDEF DEBUG}
{ $DEFINE DEBUG} type integer = longint;

const
  base = 1000000000;
type
  long = array [0..170] of longint;

procedure OVERFLOW;
begin writeln ('OVERFLOW'); halt; end;

procedure lnull (var a :long); //a := 0
begin fillchar(a,sizeof(a),0); end;

procedure ladd (var a,b :long); // a := a+b
var t,i :integer;
begin
  t := 0;
  for i := 0 to high(long) do
    begin
      t := t+a[i]+b[i];
      a[i] := t mod base;
      t := t div base;
    end;
  {$IFDEF DEBUG}if t>0 then OVERFLOW;{$ENDIF}
end;

procedure lsub (var a,b :long); // a := a-b
var t,i :integer;
begin
  t := 0;
  for i := 0 to high(long) do
    begin
      t := t + a[i]-b[i] + base;
      a[i] := t mod base;
      t := t div base - 1;
    end;
  {$IFDEF DEBUG}if t>0 then OVERFLOW;{$ENDIF}
end;

procedure lsmul (var a :long; k :integer); //a := a*k
var i :integer; t :int64;
begin
  t := 0;
  for i := 0 to high(long) do
    begin
      t := t + int64(a[i])*k;
      a[i] := t mod base;
      t := t div base;
    end;
  {$IFDEF DEBUG}if t>0 then OVERFLOW;{$ENDIF}
end;

procedure lmul (var a,b,c :long); // c := c+a*b
var
  i,j :integer;
  t :int64;
begin
  for i := 0 to high(long) do
    begin
      t := 0;
      for j := 0 to high(long)-i do
        begin
          t := t + c[i+j] + int64(a[i])*b[j];
          c[i+j] := t mod base;
          t := t div base;
        end;
      {$IFDEF DEBUG}
        if t>0 then OVERFLOW;
        for j := high(long)-i+1 to high(long) do
          if int64(a[i])*b[j]>0 then OVERFLOW;
      {$ENDIF}
    end;
end;

procedure lmul2p (var a :long; x :integer); //a := a * 2^x
var i :integer;
begin
  for i := 1 to x div 30 do
    lsmul(a, 1 shl 30);
  lsmul(a, 1 shl (x mod 30));
end;

procedure lwrite (var a :long);
  procedure swrite (a,base :integer);
  begin
    while base>1 do
      begin
        base := base div 10;
        write(a div base mod 10);
      end;
  end;
var i,j :integer;
begin
  j := 0;
  for i := high(long) downto 0 do
    if a[i]<>0 then begin j := i; break; end;
  write(a[j]);
  for i := j-1 downto 0 do
    swrite(a[i],base);
end;

////////////////////////////////////////////////////////////////////////

var
  cc :array [0..100, 0..100] of long;
  d :array [0..100] of long;
  a,b,c,nk,cur :long;

procedure runa (n :integer);
var k,i,j :integer;
begin
  fillchar(d, sizeof(d), 0);
  d[0][0] := 1;
  for k := 1 to n do //⥪騩 ஢
    begin
      j := n;
      //᫨ ஢ - ᫥...
      for i := j-1 downto 0 do //⢮ 設   ஢
        begin
          cur := d[i];
          if j-i>1 then lsmul (cur,2);

          lnull(nk);
          lmul(cur, cc[j,i], nk);
          ladd(a,nk);
        end;

      for j := n downto 0 do //饥 ⢮ 設
        begin
          //᫨ ஢ -  ᫥...
          lnull(d[j]);
          for i := j-1 downto 0 do //⢮ 設   ஢
            begin
              cur := d[i];
              lmul2p (cur, j-i);
              lsub(cur,d[i]);

              lmul(cur, cc[j,i], d[j]);
            end;
        end;
    end;
end;

procedure run;
var
  n,k :integer;
begin
  read(n); dec(n);

  //a
  lnull(a); a[0]:=ord(n=0);
  if n<10 then runa(n);
  //b
  lnull(b); b[0] := ord(n=0);
  lnull(nk); nk[0] := 1;
  for k := n downto 1 do
    begin
      cur := nk;
      lmul2p(cur,(k*k-k) div 2);
      ladd(b,cur);
      lsmul(nk,k);
    end;
  //c
  lnull(c); c[0] := ord(n=0);
  lnull(nk); nk[0] := 1;
  for k := n downto 1 do
    begin
      cur := nk;
      if k<>1 then lsmul(cur,2);
      ladd(c,cur);
      lsmul(nk,k);
    end;

  lwrite(a); write(' ');
  lwrite(b); write(' ');
  lwrite(c); writeln;
end;

var
  i,j :integer;

begin
  fillchar(cc, sizeof(cc), 0);
  for i := 0 to high(cc) do
    cc[i,0][0] := 1;
  for i := 1 to high(cc) do
    for j := 1 to i do
      begin
        cc[i,j] := cc[i-1,j];
        ladd(cc[i,j], cc[i-1,j-1]);
      end;

  {$IFNDEF DEBUG}
  {$ELSE}
    while not seekeof do
  {$ENDIF}
  run;
  close(input); close(output);
end.
