#include <stdio.h>
#include <string.h>

struct huge
{
  int d[4096];
  int l;
};
huge& h_init (huge& x, int a = 0)
{
  memset (&x, 0, sizeof x);
  if (a)
    x.l = 1, x.d[0] = a;
  return x;
}
huge& h_copy (huge& r, huge const& a)
{
  memcpy (&r, &a, sizeof r);
  return r;
}
huge& h_add (huge& r, huge const& a, huge const& b)
{
  int c = 0;
  int i;
  for (i = 0; i < a.l || i < b.l || c; i++)
  {
    int d = a.d[i] + b.d[i] + c;
    if (d >= 10000)
      d -= 10000, c = 1;
    else
      c = 0;
    r.d[i] = d;
  }
  r.l = i;
  memset (r.d + i, 0, sizeof r.d - sizeof r.d[0] * i);
  return r;
}
huge& h_mul (huge& r, huge const& a, int b)
{
  if (b == 0)
  {
    h_init (r);
    return r;
  }
  int c = 0;
  int i;
  for (i = 0; i < a.l || c; i++)
  {
    int d = a.d[i] * b + c;
    if (d >= 10000)
      c = d / 10000, d -= c * 10000;
    else
      c = 0;
    r.d[i] = d;
  }
  r.l = i;
  memset (r.d + i, 0, sizeof r.d - sizeof r.d[0] * i);
  return r;
}
huge& h_mul (huge& r, huge const& a, huge const& b)
{
  huge t;
  h_init (t);
  for (int i = 0; i < a.l; i++)
  {
    if (a.d[i] == 0)
      continue;
    int c = 0;
    int j;
    for (j = 0; j < b.l || c; j++)
    {                      
      int d = a.d[i] * b.d[j] + t.d[i + j] + c;
      if (d >= 10000)
        c = d / 10000, d -= c * 10000;
      else
        c = 0;
      t.d[i + j] = d;
    }
    if (j + i > t.l) t.l = j + i;
  }
  return h_copy (r, t);
}       
huge& h_pow (huge& r, huge const& a, int p)
{
  huge t;
  h_init (t, 1);
  huge m;
  h_copy (m, a);
  while (p)
  {
    if (p & 1)
      h_mul (t, t, m);
    h_mul (m, m, m);
    p >>= 1;
  }
  return h_copy (r, t);
}
huge const& h_print (huge const& a)
{
  if (a.l == 0)
  {
    printf ("0");
    return a;
  }
  printf ("%d", a.d[a.l - 1]);
  for (int i = a.l - 2; i >= 0; i--)
    printf ("%04d", a.d[i]);
  return a;
}

huge th[4];

int main ()
{
  freopen ("pim.in", "rt", stdin);
  freopen ("pim.out", "wt", stdout);

  int n;
  scanf ("%d", &n);
  if (n == 1)
  {
    printf ("1 1 1");
    return 0;
  }
  huge sumb, sumc;
  h_init (sumb);
  h_init (sumc);
  huge prod;
  h_init (prod, 1);
  for (int k = n - 1; k > 0; k--)
  {
    h_add (sumb, sumb, h_mul (th[1], h_pow (th[0], h_init (th[0], 2), k * (k - 1) / 2), prod));
    if (k > 1)
      h_add (sumc, sumc, h_mul (th[0], prod, 2));
    else
      h_add (sumc, sumc, prod);
    h_mul (prod, prod, k);
  }
  printf ("23 ");
  h_print (sumb);
  printf (" ");
  h_print (sumc);

  return 0;
}
