#include <cstdio>
#include <cstring>

int _stklen = 50 << 20;

#define MAXD 500
#define BASE 10000
#define LGBASE 4

typedef int Long[MAXD];

int n;
Long I, M, Cur, temp, P;
Long C[101][101];
Long Two[101];
Long DP[101][101];

void lput(Long a, int b)
{
	memset(a, 0, MAXD * sizeof(int));
	while (b)
	{
		a[++a[0]] = b % BASE;
		b /= BASE;
	}
}

void lmul(Long a, int b)
{
	int os = 0;
	for (int i = 1; i <= a[0]; i++)
	{
		int temp = a[i] * b + os;
		a[i] = temp % BASE;
		os = temp / BASE;
	}
	while (os)
	{
		a[++a[0]] = os % BASE;
		os /= BASE;
	}
}

void ladd(Long a, Long b)
{
	a[0] >?= b[0];
	int os = 0;
	for (int i = 1; i <= a[0]; i++)
	{
		int temp = a[i] + b[i] + os;
		a[i] = temp % BASE;
		os = temp / BASE;
	}
	while (os)
	{
		a[++a[0]] = os % BASE;
		os /= BASE;
	}
}

void lprint(Long a)
{
	printf("%d", a[a[0]]);
	for (int i = a[0] - 1; i >= 1; i--)
		printf("%0*d", LGBASE, a[i]);
}

void ldec(Long a)
{
	int cur = 1;
	while (!a[cur]) a[cur++] = BASE - 1;
	a[cur]--;
	while (a[0] && !a[a[0]]) a[0]--;
}

void lmul(Long a, Long b)
{
	Long c;
	lput(c, 0);
	c[0] = a[0] + b[0];
	for (int i = 1; i <= a[0]; i++)
		for (int j = 1; j <= b[0]; j++)
		{
			c[i + j - 1] += a[i] * b[j];
			c[i + j] += c[i + j - 1] / BASE;
			c[i + j - 1] %= BASE;
		}
	int os = 0;
	for (int i = 1; i <= c[0]; i++)
	{
		int temp = c[i] + os;
		c[i] = temp % BASE;
		os = temp / BASE;
	}
	while (os)
	{
		c[++c[0]] = os % BASE;
		os /= BASE;
	}
	while (c[0] && !c[c[0]]) c[0]--;
	for (int i = 0; i <= c[0]; i++)
		a[i] = c[i];
}

int main()
{
	scanf("%d", &n);
	if (n == 1)
	{
		printf("1 1 1\n");
		return 0;
	}
	memset(C, 0, sizeof(C));
	for (int i = 0; i <= 100; i++)
	{
		lput(C[i][0], 1);
		lput(C[i][i], 1);
		for (int j = 1; j < i; j++)
		{
			ladd(C[i][j], C[i - 1][j - 1]);
			ladd(C[i][j], C[i - 1][j]);
		}
	}
	lput(Two[0], 1);
	for (int i = 1; i <= 100; i++)
	{
		lput(Two[i], 0);
		ladd(Two[i], Two[i - 1]);
		ladd(Two[i], Two[i - 1]);
	}
	for (int i = 1; i <= 100; i++)
		ldec(Two[i]);
	memset(DP, 0, sizeof(DP));
	lput(DP[1][1], 1);
	for (int i = 2; i <= n; i++)
		for (int j = 1; j < i; j++)
			for (int k = 1; k <= i - j; k++)
			{
				lput(temp, 0);
				ladd(temp, DP[i - j][k]);
				lmul(temp, Two[k]);
				lmul(temp, C[i - 1][j]);
				ladd(DP[i][j], temp);
			}
	lput(P, 0);
	for (int i = 1; i < n; i++)
	{
		ladd(P, DP[n][i]);
		if (i != 1) ladd(P, DP[n][i]);
	}
	lput(I, 0);
	lput(M, 0);
	for (int i = 2; i <= n; i++)
	{
		lput(Cur, 1);
		for (int j = 2; j < i; j++)
			lmul(Cur, n - j + 1);
		ladd(M, Cur);
		if (i != n) ladd(M, Cur);
		int comb = (n - i + 1) * (n - i) / 2;
		for (int j = 0; j < comb; j++)
			lmul(Cur, 2);
		ladd(I, Cur);
	}
	lprint(P);
	printf(" ");
	lprint(I);
	printf(" ");
	lprint(M);
	printf("\n");
	return 0;
}
