#include <cstdio>
#define MAXN 5
using namespace std;
#include <vector>
#include <set>
#include <queue>
#include <algorithm>

int n;
struct mytype{
	int a[MAXN];
	bool friend operator <(mytype a, mytype b){
		for (int i = 0; i < n; i++)
			if (a.a[i] != b.a[i])
				return a.a[i] < b.a[i];
		return false;
	}
};              
set<mytype> sh;
set<mytype> g;
bool sm[MAXN][MAXN];
bool q[MAXN][MAXN];
vector<int> order[MAXN];
queue<int> qu;
bool used[MAXN];

bool good(){                       
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			q[i][j] = sm[i][j];
    for (int k = 0; k < n; k++)
    	for (int i = 0; i < n; i++)
    		for (int j = 0; j < n; j++)
    			if ((q[i][k]) && (q[k][j]))
    				q[i][j] = true;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (!q[i][j])
				return false;
	return true;
}

bool gen_next(){
	for (int i = 0; i < n; i++)
		if (next_permutation(order[i].begin(), order[i].end()))
			return true;
	return false;
}   

void gen_first(){
	for (int i = 0; i < n; i++){
		order[i].clear();
		for (int j = 0; j < n; j++)
			order[i].push_back(j);
	}
}

void print_perm(){
	for (int i = 0; i < n; i++){
		for (int j = 0; j < n; j++)
			printf("%d ", order[i][j]);
		printf("\n");
	}
	printf("\n");
}

void printvec(mytype a){
	for (int i = 0; i < n; i++)
		printf("%d ", a.a[i]);
    printf("\n");
}
         
int sz;
mytype o;

void getsh(){
	sh.clear();    
	gen_first();
	while (gen_next()){
		for (int i = 0; i < n; i++)
			used[i] = false;
		used[0] = true;
		sz = 0;
		qu.push(0);
		while (!qu.empty()){
			int tmp = qu.front();
			o.a[sz] = tmp;
			sz++;
			qu.pop();
			for (int i = 0; i < n; i++)
				if ((sm[tmp][order[tmp][i]]) && (!used[order[tmp][i]])){
					used[order[tmp][i]] = true;
					qu.push(order[tmp][i]);
				}
		}
		sh.insert(o);
	}              
}

void DFS(int v){
	if (!used[v]){
		used[v] = true;
		o.a[sz] = v;
		sz++;
		for (int i = 0; i < n; i++)
			if ((sm[v][order[v][i]]) && (!used[order[v][i]]))
				DFS(order[v][i]);
	}
}

void getg(){       
	g.clear();    
	gen_first();
	while (gen_next()){
		sz = 0;
		for (int i = 0; i < n; i++)
			used[i] = false;
		DFS(0);
		g.insert(o);
	}
}

bool isP(){
	for (set<mytype>::iterator tmp = sh.begin(); tmp != sh.end(); tmp++){
		if (g.find(*tmp) == g.end())
			return false;
	}
	return true;
}

bool isI(){
	for (set<mytype>::iterator tmp = g.begin(); tmp != g.end(); tmp++){
		if (sh.find(*tmp) == sh.end())
			return false;
	}
	return true;
}

bool isM(){
	return (isI()) && (isP());
}

int colp, coli, colm;

void dfs(int i, int j){
	if ((i == n)){
		if (good()){
			getsh();
			getg();                
			if (isP()){
				printf("P-GRAF\n");
				colp++;
			}
			if (isI()){
				printf("I-GRAF\n");
				coli++;      
			}
			if (isM()){
				printf("M-GRAF\n");
				colm++;
			}
			for (int a = 0; a < n; a++){
				for (int b = 0; b < n; b++)
					if ((a < b) && (sm[a][b]))
						printf("(%d,%d)\n", a + 1, b + 1);
//				printf("\n");
			}
			printf("\n");

		}
	}
	else{
		if (i < j){
			sm[i][j] = true;
			sm[j][i] = true;
			if (j + 1 == n)
				dfs(i + 1, 0);
			else
				dfs(i, j + 1);
			sm[i][j] = false;
			sm[j][i] = false;
			if (j + 1 == n)
				dfs(i + 1, 0);
			else
				dfs(i, j + 1);
		}
		else{                 
			if (j + 1 == n)
				dfs(i + 1, 0);
			else
				dfs(i, j + 1);
		}
	}
}

int main(){
	n = 4;
	freopen("output.txt", "wt", stdout);
	dfs(0, 0);              
	printf("\n\n%d %d %d", colp, coli, colm);
}
