program taskb; 

{$MODE DELPHI}

const
  MAXN   = 100;
  BASE   = 10000;
  MAXLEN = 1000;

type TLong = array [0..MAXLEN] of Integer;

procedure lMul(var a: TLong; k: Integer);
var
  i: Integer;
begin
  for i := 1 to a[0] do
    a[i] := a[i] * k;

  for i := 1 to a[0] do
    begin
      inc(a[i+1], a[i] div BASE);
      a[i] := a[i] mod BASE;
    end;

  if a[a[0]+1] > 0 then
    inc(a[0]);
end;

procedure lAdd(var a: TLong; const b: TLong); overload;
var
  i: Integer;
begin
  if a[0] < b[0] then
    a[0] := b[0];

  for i := 1 to a[0] do
    inc(a[i], b[i]);

  for i := 1 to a[0] do
    begin
      inc(a[i+1], a[i] div BASE);
      a[i] := a[i] mod BASE;
    end;

  if a[a[0]+1] > 0 then
    inc(a[0]);
end;

procedure lAdd(var a: TLong; k: Integer); overload;
var
  i: Integer;
begin
  inc(a[1], k);

  for i := 1 to a[0] do
    begin
      inc(a[i+1], a[i] div BASE);
      a[i] := a[i] mod BASE;
    end;

  if a[a[0]+1] > 0 then
    inc(a[0]);
end;

procedure lWrite(const a: TLong);
var
  i: Integer;
begin
  Write(a[a[0]]);
  for i := a[0]-1 downto 1 do
    begin
      if a[i] < 1000 then Write(0);
      if a[i] < 100 then Write(0);
      if a[i] < 10 then Write(0);
      Write(a[i]);
    end;
end;

var
  n, i: Integer;
  ans: TLong;
  pow2: array [0..MAXN*MAXN div 2] of TLong;

begin
  Read(n);

  fillchar(pow2, sizeof(pow2), 0);
  pow2[0][0] := 1;
  pow2[0][1] := 1;
  for i := 1 to MAXN*MAXN div 2 do
    begin
      pow2[i] := pow2[i-1];
      lMul(pow2[i], 2);
    end;

  // P-graphs
  Write('0 ');

  // I-graphs
  fillchar(ans, sizeof(ans), 0);
  ans[0] := 1;
  ans[1] := 1;
  for i := 3 to n do
    begin
      lMul(ans, i-1);
      lAdd(ans, pow2[(i-1)*(i-2) div 2]);
    end;
  lWrite(ans);
  Write(' ');

  // M-graphs
  fillchar(ans, sizeof(ans), 0);
  ans[0] := 1;
  ans[1] := 1;
  for i := 3 to n do
    begin
      lMul(ans, i-1);
      lAdd(ans, 2);
    end;
  lWrite(ans);
end.