{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 100002;
    EPS = 1E-5;
type
    int = longint;
    real = extended;
var
    x, y: array [0..NMAX] of int;
    price, a, u: array [0..NMAX] of real;
    n: int;
    ans: real;

function get(x1, y1, x2, y2, x3, y3: real): real;
var
    a, b, c, cos, tg: real;
begin
    a := sqr(x1 - x2) + sqr(y1 - y2);
    b := sqr(x3 - x2) + sqr(y3 - y2);
    c := sqr(x1 - x3) + sqr(y1 - y3);
    cos := (a + b - c) / (2 * sqrt(a) * sqrt(b));
    if abs(cos) < EPS then begin
        result := 90;
        exit;
    end;
    if cos > 1 - EPS then begin
        result := 0;
        exit;
    end;
    if cos < EPS - 1 then begin
        result := 180;
        exit;
    end;
    tg := sqrt(abs(1 - cos * cos)) / cos;
    result := 180 * arctan(tg) / pi;
    if result < 0 then result := result + 180;
end;

procedure find_price(v: int);
begin
    price[v] := get(x[v - 1], y[v - 1], x[v], y[v], x[v + 1], y[v + 1]) *
        get(x[v], y[v], x[v + 1], y[v + 1], x[v + 2], y[v + 2]);
end;

procedure make(k: int);
var
    i, m, j: int;
    now: real;
begin
    fillchar(a, sizeof(a), 0);
    a[0] := price[k];
    m := n - k;
    for i := 1 to n - k do
        u[i] := price[i + k];
    for i := 1 to k - 2 do begin
        inc(m);
        u[m] := price[i];
    end;
    if k = 1 then dec(m);

    for i := 1 to m do
        for j := max(0, i - 3) to i - 2 do
            a[i] := max(a[i], a[j] + u[i]);
    now := 0;
    for i := 0 to m do
        now := max(now, a[i]);
    ans := max(ans, now);
end;

var
    i: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    read(n);
    for i := 1 to n do
        read(x[i], y[i]);
    x[0] := x[n];
    y[0] := y[n];
    x[n + 1] := x[1];
    y[n + 1] := y[1];
    x[n + 2] := x[2];
    y[n + 2] := y[2];
    for i := 1 to n do
        find_price(i);

    ans := 0;
    for i := 1 to 3 do
        make(i);
    writeln(ans: 0: 6);
end.