#include <stdio.h>
#include <math.h>

#define MAXN 200000
#define PI 3.14159265358979
#define EPS 1e-5

struct point
{
       int x, y;
};

struct point a[MAXN];
double c[MAXN];
double p[MAXN][2];
int n;

void init()
{
   //  freopen("input.txt", "r", stdin);
   //  freopen("output.txt", "w", stdout);
}

void readdata()
{
     int i;
     scanf("%d", &n);
     for(i=0;i<n;i++)
       scanf("%d%d", &a[i].x, &a[i].y);
}

double get_angle(struct point p1, struct point p2, struct point p3)
{
       struct point v1, v2;
       double sinus, cosinus, l1, l2, res;
       v1.x = p1.x-p2.x;  v2.x = p3.x-p2.x;
       v1.y = p1.y-p2.y;  v2.y = p3.y-p2.y;
       l1 = sqrt(v1.x*v1.x+v1.y*v1.y);
       l2 = sqrt(v2.x*v2.x+v2.y*v2.y);
       sinus   = (v1.x*v2.y-v1.y*v2.x)/(l1*l2);
       cosinus = (v1.x*v2.x+v1.y*v2.y)/(l1*l2);
       if(fabs(cosinus) <= EPS)
         res = 90;
       else
       {
         res = atan(sinus/cosinus)*180/PI;
         if(res < 0.)
           res += 180;
       }
      // printf("%Lf\n", res);       
       return res;
}

double max(double a, double b)
{
       if(a>=b)
         return a;
       return b;
}

void solve()
{
     int i;
     double res;
     for(i=0;i<n;i++)
     {
       c[i] = get_angle(a[(i-1+n)%n], a[i], a[(i+1)%n])*get_angle(a[i], a[(i+1)%n], a[(i+2)%n]);
       //printf("%Lf\n", c[i]);
     }
     p[0][0] = c[0];
     p[0][1] = 0.;
     p[1][0] = c[1];
     p[1][1] = 0.;
     for(i=2;i<n;i++)
     {
       p[i][0] = p[i-1][1] + c[i];
       p[i][1] = max(p[i-1][0],p[i-1][1]);
     }
     res = max(p[n-1][0], p[n-1][1]);
     for(i=1;i<n;i++)
     {
       p[i][0] = p[i-1][1] + c[i];
       p[i][1] = max(p[i-1][0],p[i-1][1]);
     }     
     res = max(res, p[n-1][1]);
     printf("%0.4Lf", res);
}

int main()
{
    init();
    readdata();
    solve();
    return 0;
}
