#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

#define pi 3.1415926535897932384626433832795

double arcsin( double val )
{
  double mn = 0, mx = pi / 2;
  for (int t = 0; t < 60 && 1e-14 < mx - mn; t++)
  {
    double av = (mn + mx) / 2;
    if (sin(av) > val)
      mx = av;
    else
      mn = av;
  }
  return mn;
}

#define maxn 100010

double a[maxn], d1[maxn], d2[maxn];
int x[maxn], y[maxn];

int main( void )
{
  fprintf(stderr, "start...\n");
  int n;

  scanf("%d", &n);
  for (int i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]);

  for (int i = 0; i < n; i++)
  {
    long long x1 = x[(i + n - 1) % n] - x[i], x2 = x[(i + 1) % n] - x[i];
    long long y1 = y[(i + n - 1) % n] - y[i], y2 = y[(i + 1) % n] - y[i];
    long long vp = abs(x1 * y2 - x2 * y1);
    double sina = 1.0 * vp / sqrt(x1 * x1 + y1 * y1) / sqrt(x2 * x2 + y2 * y2);
    a[i] = arcsin(sina) / pi * 180;
  }

  fprintf(stderr, "sin...\n");

  memset(d1, 0, sizeof(d1));
  memset(d2, 0, sizeof(d2));
  d1[0] = 0, d2[1] = a[n - 1] * a[0];
  for (int i = 0; i < n; i++)
    d1[i + 1] >?= d1[i], d1[i + 2] >?= d1[i] + a[i] * a[i + 1];
  for (int i = 1; i < n - 1; i++)
    d2[i + 1] >?= d2[i], d2[i + 2] >?= d2[i] + a[i] * a[i + 1];

  double ans = max(d1[n], d2[n - 1]);

  fprintf(stderr, "end...\n");

  printf("%.4lf\n", ans);

  return 0;
}
