{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math;

const
 StreamIn='';
 StreamOut='';
 NMAX=110000;

type
 real=extended;
 RealVect=array [0..NMAX] of real;
 Cord=record
   x,y:real
  end;
 CordSet=array [0..NMAX] of Cord;

var P:CordSet;
    Dpt1,Dpt2:RealVect;
    n:integer;
    Ans:real;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n);
 for i:=0 to n-1 do read(P[i].x,P[i].y)
end;

function GetVect(p1,p2:Cord):Cord;
begin
 with Result do begin
   x:=p2.x-p1.x;
   y:=p2.y-p1.y
  end
end;

function ScalMul(v1,v2:Cord):real;
begin
 Result:=v1.x*v2.x+v1.y*v2.y
end;

function Modul(v:Cord):real;
begin
 Result:=Sqrt(Sqr(v.x)+Sqr(v.y))
end;

function Angle(v1,v2:Cord):real;
var v:real;
begin
 v:=ScalMul(v1,v2)/(Modul(v1)*Modul(v2));
 if v<-1 then v:=-1
 else
  if v>1 then v:=1;
 Result:=ArcCos(v);
 Result:=(Result/pi)*180
end;

function Calc(v:integer):real;
var a1,a2:real;
begin
 a1:=Angle(GetVect(P[v],P[(v+1) mod n]),GetVect(P[v],P[(v+n-1) mod n]));
 v:=(v+1) mod n;
 a2:=Angle(GetVect(P[v],P[(v+1) mod n]),GetVect(P[v],P[(v+n-1) mod n]));
 Result:=a1*a2
end;

procedure SolveAndSave;
var i:integer;
begin
 for i:=1 to n do begin
   Dpt1[i]:=0;
   Dpt2[i]:=0
  end;
 Dpt1[1]:=0;
 Dpt2[1]:=0;
 for i:=1 to n-1 do begin
   Dpt1[i+1]:=Dpt2[i]+Calc(i);
   Dpt2[i+1]:=Max(Dpt1[i],Dpt2[i])
  end;
 Ans:=Max(Dpt1[n],Dpt2[n]);
 Dpt1[1]:=Calc(0);
 Dpt2[1]:=0;
 for i:=1 to n-1 do begin
   Dpt1[i+1]:=Dpt2[i]+Calc(i);
   Dpt2[i+1]:=Max(Dpt1[i],Dpt2[i])
  end;
 Ans:=Max(Ans,Dpt2[n]);
 writeln(Ans:0:6)
end;


begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
