{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

const
 StreamIn='';
 StreamOut='';
 NMAX=110;

type
 IntVect=array [0..NMAX] of integer;
 IntGrid=array [0..NMAX] of IntVect;
 BoolVect=array [0..NMAX] of boolean;

var G,Fig:IntGrid;
    Mark:BoolVect;
    Prev:IntVect;
    n,root,Ans:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i,j,v,m:integer;
begin
 read(n,root);
 fillchar(G,sizeof(G),0);
 for i:=1 to n do begin
   read(m);
   for j:=1 to m do begin
     read(v);
     if i<>root then G[v,i]:=1
    end
  end
end;

function DFS(v:integer):integer;
var i:integer;
begin
 Result:=1;
 Mark[v]:=False;
 for i:=1 to n do
  if (G[v,i]=1) and Mark[i] then begin
    Prev[i]:=v;
    Result:=Result+DFS(i);
    G[v,i]:=0
   end
end;

procedure SolveAndSave;
var i,j:integer;
begin
 Prev[root]:=0;
 fillchar(Mark,sizeof(Mark),True);
 while DFS(root)=n do begin
   inc(Ans);
   Fig[Ans]:=Prev;
   fillchar(Mark,sizeof(Mark),True)
  end;
 writeln(Ans);
 for i:=1 to Ans do begin
   for j:=1 to n do write(Fig[i,j],' ');
   writeln
  end
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
