program ATetris;
uses math;

{$MODE DELPHI}
//{$DEFINE DEBUG}
{$IFDEF DEBUG}
        {$O-,Q+,R+}
{$ELSE}
        {$O+,Q-,R-}
{$ENDIF}

function roundto(A, P:Extended):Extended;
var
        T:Extended;
begin
T := A / P;
T := round(T);
T := T * P;
roundto := T;
end;

const MaxN = 100000;

function CalcAng(X1, Y1, X2, Y2, X3, Y3:Longint):Extended;
var
        A1, A2, AR:Extended;
        D:Real;
begin
X1 := X1 - X2; Y1 := Y1 - Y2;
X3 := X3 - X2; Y3 := Y3 - Y2;

D := sqrt(X1 * X1 + Y1 * Y1);
A1 := radtodeg(arccos(X1 / D));
if Y1 < 0 then A1 := -A1;
A1 := roundto(A1, 10E-15);

D := sqrt(X3 * X3 + Y3 * Y3);
A2 := radtodeg(arccos(X3 / D));
if Y3 < 0 then A2 := -A2;
A2 := roundto(A2, 10E-15);

AR := abs(A1 - A2);
if AR > 180 then AR := 360 - AR;
CalcAng := AR;
end;

var
        N:Longint;
        A:Array[1..MaxN] of Extended;
        P:Array[1..MaxN] of Extended;
        D:Array[1..MaxN] of Longint;

function GetAns:Extended;
var
        R, I, I2:Longint;
        S, MaxP:Extended;
        MaxPI:Longint;
begin
fillchar (D, sizeof(D), 0);

S := 0;
for R := N downto 1 do begin
        MaxP := 0;
        for I := 1 to N do
                if (P[I] > MaxP) and (D[I] = 0) then begin
                        MaxP := P[I];
                        MaxPI := I;
                end;

        S := S + MaxP;
        D[MaxPI] := 1;
        if MaxPI = 1 then
                P[N] := 0
        else
                P[MaxPI - 1] := 0;

        if MaxPI = N then
                P[1] := 0
        else
                P[MaxPI + 1] := 0;
        P[MaxPI] := 0;
end;

GetAns := S;
end;

var
        I, oX2, oY2, oX1, oY1, X, Y:Longint;
        X1, Y1, X2, Y2:Longint;
begin
{$IFDEF DEBUG} assign (input, 'road.in'); reset (input); {$ENDIF}
readln (N);
readln (X1, Y1); oX2 := X1; oY2 := Y1;
readln (X2, Y2); oX1 := X2; oY1 := Y2;

for I := 3 to N do begin
        readln (X, Y);
        A[I - 1] := CalcAng(oX2, oY2, oX1, oY1, X, Y);
        oX2 := oX1; oY2 := oY1;
        oX1 := X; oY1 := Y;
end;
X := X1; Y := Y1;
A[N] := CalcAng(oX2, oY2, oX1, oY1, X, Y);
oX2 := oX1; oY2 := oY1;
oX1 := X; oY1 := Y;

X := X2; Y := Y2;
A[1] := CalcAng(oX2, oY2, oX1, oY1, X, Y);
oX2 := oX1; oY2 := oY1;
oX1 := X; oY1 := Y;

{$IFDEF DEBUG} close (input); {$ENDIF}

for I := 1 to N - 1 do
        P[I] := A[I] * A[I + 1];
P[N] := A[N] * A[1];

writeln (GetAns:0:3);
end.
