#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <utility>

#include "gameunit.h"

using namespace std;

#define fi first
#define se second
#define mp make_pair

#define INF 987654321

int fig[7][4][4] = {{{1, 0, 0, 0}, {1, 0, 0, 0}, {1, 0, 0, 0}, {1, 0, 0, 0}},
                    {{1, 1, 0, 0}, {1, 0, 0, 0}, {1, 0, 0, 0}, {0, 0, 0, 0}},
                    {{1, 0, 0, 0}, {1, 0, 0 ,0}, {1, 1, 0, 0}, {0, 0, 0, 0}},
                    {{0, 1, 0, 0}, {1, 1, 0, 0}, {1, 0, 0, 0}, {0, 0, 0, 0}},
                    {{1, 0, 0, 0}, {1, 1, 0, 0}, {0, 1, 0, 0}, {0, 0, 0, 0}},
                    {{1, 0, 0, 0}, {1, 1, 0, 0}, {1, 0, 0, 0}, {0, 0, 0, 0}},
                    {{1, 1, 0, 0}, {1, 1, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}};

typedef pair<int, int> ii;

bool my_field[200];
bool A[200][100];
int F[4][7][4][4];
bool sp[20];

ii get_bounds(int fig, int ori)
{
	ii r = mp(INF, -INF);
	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 4; j++)
			if (F[ori][fig][i][j])
			{
				r.fi <?= j;
				r.se >?= j;
			}
	return r;
}

bool free(int x, int y)
{
	if (y < 0 || y > 9 || x > 19) return false;
	if (x < 0) return true;
	return !A[x][y];
}

int fall(int fig, int ori, int left)
{
	for (int i = -50; i <= 50; i++)
	{
		bool bad = false;
		for (int j = 0; j < 4; j++)
			for (int k = 0; k < 4; k++)
				if (F[ori][fig][j][k] && !free(i + j, left + k))
					bad = true;
		if (bad) return i - 1;
	}
}

bool cool(int cx, int cy)
{
	if (cx < 0 || cx > 19 || cy < 0 || cy > 9) return false;
	return true;
}

bool write(int fig, int ori, int left, int up, bool what)
{
	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 4; j++)
			if (F[ori][fig][i][j])
			{
				if (!cool(up + i, left + j)) return false;
				A[up + i][left + j] = what;
			}
	return true;
}

int filled_rows()
{
	int score = 0;
	for (int i = 0; i < 20; i++)
	{
		bool filled = true;
		for (int j = 0; j < 10; j++)
			if (!A[i][j])
			{
				filled = false;
				break;
			}
		if (filled) score++;
	}
	return score;
}

int empty_rows()
{
	int score = 0;
	for (int i = 0; i < 20; i++)
	{
		bool filled = true;
		for (int j = 0; j < 10; j++)
			if (A[i][j])
			{
				filled = false;
				break;
			}
		if (filled) score++;
	}
	return score;
}

int spoiled_rows()
{
	memset(sp, 0, sizeof(sp));
	for (int i = 0; i < 10; i++)
	{
		bool bad = false;
		for (int j = 0; j < 20; j++)
			if (A[j][i]) bad = true;
			else if (bad) sp[j] = true;
	}
	int score = 0;
	for (int i = 0; i < 20; i++)
		if (sp[i]) score++;
	return score;
}

int estimate()
{
	int A = filled_rows();
	int B = empty_rows();
	int C = spoiled_rows();
	if (B <= 5) return B;
	int score = A * 3 + B;
	return score;
}

ii think(int fig)
{
	ii ans = mp(rand() % 4, 0);
	int best = -1000;
	for (int i = 0; i < 4; i++)
	{
		for (int j = 0; j < 10; j++)
		{
			int temp = fall(fig, i, j);
			if (temp == -51) continue;
			bool res = write(fig, i, j, temp, true);
			if (res)
			{
				int temp = estimate();
				if (temp > best)
				{
					best = temp;
					ans = mp(i, j);
				}
			}
			write(fig, i, j, temp, false);
		}
	}
	return ans;
}

int main()
{
	srand(time(NULL));
	for (int i = 0; i < 7; i++)
		for (int j = 0; j < 4; j++)
			for (int k = 0; k < 4; k++)
				F[0][i][j][k] = fig[i][j][k];
	for (int ii = 1; ii < 4; ii++)
	{
		for (int i = 0; i < 7; i++)
			for (int j = 0; j < 4; j++)
				for (int k = 0; k < 4; k++)
					F[ii][i][j][k] = F[ii - 1][i][k][3 - j];
	}
	for (int ii = 0; ii < 4; ii++)
	{
		for (int i = 0; i < 7; i++)
		{
			int a = INF, b = INF;
			for (int j = 0; j < 4; j++)
				for (int k = 0; k < 4; k++)
					if (F[ii][i][j][k])
					{
						a <?= j;
						b <?= k;
					}
			for (int j = 0; j < 4; j++)
				for (int k = 0; k < 4; k++)
				{
					if (j + a < 4 && k + b < 4) F[ii][i][j][k] = F[ii][i][j + a][k + b];
					else F[ii][i][j][k] = 0;
				}
		}
	}
	int cfigure = Initialize();
	for (;;)
	{
		GetField(0, my_field);
		int cur = 0;
		for (int i = 0; i < 20; i++)
			for (int j = 0; j < 10; j++)
				A[i][j] = my_field[cur++];
		ii temp = think(cfigure);
		cfigure = Drop(temp.fi, temp.se);
	}
	return 0;
}
