#include <cmath>
#include <cstdio>
#include <cstring>

int _stklen = 50 << 20;

#define PI 3.14159265358979323

int n, ntemp;
int x[100000], y[100000];
double score[100000];
double temp[100000];
double dp[100000][2];

double vect(double x1, double y1, double x2, double y2)
{
	return x1 * y2 - x2 * y1;
}

double scal(double x1, double y1, double x2, double y2)
{
	return x1 * x2 + y1 * y2;
}

double abs(double x)
{
	if (x > 0) return x;
	return -x;
}

double get_angle(double x1, double y1, double x2, double y2)
{
	return (atan2(abs(vect(x1, y1, x2, y2)), scal(x1, y1, x2, y2))) / PI * 180;
}

double get(double *a, int n)
{
	dp[0][0] = 0;
	dp[0][1] = a[0];
	for (int i = 1; i < n; i++)
	{
		dp[i][0] = dp[i - 1][0] >? dp[i - 1][1];
		dp[i][1] = dp[i - 1][0] + a[i];
	}
	return dp[n - 1][0] >? dp[n - 1][1];
}

int main()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &x[i], &y[i]);
	for (int i = 0; i < n; i++)
	{
		int p = i;
		int q = (i + 1) % n;
		int p1 = (p + n - 1) % n;
		int q1 = (q + 1) % n;
		double a1 = get_angle(x[q] - x[p], y[q] - y[p], x[p1] - x[p], y[p1] - y[p]);
		double a2 = get_angle(x[p] - x[q], y[p] - y[q], x[q1] - x[q], y[q1] - y[q]);
		score[i] = a1 * a2;
	}
	double ans = -1;
	for (int i = 0; i < 2; i++)
	{
		int ntemp = 0;
		for (int j = (i + 1) % n; j != i; j = (j + 1) % n)
			temp[ntemp++] = score[j];
		ans >?= get(temp, ntemp);
	}
	printf("%.15lf\n", ans);
	return 0;
}
