#include "c/gameunit.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int got_rows = 0;

struct state
{
  bool t[2][24][10];
  int m[2];
};
bool isfirst = true;
state stack[256];
int ssize = 0;
void push_state ()
{
  memcpy (&stack[ssize], &stack[ssize - 1], sizeof stack[0]);
  ssize++;
}
void pop_state ()
{
  ssize--;
}
inline state* get_state ()
{
  return &stack[ssize - 1];
}
void init_stack ()
{
  ssize = 1;
  int m;
  if (!isfirst)
    m = stack[0].m[0];
  memset (stack, 0, sizeof stack);
  GetField (0, &stack[0].t[0][4][0]);
  GetField (1, &stack[0].t[1][4][0]);
  for (int i = 0; i < 2; i++)
  {
    stack[0].m[i] = 0;
    for (int x = 0; x < 10; x++)
      for (int y = 4; y < 24; y++)
        if (stack[0].t[i][y][x] && 24 - y > stack[0].m[i])
          stack[0].m[i] = 24 - y;
  }
  if (!isfirst)
    got_rows = stack[0].m[0] - m;
  if (got_rows < 0) got_rows = 0;
  isfirst = false;
}
struct piece
{
  bool x[4][4];
  int h[4];
  int w;
  int mh;
};
piece pc[19] = {
 {{{true,false,false,false},{true,false,false,false},{true,false,false,false},{true,false,false,false}},{4,0,0,0},1,4},
 {{{true,true,true,true},{false,false,false,false},{false,false,false,false},{false,false,false,false}},{1,1,1,1},4,1},

 {{{true,true,false,false},{true,false,false,false},{true,false,false,false},{false,false,false,false}},{3,1,0,0},2,3},
 {{{true,false,false,false},{true,true,true,false},{false,false,false,false},{false,false,false,false}},{2,2,2,0},3,2},
 {{{false,true,false,false},{false,true,false,false},{true,true,false,false},{false,false,false,false}},{3,3,0,0},2,3},
 {{{true,true,true,false},{false,false,true,false},{false,false,false,false},{false,false,false,false}},{1,1,2,0},3,2},

 {{{true,false,false,false},{true,false,false,false},{true,true,false,false},{false,false,false,false}},{3,3,0,0},2,3},
 {{{false,false,true,false},{true,true,true,false},{false,false,false,false},{false,false,false,false}},{2,2,2,0},3,2},
 {{{true,true,false,false},{false,true,false,false},{false,true,false,false},{false,false,false,false}},{1,3,0,0},2,3},
 {{{true,true,true,false},{true,false,false,false},{false,false,false,false},{false,false,false,false}},{2,1,1,0},3,2},

 {{{false,true,false,false},{true,true,false,false},{true,false,false,false},{false,false,false,false}},{3,2,0,0},2,3},
 {{{true,true,false,false},{false,true,true,false},{false,false,false,false},{false,false,false,false}},{1,2,2,0},3,2},
  
 {{{true,false,false,false},{true,true,false,false},{false,true,false,false},{false,false,false,false}},{2,3,0,0},2,3},
 {{{false,true,true,false},{true,true,false,false},{false,false,false,false},{false,false,false,false}},{2,2,1,0},3,2},
  
 {{{true,false,false,false},{true,true,false,false},{true,false,false,false},{false,false,false,false}},{3,2,0,0},2,3},
 {{{false,true,false,false},{true,true,true,false},{false,false,false,false},{false,false,false,false}},{2,2,2,0},3,2},
 {{{false,true,false,false},{true,true,false,false},{false,true,false,false},{false,false,false,false}},{2,3,0,0},2,3},
 {{{true,true,true,false},{false,true,false,false},{false,false,false,false},{false,false,false,false}},{1,2,1,0},3,2},

 {{{true,true,false,false},{true,true,false,false},{false,false,false,false},{false,false,false,false}},{2,2,0,0},2,2}
};
int allow[7][4] = {
  { 0,  1, -1, -1},
  { 2,  3,  4,  5},
  { 6,  7,  8,  9},
  {10, 11, -1, -1},
  {12, 13, -1, -1},
  {14, 15, 16, 17},
  {18, -1, -1, -1}
};
int execute (int cur, int pos, state* st, int side)
{
  int faly = 1000;
  for (int x = 0; x < 4; x++)
  {      
    int al = 24;
    for (int y = 0; y < 24; y++)
      if (st->t[side][y][x + pos])
      {
        al = y;
        break;
      }
    if (al - pc[cur].h[x] < faly)
      faly = al - pc[cur].h[x];
  }
  if (24 - faly > st->m[side])
    st->m[side] = 24 - faly;
  for (int x = 0; x < 4; x++)
    for (int y = 0; y < 4; y++)
      if (pc[cur].x[y][x])
        st->t[side][y + faly][x + pos] = true;
  int rem[5] = {-1,-1,-1,-1,-1};
  int nrem = 0;
  for (int y = pc[cur].mh - 1; y >= 0; y--)
  {
    bool full = true;
    for (int x = 0; x < 10 && full; x++)
      if (!st->t[side][y + faly][x])
        full = false;
    if (full)
      rem[nrem++] = y + faly;
  }
  int shift = 0;
  for (int y = 23; y >= 0; y--)
  {
    if (y == rem[shift])
      shift++;
    if (shift)
    {
      if (y < shift)
        memset (st->t[side][y], 0, sizeof st->t[side][y]);
      else
        for (int x = 0; x < 10; x++)
          st->t[side][y][x] = st->t[side][y - shift][x];
    }
  }
  st->m[side] -= shift;
  for (int y = 0; y < 24; y++)
  {
    if (y + shift >= 24)
    {
      for (int x = 0; x < 10; x++)
        st->t[1 - side][y][x] = true;
    }
    else
      for (int x = 0; x < 10; x++)
        st->t[1 - side][y][x] = st->t[1 - side][y + shift][x];
  }
  st->m[1 - side] += shift;
  if (st->m[side] > 20)
    return side * 2 - 1;
  if (st->m[1 - side] > 20)
    return 1 - side * 2;
  return 0;
}

int dep = 1;

int prob[7] = {5,5,5,5,5,5,5};
int num_turns = 0;
int evil[5] = {2,2,2,0,2};
int get_random ()
{
  int sum = 0;
  for (int i = 0; i < 7; i++)
    sum += prob[i];
  sum = rand () % sum;
  int cur = 0;
  while (sum >= prob[cur])
    sum -= prob[cur], cur++;
  return cur;
}

int evaluate ()
{
  state* st = get_state ();
  if (st->m[0] > 20)
    return -1000;
  if (st->m[1] > 20)
    return 1000;
  double coeff = double (prob[0]) * double (num_turns + 7) /
    double (evil[1] * 0.25 + evil[2] + 4 * evil[4]) / double (num_turns + 35);
  int val = st->m[1] - st->m[0];
  if (val < -6)
    return val;
  val += int (double (st->m[1] - stack[0].m[1]) / coeff);
  val *= 10;
  for (int x = 0; x < 20; x++)
  {
    bool got[2] = {false, false};
    for (int y = 0; y < 20; y++)
    {
      if (st->t[0][y][x]) got[0] = true;
      else if (got[0]) val--;
      if (st->t[1][y][x]) got[1] = true;
      else if (got[1]) val++;
    }
  }
  return val;
}

int find_min (int cur, int alpha, int beta, int d);
int find_max (int* rot, int* pos, int cur, int alpha = -1000, int beta = 1000, int d = 57)
{
  if (d == 57) d = dep;
  if (d <= 0)
    return evaluate ();
  for (int i = 0; i < 4 && allow[cur][i] >= 0; i++)
  {
    for (int x = 0; x <= 10 - pc[allow[cur][i]].w; x++)
    {
      push_state ();
      int r = execute (allow[cur][i], x, get_state (), 0) * 1000;
      if (r != 0)
      {
        pop_state ();
        if (r >= beta)
          return beta;
        else
          continue;
      }
      r = find_min (cur, alpha, beta, d - 1);
      if (r >= beta)
      {
        pop_state ();
        return beta;
      }        
      if (r > alpha)
      {
        alpha = r;
        if (rot) *rot = i;
        if (pos) *pos = x;
      }        
      pop_state ();
    }
  }
  return alpha;
}
int find_min (int cur, int alpha, int beta, int d)
{
  if (d <= 0)
    return evaluate ();
  for (int i = 0; i < 4 && allow[cur][i] >= 0; i++)
  {
    for (int x = 0; x <= 10 - pc[allow[cur][i]].w; x++)
    {
      push_state ();
      int r = execute (allow[cur][i], x, get_state (), 1) * 1000;
      if (r != 0)
      {
        pop_state ();
        if (r <= alpha)
          return alpha;
        else
          continue;
      }
      r = find_max (NULL, NULL, get_random (), alpha, beta, d - 1);
      if (r <= alpha)
      {
        pop_state ();
        return alpha;
      }
      if (r < beta)
        beta = r;
      pop_state ();
    }
  }
  return beta;
}

int main ()
{
  int cur = Initialize ();

  while (true)
  {
    prob[cur]++;
    init_stack ();
    evil[got_rows]++;
//    if (got_rows > 0)
  //    fprintf (stderr, "HEY: %d\n", got_rows);
    int rot, pos;
    find_max (&rot, &pos, cur);
    execute (allow[cur][rot], pos, &stack[0], 0);
    cur = Drop (rot, pos);
    num_turns++;
  }
  return 0;
}

