#include <stdio.h>
#include <string.h>

#include <stdlib.h>

#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define min(a,b) ((a)<(b)?(a):(b))

struct edge
{
  int p, f;
  int b;
  edge* next;
  edge* back;
};
edge ea[128 * 128 * 2];
int nea = 0;
edge* ealloc ()
{
  return &ea[nea++];
}

edge* ve[128];
void add_edge (int a, int b)
{
  edge* e1 = ealloc ();
  e1->b = b, e1->p = 1, e1->f = 0, e1->next = ve[a], ve[a] = e1;
  edge* e2 = ealloc ();
  e2->b = a, e2->p = 0, e2->f = 0, e2->next = ve[b], ve[b] = e2;
  e1->back = e2, e2->back = e1;
}

int S, T;

int q[128];
edge* by[128];
int mf[128];

int flow ()
{
  int sum = 0;
  for (int i = 0; i < nea; i++)
    ea[i].f = 0;
  while (true)
  {
    int head = 1;
    int tail = 0;
    memset (by, 0, sizeof by);
    memset (mf, 0, sizeof mf);
    q[0] = S;
    mf[S] = 1000000;
    while (tail < head)
    {
      int v = q[tail++];
      for (edge* e = ve[v]; e; e = e->next)
        if (mf[e->b] == 0 && e->p > e->f)
          mf[e->b] = min (mf[v], e->p - e->f), by[e->b] = e, q[head++] = e->b;
    }
    if (mf[T] == 0)
      break;
    int cur = T;
    sum += mf[T];
    while (cur != S)
    {
      by[cur]->f += mf[T];
      by[cur]->back->f -= mf[T];
      cur = by[cur]->back->b;
    }
  }
  return sum;
}

int main ()
{
#ifdef _LOCAL_
  freopen ("c.in", "rt", stdin);
  freopen ("c.out", "wt", stdout);
#endif

  int n, l;
  scanf ("%d %d", &n, &l), l--;
  memset (ve, 0, sizeof ve);
  T = l;
  for (int i = 0; i < n; i++)
  {
    int k;
    scanf ("%d", &k);
    for (int j = 0; j < k; j++)
    {
      int b;
      scanf ("%d", &b);
      add_edge (i, b - 1);
    }
  }
  int best = 10000;
  for (int i = 0; i < n; i++)
  {
    if (i == l) continue;
    S = i;
    int cur = flow ();
    if (cur < best)
      best = cur;
  }
  printf ("%d", best);

  return 0;
}
