{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses GameUnit,Math;

const
 NMAX=10;
 MMAX=25;

type
 integer=longint;
 BoolGrid=array [0..NMAX,0..MMAX] of boolean;

var Field,go:BoolGrid;
    Temp:TField;

procedure Normalize;
var i,j,t:integer;
begin
 fillchar(Field,sizeof(Field),False);
 t:=0;
 for j:=19 downto 0 do
  for i:=0 to 9 do begin
    Field[i,j]:=Temp[t];
    inc(t)
   end
end;

function AtField(x,y:integer):boolean;
begin
 Result:=(x>=0) and (x<=9) and (y>=0) and (y<=MMAX)
end;

procedure Dropped(a:integer; var Rotation,Shift:integer);
var height,unstable,delrow,depth,i,j:integer;

 procedure Calc(x1,y1,x2,y2,x3,y3,x4,y4,trot:integer);
 var Used:array [0..9] of boolean;
     i,j:integer;

  procedure Estimate(i,j:integer);
  var p1,p2,p3,p4,x,y,k:integer;
      Flag:boolean;
  begin
   Field[i+x1,j+y1]:=True;
   Field[i+x2,j+y2]:=True;
   Field[i+x3,j+y3]:=True;
   Field[i+x4,j+y4]:=True;
   x:=i;
   y:=j;
   p1:=0;
   p2:=0;
   p3:=0;
   p4:=maxint;
   fillchar(go,sizeof(go),True);
   for j:=MMAX-1 downto 0 do begin
     Flag:=True;
     for i:=0 to 9 do begin
       Flag:=Flag and Field[i,j];
       if (not Field[i,j]) and Field[i,j+1] then begin
         k:=j;
         while (k>0) and (not Field[i,k]) do begin
           go[i,k]:=False;
           inc(p1);
           dec(k)
          end
        end
       else
        if go[i,j] then p4:=min(p4,j);
       if Field[i,j] then p2:=Max(p2,j)
      end;
     inc(p3,integer(Flag))
    end;
   i:=x;
   j:=y;
   if p2<=19 then begin
     if (p3>1) and (p3>delrow) then begin
       unstable:=p1;
       height:=p2;
       delrow:=p3;
       Rotation:=trot;
       depth:=p4;
       Shift:=i;
       Exit
      end;
     if p2<4 then begin
       if (p1<unstable) or ((p1=unstable) and (p2<height)) then begin
         unstable:=p1;
         height:=p2;
         delrow:=p3;
         depth:=p4;
         Rotation:=trot;
         Shift:=i
        end
      end
     else
      if p2<10 then begin
        if ((p2+p1-p4)<(height+unstable-depth)) then begin
          unstable:=p1;
          height:=p2;
          delrow:=p3;
          depth:=p4;
          Rotation:=trot;
          Shift:=i
         end
       end
      else
       if ((p2-p4)<(height-depth)) or
          (((p2-p4)=(height-depth)) and (p1<unstable)) then begin
         unstable:=p1;
         height:=p2;
         delrow:=p3;
         depth:=p4;
         Rotation:=trot;
         Shift:=i
        end
    end;
   Field[i+x1,j+y1]:=False;
   Field[i+x2,j+y2]:=False;
   Field[i+x3,j+y3]:=False;
   Field[i+x4,j+y4]:=False
  end;

 begin
  fillchar(Used,sizeof(Used),True);
  for j:=20 downto 0 do
   for i:=0 to 9 do
    if Used[i] then
     if AtField(i+x1,j+y1) and AtField(i+x2,j+y2) and
        AtField(i+x3,j+y3) and AtField(i+x4,j+y4)
     then begin
       if Field[i+x1,j+y1] or Field[i+x2,j+y2] or
          Field[i+x3,j+y3] or Field[i+x4,j+y4]
       then begin
         Estimate(i,j+1);
         Used[i]:=False
        end
      end
     else Used[i]:=False;
  for i:=0 to 9 do
   if Used[i] then
    Estimate(i,0)
 end;

begin
 unstable:=maxint div 2;
 height:=maxint div 2;
 delrow:=0;
 depth:=0;
 case a of
   0:begin
      Calc(0,0,0,1,0,2,0,3,0);
      Calc(0,0,1,0,2,0,3,0,1)
     end;
   1:begin
      Calc(0,0,0,1,0,2,1,2,0);
      Calc(0,0,0,1,1,0,2,0,1);
      Calc(0,0,1,0,1,1,1,2,2);
      Calc(0,1,1,1,2,1,2,0,3)
     end;
   2:begin
      Calc(0,0,0,1,0,2,1,0,0);
      Calc(0,0,1,0,2,0,2,1,1);
      Calc(0,2,1,0,1,1,1,2,2);
      Calc(0,0,0,1,1,1,2,1,3)
     end;
   3:begin
      Calc(0,0,0,1,1,1,1,2,0);
      Calc(0,1,1,0,1,1,2,0,1);
      Calc(0,0,0,1,1,1,1,2,2)
     end;
   4:begin
      Calc(0,1,0,2,1,0,1,1,0);
      Calc(0,0,1,0,1,1,2,1,1);
      Calc(0,1,0,2,1,0,1,1,2)
     end;
   5:begin
      Calc(0,0,0,1,0,2,1,1,0);
      Calc(0,0,1,0,1,1,2,0,1);
      Calc(0,1,1,0,1,1,1,2,2);
      Calc(0,1,1,0,1,1,2,1,3)
     end;
   6:begin
      Calc(0,0,0,1,1,0,1,1,0)
     end
  end
end;

procedure Solve;
var a,Rotation,Shift:integer;
begin
 a:=Initialize;
 GetField(0,Temp);
 Normalize;
 Dropped(a,Rotation,Shift);
 while True do begin
   a:=Drop(Rotation,Shift);
   GetField(0,Temp);
   Normalize;
   Dropped(a,Rotation,Shift)
  end
end;


begin
 Solve
end.
