#include <stdio.h>
#include <string.h>
#include <math.h>

const int maxn = 131072;
int x[maxn];
int y[maxn];
long double prize[maxn];
long double ang[maxn];

long double get_angle (long double x1, long double y1, long double x2, long double y2)
{
  long double cs = x1 * x2 + y1 * y2;
  long double sn = x1 * y2 - x2 * y1;
  return fabs (atan2 (sn, cs)) * 180 / M_PI;
}

long double P[maxn];
long double Q[maxn];

int main ()
{
#ifdef _LOCAL_
  freopen ("roads.in", "rt", stdin);
  freopen ("roads.out", "wt", stdout);
#endif

  int n;
  scanf ("%d", &n);
  for (int i = 0; i < n; i++)
    scanf ("%d %d", &x[i], &y[i]);

  long double px = x[0] - x[n - 1];
  long double py = y[0] - y[n - 1];
  long double len = sqrt (px * px + py * py);
  px /= len, py /= len;
  for (int i = 0; i < n; i++)
  {
    int next = i + 1;
    if (next == n) next = 0;
    long double dx = x[next] - x[i];
    long double dy = y[next] - y[i];
    len = sqrt (dx * dx + dy * dy);
    dx /= len;
    dy /= len;
    ang[i] = get_angle (-px, -py, dx, dy);
    px = dx;
    py = dy;
  }
  int prev = n - 1;
  for (int i = 0; i < n; i++)
    prize[i] = ang[prev] * ang[i], prev = i;

  P[0] = 0;
  Q[0] = 0;
  for (int i = 1; i < n; i++)
  {
    P[i] = P[i - 1];
    if (i < 2 || P[i - 2] + prize[i] > P[i]) P[i] = P[i - 2] + prize[i];
    Q[i] = Q[i - 1];
    if (i > 1 && Q[i - 2] + prize[i] > Q[i]) Q[i] = Q[i - 2] + prize[i];
  }
  long double res = P[n - 1];
  if (Q[n - 2] + prize[0] > res) res = Q[n - 2] + prize[0];
  printf ("%.3lf", double (res));

  return 0;
}
