program ATetris;
uses GameUnit;

{$MODE DELPHI}
{$DEFINE DEBUG}
{$IFDEF DEBUG}
        {$O-,Q+,R+}
{$ELSE}
        {$O+,Q-,R-}
{$ENDIF}

//type TField = array[0..199] of boolean;

type TFig = record
                W, H:Longint;
                E:Array[1..4, 1..4] of Boolean;
            end;

var
        Figs:Array[0..6, 0..3] of TFig;

procedure FillFigs;
begin
fillchar (Figs, sizeof(Figs), 0);

//0, 0
Figs[0, 0].W := 1;
Figs[0, 0].H := 4;
Figs[0, 0].E[1, 1] := true;
Figs[0, 0].E[1, 2] := true;
Figs[0, 0].E[1, 3] := true;
Figs[0, 0].E[1, 4] := true;
//0, 1
Figs[0, 1].W := 4;
Figs[0, 1].H := 1;
Figs[0, 1].E[1, 1] := true;
Figs[0, 1].E[2, 1] := true;
Figs[0, 1].E[3, 1] := true;
Figs[0, 1].E[4, 1] := true;
//0, 2
Figs[0, 2].W := 1;
Figs[0, 2].H := 4;
Figs[0, 2].E[1, 1] := true;
Figs[0, 2].E[1, 2] := true;
Figs[0, 2].E[1, 3] := true;
Figs[0, 2].E[1, 4] := true;
//0, 3
Figs[0, 3].W := 4;
Figs[0, 3].H := 1;
Figs[0, 3].E[1, 1] := true;
Figs[0, 3].E[2, 1] := true;
Figs[0, 3].E[3, 1] := true;
Figs[0, 3].E[4, 1] := true;

//1, 0
Figs[1, 0].W := 2;
Figs[1, 0].H := 3;
Figs[1, 0].E[1, 1] := true;
Figs[1, 0].E[2, 1] := true;
Figs[1, 0].E[1, 2] := true;
Figs[1, 0].E[1, 3] := true;
//1, 1
Figs[1, 1].W := 3;
Figs[1, 1].H := 2;
Figs[1, 1].E[1, 1] := true;
Figs[1, 1].E[1, 2] := true;
Figs[1, 1].E[2, 2] := true;
Figs[1, 1].E[3, 2] := true;
//1, 2
Figs[1, 2].W := 2;
Figs[1, 2].H := 3;
Figs[1, 2].E[2, 1] := true;
Figs[1, 2].E[2, 2] := true;
Figs[1, 2].E[2, 3] := true;
Figs[1, 2].E[1, 3] := true;
//1, 3
Figs[1, 3].W := 3;
Figs[1, 3].H := 2;
Figs[1, 3].E[1, 1] := true;
Figs[1, 3].E[2, 1] := true;
Figs[1, 3].E[3, 1] := true;
Figs[1, 3].E[3, 2] := true;

//2, 0
Figs[2, 0].W := 2;
Figs[2, 0].H := 3;
Figs[2, 0].E[1, 1] := true;
Figs[2, 0].E[1, 2] := true;
Figs[2, 0].E[1, 3] := true;
Figs[2, 0].E[2, 3] := true;
//2, 1
Figs[2, 1].W := 3;
Figs[2, 1].H := 2;
Figs[2, 1].E[1, 2] := true;
Figs[2, 1].E[2, 2] := true;
Figs[2, 1].E[3, 2] := true;
Figs[2, 1].E[3, 1] := true;
//2, 2
Figs[2, 2].W := 2;
Figs[2, 2].H := 3;
Figs[2, 2].E[1, 1] := true;
Figs[2, 2].E[2, 1] := true;
Figs[2, 2].E[2, 2] := true;
Figs[2, 2].E[2, 3] := true;
//2, 3
Figs[2, 3].W := 3;
Figs[2, 3].H := 2;
Figs[2, 3].E[1, 1] := true;
Figs[2, 3].E[1, 2] := true;
Figs[2, 3].E[2, 1] := true;
Figs[2, 3].E[3, 1] := true;

//3, 0
Figs[3, 0].W := 2;
Figs[3, 0].H := 3;
Figs[3, 0].E[2, 1] := true;
Figs[3, 0].E[1, 2] := true;
Figs[3, 0].E[2, 2] := true;
Figs[3, 0].E[1, 3] := true;
//3, 1
Figs[3, 1].W := 3;
Figs[3, 1].H := 2;
Figs[3, 1].E[1, 1] := true;
Figs[3, 1].E[2, 1] := true;
Figs[3, 1].E[2, 2] := true;
Figs[3, 1].E[3, 2] := true;
//3, 2
Figs[3, 2].W := 2;
Figs[3, 2].H := 3;
Figs[3, 2].E[2, 1] := true;
Figs[3, 2].E[1, 2] := true;
Figs[3, 2].E[2, 2] := true;
Figs[3, 2].E[1, 3] := true;
//3, 3
Figs[3, 3].W := 3;
Figs[3, 3].H := 2;
Figs[3, 3].E[1, 1] := true;
Figs[3, 3].E[2, 1] := true;
Figs[3, 3].E[2, 2] := true;
Figs[3, 3].E[3, 2] := true;

//4, 0
Figs[4, 0].W := 2;
Figs[4, 0].H := 3;
Figs[4, 0].E[1, 1] := true;
Figs[4, 0].E[1, 2] := true;
Figs[4, 0].E[2, 2] := true;
Figs[4, 0].E[2, 3] := true;
//4, 1
Figs[4, 1].W := 3;
Figs[4, 1].H := 2;
Figs[4, 1].E[1, 2] := true;
Figs[4, 1].E[2, 1] := true;
Figs[4, 1].E[2, 2] := true;
Figs[4, 1].E[3, 1] := true;
//4, 2
Figs[4, 2].W := 2;
Figs[4, 2].H := 3;
Figs[4, 2].E[1, 1] := true;
Figs[4, 2].E[1, 2] := true;
Figs[4, 2].E[2, 2] := true;
Figs[4, 2].E[2, 3] := true;
//4, 3
Figs[4, 3].W := 3;
Figs[4, 3].H := 2;
Figs[4, 3].E[1, 2] := true;
Figs[4, 3].E[2, 1] := true;
Figs[4, 3].E[2, 2] := true;
Figs[4, 3].E[3, 1] := true;

//5, 0
Figs[5, 0].W := 2;
Figs[5, 0].H := 3;
Figs[5, 0].E[1, 1] := true;
Figs[5, 0].E[1, 2] := true;
Figs[5, 0].E[1, 3] := true;
Figs[5, 0].E[2, 2] := true;
//5, 1
Figs[5, 1].W := 3;
Figs[5, 1].H := 2;
Figs[5, 1].E[1, 2] := true;
Figs[5, 1].E[2, 2] := true;
Figs[5, 1].E[3, 2] := true;
Figs[5, 1].E[2, 1] := true;
//5, 2
Figs[5, 2].W := 2;
Figs[5, 2].H := 3;
Figs[5, 2].E[2, 1] := true;
Figs[5, 2].E[2, 2] := true;
Figs[5, 2].E[2, 3] := true;
Figs[5, 2].E[1, 2] := true;
//5, 3
Figs[5, 3].W := 3;
Figs[5, 3].H := 2;
Figs[5, 3].E[1, 1] := true;
Figs[5, 3].E[2, 1] := true;
Figs[5, 3].E[3, 1] := true;
Figs[5, 3].E[2, 2] := true;

//6, 0
Figs[6, 0].W := 2;
Figs[6, 0].H := 2;
Figs[6, 0].E[1, 1] := true;
Figs[6, 0].E[1, 2] := true;
Figs[6, 0].E[2, 1] := true;
Figs[6, 0].E[2, 2] := true;
//6, 1
Figs[6, 1].W := 2;
Figs[6, 1].H := 2;
Figs[6, 1].E[1, 1] := true;
Figs[6, 1].E[1, 2] := true;
Figs[6, 1].E[2, 1] := true;
Figs[6, 1].E[2, 2] := true;
//6, 2
Figs[6, 2].W := 2;
Figs[6, 2].H := 2;
Figs[6, 2].E[1, 1] := true;
Figs[6, 2].E[1, 2] := true;
Figs[6, 2].E[2, 1] := true;
Figs[6, 2].E[2, 2] := true;
//6, 3
Figs[6, 3].W := 2;
Figs[6, 3].H := 2;
Figs[6, 3].E[1, 1] := true;
Figs[6, 3].E[1, 2] := true;
Figs[6, 3].E[2, 1] := true;
Figs[6, 3].E[2, 2] := true;
end;

var
        Fld:TField;
        nFld:TField;

        MinL:Array[0..9] of Longint;


function FullC(Var MN:Longint):Longint;
var
        I, C:Longint;
//        CF:Boolean;
        Res:Longint;
begin
fillchar (MinL, sizeof(MinL), 255);

for I := 0 to 199 do begin
        if nFld[I] then
                if MinL[I mod 10] < 0 then
                        MinL[I mod 10] := 19 - (I div 10);
end;

Res := 0; MN := 10; C := 0; //CF := true;
for I := 0 to 199 do begin
        if nFld[I] then
                inc (C, 1);
//        else
//                CF := CF and (19 - (I div 10) = MinL[I mod 10] + 1);

        if (I mod 10) = 9 then begin
                if C = 10 then inc (Res, 1);
//                if CF then
                        if MN > (10 - C) then MN := 10 - C;
//                CF := true;
                C := 0;
        end;
end;
FullC := Res;
end;

function GoDown(T, R, S:Longint):Boolean;
var
        X, Y, A:Longint;
        PY:Longint;
        G:Boolean;
begin
PY := 0;

GoDown := false;
if (S + Figs[T, R].W - 1) > 9 then
        exit;

while (true) do begin
        G := true;

        if (PY + Figs[T, R].H - 1) > 19 then begin
                G := False;
        end else begin
                for X := 1 to Figs[T, R].W do begin
                        for Y := 1 to Figs[T, R].H do begin
                                A := (PY + Y - 1) * 10;
                                A := A + S + X - 1;
                                if Figs[T, R].E[X, Y] then
                                        if nFld[A] then begin
                                                G := false;
                                                break;
                                        end;
                        end;
                        if not G then break;
                end;
        end;

        if G then
                inc (PY)
        else
                break;
end;

dec (PY);
if PY < 0 then
        exit;
for X := 1 to Figs[T, R].W do
        for Y := 1 to Figs[T, R].H do begin
                A := (PY + Y - 1) * 10;
                A := A + S + X - 1;
                nFld[A] := nFld[A] or Figs[T, R].E[X,Y];
        end;

GoDown := true;
end;

procedure DoMove(T:Longint; var R, S:Longint);
var
        I, I2:Longint;
        FC, MN:Longint;
        GFC, GMN:Longint;
begin
GetField(0, Fld);
GFC := 0; GMN := 12;
R := 0; S := 0;

for I := 0 to 3 do
        for I2 := 0 to 9 do begin
                nFld := Fld;
                if not GoDown(T, I, I2) then continue;
                FC := FullC(MN);

                if FC > GFC then begin
                        GFC := FC;
                        GMN := MN;
                        R := I;
                        S := I2;
                end;
                if (FC = GFC) and (MN <= GMN) then begin
                        GFC := FC;
                        GMN := MN;
                        R := I;
                        S := I2;
                end;
        end;
//nFld := Fld;
//GoDown (T, R, S);
//Fld := nFld;
end;

var
        T, R, S:Longint;
        C, I:Longint;
        A:Char;
begin
FillFigs;

fillchar (Fld, sizeof(Fld), 0);

T := Initialize();
while (T >= 0) do begin
        DoMove (T, R, S);

        {
        for I := 0 to 199 do begin
                if Fld[I] then
                        write ('1')
                else
                        write ('0');
                if (i mod 10) = 9 then writeln;
        end;
        }

        T := Drop(R, S);
end;
end.






