{$MODE DELPHI}
const
 Maxn=2000;

type
 TNode=record
  c:array[1..26] of integer;
 end;

function Trim(S:String):String;
begin
 while S[1]=' ' do delete(S,1,1);
 while S[length(S)]=' ' do delete(S, length(S), 1);
 result:=S;
end;

var
 Tree:array[1..maxn*maxn div 2 + 1] of TNode;
 d:array[1..maxn*maxn div 2 + 1] of integer;
 count:integer;
 k,i:integer;
 S:String;
 res:int64;

function GetSymb(c:char):integer;
begin
 result:=ord(c)-ord('a')+1;
end;

procedure MakeTree(S:String);
var
 i,j,n:integer;

procedure Insert(S:String);
var
 curr,i,n:integer;
begin
 curr:=1;
 n:=length(S);
 for i:=1 to n do begin
  if Tree[curr].c[GetSymb(S[i])]=0 then begin
   inc(count);
   Tree[curr].c[GetSymb(S[i])]:=count;
  end;
  curr:=Tree[curr].c[GetSymb(S[i])];
 end;
 d[curr]:=1;
end;

begin
 n:=length(S);
 if n>maxn then begin
  writeln('-1');
  halt;
 end;
 count:=1;
 for i:=1 to n do
  Insert(copy(S,i,length(S)-i+1));
end;

procedure DFS(v:integer);
var
 i:integer;
begin
 for i:=1 to 26 do
  if Tree[v].c[i]<>0 then begin
    DFS(Tree[v].c[i]);
    inc(d[v], d[Tree[v].c[i]]);
  end;
end;

function RandomRange(L,R:integer):integer;
begin
 result:=L+Random(R-L);
end;

procedure QSort(L,R:integer);
var
 i,j,k,c:integer;
begin
 i:=L; j:=R; k:=d[RandomRange(L,R)];
 repeat
  while d[i]<k do inc(i);
  while d[j]>k do dec(j);
  if i<=j then begin
   c:=d[i]; d[i]:=d[j]; d[j]:=c;
   inc(i); dec(j);
  end;
 until i>j;
 if i<R then QSort(i,R);
 if L<j then QSort(L,j);
end;

begin
 readln(k);
 readln(S);
 S:=Trim(S);
 fillchar(D, sizeof(d),0);
 MakeTree(S);
 if k>count-1 then begin
  writeln('-1');
  halt;
 end;
 DFS(1);
 QSort(1, count);
 res:=0;
 for i:=count-1 downto count-k do inc(res, d[i]);
 writeln(res);
end.
