{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-,O-,H+}

const
 StreamIn='';
 StreamOut='';
 Alph:set of char=['a'..'z'];
 SSimb='$';
 Root=1;
 NMAX=510000;
 INFVAL=-1;

type
 integer=longint;
 IntList=array of integer;
 ChrList=array of char;
 Node=record
   Edge:IntList;
   Mark:ChrList;
   Prev,Depth,SufLink,L,R:integer
  end;
 SuffixTree=array [0..NMAX] of Node;
 IntVect=array [0..NMAX] of integer;

var Str:string;
    SufTree:SuffixTree;
    Val,Count,Dpt:IntVect;
    k,Ans:int64;
    m:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var Ch:char;
begin
 readln(k);
 Str:='';
 while not seekeoln do begin
   read(Ch);
   if Ch in Alph then Str:=Str+Ch
  end
end;

function FindSimb(const Elem:Node; const Ch:char):integer;
var i:integer;
begin
 Result:=INFVAL;
 if length(Elem.Mark)>0 then
  for i:=0 to High(Elem.Mark) do
   if Elem.Mark[i]=Ch then begin
     Result:=i;
     Exit
    end
end;

procedure AddEdge(var Elem:Node; const Ch:char; const Vert:integer);
begin
 setlength(Elem.Edge,length(Elem.Edge)+1);
 setlength(Elem.Mark,length(Elem.Mark)+1);
 Elem.Edge[High(Elem.Edge)]:=Vert;
 Elem.Mark[High(Elem.Mark)]:=Ch
end;

procedure MakeSuffixTree(const S:string);
var i,j,VNum,Last,Shift,Temp,Done,NewDone,Expect,NewExpect,Cur:integer;
    ThirdRule:boolean;
begin
 VNum:=1;
 ThirdRule:=False;
 Last:=Root;
 Done:=0;
 for i:=1 to length(S) do begin
   NewDone:=Done;
   if not ThirdRule then Cur:=Last;
   Expect:=INFVAL;
   for j:=Done+1 to i do begin
     if not ThirdRule then begin
       while (Cur<>Root) and (SufTree[Cur].SufLink=INFVAL) do
        Cur:=SufTree[Cur].Prev;
       if Cur<>Root then Cur:=SufTree[Cur].SufLink
      end;
     NewExpect:=INFVAL;
     Shift:=SufTree[Cur].Depth;
     while Shift<(i-j) do begin
       Cur:=SufTree[Cur].Edge[FindSimb(SufTree[Cur],S[Shift+j])];
       Shift:=SufTree[Cur].Depth
      end;
     if Shift>(i-j) then begin
       dec(Shift,SufTree[Cur].R-SufTree[Cur].L+1);
       if S[SufTree[Cur].L+i-j-Shift]=S[i] then begin
         ThirdRule:=True;
         Break
        end;
       Temp:=SufTree[Cur].Prev;
       inc(VNum);
       with SufTree[VNum] do begin
         Prev:=Temp;
         L:=SufTree[Cur].L;
         R:=L+i-j-Shift-1;
         Depth:=SufTree[Temp].Depth+R-L+1;
         SufLink:=INFVAL
        end;
       AddEdge(SufTree[VNum],S[SufTree[VNum].R+1],Cur);
       SufTree[Temp].Edge[FindSimb(SufTree[Temp],S[SufTree[Cur].L])]:=VNum;
       with SufTree[Cur] do begin
         Prev:=VNum;
         L:=SufTree[VNum].R+1
        end;
       Cur:=VNum;
       NewExpect:=Cur
      end
     else
      if FindSimb(SufTree[Cur],S[i])<>INFVAL then begin
        ThirdRule:=True;
        Break
       end;
     if Expect<>INFVAL then SufTree[Expect].SufLink:=Cur;
     Expect:=NewExpect;
     inc(VNum);
     with SufTree[VNum] do begin
       Prev:=Cur;
       L:=i;
       R:=length(S);
       Depth:=SufTree[Cur].Depth+R-L+1;
       SufLink:=INFVAL
      end;
     Last:=VNum;
     AddEdge(SufTree[Cur],S[i],VNum);
     ThirdRule:=False;
     inc(NewDone)
    end;
   Done:=NewDone
  end
end;

procedure DFS(Vert,Prev:integer);
var i:integer;
begin
 if length(SufTree[Vert].Edge)>0 then begin
   Dpt[Vert]:=0;
   for i:=0 to High(SufTree[Vert].Edge) do begin
     DFS(SufTree[Vert].Edge[i],Vert);
     inc(Dpt[Vert],Dpt[SufTree[Vert].Edge[i]])
    end
  end
 else Dpt[Vert]:=1;
 if Vert<>Root then begin
   inc(m);
   Val[m]:=Dpt[Vert];
   if Dpt[Vert]=1 then
    Count[m]:=SufTree[Vert].R-SufTree[Vert].L
   else
    Count[m]:=SufTree[Vert].R-SufTree[Vert].L+1
  end
end;

procedure IntSwap(var a,b:integer);
var q:integer;
begin
 q:=a;
 a:=b;
 b:=q
end;

procedure QSort(l,r:integer);
var i,j,q:integer;
begin
 i:=l;
 j:=r;
 q:=Val[l+random(r-l+1)];
 repeat
  while Val[i]>q do inc(i);
  while Val[j]<q do dec(j);
  if i<=j then begin
    IntSwap(Val[i],Val[j]);
    IntSwap(Count[i],Count[j]);
    inc(i);
    dec(j)
   end
 until i>j;
 if i<r then QSort(i,r);
 if l<j then QSort(l,j)
end;

function Min(a,b:int64):int64;
begin
 if a<b then Result:=a
 else Result:=b
end;

procedure SolveAndSave;
var i:integer;
begin
 MakeSuffixTree(Str+SSimb);
 fillchar(Val,sizeof(Val),0);
 m:=0;
 DFS(Root,Root);
 randomize;
 if m>0 then QSort(1,m);
 i:=1;
 Ans:=0;
 while (k>0) and (i<=m) do begin
   Ans:=Ans+int64(Val[i])*Min(k,int64(Count[i]));
   dec(k,Min(k,int64(Count[i])));
   inc(i)
  end;
 if k>0 then writeln(INFVAL)
 else writeln(Ans)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
