#include <algorithm>
#include <cassert>
#include <cstdio>
#include <cstring>
#include <functional>
#include <set>
#include <utility>
#include <vector>

using namespace std;

typedef pair<int, int> ii;
typedef vector<ii> vii;

#define mp make_pair
#define pb push_back

int _stklen = 50 << 20;

#define MAXN 250010

long long k;
char s[MAXN];
int n, bound, slen;
int cnt[27], sum[27];
int a[2][MAXN], b[2][MAXN], c[2][MAXN], lcp[2][525000];
int l[MAXN], left[MAXN], right[MAXN], stack[MAXN];
set<ii> was;
vii data;

void update(int *a, int x, int y)
{
	x += bound - 1;
	a[x] = y;
	for (;;)
	{
		x = (x - 1) >> 1;
		a[x] = a[2 * x + 1] <? a[2 * x + 2];
		if (!x) return;
	}
}

int get_lcp(int x, int y, int *b, int *l)
{
	x = b[x];
	y = b[y];
	if (x > y)
	{
		int t = x;
		x = y;
		y = t;
	}
	if (x == y) return 987654321;
	y--;
	x += bound - 1;
	y += bound - 1;
	int ans = 987654321;
	while (x < y)
	{
		if (x % 2 == 0) ans <?= l[x], x++;
		if (y % 2 == 1) ans <?= l[y], y--;
		x = (x - 1) >> 1;
		y = (y - 1) >> 1;
	}
	if (x == y) ans <?= l[x];
	return ans;
}

void make_step(int h, int *a, int *b, int *c, int *l, int *a1, int *b1, int *c1, int *l1)
{
	for (int i = 0; i < n; i++) if (c[i] == i) c1[i] = i;
	for (int i = 0; i < n; i++)
	{
		a[i] = (a[i] - h + 2 * n) % n;
		a1[c1[c[b[a[i]]]]++] = a[i];
	}
	for (int i = 0; i < n; i++) b1[a1[i]] = i;
	for (int i = 0; i < n; i++)
	{
		if (!i || c[b[a1[i]]] != c[b[a1[i - 1]]] ||
		    c[b[(a1[i] + h) % n]] != c[b[(a1[i - 1] + h) % n]]) c1[i] = i;
		else c1[i] = c1[i - 1];
	}
	memset(l1, 0, sizeof(l1));
	for (int i = 0; i < n - 1; i++)
	{
		if (c1[i] == c1[i + 1]) update(l1, i, 2 * h);
		else if (c[b[a1[i]]] != c[b[a1[i + 1]]])
			update(l1, i, get_lcp(a1[i], a1[i + 1], b, l));
		else update(l1, i, h + get_lcp((a1[i] + h) % n, (a1[i + 1] + h) % n, b, l));
	}
}

int main()
{
	/*
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
        */
	scanf("%Ld%s", &k, s);
	n = strlen(s);
	s[n++] = '`';
	memset(cnt, 0, sizeof(cnt));
	for (int i = 0; i < n; i++)
	{
		s[i] -= '`';
		cnt[s[i]]++;
	}
	sum[0] = 0;
	for (int i = 1; i < 27; i++)
		sum[i] = sum[i - 1] + cnt[i - 1];	
	for (int i = 0; i < n; i++) a[0][sum[s[i]]++] = i;
	for (int i = 0; i < n; i++) b[0][a[0][i]] = i;
	for (int i = 0; i < n; i++)
	{
		if (!i || s[a[0][i]] != s[a[0][i - 1]]) c[0][i] = i;
		else c[0][i] = c[0][i - 1];
	}
	bound = n;
	while (bound & (bound - 1)) bound++;
	memset(lcp[0], 0, sizeof(lcp));
	for (int i = 0; i < n - 1; i++)
		if (c[0][i] == c[0][i + 1]) update(lcp[0], i, 1);
	int h = 1, temp = 0;
	while (h < n)
	{
		make_step(h, a[temp], b[temp], c[temp], lcp[temp], a[1 - temp], b[1 - temp], c[1 - temp], lcp[1 - temp]);
		h *= 2;
		temp = 1 - temp;
	}
	for (int i = 0; i < n - 1; i++) l[i] = get_lcp(a[temp][i], a[temp][i + 1], b[temp], lcp[temp]);
	long long amount = 0;
	for (int i = 0; i < n; i++)
	{
		amount += n - a[temp][i];
		if (i) amount -= l[i - 1];
	}
	amount -= n;
	if (k > amount)
	{
		printf("-1\n");
		return 0;
	}
	l[n - 1] = 0;
	slen = 1;
	stack[0] = 0;
	for (int i = 1; i < n; i++)
	{
		while (slen && l[stack[slen - 1]] > l[i]) right[stack[--slen]] = i;
		stack[slen++] = i;
	}
	slen = 1;
	stack[0] = n - 1;
	for (int i = n - 2; i >= 0; i--)
	{
		while (slen && l[stack[slen - 1]] > l[i]) left[stack[--slen]] = i;
		stack[slen++] = i;
	}
	for (int i = 1; i < n - 1; i++)
	{
		if (!l[i]) continue;
		int j = left[i], k = right[i];
		j++;
		if (was.count(mp(j, k))) continue;
		int p = (l[j - 1] >? l[k]) + 1;
		int q = l[i];
		data.pb(mp(k - j + 1, q - p + 1));
		was.insert(mp(j, k));
	}
	sort(data.begin(), data.end(), greater<ii>());
	long long ans = 0;
	for (int i = 0; i < data.size(); i++)
	{
		long long dk = (data[i].second <? k);
		k -= dk;
		ans += dk * data[i].first;
	}
	ans += k;
	printf("%Ld\n", ans);
	return 0;
}
