#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#define MAXN 26
using namespace std;
#define eps 1e-6

double fabs(double a){
	if (a < 0)
		return -a;
	return a;
}

struct point{
	double x, y;
	bool friend operator ==(point a, point b){
		return (fabs(a.x - b.x) < eps) && (fabs(a.y - b.y) < eps);
	}

	bool friend operator <(point a, point b){
		return ((a.x < b.x) || ((a.x == b.x) && (a.y < b.y)));
	}
};

vector<point> P;

struct TR{//᪮
	vector<bool> p;           //ਭ  १
	vector<vector<bool> > seg;//ਭ  窠
	bool friend operator ==(TR a, TR b){
		for (int i = 0; i < P.size(); i++)
			if (a.p[i] != b.p[i]){                              
//				printf("!= because a.p[%d] != b.p[%d]\n", i, i);
				return false;
			}
	    for (int i = 0; i < P.size(); i++)
	    	for (int j = 0; j < P.size(); j++)
	    		if (a.seg[i][j] != b.seg[i][j]){
//					printf("!= because a.seg[%d][%d] != b.seg[%d][%d]\n", i, j, i, j);
	    			return false;
	    		}
	    return true;
	}
};

struct TSeg{
	point a, b;
	TSeg(){}
	TSeg(point aa, point bb){
		a = aa;
		b = bb;
	}
};

struct line{
	double a, b, c;
	line(){}
	line(TSeg s){
		a = s.a.y - s.b.y;
		b = s.b.x - s.a.x;
		c = -(s.a.x * a + s.a.y * b);
	}
};

point make_vector(point a, point b){	
	point rez;
	rez.x = b.x - a.x;
	rez.y = b.y - a.y;
	return rez;
}

double vp(point a, point b){
	return a.x * b.y - a.y * b.x;
}

double sp(point a, point b){
	return a.x * b.x + a.y * b.y;
}

bool pointinseg(point p, TSeg s){
	return ((p == s.a) || (p == s.b)) || ((fabs(vp(make_vector(p, s.a), make_vector(p, s.b))) < eps) && (sp(make_vector(p, s.a), make_vector(p, s.b)) < 0));
}

point intersectlines(line a, line b){
//	printf("%.3lfx+%.3lfy+%.3lf=0 Vs %.3lfx+%.3lfy+%.3lf=0\n");
	point rez;
	if (fabs(a.b * b.a - a.a * b.b) < eps){
		rez.x = 0;
		rez.y = 0;
	}
	else{
		rez.x = (a.c * b.b - a.b * b.c) / (a.b * b.a - a.a * b.b);
		rez.y = -(a.c * b.a - a.a * b.c) / (a.b * b.a - a.a * b.b);
	}
	return rez;
}

point intersectseg(TSeg a, TSeg b){
	return intersectlines(line(a), line(b));	
}

#define MAXL 26
TSeg s[MAXL];
set<point> points;
TR otr[MAXL];

bool init(){
	char c;
	while (1){
		scanf("%c", &c);
		if (c == '-'){
			while (c == '-')
				scanf("%c", &c);
			for (int i = 0; i < MAXL; i++)
				for (int j = 0; j < MAXL; j++)
					points.insert(intersectseg(s[i], s[j]));
			return false;
		}
		point a, b;      
		scanf("%lf%lf%lf%lf\n", &a.x, &a.y, &b.x, &b.y);
		points.insert(a);
		points.insert(b);
		s[c - 'A'] = TSeg(a, b);
	}                                               
}
                

void presolve(){
	for (int o = 0; o < MAXL; o++){
		for (int i = 0; i < P.size(); i++)
			otr[o].p.push_back(pointinseg(P[i], s[o]));
		for (int i = 0; i < P.size(); i++){
			vector<bool> tmp;
			tmp.clear();
			for (int j = 0; j < P.size(); j++)
				if (pointinseg(P[i], s[o]) && pointinseg(P[j], s[o])){
					bool cool = true;
					for (int k = 0; k < P.size(); k++)
						if (pointinseg(P[k], TSeg(P[i], P[j]))){
							cool = false;
							break;
						}
					tmp.push_back(cool);
				}
				else
					tmp.push_back(false);
		    otr[o].seg.push_back(tmp);
		}
	}
}

string zapros;

int xxor(bool a, bool b){
	if (a & (!b))
		return true;
	if (b & (!a))
		return true;
	return false;
}

TR GetAns(int l, int r){                      
	if (l == r)
		return otr[zapros[l] - 'A'];
	int g = 0;
	int best = -1;
	for (int i = l; i <= r; i++){
		if (zapros[i] == '(')
			g++;
		if (zapros[i] == ')')
			g--;
		if (g == 0){
			if ((best == -1) && ((zapros[i] == '^') || (zapros[i] == '&') || (zapros[i] == '+')))
				best = i;
			if ((zapros[best] != '^') && (zapros[i] == '^'))
				best = i;
			if ((zapros[i] == '+') && (zapros[best] == '&'))
				best = i;
		}
	}
//	printf("From %d to %d(%d)\n", l, r, best);
	if (best == -1)
		return GetAns(l + 1, r - 1);
    else{
    	TR ll, rr;
    	ll = GetAns(l, best - 1);
    	rr = GetAns(best + 1, r);
    	if (zapros[best] == '&'){
    		for (int i = 0; i < P.size(); i++)
    			ll.p[i] = ll.p[i] && rr.p[i];
    		for (int i = 0; i < P.size(); i++)
    			for (int j = 0; j < P.size(); j++)
    				ll.seg[i][j] = ll.seg[i][j] && rr.seg[i][j]; 
    	    return ll;
    	}

    	if (zapros[best] == '+'){
    		for (int i = 0; i < P.size(); i++)
    			ll.p[i] = ll.p[i] || rr.p[i];
    		for (int i = 0; i < P.size(); i++)
    			for (int j = 0; j < P.size(); j++)
    				ll.seg[i][j] = ll.seg[i][j] || rr.seg[i][j]; 
    	    return ll;
    	}

    	if (zapros[best] == '^'){
    		for (int i = 0; i < P.size(); i++)
    			ll.p[i] = xxor(ll.p[i], rr.p[i]);
    		for (int i = 0; i < P.size(); i++)
    			for (int j = 0; j < P.size(); j++)
    				ll.seg[i][j] = xxor(ll.seg[i][j], rr.seg[i][j]); 
    	    return ll;
    	}
    }
}


bool solve(){     
	if ((cin >> zapros) == false)
		return false;
//	cout << zapros << "\n";
	char c;
	for (int i = 0; i < zapros.size(); i++)
		if (zapros[i] == '='){
//			printf("%d\n\n", i);
			if (GetAns(0, i - 1) == GetAns(i + 1, zapros.size() - 1))
				printf("da\n");
			else
				printf("ne\n");
		}            
//	if (scanf("%c", &c) == EOF)
//		return false;
	return true;
}

int main(){
//	freopen("input.txt", "rt", stdin);
	init();
	for (set<point>::iterator tmp = points.begin(); tmp != points.end(); tmp++)
		P.push_back(*tmp);
    presolve();
    while (solve());
//	printf("ne\nda\nne\n");
}
    
