{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}


const
 StreamIn='';
 StreamOut='';
 NMAX=110;

type
 integer=longint;
 IntVect=array [0..NMAX] of integer;

var a,b,sol,num,order:IntVect;
    n,k:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure LoadData;
var i:integer;
begin
 read(n,k);
 for i:=1 to k do read(a[i]);
 for i:=1 to n do read(b[i])
end;

procedure Estimate(cur:integer);
var i,j,v,tmp1,tmp2:integer;
begin
 if cur>k then begin
   writeln('YES');
   for i:=1 to k do write(sol[i],' ');
   halt(0)
  end
 else begin
   i:=1;
   while (i<=n) and (a[cur]>b[i]) do inc(i);
   while i<=n do begin
     dec(b[i],a[cur]);
     j:=i-1;
     while (j>0) and (b[j]>b[i]) do dec(j);
     inc(j);
     tmp1:=b[i];
     tmp2:=num[i];
     for v:=i-1 downto j do begin
       b[v+1]:=b[v];
       num[v+1]:=num[v]
      end;
     b[j]:=tmp1;
     num[j]:=tmp2;
     sol[order[cur]]:=tmp2;
     Estimate(cur+1);
     for v:=j+1 to i do begin
       b[v-1]:=b[v];
       num[v-1]:=num[v]
      end;
     b[i]:=tmp1+a[cur];
     num[i]:=tmp2;
     inc(i)
    end
  end
end;

procedure SolveAndSave;
var i,j,m,tmp1,tmp2:integer;
begin
 for i:=1 to k do order[i]:=i;
 for i:=1 to k-1 do
  for j:=i+1 to k do
   if a[i]<a[j] then begin
     tmp1:=a[i];
     a[i]:=a[j];
     a[j]:=tmp1;
     tmp1:=order[i];
     order[i]:=order[j];
     order[j]:=tmp1
    end;
 m:=0;
 for i:=1 to n do num[i]:=i;
 for i:=1 to n do
  if b[i]>=a[k] then begin
    inc(m);
    b[m]:=b[i];
    num[m]:=num[i]
   end;
 n:=m;
 for i:=1 to n-1 do
  for j:=i+1 to n do
   if b[i]>b[j] then begin
     tmp1:=b[i];
     b[i]:=b[j];
     b[j]:=tmp1;
     tmp1:=num[i];
     num[i]:=num[j];
     num[j]:=tmp1
    end;
 tmp1:=0;
 tmp2:=0;
 for i:=1 to n do inc(tmp1,b[i]);
 for i:=1 to k do inc(tmp2,a[i]);
 if tmp2>tmp1 then writeln('NO')
 else Estimate(1);
 writeln('NO')
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
