program taskb;

{$MODE DELPHI}
//{$Q-,R-,S-,I-,D-,L-}
//{$M 16000000}

uses
  Math;

const
  MAXN  = 524287;
  SHIFT = MAXN div 2;
  INF   = MaxLongInt;

type
  TArr = array [0..MAXN] of Integer;

var
  n: Integer;
  s: String;
  pos, inv, col: array [Boolean] of TArr;
  count, rel, tmp: TArr;
  q, w: TArr;

procedure update(k, val: Integer);
begin
  w[k] := val;
  inc(k, SHIFT);
  q[k] := val;
  while k > 1 do
    begin
      k := k shr 1;
      q[k] := min(q[k shl 1], q[k shl 1 + 1]);
    end;
end;

function getmin(l, r: Integer): Integer;
begin
  inc(l, SHIFT);
  inc(r, SHIFT);
  Result := q[l];
  while l <= r do
    begin
      Result := min(Result, q[l]);
      Result := min(Result, q[r]);
      l := (l + 1) shr 1;
      r := (r - 1) shr 1;
    end;
end;

function lcp(const inv: TArr; i, j: Integer) : Integer;
var
  l, r: integer;
begin
  l := inv[i];
  r := inv[j];
  if l < r then
    Result := getmin(l, r-1)
  else
    if l > r then
      Result := getmin(r, l-1)
    else
      Result := n - i;
end;

procedure InitSteps(var pos, inv, col : TArr);
var
  count, rel: array [Char] of Integer;
  i: Integer;
  j: Char;
begin
  fillchar(count, sizeof(count), 0);
  fillchar(rel, sizeof(rel), 0);
  for i := 1 to n do
    inc(count[s[i]]);
  rel[#0] := 1;
  for j := #1 to #255 do
    rel[j] := rel[pred(j)] + count[pred(j)];
  for i := 1 to n do
    begin
      pos[rel[s[i]]] := i;
      inc(rel[s[i]]);
    end;
  col[1] := 1;
  for i := 2 to n do
      if s[pos[i]] = s[pos[i-1]] then
          col[i] := col[i-1]
      else
          col[i] := col[i-1] + 1;
  for i := 1 to n do
      inv[pos[i]] := i;

  for i := 1 to MAXN do
    begin
      q[i] := INF;
      w[i] := INF;
    end;

  for i := 1 to n - 1 do
    if col[i] <> col[i+1] then
      update(i, 0);
end;

procedure MakeStep(h : Integer; var pos1, inv1, col1, pos2, inv2, col2 : TArr);
var
  i, j: Integer;
begin
  for i := 1 to n do
    dec(pos1[i], h);
  j := n;
  for i := n downto 1 do
    if pos1[i] > 0 then
      begin
        pos1[j] := pos1[i];
        dec(j);
      end;
  for i := 1 to h do
    pos1[i] := n - h + i;

  for j := 1 to n do
    tmp[j] := col1[inv1[j]];

//  fillchar(count, sizeof(count), 0);
  fillchar(count[1], sizeof(Integer) * n, 0);

  for i := 1 to n do
    inc(count[tmp[pos1[i]]]);

  rel[1] := 1;
  for i := 2 to n do
    rel[i] := rel[i-1] + count[i-1];

  for i := 1 to n do
    begin
      pos2[rel[tmp[pos1[i]]]] := pos1[i];
      inc(rel[tmp[pos1[i]]]);
    end;

  for i := 1 to n do
    inv2[pos2[i]] := i;

  col2[1] := 1;
  for i := 2 to n do
    if (col1[inv1[pos2[i]]] = col1[inv1[pos2[i-1]]]) and
       (col1[inv1[pos2[i]+h]] = col1[inv1[pos2[i-1] + h]]) then
      col2[i] := col2[i-1]
    else
      col2[i] := col2[i-1] + 1;

  for i := 1 to n-1 do
    if (w[i] = INF) and (col2[i] <> col2[i+1]) then
      update(i, h + lcp(inv2, pos2[i] + h, pos2[i+1] + h));
end;

var
  h, i, c, u, l, r, x, j, t, d: Integer;
  f: Boolean;
  k, ans: Int64;
  hl, hr, hh, head, next: TArr;

begin
  //Assign(input, 'stdin');
  //Reset(input);

  //ReadLn(k);
  //ReadLn(s);

  SetLength(s, 250000);
  k := 31250125000;
  for i := 1 to 150000 do
    s[i] := chr(Random(26) + ord('a'));

  s := s + '$';
  n := length(s);

  fillchar(col, sizeof(col), 0);
  fillchar(inv, sizeof(inv), 0);
  fillchar(pos, sizeof(pos), 0);
  f := false;
  h := 1;
  InitSteps(pos[f], inv[f], col[f]);

  while h < length(s) do
    begin
      MakeStep(h, pos[f], inv[f], col[f], pos[not f], inv[not f], col[not f]);
      f := not f;
      h := h * 2;
    end;

  c := 1;
  hl[1] := 2;
  hr[1] := n;
  hh[1] := 0;
  fillchar(head, sizeof(head), 0);
  head[n] := 1;
  next[1] := 0;
  ans := 0;

  for i := n downto 1 do
    begin
      u := head[i];
      while u > 0 do
        begin
          t := lcp(inv[f], pos[f,hl[u]], pos[f,hr[u]]) - hh[u];
          if k <= t then
            begin
              inc(ans, Int64(hr[u] - hl[u] + 1) * k);
              Write(ans);
              halt(0);
            end
          else
            begin
              inc(ans, Int64(hr[u] - hl[u] + 1) * t);
              dec(k, t);
            end;

          inc(t, hh[u]);
          j := hl[u];
          while j <= hr[u] do
            begin
              if pos[f,j] + t >= n then
                inc(j);
              if j > hr[u] then
                break;

              l := j; r := hr[u];
              while l < r do
                begin
                  x := (l + r + 1) shr 1;
                  if s[pos[f,x]+t] = s[pos[f,j]+t] then
                    l := x
                  else
                    r := x-1;
                end;

              inc(c);
              hl[c] := j;
              hr[c] := r;
              hh[c] := t;
              d := r - j + 1;
              next[c] := head[d];
              head[d] := c;
              j := r + 1;
            end;

          u := next[u];
        end;
    end;

  if k > 0 then
    Write(-1)
  else
    Write(ans);
end.
