#include <stdio.h>
#include <string.h>

#include <stdlib.h>

#include <algorithm>
using namespace std;

const int maxn = 262144;
char str[maxn];
const int inf = maxn + maxn + 5;
int LEN;

struct node
{
public:
  node* p;
  node* c[7];
  node* suf;
  int a, b, d;
  node* next;
  int _i;

  node* get_child (int ch)
  {
    node* cur = c[ch / 4];
    char src = ch + 'a';
    while (cur)
    {
      if (str[cur->a] == src)
        return cur;
      cur = cur->next;
    }
    return NULL;
  }
  void set_child (node* n)
  {
    int ch = (str[n->a] - 'a') / 4;
    node* cur = c[ch];
    node* prev = NULL;
    char src = str[n->a];
    while (cur)
    {
      if (str[cur->a] == src)
      {
        if (prev)
          prev->next = n;
        else
          c[ch] = n;
        n->next = cur->next;
        return;
      }
      prev = cur;
      cur = cur->next;
    }
    n->next = c[ch];
    c[ch] = n;
  }           

  node* split (int o);
  node* add_child (int _a, int _b);
  node* trace (int _a, int _b, int& o);

  node* trace (char const* buf, int& o);
};
node nodea[maxn * 2 + 6];
int nnodea = 0;
inline node* nalloc ()
{
  nodea[nnodea]._i = nnodea;
  return &nodea[nnodea++];
}

node* node::split (int o)
{
  if (o == 0) return this;
  node* n = nalloc ();
  n->a = a;
  n->b = b - o;
  if (p) p->set_child (n);
  a = n->b;
  n->d = d - o;
  n->p = p;
  p = n;
  n->set_child (this);
  return n;
}

node* node::add_child (int _a, int _b)
{
  node* n = nalloc ();
  n->p = this;
  n->a = _a, n->b = _b;
  n->d = d + _b - _a;
  set_child (n);
  return n;
}

node* node::trace (int _a, int _b, int& o)
{
  node* cur = this;
  while (true)
  {
    int len = _b - _a;
    node* n = cur->get_child (str[_a] - 'a');
    int nl = n->b - n->a;
    if (nl >= len)
    {
      o = nl - len;
      return n;
    }
    else
      _a += nl, cur = n;
  }
  return NULL;
}

node* root;
node* last;
int lo, li, cnt;
int total;

void u_init ()
{
  total = (int) strlen (str);
  root = nalloc ();
  root->suf = root;
  last = root;
  lo = li = cnt = 0;
}

bool trace_char (node* n, int tp, int& p)
{
  node* ch = n->get_child (str[tp] - 'a');
  if ((p == 0 && ch) || (p > 0 && str[n->b - p] == str[tp]))
  {
    last = n;
    if (p == 0)
      last = ch,
      p = last->b - last->a - 1;
    else
      p--;
    return true;
  }
  else
  {
    if (p == 0)
      last = n->add_child (tp, inf),
      p = last->b - last->a - 1;
    else
      last = n->split (p)->add_child (tp, inf),
      p = last->b - last->a - 1;
    return false;
  }
}

void u_add_char (char c)
{
  cnt++;
  if (trace_char (last, cnt - 1, lo))
    return;
  li++;
  while (li < cnt)
  {
    node* n = last->p;
    if (n->p == NULL)
    {
      int p;
      node* nd = n->trace (li, cnt - 1, p);
      if (trace_char (nd, cnt - 1, lo = p))
        return;
    }
    else
    {
      node* v = n->p;
      node* zn;
      int zp;
      if (v->p == NULL)
      {
        if (n->a + 1 != n->b)
          zn = v->trace (n->a + 1, n->b, zp);
        else
          zn = v, zp = 0;
      }
      else
        zn = v->suf->trace (n->a - v->d + v->suf->d + 1, n->b, zp);
      if (zp > 0)
        n->suf = zn->p;
      else
        n->suf = zn;
      if (trace_char (zn, cnt - 1, lo = zp))
        return;
      if (zp > 0)
        n->suf = zn->p;
      else
        n->suf = zn;
    }
    li++;
  }
  last = root;
  lo = 0;
}

struct block
{
  __int64 len;
  __int64 p;
};
inline bool operator < (block const& a, block const& b)
{
  return a.p > b.p;
}
block bls[maxn + maxn + 6];
int nbl = 0;

int dfs1 (node* n)
{
  int occ = 0;
  int kids = 0;
  for (int i = 0; i < 7; i++)
  {
    node* cur = n->c[i];
    while (cur)
    {
      kids++;
      occ += dfs1 (cur);
      cur = cur->next;
    }
  }
  if (kids == 0) occ = 1;

  int _b = n->b;
  if (_b > LEN - 1) _b = LEN - 1;
  bls[nbl].len = _b - n->a;
  bls[nbl].p = occ;
  nbl++;

  return occ;
}

int main ()
{
#ifdef _LOCAL_
  freopen ("prize.in", "rt", stdin);
  freopen ("prize.out", "wt", stdout);
#endif

  __int64 k;
  scanf ("%I64d %s", &k, str);
  LEN = (int) strlen (str);
  str[LEN] = 'z' + 1;
  str[++LEN] = 0;
  memset (nodea, 0, sizeof nodea);
  u_init ();
  for (int i = 0; str[i]; i++)
    u_add_char (str[i]);
  dfs1 (root);
  sort (bls, bls + nbl);

  __int64 sum = 0;
  for (int i = 0; i < nbl && k > 0; i++)
  {
    if (k >= bls[i].len)
      k -= bls[i].len, sum += bls[i].len * bls[i].p;
    else
      sum += k * bls[i].p, k = 0;
  }
  if (k)
    printf ("-1");
  else
    printf ("%I64d", sum);

  return 0;
}
