{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 3001;
    LOG = 11;
type
    int = longint;
var
    s: string;
    a: array [0..LOG, 1..NMAX] of int;
    p1, p2, o: array [1..NMAX] of int;
    u1, u2, res: array [0..4500000] of int;
    ans, n, m, k: int;

function less(l1, d1, l2, d2: int): boolean;
var
    i, lg, d: int;
begin
    lg := LOG;
    while (d1 > 0) and (d2 > 0) do begin
        d := min(d1, d2);
        for i := lg downto 0 do
            if 1 shl i <= d then begin
                lg := i;
                break;
            end;
        if a[lg, l1] > a[lg, l2] then begin
            result := false;
            exit;
        end;
        if a[lg, l1] < a[lg, l2] then begin
            result := true;
            exit;
        end;
        inc(l1, 1 shl lg);
        dec(d1, 1 shl lg);
        inc(l2, 1 shl lg);
        dec(d2, 1 shl lg);
    end;
    if d2 > 0 then result := true
        else result := false;
end;

procedure swap(var a, b: int);
var
    c: int;
begin
    c := a;
    a := b;
    b := c;
end;

procedure qsort(l, r: int);
var
    i, j, x1, x2: int;
begin
    i := l;
    j := r;
    x1 := p1[(l + r) div 2];
    x2 := p2[(l + r) div 2];
    while i <= j do begin
        while (p1[i] < x1) or ((p1[i] = x1) and (p2[i] < x2)) do
            inc(i);
        while (p1[j] > x1) or ((p1[j] = x1) and (p2[j] > x2)) do
            dec(j);
        if i <= j then begin
            swap(o[i], o[j]);
            swap(p1[i], p1[j]);
            swap(p2[i], p2[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort(i, r);
    if l < j then qsort(l, j);
end;

procedure qsort3(l, r: int);
var
    i, j, x: int;
begin
    i := l;
    j := r;
    x := res[(l + r) div 2];
    while i <= j do begin
        while res[i] > x do
            inc(i);
        while res[j] < x do
            dec(j);
        if i <= j then begin
            swap(res[i], res[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort3(i, r);
    if l < j then qsort3(l, j);
end;

procedure qsort2(l, r: int);
var
    i, j, x1, x2: int;
begin
    i := l;
    j := r;
    x1 := u1[(l + r) div 2];
    x2 := u2[(l + r) div 2];
    while i <= j do begin
        while less(u1[i], u2[i], x1, x2) do
            inc(i);
        while less(x1, x2, u1[j], u2[j]) do
            dec(j);
        if i <= j then begin
            swap(u1[i], u1[j]);
            swap(u2[i], u2[j]);
            inc(i);
            dec(j);
        end;
    end;
    if i < r then qsort2(i, r);
    if l < j then qsort2(l, j);
end;

var
    i, j, dl, now: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    readln(k);
    readln(s);
    n := length(s);
    if n > NMAX then begin
        writeln(-1);
        exit;
    end;

    for i := 1 to n do
        a[0, i] := ord(s[i]);
    for i := 1 to LOG do begin
        dl := 1 shl i;
        m := 0;
        for j := 1 to n - dl + 1 do begin
            inc(m);
            p1[m] := a[i - 1, j];
            p2[m] := a[i - 1, j + (dl shr 1)];
            o[m] := j;
        end;
        if m > 1 then qsort(1, m);
        now := 0;
        for j := 1 to m do begin
            if (j = 1) or (p1[j] <> p1[j - 1]) or (p2[j] <> p2[j - 1]) then
                inc(now);
            a[i, o[j]] := now;
        end;
    end;

    m := 0;
    for i := 1 to n do
        for j := 1 to n - i + 1 do begin
            inc(m);
            u1[m] := i;
            u2[m] := j;
        end;

    qsort2(1, m);
    n := 0;
    for i := 1 to m do
        if (i = 1) or (less(u1[i], u2[i], u1[i - 1], u2[i - 1]) or
            less(u1[i - 1], u2[i - 1], u1[i], u2[i])) then begin
            inc(n);
            res[n] := 1;
        end
        else
            inc(res[n]);

    qsort3(1, n);
    ans := 0;
    for i := 1 to min(n, k) do
        inc(ans, res[i]);
    if n >= k then
        writeln(ans)
    else
        writeln(-1);
end.