Program prg;

{$H+}

type
  integer = longint;

const
  taskname = 'discount';

  inf = 1000000000;
  eps = 1e-7;

  maxw = 3000000000.0;

var
  n, m: integer;

  i, j, k: integer;

  dis: extended;
  s, t: integer;

  a, b: array[0..3001] of integer;
  w, wd: array[0..3001] of extended;
  d: array[0..3001] of extended;

  l, r, now1, now2: extended;
  tmp: extended;

  bests, bestw: extended;
  bestprev: array[0..3010] of integer;

  res1, res2: extended;
  s1, s2, w1, w2: extended;

  prev1, prev2: array[0..3010] of integer;

  path: array[0..3010] of integer;

  v: integer;

begin
  assign(input, taskname + '.in');
  assign(output, taskname + '.out');
  reset(input);
  rewrite(output);

  read(n, m);
  for i := 1 to m do begin
    read(a[i], b[i], wd[i]);
  end;
  read(s, t);
  read(dis);

  l := 0.0;
  r := maxw;

  bests := maxw;
  bestw := maxw;

  while (r - l) > eps do begin
    now1 := l * 2 / 3 + r / 3;
    now2 := l / 3 + r * 2 / 3;

    for i := 1 to n do begin
      d[i] := inf;
    end;
    d[s] := 0;
    for i := 1 to m do begin
      w[i] := wd[i] - now1 * dis;
      if (w[i] < 0) then w[i] := 0.0;
    end;

    for i := 1 to n do begin
      for j := 1 to m do begin
        tmp := d[a[j]] + w[j];
        if (d[b[j]] > tmp) then begin
          d[b[j]] := tmp;
          prev1[b[j]] := a[j];
        end;
      end;
    end;

    s1 := now1;
    w1 := d[t];

    for i := 1 to n do begin
      d[i] := inf;
    end;
    d[s] := 0;
    for i := 1 to m do begin
      w[i] := wd[i] - now2 * dis;
      if (w[i] < 0) then w[i] := 0.0;
    end;

    for i := 1 to n do begin
      for j := 1 to m do begin
        tmp := d[a[j]] + w[j];
        if (d[b[j]] > tmp) then begin
          d[b[j]] := tmp;
          prev2[b[j]] := a[j];
        end;
      end;
    end;

    s2 := now2;
    w2 := d[t];

    res1 := s1 + w1;
    res2 := s2 + w2;

    if (res1 < res2) then begin
      r := now2;
      bests := s1;
      bestw := w1;
      bestprev := prev1;
    end else begin
      l := now1;
      bests := s2;
      bestw := w2;
      bestprev := prev2;
    end;

  end;

  writeln(bests:0:6, ' ', (bestw + bests):0:6);

  path[0] := 1;
  path[1] := t;
  while (path[path[0]] <> s) do begin
    inc(path[0]);
    path[path[0]] := bestprev[path[path[0] - 1]];
  end;
  for i := path[0] downto 1 do write(path[i], ' ');


  close(input);
  close(output);
end.
