{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 5001;
type
    int = longint;
    list = ^node;
    node = record
        inf: int;
        next: list;
    end;
const
    con: array [1..2] of char = ('A', 'B');
var
    g: array [1..NMAX] of list;
    ans, min_, a, b, poz, price, used: array [1..NMAX] of int;
    n: int;

function may(k, d: int): boolean;
var
    flag: boolean;

procedure dfs(k, d: int);
var
    t: list;
begin
    if used[k] = d xor 3 then begin
        flag := false;
        exit;
    end;
    if used[k] > 0 then exit;
    used[k] := d;
    t := g[k];
    while t <> nil do begin
        dfs(t^.inf, d xor 3);
        t := t^.next;
    end;
end;

var
    i: int;
begin
    flag := true;
    fillchar(used, sizeof(used), 0);
    dfs(k, d);
    result := flag;
    if result then
        for i := 1 to n do
            if ans[i] = 0 then
                ans[i] := used[i];
end;

procedure add(x, y: int);
var
    t: list;
begin
    new(t);
    t^.inf := y;
    t^.next := g[x];
    g[x] := t;
end;

procedure make(x, y: int);
begin
    if (poz[x] - poz[y]) * (price[poz[x]] - price[poz[y]]) < 0 then exit;
    if min_[max(poz[x], poz[y])] >= min(price[poz[x]], price[poz[y]]) then exit;
    add(x, y);
    add(y, x);
end;

var
    i, j, yl: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    read(n);
    for i := 1 to n do begin
        read(a[i]);
        poz[a[i]] := i;
    end;
    for i := 1 to n do begin
        read(b[i]);
        price[poz[b[i]]] := i;
    end;

    min_[n + 1] := n + 1;
    for i := n downto 1 do
        min_[i] := min(min_[i + 1], price[i]);
    for i := 1 to n do
        for j := i + 1 to n do
            make(i, j);

    fillchar(ans, sizeof(ans), 0);
    for i := 1 to n do
        if ans[i] = 0 then
            if (not may(i, 1)) and (not may(i, 2)) then begin
                writeln('impossible');
                exit;
            end;

    yl := 1;
    for i := 1 to n do begin
        writeln('move ', a[i], ' to ', con[ans[a[i]]]);
        while (yl <= n) and (poz[b[yl]] <= i) do begin
            writeln('move ', b[yl], ' from ', con[ans[b[yl]]]);
            inc(yl);
        end;
    end;
end.