{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math;

const
 StreamIn='';
 StreamOut='';
 NMAX=11000;
 MMAX=55;
 INFVAL=maxint div 2;

type
 integer=longint;
 IntVect=array [0..NMAX] of integer;
 IntList=array of integer;
 Graph=array [0..NMAX] of IntList;
 DpTable=array [0..NMAX,0..MMAX] of integer;
 IntHeap=array [0..NMAX*MMAX] of integer;

var n,k,m,Vs,Vt,Count:integer;
    Cost:IntVect;
    Dpt,Pos:DpTable;
    Heap1,Heap2:IntHeap;
    G,H:Graph;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure AddEdge(x,y,z:integer);
begin
 inc(G[x,0]);
 if G[x,0]=length(G[x]) then begin
   setlength(G[x],2*length(G[x]));
   setlength(H[x],2*length(H[x]))
  end;
 G[x,G[x,0]]:=y;
 H[x,G[x,0]]:=z
end;

procedure LoadData;
var i,t,x,y,z:integer;
begin
 read(n,t,k,m);
 for i:=1 to m do read(Cost[i]);
 for i:=1 to n do begin
   setlength(G[i],1);
   setlength(H[i],1);
   G[i,0]:=0
  end;
 for i:=1 to t do begin
   read(x,y,z);
   AddEdge(x,y,z);
   AddEdge(y,x,z)
  end;
 read(Vs,Vt)
end;

procedure ModeHeap1(t:integer);
var k:integer;
begin
 if t>1 then
  if Dpt[Heap1[t],Heap2[t]]<Dpt[Heap1[t shr 1],Heap2[t shr 1]]
  then begin
    k:=Heap1[t];
    Heap1[t]:=Heap1[t shr 1];
    Heap1[t shr 1]:=k;
    k:=Heap2[t];
    Heap2[t]:=Heap2[t shr 1];
    Heap2[t shr 1]:=k;
    Pos[Heap1[t],Heap2[t]]:=t;
    Pos[Heap1[t shr 1],Heap2[t shr 1]]:=t shr 1;
    ModeHeap1(t shr 1)
   end
end;

procedure ModeHeap2(t:integer);
var Larg,k:integer;
begin
 Larg:=t;
 if 2*t<=Count then
  if Dpt[Heap1[Larg],Heap2[Larg]]>Dpt[Heap1[2*t],Heap2[2*t]]
  then Larg:=2*t;
 if (2*t+1)<=Count then
  if Dpt[Heap1[Larg],Heap2[Larg]]>Dpt[Heap1[2*t+1],Heap2[2*t+1]]
  then Larg:=2*t+1;
 if Larg<>t then begin
   k:=Heap1[t];
   Heap1[t]:=Heap1[Larg];
   Heap1[Larg]:=k;
   k:=Heap2[t];
   Heap2[t]:=Heap2[Larg];
   Heap2[Larg]:=k;
   Pos[Heap1[t],Heap2[t]]:=t;
   Pos[Heap1[Larg],Heap2[Larg]]:=Larg;
   ModeHeap2(Larg)
  end
end;

procedure AddElem(Vert,Lev:integer);
begin
 inc(Count);
 Heap1[Count]:=Vert;
 Heap2[Count]:=Lev;
 Pos[Vert,Lev]:=Count;
 ModeHeap1(Count)
end;

procedure DelElem(t:integer);
begin
 Heap1[t]:=Heap1[Count];
 Heap2[t]:=Heap2[Count];
 Pos[Heap1[t],Heap2[t]]:=t;
 dec(Count);
 ModeHeap1(t);
 ModeHeap2(t)
end;

procedure SolveAndSave;
var q,i,j,Lev,NLev,Vert,Temp,Ans:integer;
begin
 if Vs=Vt then begin
   writeln(0);
   Exit
  end;
 Ans:=INFVAL;
 for q:=1 to m do begin
   for i:=1 to n do
    for j:=0 to k do begin
      Dpt[i,j]:=INFVAL;
      Pos[i,j]:=INFVAL
     end;
   Count:=0;
   Dpt[Vs,0]:=0;
   AddElem(Vs,0);
   while (Count>0) and (Dpt[Heap1[1],Heap2[1]]<>INFVAL) do begin
     Vert:=Heap1[1];
     Lev:=Heap2[1];
     DelElem(1);
     for i:=1 to G[Vert,0] do begin
       if Cost[H[Vert,i]]<=Cost[q] then Temp:=0
       else Temp:=Cost[H[Vert,i]];
       if Temp=0 then NLev:=Lev else NLev:=Min(k,Lev+1);
       if Dpt[G[Vert,i],NLev]>(Dpt[Vert,Lev]+Temp) then begin
         if Dpt[G[Vert,i],NLev]<>INFVAL then
          DelElem(Pos[G[Vert,i],NLev]);
         Dpt[G[Vert,i],NLev]:=Dpt[Vert,Lev]+Temp;
         AddElem(G[Vert,i],NLev)
        end
      end
    end;
   for i:=0 to k-1 do
    Ans:=Min(Ans,Dpt[Vt,i]+(k-i)*Cost[q])
  end;
 writeln(Ans)
end;

begin
 OpenFiles;
 LoadData;
 SolveAndSave;
 CloseFiles
end.
