#include <cstdio>
#include <algorithm>
#include <vector>
#include <memory.h>
using namespace std;
#define MAXT 52
#define MAXN 10002
#define INF 2000000000
int N,M,K,T,s,t;
int cost[MAXT],order[MAXT];
int dist[MAXN][MAXT];
bool was[MAXN][MAXT];
struct Edge {int end,type;};
vector<Edge> gr[MAXN];

bool compare(const int a,const int b) {
	return cost[order[a]]>cost[order[b]];
}

void addEdge(int a,int b,int t) {
	int l = gr[a].size();
	gr[a].resize(l+1);
	gr[a][l].end = b;
	gr[a][l].type = t;
}

void init() {
	for (int i=0;i<N;i++)
		for (int k=0;k<=K;k++) {
			dist[i][k] = INF;
		}
	dist[s][K] = 0;
	memset(was,false,sizeof(was));
}

bool extractMin(int &n,int &k) {
	int mv,mn,mk;
	mv = INF;
	for (int i=0;i<N;i++)
		for (int k=0;k<=K;k++) {
			if ((!was[i][k])&&(dist[i][k]<mv)) {
				mv = dist[i][k];
				mn = i;
				mk = k;
			}
		}
	if (mv != INF) {
		n = mn;
		k = mk;
		was[n][k] = true;
		return true;
	} else return false;
}

int main() {
	int i,j;
	freopen("country.in","rt",stdin);
	freopen("country.out","wt",stdout);
	scanf("%d %d %d %d",&N,&M,&K,&T);
	for (i=0;i<T;i++) {
		scanf("%d",&cost[i]);
		order[i] = i;
	}
	sort(order,order+T,compare);
	for (i=0;i<M;i++) {
		int x,y,z;
		scanf("%d %d %d",&x,&y,&z);
		x--; y--; z--;
		addEdge(x,y,order[z]);
		addEdge(y,x,order[z]);
	}
	scanf("%d %d",&s,&t);
	s--; t--;
	int ans = INF;
	for (int mt = 0; mt <= T; mt++) {
		init();
		if (mt==T) {
			dist[s][K] = INF;
			dist[s][0] = 0;
		}
		int cn,ck;
		while (extractMin(cn,ck)) {
			int cnt = gr[cn].size();
			int dst = dist[cn][ck];
			for (i=0;i<cnt;i++) {
				int u = gr[cn][i].end;
				int w = gr[cn][i].type;
				int nk,ndst = dst;
				if (w > mt) {
					nk = ck;
				} else {
					nk = ck-1;
					if (nk < 0) nk = 0;
					ndst += cost[w];
				}
				if (dist[u][nk]>ndst) {
					dist[u][nk] = ndst;

				}
			}
		}
		int cur = dist[t][0];
		if (cur < ans) ans = cur;
	}
	printf("%d",ans);
	return 0;
}
