program taskb;

{$MODE DELPHI}

uses
  Math;

const
  MAXN = 4095;
  MAXM = 3000;
  MAXS = 1E+15;
  EPS  = 1E-7;
  INF  = 1E+30;

var
  n, m, u, v, i, v0, v1: Integer;
  ww, l, r, x, y, alpha: Extended;
  h, p: array [1..MAXN] of Integer;
  a, next: array [1..2*MAXM] of Integer;
  w: array [1..2*MAXM] of Extended;
  d: array [0..MAXN] of Extended;
  t: array [1..2*MAXN+1] of Integer;

function minv(u, v: Integer): Integer;
begin
  if d[u] < d[v] then
    Result := u
  else
    Result := v;
end;

procedure update(v: Integer);
begin
  inc(v, MAXN);
  while v > 1 do
    begin
      v := v shr 1;
      t[v] := minv(t[2*v], t[2*v+1]);
    end;
end;

function f(s: Extended): Extended;
var
  v, u: Integer;
  ww: Extended;
begin
  d[0] := INF*10;
  for v := 1 to n do
    d[v] := INF;
  d[v0] := 0;
  for v := 1 to n do
    t[v+MAXN] := v;
  for v := MAXN downto 1 do
    t[v] := minv(t[2*v], t[2*v+1]);

  while d[t[1]] < INF do
    begin
      v := t[1];
      u := h[v];
      while u > 0 do
        begin
          ww := max(w[u] - alpha*s, 0);
          if d[a[u]] > d[v] + ww then
            begin
              d[a[u]] := d[v] + ww;
              p[a[u]] := v;
              update(a[u]);
            end;
          u := next[u];
        end;
      t[v+MAXN] := 0;
      update(v);
    end;

  Result := d[v1];
end;

procedure print(v: Integer);
begin
  if v <> v0 then
    print(p[v]);
  Write(v, ' ');
end;

begin
  Read(n, m);
  fillchar(h, sizeof(h), 0);
  for i := 1 to m do
    begin
      Read(u, v, ww);
      a[2*i-1] := v;
      w[2*i-1] := ww;
      next[2*i-1] := h[u];
      h[u] := 2*i-1;
      a[2*i] := u;
      w[2*i] := ww;
      next[2*i] := h[v];
      h[v] := 2*i;
    end;
  Read(v0, v1, alpha);

  fillchar(t, sizeof(t), 0);
  l := 0;
  r := MAXS;
  while l + EPS < r do
    begin
      x := (2*l + r) / 3;
      y := (l + 2*r) / 3;
      if x + f(x) > y + f(y) then
        l := x
      else
        r := y;
    end;

  WriteLn(x:0:6, ' ', (x + f(x)):0:6);
  print(v1);
end.
