#include <algorithm>
#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

int _stklen = 50 << 20;

struct Edge
{
	int a, b, c;
	Edge(int _a, int _b, int _c): a(_a), b(_b), c(_c) {}
};

struct State
{
	int a, b;
	State() {}
	State(int _a, int _b): a(_a), b(_b) {}
};

int N, M, K, T, V0, V1, hl;
int Cost[50];
vector<Edge> E[10000];
int Bound;
int D[10000][51], hpos[10000][51];
State heap[510000];

void hswap(int x, int y)
{
	swap(heap[x], heap[y]);
	hpos[heap[x].a][heap[x].b] = x;
	hpos[heap[y].a][heap[y].b] = x;
}

void hup(int x)
{
	while (x && D[heap[x].a][heap[x].b] < D[heap[(x - 1) >> 1].a][heap[(x - 1) >> 1].b])
	{
		hswap(x, (x - 1) >> 1);
		x = (x - 1) >> 1;
	}
}

void hadd(int x, int y)
{
	heap[hl++] = State(x, y);
	hpos[x][y] = hl - 1;
	hup(hl - 1);
}

void hdown(int x)
{
	int l = (x << 1) + 1;
	int r = (x << 1) + 2;
	int b = x;
	if (l < hl && D[heap[l].a][heap[l].b] < D[heap[b].a][heap[b].b]) b = l;
	if (r < hl && D[heap[r].a][heap[r].b] < D[heap[b].a][heap[b].b]) b = r;
	if (b != x)
	{
		hswap(b, x);
		hdown(b);
	}
}

State hext()
{
	State res = heap[0];
	hswap(0, --hl);
	if (hl) hdown(0);
	return res;
}

void relax(int p, int q, int p1, int c)
{
	int q1 = q, w = 0;
	if (Cost[c] >= Cost[Bound]) q1++, w = Cost[c];
	if (q1 > K) q1 = K;
	if (D[p][q] + w < D[p1][q1])
	{
		D[p1][q1] = D[p][q] + w;
		hup(hpos[p1][q1]);
	}
}

int main()
{
	/*
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
        */
	scanf("%d%d%d%d", &N, &M, &K, &T);
	for (int i = 0; i < T; i++)
		scanf("%d", &Cost[i]);
	for (int i = 0; i < M; i++)
	{
		int x, y, z;
		scanf("%d%d%d", &x, &y, &z);
		x--, y--, z--;
		E[x].push_back(Edge(x, y, z));
		E[y].push_back(Edge(y, x, z));
	}
	scanf("%d%d", &V0, &V1);
	if (V0 == V1)
	{
		printf("0\n");
		return 0;
	}
	V0--, V1--;
	int ans = 987654321;
	for (Bound = 0; Bound < T; Bound++)
	{
		bool bad = false;
		for (int i = 0; i < T; i++)
			if (Cost[i] < Cost[Bound])
			{
				bad = true;
				break;
			}
		memset(D, 63, sizeof(D));
		D[V0][0] = 0;
		hl = 0;
		for (int i = 0; i < N; i++)
			for (int j = 0; j <= K; j++)
				hadd(i, j);
		while (hl)
		{
			State cstate = hext();
			for (int i = 0; i < E[cstate.a].size(); i++)
				relax(cstate.a, cstate.b, E[cstate.a][i].b, E[cstate.a][i].c);
		}
		if (bad) ans <?= D[V1][K];
		else
		{
			for (int i = 0; i <= K; i++)
				ans <?= D[V1][i];
		}
	}
	printf("%d\n", ans);
	return 0;
}
