{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 10001;
    inf = 100000000;
    KMAX = 51;
type
    int = longint;
    list = ^node;
    node = record
        inf, w: int;
        next: list;
    end;
var
    g, a: array [1..NMAX] of list;
    price: array [1..KMAX] of int;
    dist: array [0..KMAX, 1..NMAX] of int;
    used: array [1..NMAX] of boolean;
    n, m, k, t, ans, v1, v2: int;

procedure add(var g: list; y, c: int);
var
    t: list;
begin
    new(t);
    t^.inf := y;
    t^.w := c;
    t^.next := g;
    g := t;
end;

function find: int;
var
    min_, i: int;
begin
    min_ := inf;
    result := 0;
    for i := 1 to n do
        if (not used[i]) and (min_ > dist[k, i]) then begin
            min_ := dist[k, i];
            result := i;
        end;
end;

procedure make(s: int);
var
    i, j, u: int;
    t: list;
begin
    for i := 1 to n do
        a[i] := nil;
    for i := 1 to n do begin
        t := g[i];
        while t <> nil do begin
            if t^.w >= s then
                add(a[i], t^.inf, t^.w);
            t := t^.next;
        end;
    end;

    for j := 0 to k do
        for i := 1 to n do
            dist[j, i] := inf;
    dist[0, v1] := 0;
    for i := 0 to k - 1 do
        for j := 1 to n do begin
            t := a[j];
            while t <> nil do begin
                dist[i + 1, t^.inf] := min(dist[i + 1, t^.inf], dist[i, j] + t^.w);
                t := t^.next;
            end;
        end;

    for i := 1 to n do
        a[i] := nil;
    for i := 1 to n do begin
        t := g[i];
        while t <> nil do begin
            if t^.w > s then
                add(a[i], t^.inf, t^.w)
            else
                add(a[i], t^.inf, 0);
            t := t^.next;
        end;
    end;

    fillchar(used, sizeof(used), 0);
    while not used[v2] do begin
        u := find;
        if u = 0 then break;
        used[u] := true;
        t := a[u];
        while t <> nil do begin
            dist[k, t^.inf] := min(dist[k, t^.inf], dist[k, u] + t^.w);
            t := t^.next;
        end;
    end;
    for i := 0 to k do
        ans := min(ans, dist[i, v2]);
end;

var
    i, x, y, c: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    read(n, m, k, t);
    for i := 1 to t do
        read(price[i]);
    for i := 1 to m do begin
        read(x, y, c);
        add(g[x], y, price[c]);
        add(g[y], x, price[c]);
    end;
    read(v1, v2);

    ans := inf;
    for i := 1 to t do
        make(price[i]);
    c := v1;
    v1 := v2;
    v2 := c;
    for i := 1 to t do
        make(price[i]);
    writeln(ans);
end.