#pragma comment(linker, "/STACK: 67108864 ")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <vector>
#include <list>
#include <cmath>
using namespace std;
#define PB push_back
#define MP make_pair
#define MAXN 3010
const double INF = 1e15;
const double EPS = 1e-7;
int n,m,s,t;
double alpha;
vector<pair<int,double> > e[MAXN];
double dist[MAXN];     
int hlen, heap[MAXN], hpos[MAXN];

void hswap(int p, int q) {
	int t;
	t = heap[p];
	heap[p] = heap[q];
	heap[q] = t;
	hpos[heap[p]] = p;
	hpos[heap[q]] = q;
}

void hdown(int node) {
	int left = (node << 1) + 1;
	int right = (node << 1) + 2;
	int best = node;
	if (left < hlen && (dist[heap[left]]<dist[heap[best]])){
		best = left;
	}
	if (right < hlen && (dist[heap[right]]<dist[heap[best]])){
		best = right;
	}
	if (best != node){
		hswap(best, node);
		hdown(best);
	}
}

int hex() {
	hswap(0, --hlen);
	if (hlen > 0) hdown(0);
	return heap[hlen];
}

void hup(int node) {
	while (node > 0 && dist[heap[node]] < dist[heap[(node - 1) >> 1]]){
		hswap(node, (node - 1) >> 1);
		node = (node - 1) >> 1;
 	}
}

double dijkstra(double sub){
//	bool u[n];
//	memset(u,0,sizeof(u));
	for(int i = 0;i<n;i++){
		dist[i] = INF;
		heap[i] = i;
		hpos[i] = i;
	}
	hlen = n;
	hswap(0,s);
	dist[s] = 0;
	while(hlen>0){
		int besti = hex();
		double best = dist[besti];

		for(int j =0;j < e[besti].size();j++){
			if (best+max(e[besti][j].second-sub,0.0)<dist[e[besti][j].first]){
				dist[e[besti][j].first] = best+max(e[besti][j].second-sub,0.0);
				hup(hpos[e[besti][j].first]);
			}
		}
	}
	return dist[t];
}
double dijkstraOut(double sub){
	int p[n];
	for(int i = 0;i<n;i++){
		dist[i] = INF;
		heap[i] = i;
		hpos[i] = i;
		p[i] = -1;
	}
	hlen = n;
	hswap(0,s);
	dist[s] = 0;
	while(hlen>0){
		int besti = hex();
		double best = dist[besti];

		for(int j =0;j < e[besti].size();j++){
			if (best+max(e[besti][j].second-sub,0.0)<dist[e[besti][j].first]){
				p[e[besti][j].first] = besti;
				dist[e[besti][j].first] = best+max(e[besti][j].second-sub,0.0);
				hup(hpos[e[besti][j].first]);
			}
		}
	}
	int i = t;
	list<int> ans;
	while(i!=-1){
		ans.push_front(i);
		i = p[i];
	}
	while(!ans.empty()){
		cout << ans.front()+1 << " ";
		ans.pop_front();
	}
	return dist[t];
}

double dijkstraOutSlow(double sub){
	bool u[n];
	memset(u,0,sizeof(u));
	double dist[n];
	int p[n];
	for(int i = 0;i<n;i++){
		dist[i] = INF;
		p[i] = -1;
	}
	dist[s] = 0;
	while(!u[t]){
		double best = INF;
		int besti=-1;
		for(int i =0;i<n;i++){
			//cerr << u[i] << ":" << dist[i] << "  ";
			if (!u[i] && dist[i]<best){
				best = dist[i];
				besti = i;
			}
		}
		//cerr << endl;
		if (besti==-1)break;
		u[besti] = 1;
		for(int j =0;j < e[besti].size();j++){
			if (best+max(e[besti][j].second-sub,0.0)<dist[e[besti][j].first]){
				p[e[besti][j].first] = besti;
				dist[e[besti][j].first] = best+max(e[besti][j].second-sub,0.0);
			}
		}
	}
	int i = t;
	list<int> ans;
	while(i!=-1){
		ans.push_front(i);
		i = p[i];
	}
	while(!ans.empty()){
		cout << ans.front()+1 << " ";
		ans.pop_front();
	}
	return dist[t];
}

int main(){
	//freopen("b.in","r",stdin);
	cin >> n >> m;
	for(int i = 0;i<n;i++){
		int a,b;
		double w;
		cin >> a >> b >> w;
		a--;b--;
		e[a].PB(MP(b,w));
		e[b].PB(MP(a,w));
	}
	cin >> s >> t >>alpha;
	s--;t--;
	double l = 0.0;
	double lc = dijkstra(0.0);
	double r = INF;
	double rc = r;
	while(abs(l-r)>EPS){
		double ml = (2.0*l+r)/3.0;
		double mlc = dijkstra(alpha*ml)+ml;
		double mr = (l+2.0*r)/3.0;
		double mrc = dijkstra(alpha*mr)+mr;
		//cerr << l << " "<< ml << " " << mr << " "<< r << endl;
		//cerr << lc << " "<< mlc << " " << mrc << " "<< rc << endl <<endl;
		if (mlc<mrc){
			r = mr;
			rc = mrc;
		}else{
			l = ml;
			lc = mlc;
		}
	}
	cout << l << " "<<dijkstra(alpha*l)+l << endl;
	dijkstraOut(alpha*l);
	flush(cout);
	return 0;
}
