#include <cstdio>
#include <algorithm>
#include <vector>
#include <memory.h>
using namespace std;
#define MAXT 52
#define MAXN 10002
#define INF 2000000000
int N,M,K,T,s,t;
int cost[MAXT],order[MAXT];
int dist[MAXN][MAXT];
struct heapnode {int n,k;} heap[MAXN*MAXT];
int heapsize = 0;

struct Edge {int end,type;};
vector<Edge> gr[MAXN];

bool compare(const int a,const int b) {
	return cost[order[a]]>cost[order[b]];
}

void addEdge(int a,int b,int t) {
	int l = gr[a].size();
	gr[a].resize(l+1);
	gr[a][l].end = b;
	gr[a][l].type = t;
}

void init() {
	for (int i=0;i<N;i++)
		for (int k=0;k<=K;k++) {
			dist[i][k] = INF;
		}
	dist[s][K] = 0;
	heapsize = 0;
}

void heapify(int i) {
   while (true) {
		int l = i << 1;
		int r = l+1;
		int mn = i;
		int mnv = dist[heap[i].n][heap[i].k];
		if (l<=heapsize) {
			int tv = dist[heap[l].n][heap[l].k];
			if (tv < mnv) {mnv = tv; mn = l;}
		}
		if (r<=heapsize) {
			int tv = dist[heap[r].n][heap[r].k];
			if (tv < mnv) {mnv = tv; mn = r;}
		}
		if (mn == i) return;
		swap(heap[mn],heap[i]);
		i = mn;
	}
}

void heap_insert(int n,int k) {
//	fprintf(stderr,">Heap.insert\n");
	int dst = dist[n][k];
	heapsize++;
	heap[heapsize].n = n;
	heap[heapsize].k = k;
	int i=heapsize,j;
	while (true) {
		j = i/2;
		if (j<1||dist[heap[j].n][heap[j].k]<=dst) break;
		swap(heap[i],heap[j]);
		i = j;
	}
//	fprintf(stderr,"<Heap.insert\n");
}

bool extractMin(int &n,int &k) {
	if (heapsize == 0) return false;
	n = heap[1].n;
	k = heap[1].k;
	swap(heap[1],heap[heapsize]);
	heapsize--;
	heapify(1);
	return true;
}

int main() {
	int i,j;
//	freopen("country.in","rt",stdin);
//	freopen("country.out","wt",stdout);
	scanf("%d %d %d %d",&N,&M,&K,&T);
	for (i=0;i<T;i++) {
		scanf("%d",&cost[i]);
		order[i] = i;
	}
	sort(order,order+T,compare);
	for (i=0;i<M;i++) {
		int x,y,z;
		scanf("%d %d %d",&x,&y,&z);
		x--; y--; z--;
		addEdge(x,y,order[z]);
		addEdge(y,x,order[z]);
	}
	scanf("%d %d",&s,&t);
	s--; t--;
	int ans = INF;
	for (int mt = 0; mt <= T; mt++) {
		init();
		if (mt==T) {
			dist[s][K] = INF;
			dist[s][0] = 0;
			heap_insert(s,0);
		} else
			heap_insert(s,K);
		int cn,ck;
		while (extractMin(cn,ck)) {
//			printf("%d %d\n",cn,ck);
			int cnt = gr[cn].size();
			int dst = dist[cn][ck];
			for (i=0;i<cnt;i++) {
				int u = gr[cn][i].end;
				int w = gr[cn][i].type;
//				fprintf(stderr,"%d %d\n",cn+1,u+1);
				int nk,ndst = dst;
				if (w > mt) {
					nk = ck;
				} else {
					nk = ck-1;
					if (nk < 0) nk = 0;
					ndst += cost[w];
				}
				if (dist[u][nk]>ndst) {
//					assert(dist[u][nk]==INF);
					dist[u][nk] = ndst;
					heap_insert(u,nk);
				}
			}
		}
		int cur = dist[t][0];
		if (cur < ans) ans = cur;
	}
	printf("%d",ans);
	return 0;
}
