{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 3001;
    inf = 2E10;
    EPS = 1E-5;
    BASE = 50;
type
    int = longint;
    real = extended;
    list = ^node;
    node = record
        inf: int;
        w: real;
        next: list;
    end;
var
    g: array [1..NMAX] of list;
    dist, w, base_min: array [0..NMAX] of real;
    used: array [1..NMAX] of boolean;
    tree, base_q: array [1..NMAX] of int;
    n, m, v1, v2, were: int;
    alpha, ans: real;

function get(k: int): int;
begin
    result := ((k - 1) div BASE) + 1;
end;

function find: int;
var
    d, i, ind, ind2: int;
    min_: real;
begin
    d := get(n);
    min_ := inf;
    result := 0;
    for i := 1 to d do
        if base_min[i] < min_ then begin
            min_ := base_min[i];
            result := base_q[i];
        end;
    ind := result;
    ind2 := get(result);
    used[ind] := true;
    base_min[ind2] := inf;
    d := min(n, ind2 * BASE);
    for i := (ind2 - 1) * BASE + 1 to d do
        if (not used[i]) and (base_min[ind2] > dist[i]) then begin
            base_min[ind2] := dist[i];
            base_q[ind2] := i;
        end;
end;

procedure update(v, pr: int; w: real);
var
    temp: int;
begin
    if w > dist[v] then exit;
    dist[v] := w;
    tree[v] := pr;
    temp := get(v);
    if (base_min[temp] > w) and (not used[v]) then begin
        base_min[temp] := w;
        base_q[temp] := v;
    end;
end;

procedure make(k: int);
var
    i, u: int;
    www: real;
    t: list;
begin
    fillchar(used, sizeof(used), 0);
    for i := 1 to n do begin
        dist[i] := inf;
        base_min[i] := inf;
    end;
    update(v1, v1, 0);

    while not used[v2] do begin
        u := find;
        t := g[u];
        while t <> nil do begin
            update(t^.inf, u, dist[u] + max(0, t^.w - w[k]));
            t := t^.next;
        end;
    end;

    www := 0;
    if alpha > EPS then
        www := w[k] / alpha;
    if ans > www + dist[v2] then begin
        ans := www + dist[v2];
        were := k;
    end;
end;

procedure add(x, y: int; w: real);
var
    t: list;
begin
    new(t);
    t^.inf := y;
    t^.w := w;
    t^.next := g[x];
    g[x] := t;
end;

procedure way(k: int);
begin
    if k = v1 then begin
        write(k, ' ');
        exit;
    end;
    way(tree[k]);
    write(k, ' ');
end;

var
    i, x, y: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    read(n, m);
    ans := inf;
    w[0] := 0;
    for i := 1 to m do begin
        read(x, y, w[i]);
        add(x, y, w[i]);
        add(y, x, w[i]);
    end;
    read(v1, v2, alpha);
    if alpha < EPS then begin
        make(0);
        writeln(0.0: 0: 10, ' ', ans: 0: 10);
        way(v2);
        exit;
    end;

    were := 0;
    for i := 0 to m do
        make(i);
    make(were);

    writeln(w[were] / alpha: 0: 10, ' ', ans: 0: 10);
    way(v2);
end.