{$MODE DELPHI}
const
 maxn=10000;
 maxh=10000;

type
 integer=longint;

 THeap=record
  cost:integer;
  curk:integer;
  tickets:array[1..50] of integer;
  v:integer;
 end;


 PList=^TList;
 TList=record
  u:integer;
  t:integer;
  n:PList;
 end;


 PHash=^THash;
 THash=record
  v, cost,pv:integer;
  count:integer;
  next:PHash;
 end;

var
  St, En:array[1..maxn] of PList;
  c,num,cn:array[1..50] of integer;
  t,i,j,n,m,k,x,y,z:integer;
  Heap:array of THeap;
  cur,newh:THeap;
  s,f:integer;
  pl:Plist;
  pp:integer;

  hash:array[0..maxh-1] of PHash;

function HashF(pv, v, cost:integer):integer;
begin
 result:=(v*13+cost*17) mod maxh;
end;


function AddToHash(pv, v, cost:integer):integer;
var
 p,p1:PHash;
 F:integer;
begin
 F:=HashF(pv, v,cost);
 p1:=nil;
 p:=Hash[F];
 while p<>nil do begin
  if (p^.pv=pv) and (p^.v=v) and (p^.cost=cost) then begin
   result:=p^.Count;
   inc(p^.count);
   exit;
  end;
  p1:=p;
  p:=p^.next;
 end;

 new(p);
 result:=0;
 p^.v:=v; p^.cost:=cost; p^.count:=1; p^.next:=nil; p^.pv:=pv;
 if p1=nil then begin
  Hash[F]:=p
 end else p1^.next:=p;
end;

procedure AddToList(v,u,t:integer);
var
 p:PList;
begin
 new(p);
 p^.u:=u; p^.t:=t; p^.n:=nil;
 if En[v]=nil then begin
  St[v]:=p;
  En[v]:=p;
 end else begin
  En[v]^.n:=p;
  En[v]:=p;
 end;
end;


function Father(i:integer):integer;
begin
 result:=i div 2;
end;

function Left(i:integer):integer;
begin
 result:=i*2;
end;

function Right(i:integer):integer;
begin
 result:=i*2+1;
end;

function GetP(x:THeap):integer;
var
 i,m:integer;
begin
 if x.curk<k then begin
  result:=-1;
  exit;
 end;
 m:=k;
 for i:=t downto 1 do begin
  dec(m, x.tickets[num[i]]);
  if m<=0 then begin
   result:=c[i];
   exit;
  end;
 end;
end;

procedure SwapTHeap(var a,b:THeap);
var
 c:THeap;
begin
 c:=a; a:=b; b:=c;
end;

procedure Heapy(i:integer);
begin
 if i=1 then exit;
 if Heap[i].cost<Heap[Father(i)].cost then begin
  SwapTHeap(Heap[i], Heap[Father(i)]);
  Heapy(Father(i));
 end;
end;

procedure HeapyDown(i:integer);
var
 p:integer;
begin
 p:=0;
 if (Left(i)<=High(Heap))and(Heap[i].cost>Heap[Left(i)].cost) then p:=1;
 if p=0 then begin
  if (Right(i)<=High(Heap))and(Heap[i].cost>Heap[Right(i)].cost) then begin
   SwapTHeap(Heap[i], Heap[Right(i)]);
   HeapyDown(Right(i));
  end;
 end else begin
  if (Right(i)<=High(Heap))and(Heap[Right(i)].cost<Heap[Left(i)].cost) then begin
   SwapTHeap(Heap[i], Heap[Right(i)]);
   HeapyDown(Right(i));
  end else begin
   SwapTHeap(Heap[i], Heap[Left(i)]);
   HeapyDown(Left(i));
  end;
 end;
end;

procedure AddToHeap(Node:THeap);
begin
 SetLength(Heap, length(Heap)+1);
 Heap[High(Heap)]:=Node;
 Heapy(High(Heap));
end;

function GetFromHeap:THeap;
begin
 result:=Heap[1];
 SwapTHeap(Heap[1], Heap[High(Heap)]);
 setlength(Heap, length(Heap)-1);
 HeapyDown(1);
end;

procedure Swap(var a,b:integer);
var
 c:integer;
begin
 c:=a; a:=b; b:=c;
end;

begin
 assign(input,'bigcountry.txt'); reset(input);
 SetLength(Heap, 1);  // not use 0
 for i:=0 to maxh-1 do Hash[i]:=nil;
 readln(n,m,k,t);
 for i:=1 to t do begin
  read(c[i]);
  num[i]:=i;
 end;
 cn:=c;
 for i:=t downto 1 do
  for j:=1 to i-1 do
   if c[j]>c[j+1] then begin
    Swap(c[j], c[j+1]);
    Swap(num[j], num[j+1]);
   end;

 for i:=1 to m do begin
  readln(x,y,z);
  AddToList(x,y,z);
  AddToList(y,x,z);
 end;

 readln(s,f);
 cur.cost:=0;
 cur.v:=s;
 cur.curk:=0;

 AddToHeap(cur);
 while High(Heap)>0 do begin
  if cur.v=f then begin
   writeln(cur.cost);
   halt;
  end;
  cur:=GetFromHeap;
  pl:=St[cur.v];
  pp:=GetP(cur);
  while pl<>nil do begin
   newh:=cur;
   newh.v:=pl^.u;
   if pp<cn[pl^.t] then inc(newh.cost, cn[pl^.t]);
   if AddToHash(cur.v, pl^.u, newh.cost)>K+2 then begin
    pl:=pl^.n;
    continue;
   end;
   inc(newh.tickets[pl^.t]);
   inc(newh.curk);
   AddToHeap(newh);
   pl:=pl^.n;
  end;
 end;
end.
