#include <stdio.h>
#include <string.h>

#include <algorithm>
using namespace std;

const int maxn = 16384;
const int inf = 2000000000;

int c[maxn];
int n;

class tree
{
public:
  int t[maxn + maxn];
  int lc[maxn];
  void build ();
  void set (int i, int x);
  int get ();
};
void tree::build ()
{
  for (int i = 0; i < n; i++)
    lc[i] = c[i], t[i + maxn] = i;
  lc[n] = inf - 5;
  for (int i = n; i < maxn; i++)
    t[i + maxn] = n;
  for (int i = maxn - 1; i > 0; i--)
    if (c[t[i + i]] < c[t[i + i + 1]])
      t[i] = t[i + i];
    else
      t[i] = t[i + i + 1];
}
void tree::set (int i, int x)
{
  lc[i] = x;
  for (i = (i + maxn) >> 1; i > 0; i >>= 1)
    if (lc[t[i + i]] < lc[t[i + i + 1]])
      t[i] = t[i + i];
    else
      t[i] = t[i + i + 1];
}
int tree::get ()
{
  int l = maxn;
  int r = maxn + n;
  int b = t[l];
  if (lc[t[r]] < lc[t[l]])
    b = t[r];
  while (l < r)
  {
    if (!(l & 1))
      if (lc[t[l + 1]] < lc[b]) 
        b = t[l + 1];
    if (r & 1)
      if (lc[t[r - 1]] < lc[b])
        b = t[r - 1];
    l >>= 1;
    r >>= 1;
  }
  return b;
}
tree tr;

struct edge
{
  int a;
  int b;
  int i;
  edge* next;
};
edge ea[maxn + maxn];
int nea = 0;
edge* ealloc ()
{
  return &ea[nea++];
}

int m;
edge* ve[maxn];
bool vis[maxn];
edge* by[maxn];
int s, t;

int cost[64];

struct epair
{
  int c;
  int i;
};
epair ec[maxn]; 
inline bool operator < (epair const& a, epair const& b)
{
  return a.c < b.c;
}
int eci[maxn];
int firstd;

int best;
int K;
int cnt;
int total;

void path ()
{
  for (int i = 0; i < m; i++)
    if (i < firstd)
      eci[ec[i].i] = 0;
    else
      eci[ec[i].i] = ec[i].c;
  for (int i = 0; i < n; i++)
    c[i] = inf, vis[i] = false, by[i] = NULL;
  c[s] = 0;
  tr.build ();
  while (true)
  {
    int v = tr.get ();
//    for (int i = 0; i < m; i++)
//      printf ("%d ", tr.lc[i]);
//    printf ("\ngot: %d\n", v);
    if (v >= n) break;
    vis[v] = true;
    tr.set (v, inf);
    for (edge* e = ve[v]; e; e = e->next)
    {
//      printf ("%d %d\n", e->b, eci[e->i]);
      if (!vis[e->b] && c[e->b] > c[v] + eci[e->i])
        tr.set (e->b, c[v] + eci[e->i]), c[e->b] = c[v] + eci[e->i], by[e->b] = e;
    }
  }
  int cur = t;
  cnt = 0;
  int nume = 0;
  total = 0;
  while (cur != s)
  {
    if (eci[by[cur]->i] != 0)
      cnt++;
    total += eci[by[cur]->i];
    nume++;
    cur = by[cur]->a;
  }
  if ((cnt == K || cnt == nume) && total < best)
    best = total;
}

int main ()
{
#ifdef _LOCAL_
  freopen ("berland.in", "rt", stdin);
  freopen ("berland.out", "wt", stdout);
#endif

  int nt;
  scanf ("%d %d %d %d", &n, &m, &K, &nt);
  for (int i = 0; i < nt; i++)
    scanf ("%d", &cost[i]);
  memset (ve, 0, sizeof ve);
  for (int i = 0; i < m; i++)
  {
    int a, b, x;
    scanf ("%d %d %d", &a, &b, &x), a--, b--, x--;
    ec[i].c = cost[x], ec[i].i = i, eci[i] = cost[x];
    edge* e1 = ealloc ();
    e1->a = a, e1->b = b, e1->i = i, e1->next = ve[a], ve[a] = e1;
    edge* e2 = ealloc ();
    e2->a = b, e2->b = a, e2->i = i, e2->next = ve[b], ve[b] = e2;
  }
  scanf ("%d %d", &s, &t), s--, t--;
  sort (ec, ec + m);
  best = inf;
  firstd = 0;
  path ();
  int _l = 0;
  int _r = m - 1;
  while (_l < _r)
  {
    firstd = (_l + _r + 1) / 2;
    path ();
    if (cnt < K)
      _r = firstd - 1;
    else
      _l = firstd;
  }
  printf ("%d", best);

  return 0;
}
