#pragma comment(linker, "/STACK: 67108864 ")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <vector>
#include <list>
using namespace std;
#define PB push_back
#define MP make_pair
#define MAXN 10010
#define MAXT 51
#define INF 1000000000

int n,m,k,t,mpt,from,to;
vector<pair<int,int> > e[MAXN];
int dist[MAXN];     
int hlen, heap[MAXN], hpos[MAXN];
vector<pair<int,int> > tt;

void hswap(int p, int q) {
	int t;
	t = heap[p];
	heap[p] = heap[q];
	heap[q] = t;
	hpos[heap[p]] = p;
	hpos[heap[q]] = q;
}

void hdown(int node) {
	int left = (node << 1) + 1;
	int right = (node << 1) + 2;
	int best = node;
	if (left < hlen && (dist[heap[left]]<dist[heap[best]])){
		best = left;
	}
	if (right < hlen && (dist[heap[right]]<dist[heap[best]])){
		best = right;
	}
	if (best != node){
		hswap(best, node);
		hdown(best);
	}
}

int hex() {
	hswap(0, --hlen);
	if (hlen > 0) hdown(0);
	return heap[hlen];
}

void hup(int node) {
	while (node > 0 && dist[heap[node]] < dist[heap[(node - 1) >> 1]]){
		hswap(node, (node - 1) >> 1);
		node = (node - 1) >> 1;
 	}
}

int dijkstra(){
	int p[n];
	for(int i = 0;i<n;i++){
		dist[i] = INF;
		heap[i] = i;
		hpos[i] = i;
		p[i] = -1;
	}
	hlen = n;
	hswap(0,from);
	dist[from] = 0;
	while(hlen>0){
		int besti = hex();
		int best = dist[besti];

		for(int j =0;j < e[besti].size();j++){
			if (e[besti][j].second<mpt && 
				best+max(tt[e[besti][j].second].first,0)<dist[e[besti][j].first]){
				p[e[besti][j].first] = besti;
				dist[e[besti][j].first] = best+max(tt[e[besti][j].second].first,0);
				hup(hpos[e[besti][j].first]);
			}
		}
	}
/**/
	int i = to;
	list<int> ans;
	while(i!=-1){
		ans.push_front(i);
		i = p[i];
	}
	vector<int> cs;
	int prev = ans.front();ans.pop_front();
	while(!ans.empty()){
		int smc = INF;
		for(int j =0;j < e[prev].size();j++){
//			cerr << e[prev][j].first<<"=="<<ans.front() <<endl;
			if (e[prev][j].first==ans.front() && tt[e[prev][j].second].first<smc){
				smc = tt[e[prev][j].second].first;
			}
		}
//		cerr << ans.front() << "(" << smc << ") "<<endl;
		cs.PB(smc);	
		prev = ans.front();
		ans.pop_front();
	}
	sort(cs.begin(),cs.end());
	if (cs.size()<=k){
		return dist[to];
	}else{
		int r = 0;
		for(int i = 0;i<k;i++){
			r+=cs[cs.size()-1-i];
		}
//		cerr << endl << r <<"!"<<endl;
		return r;
	}
/*
*/

	return dist[to];
}

int main(){
	//freopen("c.in","r",stdin);
	cin >> n >> m >> k >> t;
//	if (n==5 && m==5  && k==2 && t==3){
//		cout << 18 << endl;
//		flush(cout);
//		return 0;
//	}
	for(int i = 0;i<t;i++){
		int cs;
		cin >> cs;
		tt.PB(MP(cs,i));
	}
	sort(tt.begin(),tt.end());
	int ttor[t];
	for(int i = 0;i<t;i++){
		ttor[tt[i].second] = i;
	}
	for(int i = 0;i<m;i++){
		int x,y,z;
		cin >> x >> y >> z;
		x--;y--;z = ttor[z-1];
//		cerr << x << " <-> " << y << "    "<< tt[z].first <<endl;
		e[x].PB(MP(y,z));
		e[y].PB(MP(x,z));
	}
	cin >> from >> to;
	from--;to--;
	int best = INF;
	for(mpt = 1;mpt<=t;mpt++){
		best = min(best,dijkstra());
	}
	cout << best <<endl;
	flush(cout);
	return 0;
}
