uses math;

//{$DEFINE DEBUG}
{$UNDEF DEBUG}
{$IFDEF DEBUG}
  {$D+,L+,I+,Q+,R+,S+,O-}
{$ELSE}
  {$D-,L-,I-,Q-,R-,S-,O+}
  {$M 1000000,2097152}
{$ENDIF DEBUG}


type list=^listelem;
     listelem=record
     y:longint;
     w:extended;
     next:list;
     end;

type q=record
     pnt:list;
     w:extended;
     end;

const inf:extended=1e11;

const eps:extended=1e-9;

type heapelem=record
     n:longint;
     key:extended;
     end;

type heap=record
     a:array[1..3000] of heapelem;
     p:array[1..3000] of longint;
     n:longint;
     end;

var n,m,j:longint;
    a:array[1..3000] of list;
    b:array[1..6000] of q;h:longint;
    v:array[0..3000] of extended;
    d,ts,ps,ds,tdist:extended;
    s,t,i:longint;
    heap1:heap;
    mark:array[1..3000] of boolean;
    p:array[1..3000] of longint;
    bdist,bs:extended;
    bp:array[1..3000] of longint;

procedure list_add(var a:list;y:longint;w:extended);
var buf:list;
 begin
 buf:= a;
 new(a);
 a^.y:= y;
 a^.w:= w;
 a^.next:= buf;
 end;

procedure list_del(var a:list);
var buf:list;
 begin
 while a<>nil do
  begin
  buf:= a^.next;
  dispose(a);
  a:= buf;
  end;
 end;

procedure initial;
 begin
 h:= 0;
 randomize;
 v[0]:= 0.0;
 j:= 0;
 ps:= -1.0;
 bdist:= 1e30;
 end;

procedure indata;
var i,x,y:longint;w:extended;
 begin
 {$IFDEF DEBUG}
 assign(input,'input.txt');
 reset(input);
 {$ENDIF DEBUG}
 readln(n,m);
 for i:= 1 to m do
  begin
  readln(x,y,w);
  inc(h);
  list_add(a[x],y,w);
  b[h].pnt:= a[x];
  b[h].w:= w;
  inc(h);
  list_add(a[y],x,w);
  b[h].pnt:= a[y];
  b[h].w:= w;
  v[i]:= w;
  end;
 read(s,t,d);
 {$IFDEF DEBUG}
 close(input);
 {$ENDIF DEBUG}
 end;

procedure outdata;
var i,j:longint;
    a:array[1..3000] of longint;
 begin
 {$IFDEF DEBUG}
 assign(output,'output.txt');
 rewrite(output);
 {$ENDIF DEBUG}
 writeln(bs:0:7,' ',bdist:0:7);
 i:= t;
 j:= 0;
 while i<>0 do
  begin
  inc(j);
  a[j]:= i;
  i:= bp[i];
  end;
 for i:= j downto 1 do
  write(a[i],' ');
 {$IFDEF DEBUG}
 close(output);
 {$ENDIF DEBUG}
 end;

procedure trash;
var i:longint;
 begin
 {$IFDEF DEBUG}
 for i:= 1 to n do
  list_del(a[i]);
 {$ENDIF DEBUG}
 end;

function rless(a,b:extended):boolean;
 begin
 rless:= (b-a)>eps;
 end;

procedure qsort(l,r:longint);
var i,j:longint;x,y:extended;
 begin
 while l<r do
  begin
  i:= l;
  j:= r;
  x:= v[random(r-l+1)+l];
  repeat
   while rless(v[i],x) do inc(i);
   while rless(x,v[j]) do dec(j);
   if i<=j then
    begin
    y:= v[i];
    v[i]:= v[j];
    v[j]:= y;
    inc(i);
    dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  l:= i;
  end;
 end;

function req(a,b:extended):boolean;
 begin
 req:= abs(a-b)<=eps;
 end;

function rlesseq(a,b:extended):boolean;
 begin
 rlesseq:= (a-b)<=eps;
 end;

procedure pereschet;
var i:longint;x:extended;
 begin
 for i:= 1 to h do
  begin
  x:= b[i].w-ds;
  if rlesseq(x,0.0) then x:= 0.0;
  b[i].pnt^.w:= x;
  end;
 end;

procedure normalize(var h:heap;i:integer);
var l,r,minch:extended;
 procedure compare(i,j:longint);
 var buf:heapelem;
  begin
  with h do
   begin
   buf:= a[i];
   a[i]:= a[j];
   a[j]:= buf;
   p[a[i].n]:= i;
   p[a[j].n]:= j;
   end;
  end;

 begin
 with h do
  begin
  while i<=n do
   begin
   if 2*i<=n then
    l:= a[2*i].key
   else
    l:= 1e30;
   if 2*i+1<=n then
    r:= a[2*i+1].key
   else
    r:= 1e30;
   minch:= min(l,r);
   if rlesseq(a[i].key,minch) then
    break
   else
    if req(a[2*i].key,minch) then
     begin
     compare(2*i,i);
     i:= 2*i;
     end
    else
     begin
     compare(2*i+1,i);
     i:=2*i+1;
     end;
   end;
  end;
 end;

procedure heap_del(var h:heap;i:integer);
var j:longint;
 begin
 with h do
  begin
  if p[i]=0 then
   exit;
  j:= p[i];
  p[i]:= 0;
  if n<>j then
   begin
   a[j]:= a[n];
   p[a[j].n]:= j;
   dec(n);
   normalize(h,j);
   end
  else
   dec(n);
  end;
 end;

procedure heap_changekey(var h:heap;i:integer;const newkey:extended);
var j,k:longint;
 procedure compare(i,j:longint);
 var buf:heapelem;
  begin
  with h do
   begin
   buf:= a[i];
   a[i]:= a[j];
   a[j]:= buf;
   p[a[i].n]:= i;
   p[a[j].n]:= j;
   end;
  end;

 begin
 j:= h.p[i];
 if j=0 then exit;
 with h do
  if rless(newkey,a[j].key) then
   begin
   a[j].key:= newkey;
   k:= j div 2;
   while k>=1 do
    if rless(a[j].key,a[k].key) then
     begin
     compare(j,k);
     j:= k;
     k:= k div 2;
     end
    else
     break;
   end
  else
   begin
   a[j].key:= newkey;
   normalize(h,j);
   end;
 end;

function deicstr:extended;
var i,j,y:longint;dist,w,k:extended;
    buf:list;
 begin
 heap1.n:= n;
 for i:= 1 to n do
  begin
  mark[i]:= false;
  p[i]:= 0;
  end;
 with heap1 do
  for i:= 1 to n do
   begin
   p[i]:= i;
   a[i].n:= i;
   a[i].key:= inf;
   end;
 for i:= n downto 1 do
  normalize(heap1,i);
 heap_changekey(heap1,s,0.0);
 while not mark[t] do
  begin
  with heap1 do
   begin
   j:= a[1].n;
   dist:= a[1].key;
   end;
  heap_del(heap1,j);
  mark[j]:= true;
  buf:= a[j];
  while buf<>nil do
   begin
   y:= buf^.y;
   w:= buf^.w;
   if not mark[y] then
    begin
    with heap1 do
     k:= a[p[y]].key;
    if rless(w+dist,k) then
     begin
     heap_changekey(heap1,y,w+dist);
     p[y]:= j;
     end;
    end;
   buf:= buf^.next;
   end;
  end;
 deicstr:= dist;
 end;


begin
initial;
indata;
if not req(d,0.0) then
 begin
 qsort(1,m);
 while j<=m do
  begin
  ts:= v[j]/d;
  if not req(ps,ts) then
   begin
   ds:= ts*d;
{   if ts=1000 then
    ts:= 1000;}
   pereschet;
   tdist:= deicstr;
   tdist:= tdist+ts;
   if rless(tdist,bdist) then
    begin
    bdist:= tdist;
    bs:= ts;
    for i:= 1 to n do
     bp[i]:= p[i];
    end;
   end;
  ps:= ts;
  inc(j);
  end;
 end
else
 begin
 bs:= 0.0;
 bdist:= deicstr;
 for i:= 1 to n do
  bp[i]:= p[i];
 end;
outdata;
end.
