#include <cstdio>
#define INFINITy 1000000000
#define MAXN 3100
#define MAXM 3100
using namespace std;
#include <queue>
#include <set>
#include <vector>

vector<pair<int, double> > sm[MAXN];
priority_queue<pair<double, int> > heap;
int n, m;
double Skidka, ANS, REZ;
int from, to;

double dst[MAXN];
int pred[MAXN];
int PRED[MAXN];
bool used[MAXN];

double djkstra(){
	while (!heap.empty())
		heap.pop();
	for (int i = 0; i < n; i++){
		used[i] = false;
		dst[i] = INFINITy;
	}
	dst[from] = 0;
	heap.push(pair<double, int>(0, from));
	while (!used[to]){
		int v = heap.top().second;
//		printf("%.10lf\n", dst[tmp.second]);
		heap.pop();
		if (!used[v]){
			used[v] = true;
			for (int i = 0; i < sm[v].size(); i++){
				double cost = sm[v][i].second;
//				printf("sm[%d][%d] = %.10lf\n", i, tmp.second, cost);
				cost -= ANS * Skidka;
				if (cost < 0)
					cost = 0;
				if (dst[sm[v][i].first] > dst[v] + cost){
					dst[sm[v][i].first] = dst[v] + cost;
					pred[sm[v][i].first] = v;
					heap.push(pair<double, int>(-dst[sm[v][i].first], sm[v][i].first));
			    }
			}
		}
	}                           
	return dst[to] + ANS;
}

set<double> w;

void dfs(int i){     
	if (i != from)
		dfs(PRED[i]);
	printf("%d ", i + 1);
}

int main(){
	freopen("input.txt", "rt", stdin);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++){
		int a, b;
		double co;
		scanf("%d%d%lf", &a, &b, &co);
		a--;
		b--;
		w.insert(co);
		sm[a].push_back(pair<int, double>(b, co));
		sm[b].push_back(pair<int, double>(a, co));
	}
	scanf("%d%d%lf", &from, &to, &Skidka);


//	n = 3000;
//	m = 3000;
//	from = 1;
//	to = n;
//	Skidka = 1;
//    for (int i = 0; i < n - 1; i++){
//    	sm[i].push_back(pair<int, double>(i + 1, i + 1 + 0.0));
//    	w.insert(i + 1.0);
//    }
//    for (int i = 1; i < n; i++)
//  	sm[i].push_back(pair<int, double>(i - 1, i + 0.0));






	from--;
	to--;
	ANS = 0;
	REZ = djkstra();
	double ANS_IDEAL = 0;
	for (int i = 0; i < n; i++)
		PRED[i] = pred[i];
	for (set<double>::iterator tmp = w.begin(); tmp != w.end(); tmp++){
		if (Skidka > 1e-9)
			ANS = *tmp / Skidka;
		else
			break;
		double q = djkstra();
		if (q < REZ){
			REZ = q;
			ANS_IDEAL = ANS;
			for (int i = 0; i < n; i++)
				PRED[i] = pred[i];
		}
	}
	printf("%.10lf %.10lf\n", ANS_IDEAL, REZ);
	dfs(to);
}
