#include <stdio.h>
#include <memory.h>

#define MAXN 6000

struct list
{
       int s;
       int t;
       int c;
       struct list* next;
       struct list* prev;
};

int p1[MAXN];
int p2[MAXN];
int a[MAXN];
int res[MAXN];
char vert[MAXN];
int n, k;
int st[2][MAXN];
int pst[2];
struct list* root = NULL;

void init()
{
//     freopen("input.txt", "r", stdin);
//     freopen("output.txt", "w", stdout);
     memset(vert, 0, sizeof(vert));
     memset(res, 0, sizeof(res));
     memset(st, 0, sizeof(st));
     pst[0] = pst[1] = 0;
     st[0][0] = st[1][0] = -1;
}

void readdata()
{
     int i;
     scanf("%d", &n);
     for(i=0;i<n;i++)
       scanf("%d", &p1[i]);
     for(i=0;i<n;i++)
       scanf("%d", &p2[i]);
}

void list_add(int s, int t, int c)
{
     struct list* pList = root;
     if(pList == NULL)
     {
       pList = new list;
       pList->s = s;
       pList->t = t;
       pList->c = c;
       pList->next = pList->prev = NULL;
       root = pList;
       return;
     }
     while(pList->next != NULL)
       pList = pList->next;
     pList->next = new list;
     pList->next->prev = pList;
     pList = pList->next;
     pList->s = s;
     pList->t = t;
     pList->c = c;
     pList->next = NULL;
}

void write_stat()
{
     struct list* pList = root;
     while(pList != NULL)
     {
       printf("%d %d %d\n", pList->s, pList->t, pList->c);
       pList = pList->next;
     }
}

int is_ok(struct list* pList, int c)
{
    while(pList != NULL)
    {
      if((pList->c!=0)&&(pList->c!=c))
        return 0;
      pList = pList->next;
    }
    return 1;
}

void mark(struct list* pList, int c)
{
    while(pList != NULL)
    {
      pList->c = c;      
      pList = pList->next;
    }
}

void del(struct list* pList)
{
     if(pList->prev != NULL)
       pList->prev->next = pList->next;
     else
       root = pList->next;
     if(pList->next != NULL)
       pList->next->prev = pList->prev;
     delete pList;
}

int list_del(int s)
{
    struct list* pList = root;
    struct list* nList;
    int t;
    
    while((s<pList->s)||(s>pList->t))
      pList = pList->next;
    if(pList->c==0)
    {
      if(pList->t == s)
      {
        if(pList->t == pList->s)
        {
          if(is_ok(pList->next, 1))
          {
            mark(pList->next, 1);
            del(pList);
            res[s] = 2;
          }
          else
          {
            if(is_ok(pList->next, 2))
            {
              mark(pList->next, 2);
              del(pList);
              res[s] = 1;
            }
            else
              return 0;
          }
        }
        else
        {
            pList->t--;
            if(is_ok(pList->next, 1))
            {
              mark(pList->next, 1);
              res[s] = 2;
            }
            else
            {
              if(is_ok(pList->next, 2))
              {
                mark(pList->next, 2);
                res[s] = 1;
              }
              else
                return 0;
            }
        } 
        return 1;
      }
      else
      {
          if(pList->s == s)
          {
            pList->s++;
            if(is_ok(pList->next, 1))
            {
              mark(pList->next, 1);
              pList->c = 1;
              res[s] = 2;
            }
            else
            {
              if(is_ok(pList->next, 2))
              {
                mark(pList->next, 2);
                pList->c = 2;
                res[s] = 1;
              }
              else
                return 0;
            }
          }
          else
          {
            nList = new list;
            nList->s = s+1;
            nList->t = pList->t;
            pList->t = s-1;
            nList->c = 0;
            nList->prev = pList;
            nList->next = pList->next;
            pList->next = nList;
            if(nList->next != NULL)
              nList->next->prev = nList;
              
            if(is_ok(pList->next, 1)) 
            {
              mark(pList->next, 1);
              res[s] = 2;
            }
            else
            {
              if(is_ok(pList->next, 2))
              {
                mark(pList->next, 2);
                res[s] = 1;
              }
              else
                return 0;
            }
          }
          return 1;
      }
    }
    if(pList->c == 1)
    {
      res[s] = 1;
      if(pList->t != s)
        return 0;
      if(pList->s == s)
      {
        if(is_ok(pList->next, 2))
        {
          mark(pList->next, 2);   
          del(pList);
        }
        else
          return 0;
      }
      else
      {
        pList->t--;
        if(is_ok(pList->next, 2))
          mark(pList->next, 2); 
        else
          return 0;
      }
      return 1;
    }
    if(pList->c == 2)
    {
      res[s] = 2;
      if(pList->t != s)
        return 0;
      if(pList->s == s)
      {
        if(is_ok(pList->next, 1))
        {
          mark(pList->next, 1);
          del(pList);
        }
        else
          return 0;
      }
      else
      {
        pList->t--;
        if(is_ok(pList->next, 1))
          mark(pList->next, 1); 
        else
          return 0;
      }
      return 1;
    }
}

void solve()
{
     int i, j, k;
     for(i=0;i<n;i++)
     {
       j = 0;
       while(p1[j] != p2[i]) j++;
       a[i] = j;
     }
     for(i=0;i<n;i++)
     {
       if(vert[a[i]] == 0)
       {
         j = a[i]-1;
         while((j>=0)&&(vert[j]==0))
         {
           vert[j] = 1;
           j--;
         }
         if(j<a[i]-1)
           list_add(j+1, a[i]-1, 0);
       }      
       else
       {
         if(!list_del(a[i]))
         {
           printf("impossible");
           return;
         }
       }
       vert[a[i]] = 2;       
     }
     j = 0;
     k = 0;
     for(i=0;i<n;i++)
     {
       if(res[i] != 0)
       {
         printf("move %d to %c\n", p1[i], res[i]+'A'-1);
         k++;
         st[res[i]-1][++pst[res[i]-1]] = i;
       }
       else
       {
         if(a[j] == i)
         {
           printf("move %d to A\n", p1[i]);
           printf("move %d from A\n", p1[i]);
           j++;
           k++;
         }
         else
         {
           if(a[j] == st[0][pst[0]])
           {
             printf("move %d from A\n", p2[j++]);
             pst[0]--;
           }
           else
           {
             printf("move %d from B\n", p2[j++]);
             pst[1]--;
           }
         }
       }
     }
     while(j<n)
     {
       if(a[j] == st[0][pst[0]])
       {
         printf("move %d from A\n", p2[j++]);
         pst[0]--;
       }
       else
       {
         if(a[j] == st[1][pst[1]])
         {
           printf("move %d from B\n", p2[j++]);
           pst[1]--;
         }
         else
         {
           printf("move %d to A\n", p1[k]); 
           printf("move %d from A\n", p1[k++]);
           j++;
         }
       }
     }
}

int main()
{
    init();
    readdata();
    solve();
    return 0;
}
