program taskc;

{$MODE DELPHI}
{$Q-,R-,S-,I-,D-,L-}

uses
  Math;

const
  MAXN = 10000;
  MAXM = 10000;
  MAXT = 50;
  MAXK = 50;
  SHFT = 16383;
  INF  = $0F0F0F0F;

type
  TArr = array [1..MAXK] of Byte;

var
  n, m, k, p, u, v, w, i, ans, v0, v1: Integer;
  h, d, d0: array [0..MAXN] of Integer;
  l, l0: array [1..MAXN] of TArr;
  c: array [0..MAXT] of Integer;
  a, z, next: array [1..2*MAXM] of Integer;
  t: array [1..2*SHFT+1] of Integer;

function minv(u, v: Integer): Integer;
begin
  if d[u] < d[v] then
    Result := u
  else
    Result := v;
end;

procedure update(v: Integer);
begin
  inc(v, SHFT);
  while v > 1 do
    begin
      v := v shr 1;
      t[v] := minv(t[2*v], t[2*v+1]);
    end;
end;

procedure swap(var a, b: Byte);
var
  tmp: Byte;
begin
  tmp := a; a := b; b := tmp;
end;

procedure down(var a: TArr; v: Integer);
begin
  while (2*v < k) and (c[a[v]] > min(c[a[2*v]], c[a[2*v+1]])) do
    if a[2*v] < a[2*v+1] then
      begin
        swap(a[v], a[2*v]);
        v := 2*v;
      end
    else
      begin
        swap(a[v], a[2*v+1]);
        v := 2*v+1;
      end;
  if (2*v = k) and (c[a[v]] > c[a[k]]) then
    swap(a[v], a[k]);
end;

begin
  Read(n, m, k, p);
  c[0] := 0;
  for i := 1 to p do
    Read(c[i]);

  fillchar(h, sizeof(h), 0);
  for i := 1 to m do
    begin
      Read(u, v, w);
      a[2*i-1] := v;
      z[2*i-1] := w;
      next[2*i-1] := h[u];
      h[u] := 2*i-1;
      a[2*i] := u;
      z[2*i] := w;
      next[2*i] := h[v];
      h[v] := 2*i;
    end;
  Read(v0, v1);

  fillchar(d, sizeof(d), $0F);
  d[v0] := 0;
  ans := INF;
  for i := 1 to k do
    begin
      d0 := d;
      l0 := l;
      fillchar(d, sizeof(d), $0F);
      for v := 1 to n do
        if d0[v] < INF then
          begin
            u := h[v];
            while u > 0 do
              begin
                if d[a[u]] > d0[v] + c[z[u]] then
                  begin
                    d[a[u]] := d0[v] + c[z[u]];
                    l[a[u]] := l0[v];
                    l[a[u],i] := z[u];
                  end;
                u := next[u];
              end;
          end;
      ans := min(ans, d[v1]);
    end;

  for v := 1 to n do
    if d[v] < INF then
      for i := k downto 1 do
        down(l[v], i);

  d[0] := 2*INF;
  fillchar(t, sizeof(t), 0);
  for i := 1 to n do
    t[i+SHFT] := i;
  for i := SHFT downto 1 do
    t[i] := minv(t[2*i], t[2*i+1]);

  while d[t[1]] < INF do
    begin
      v := t[1];
      u := h[v];
      while u > 0 do
        begin
          w := max(c[z[u]] - c[l[v,1]], 0);
          if d[a[u]] > d[v] + w then
            begin
              d[a[u]] := d[v] + w;
              l[a[u]] := l[v];
              if c[z[u]] > c[l[v,1]] then
                begin
                  l[a[u],1] := z[u];
                  down(l[a[u]], 1);
                end;
              update(a[u]);
            end;
          u := next[u];
        end;
      t[v+SHFT] := 0;
      update(v);
    end;

  ans := min(ans, d[v1]);
  Write(ans);
end.

