Program prg;

{$H+}

type
  integer = longint;

const
  taskname = 'discount';

  inf = 1000000000;
  eps = 1e-8;

  maxw = 3000000000.0;

procedure _swap(var a, b: integer);
  var
    t: integer;

  begin
    t := a;
    a := b;
    b := t;
  end;


var
  n, m: integer;

  i, j, k: integer;

  dis: extended;
  s, t: integer;

  arr: array[0..3010, 0..3010] of integer;

  b: array[0..3001] of integer;
  w, wd: array[0..3001] of extended;
  d: array[0..3001] of extended;

  l, r, now1, now2: extended;
  tmp: extended;

  bests, bestw: extended;
  bestprev: array[0..3010] of integer;

  res1, res2: extended;
  s1, s2, w1, w2: extended;

  t1: integer;

  prev1, prev2, prev: array[0..3010] of integer;

  path: array[0..3010] of integer;

  v: integer;

  h, ind: array[0..3010] of integer;
  red: array[0..3010] of boolean;

  cap: integer;

  a: integer;

procedure swap(a, b: integer);
  begin
    _swap(ind[h[a]], ind[h[b]]);
    _swap(h[a], h[b]);
  end;

procedure siftup(v: integer);
  var
    a: integer;
  begin
    if (v = 1) then exit;
    a := v div 2;
    if (d[h[a]] > d[h[v]]) then begin
      swap(a, v);
      siftup(a);
    end;
  end;

procedure siftdown(v: integer);
  var
    a, b: integer;

  begin
    a := 2*v;
    b := 2*v + 1;
    if (a > cap) then exit;
    if (b > cap) then begin
      if (d[h[a]] < d[h[v]]) then begin
        swap(a, v);
        siftdown(a);
      end;
    end else begin
      if (d[h[a]] < d[h[v]]) then begin
        if (d[h[b]] < d[h[a]]) then begin
          swap(b, v);
          siftdown(b);
        end else begin
          swap(a, v);
          siftdown(a);
        end;
      end else
      if (d[h[b]] < d[h[v]]) then begin
        swap(b, v);
        siftdown(b);
      end;
    end;
  end;


procedure dijkstra();
  var
    i: integer;

  begin
    cap := 1;

    fillchar(ind, sizeof(ind), 0);

    h[1] := s;
    ind[s] := 1;

    for i := 1 to n do d[i] := maxw;
    d[s] := 0;

    fillchar(red, sizeof(red), false);
    while (true) do begin
      if (cap = 0) then break;
      if (h[1] = t) then break;

      t1 := h[1];
      swap(1, cap);
      dec(cap);
      siftdown(1);

      red[t1] := true;
      for i := 1 to arr[t1][0] do begin
        if (not red[b[arr[t1][i]]]) then begin
          if (ind[b[arr[t1][i]]] <> 0) then begin
            if (d[b[arr[t1][i]]] > d[t1] + w[arr[t1][i]]) then begin
              d[b[arr[t1][i]]] := d[t1] + w[arr[t1][i]];
              prev[b[arr[t1][i]]] := t1;
              siftup(ind[b[arr[t1][i]]]);
            end;
          end else begin
            inc(cap);
            h[cap] := b[arr[t1][i]];
            ind[b[arr[t1][i]]] := cap;
            d[b[arr[t1][i]]] := d[t1] + w[arr[t1][i]];
            prev[b[arr[t1][i]]] := t1;
            siftup(cap);
          end;
        end;
      end;

    end;
  end;

begin
  {
  assign(input, taskname + '.in');
  assign(output, taskname + '.out');
  reset(input);
  rewrite(output);
  }

  read(n, m);

  for i := 1 to m do begin
    read(a);
    inc(arr[a][0]);
    inc(b[0]);
    arr[a][arr[a][0]] := b[0];
    read(b[b[0]]);
    read(wd[b[0]]);
  end;

  read(s, t);
  read(dis);

  l := 0.0;
  r := maxw;

  bests := maxw;
  bestw := maxw;

  while (r - l) > eps do begin
    now1 := l * 2 / 3 + r / 3;
    now2 := l / 3 + r * 2 / 3;

    for i := 1 to n do begin
      d[i] := inf;
    end;
    d[s] := 0;
    for i := 1 to m do begin
      w[i] := wd[i] - now1 * dis;
      if (w[i] < 0) then w[i] := 0.0;
    end;

    dijkstra;
    prev1 := prev;

    s1 := now1;
    w1 := d[t];

    for i := 1 to n do begin
      d[i] := inf;
    end;
    d[s] := 0;
    for i := 1 to m do begin
      w[i] := wd[i] - now2 * dis;
      if (w[i] < 0) then w[i] := 0.0;
    end;

    dijkstra;
    prev2 := prev;

    s2 := now2;
    w2 := d[t];

    res1 := s1 + w1;
    res2 := s2 + w2;

    if (res1 <= res2) then begin
      r := now2;
      bests := s1;
      bestw := w1;
      bestprev := prev1;
    end else begin
      l := now1;
      bests := s2;
      bestw := w2;
      bestprev := prev2;
    end;

  end;

  now1 := 0.0;
  for i := 1 to n do begin
    d[i] := inf;
  end;
  d[s] := 0;
  for i := 1 to m do begin
    w[i] := wd[i] - now1 * dis;
    if (w[i] < 0) then w[i] := 0.0;
  end;

  dijkstra;
  prev1 := prev;

  s1 := now1;
  w1 := d[t];

  if (s1 + w1) < (bests + bestw) then begin
    bests := s1;
    bestw := d[t];
    bestprev := prev1;
  end;


  writeln(bests:0:6, ' ', (bestw + bests):0:6);

  path[0] := 1;
  path[1] := t;
  while (path[path[0]] <> s) do begin
    inc(path[0]);
    path[path[0]] := bestprev[path[path[0] - 1]];
  end;
  for i := path[0] downto 1 do write(path[i], ' ');

  {
  close(input);
  close(output);
  }
end.
