#include <stdio.h>
#include <memory.h>

#define MAXN 4000
#define INF 1e10

struct list
{
       int v;
       double w;
       struct list* next;
};

struct list a[MAXN];
int n, m, s, t;
double d[MAXN];
int p[MAXN];
char vert[MAXN];
int res[MAXN];
double alfa;

void list_add(int x, int y, double w)
{
     struct list* pList = new list;
     pList->v = y;
     pList->w = w;
     pList->next = a[x].next;
     a[x].next = pList;
}

void init()
{
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
}

void readdata()
{
     int i, x, y;
     double w;
     scanf("%d%d", &n, &m);
     for(i=0;i<m;i++)
     {
       scanf("%d%d%Lf", &x, &y, &w);
       list_add(x, y, w);
       list_add(y, x, w);
     }
     scanf("%d%d%Lf", &s, &t, &alfa);
}

double get(double w, double s)
{
       double res = w - alfa*s;
       if(res < 0.)
         res = 0.;
       return res;
}

double get_min_path(double sum)
{
       int i, l, imin;
       struct list* pList;
       double min;
       
       for(i=1;i<=n;i++)
         d[i] = INF;
       memset(vert, 1, sizeof(vert));
       memset(p, 0, sizeof(p));
       l = s;
       vert[l] = 0;
       d[l] = 0.;
       while(l!=t)
       {
         pList = a[l].next;
         while(pList != NULL)
         {
           if((vert[pList->v])&&(d[pList->v] > d[l]+get(pList->w, sum)))
           {
             d[pList->v] = d[l] + get(pList->w, sum);
             p[pList->v] = l;
           }
           pList = pList->next;
         }
         min = INF;
         imin = 0;
         for(i=1;i<=n;i++)
           if((vert[i])&&(d[i] < min))
           {
             min = d[i];
             imin = i;
           }
         if(imin != 0)
         {
           vert[imin] = 0;
           l = imin;
         }
       }
       return d[t]+sum;
}

void get_path()
{
     int i = t;
     res[0] = 0;
     while(p[i] > 0)
     {
       res[++res[0]] = i;
       i = p[i];
     }
     res[++res[0]] = i;
     for(i=res[0];i>=1;i--)
       printf("%d ", res[i]);
}

void solve()
{
     double up = 1e10;
     double down = 0.;
     double m1, m2, min = 1e10;
     double t1, t2;
     int i;
     
     while(up-down>1e-7)
     {
       m1 = down+(up-down)/3;
       m2 = down+2.*(up-down)/3.;
       t1 = get_min_path(m1);
       t2 = get_min_path(m2);
       if(t1 > t2)
        down = m1;
       else
        up = m2;
     }
     printf("%0.7Lf %0.7Lf\n", (up+down)/2., get_min_path((up+down)/2.)); 
     get_path();
}

int main()
{
    init();
    readdata();
    solve();
    return 0;
}
