{$MODE DELPHI}
{$M 64000000,64000000,64000000}
{$R-}

uses Math;

const
 StreamIn='';
 StreamOut='';
 NMAX=110000;
 MMAX=410000;

type
 IntVect1=array [0..MMAX] of integer;
 IntVect2=array [0..2*MMAX] of integer;
 IntVect3=array [0..NMAX] of integer;
 BoolVect=array [0..MMAX] of boolean;

var v1,v2,v3,v4,c,St,Ord1,Ord2,Ans:IntVect1;
    Key,Next:IntVect2;
    Head:IntVect3;
    Mark:BoolVect;
    n,m,el,i,k1,k2:integer;

procedure OpenFiles;
begin
 assign(input,StreamIn);
 assign(output,StreamOut);
 reset(input);
 rewrite(output)
end;

procedure CloseFiles;
begin
 close(input);
 close(output)
end;

procedure IntSwap(var a,b:integer);
var q:integer;
begin
 q:=a;
 a:=b;
 b:=q
end;

procedure AddEdge(v,k:integer);
begin
 inc(el);
 Key[el]:=k;
 Next[el]:=Head[v];
 Head[v]:=el
end;

procedure DFS(v:integer);
var en:integer;
begin
 while Head[v]<>0 do begin
   en:=Key[Head[v]];
   if Mark[en] then begin
     Mark[en]:=False;
     Head[v]:=Next[Head[v]];
     DFS(v1[en]+v2[en]-v)
    end
   else Head[v]:=Next[Head[v]]
  end;
 inc(St[0]);
 St[St[0]]:=v
end;

procedure qsort1(l,r:integer);
var i,j,k,q1,q2:integer;
begin
 i:=l;
 j:=r;
 k:=l+random(r-l+1);
 q1:=min(v1[Ord1[k]],v2[Ord1[k]]);
 q2:=max(v1[Ord1[k]],v2[Ord1[k]]);
 repeat
  while (v1[Ord1[i]]<q1) or ((v1[Ord1[i]]=q1) and (v2[Ord1[i]]<q2))
  do inc(i);
  while (v1[Ord1[j]]>q1) or ((v1[Ord1[j]]=q1) and (v2[Ord1[j]]>q2))
  do dec(j);
  if i<=j then begin
    IntSwap(Ord1[i],Ord1[j]);
    inc(i);
    dec(j)
   end
 until i>j;
 if i<r then qsort1(i,r);
 if l<j then qsort1(l,j)
end;

procedure qsort2(l,r:integer);
var i,j,k,q1,q2:integer;
begin
 i:=l;
 j:=r;
 k:=l+random(r-l+1);
 q1:=min(v3[Ord2[k]],v4[Ord2[k]]);
 q2:=max(v3[Ord2[k]],v4[Ord2[k]]);
 repeat
  while (v3[Ord2[i]]<q1) or ((v3[Ord2[i]]=q1) and (v4[Ord2[i]]<q2))
  do inc(i);
  while (v3[Ord2[j]]>q1) or ((v3[Ord2[j]]=q1) and (v4[Ord2[j]]>q2))
  do dec(j);
  if i<=j then begin
    IntSwap(Ord2[i],Ord2[j]);
    inc(i);
    dec(j)
   end
 until i>j;
 if i<r then qsort2(i,r);
 if l<j then qsort2(l,j)
end;

begin
 OpenFiles;
 read(n,m);
 fillchar(Head,sizeof(Head),0);
 for i:=1 to m do begin
   read(v1[i],v2[i],c[i]);
   k1:=min(v1[i],v2[i]);
   k2:=max(v1[i],v2[i]);
   v1[i]:=k1;
   v2[i]:=k2
  end;
 randomize;
 for i:=1 to m do Ord1[i]:=i;
 for i:=1 to m do
  IntSwap(Ord1[random(m)+1],Ord1[random(m)+1]);
 el:=0;
 for i:=1 to m do begin
   AddEdge(v1[Ord1[i]],Ord1[i]);
   AddEdge(v2[Ord1[i]],Ord1[i])
  end;
 fillchar(Mark,sizeof(Mark),True);
 St[0]:=0;
 DFS(1);
 for i:=1 to m do begin
   Ord1[i]:=i;
   Ord2[i]:=i
  end;
 for i:=1 to m do begin
   v3[i]:=min(St[i],St[i+1]);
   v4[i]:=max(St[i],St[i+1])
  end;
 qsort1(1,m);
 qsort2(1,m);
 for i:=1 to m do Ans[Ord2[i]]:=Ord1[i];
 for i:=m downto 1 do write(Ans[i],' ');
 CloseFiles
end.
