#include <stdio.h>
#include <memory.h>

#define MAXN 500
#define MAXLIST 10000

const int dx[] = { 1, 0,-1, 0, 1, 1,-1,-1};
const int dy[] = { 0,-1, 0, 1, 1,-1,-1, 1};   

char a[MAXN][MAXN];
char c[MAXN][MAXN];
int lx[MAXLIST];
int ly[MAXLIST];
int next[MAXLIST];
int pr[MAXLIST];
int stack[MAXLIST];
int pst;
int n, head;
double x0, y0, m;

void init()
{
     int i;
   //  freopen("input.txt", "r", stdin);
  //   freopen("output.txt", "w", stdout);
     memset(a, 0, sizeof(a));
     memset(c, 1, sizeof(c));
     memset(lx, 0, sizeof(lx));
     memset(ly, 0, sizeof(ly));
     memset(next, 0, sizeof(next));
     memset(stack, 0, sizeof(stack));
     pst = 0;
     head = 0;
     for(i=MAXLIST-1;i>=1;i--)
       stack[++pst] = i;
}

void readdata()
{
     scanf("%d", &n);
}

void list_add(int y, int x)
{
     int p = stack[pst--];
     lx[p] = x;
     ly[p] = y;
     next[p] = head;
     pr[head] = p;
     pr[p] = 0;
     head = p;
}

void list_del(int p)
{
     if(pr[p] == 0)
       head = next[p];
     pr[next[p]] = pr[p];
     next[pr[p]] = next[p];
     stack[++pst] = p;
}

void add(int y, int x)
{
     int i;
     for(i=0;i<8;i++)
       if(c[y+dy[i]][x+dx[i]])
       {
         list_add(y+dy[i], x+dx[i]);
         c[y+dy[i]][x+dx[i]] = 0;
       }
}

void solve()
{
     int i, x, y, minx, miny, p, minp;
     double xn, yn, mn, minm;
     a[250][250] = 1;
     c[250][250] = 0;
     add(250, 250);
     x0 = y0 = 250.;
     m = 0;
     for(i=2;i<=n;i++)
     {
       minm = 10000000000.;                      
       p = head;
       while(p != 0)
       {
           x = lx[p];
           y = ly[p];
           xn = (x0*(i-1)+ x)/i;
           yn = (y0*(i-1)+ y)/i;
           mn = m + (i-1)*((xn-x0)*(xn-x0)+(yn-y0)*(yn-y0))+((xn-x)*(xn-x)+(yn-y)*(yn-y));
           if(mn < minm)
           {
             minm = mn;
             minx = x;
             miny = y;
             minp = p;
           }
           p = next[p];
       }
       a[miny][minx] = 1;
       c[miny][minx] = 0;
       x0 = (x0*(i-1)+ minx)/i;
       y0 = (y0*(i-1)+ miny)/i;
       list_del(minp);
       add(miny, minx);
       m = minm;
     }
}

void writedata()
{
     int i, j;
     int xmin, ymin, xmax, ymax;
     xmin = ymin = 1000;
     xmax = ymax = 0;
     for(i=0;i<MAXN;i++)
       for(j=0;j<MAXN;j++)
         if(a[i][j])
         {
           if(i<ymin)
             ymin = i;
           if(i>ymax) 
             ymax = i;
           if(j<xmin)
             xmin = j;
           if(j>xmax)
             xmax = j;
         }    
     printf("%d %d\n", xmax-xmin+1, ymax-ymin+1);
     for(i=ymin;i<=ymax;i++)
     {
       for(j=xmin;j<=xmax;j++)
         if(a[i][j])
           printf("*");
         else
           printf(".");
       printf("\n");
     }       
}

int main()
{
    init();
    readdata();
    solve();
    writedata();
    return 0;
}
