#include <cassert>
#include <cstdio>
#include <cstring>
#include <map>
#include <set>
#include <vector>

using namespace std;

typedef vector<int> vi;

struct Edge
{
	int a;
	int b;
	int c;
	bool d;
	int n;
};

int n, m, ne;
int f[100000];
Edge e[800000];
vector<int> nodes;
map<int, set<int> > store[100000];
int clr[400000], res[400000], pos[400000];
vector<pair<int, int> > conf[2][100000];

void add_edge(int a, int b, int c)
{
	e[ne].a = a;
	e[ne].b = b;
	e[ne].c = c;
	e[ne].n = f[a];
	e[ne].d = false;
	f[a] = ne;
	ne++;
}

void dfs(int x)
{	
	int cur = f[x];
	while (cur != -1)
	{
		if (!e[cur].d)
		{
			e[cur].d = e[cur ^ 1].d = true;
			dfs(e[cur].b);
		}
		cur = e[cur].n;
	}
	nodes.push_back(x);
}

void rotate(int x, int y)
{
	for (int i = x, j = y; i <= j; i++, j--)
	{
		swap(res[i], res[j]);
		pos[res[i]] = i;
		pos[res[j]] = j;
	}
}

void resolve(int e1, int e2, int e3, int e4)
{
	if ((pos[e1] + 1) % m != pos[e2]) swap(e1, e2);
	if ((pos[e3] + 1) % m != pos[e4]) swap(e3, e4);
	if (pos[e2] < pos[e3]) rotate(pos[e2], pos[e3]);
	else rotate(pos[e4], pos[e1]);
}

int main()
{
	/*
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
        */
	scanf("%d%d", &n, &m);
	memset(f, 255, sizeof(f));
	ne = 0;
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		a--, b--, c--;
		add_edge(a, b, c);
		add_edge(b, a, c);
		store[a][b].insert(i);
		store[b][a].insert(i);
		clr[i] = c;
	}
	dfs(0);
	for (int i = 0; i < m; i++)
	{
		int p = nodes[i], q = nodes[i + 1];
		res[i] = *store[p][q].begin();
		store[p][q].erase(res[i]);
		store[q][p].erase(res[i]);
		pos[res[i]] = i;
	}
	for (int i = 0; i < m; i++)
	{
		if (clr[res[i]] != clr[res[(i + 1) % m]]) continue;
		conf[clr[res[i]]][nodes[i + 1]].push_back(make_pair(res[i], res[(i + 1) % m]));
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < min(conf[0][i].size(), conf[1][i].size()); j++)
			resolve(conf[0][i][j].first, conf[0][i][j].second, conf[1][i][j].first, conf[1][i][j].second);
	for (int i = 0; i < m; i++)
		printf("%d ", res[i] + 1);
	printf("\n");
	return 0;
}

