{$MODE DELPHI}
{$M 60000000,60000000}
{$N+,O+,Q-,R-,S-}
uses
    math;
const
    NMAX = 501;
    inf = 1000000000000000000;
type
    int = longint;
    mass = array [-NMAX..NMAX, -NMAX..NMAX] of boolean;
var
    ans, a, d: mass;
    x, y, o: array [1..NMAX] of int;
    best: int64;
    n, k: int;

procedure swap(var a, b: int);
var
    c: int;
begin
    c := a;
    a := b;
    b := c;
end;

function get(a: mass): int64;
var
    x, y, num: int;
    i, j: int;
begin
    num := 0;
    x := 0;
    y := 0;
    for i := 1 to n do
        for j := 1 to n do
            if a[i, j] then begin
                inc(num);
                inc(x, i);
                inc(y, j);
            end;
    result := 0;
    for i := 1 to n do
        for j := 1 to n do
            inc(result, sqr(int64(num * i - x)) + sqr(int64(num * j - y)));
end;

procedure make1;
var
    i, j, min_x, min_y: int;
    m: int;
begin
    for i := 1 to n do
        if 2 * i * (i + 1) > n then begin
            k := i - 1;
            break;
        end;
    fillchar(a, sizeof(a), 0);
    for i := 1 to k do begin
        for j := 0 to i - 1 do
            a[j, i - j - 1] := true;
        for j := -1 downto -i do
            a[j, - i - j - 1] := true;
        for j := -1 downto -i do
            a[j, i + j] := true;
        for j := 0 to i - 1 do
            a[j, - i + j] := true;
    end;

    m := 0;
    i := k + 1;
    for j := 0 to i - 1 do begin
        inc(m);
        x[m] := j;
        y[m] := i - j - 1;
        o[m] := 4 * (sqr(2 * x[m] + 1) + sqr(2 * y[m] + 1)) + 0;
    end;
    for j := -1 downto -i do begin
        inc(m);
        x[m] := j;
        y[m] := - i - j - 1;
        o[m] := 4 * (sqr(2 * x[m] + 1) + sqr(2 * y[m] + 1)) + 2;
    end;
    for j := -1 downto -i do begin
        inc(m);
        x[m] := j;
        y[m] := i + j;
        o[m] := 4 * (sqr(2 * x[m] + 1) + sqr(2 * y[m] + 1)) + 1;
    end;
    for j := 0 to i - 1 do begin
        inc(m);
        x[m] := j;
        y[m] := - i + j;
        o[m] := 4 * (sqr(2 * x[m] + 1) + sqr(2 * y[m] + 1)) + 3;
    end;
    for i := 1 to m do
        for j := i + 1 to m do
            if o[i] > o[j] then begin
                swap(o[i], o[j]);
                swap(x[i], x[j]);
                swap(y[i], y[j]);
            end;
    for i := 1 to n - 2 * k * (k + 1) do
        a[x[i], y[i]] := true;

    min_x := n;
    min_y := n;
    for i := -n to n do
        for j := -n to n do
            if a[i, j] then begin
                min_x := min(min_x, i);
                min_y := min(min_y, j);
            end;
    for i := 1 to n do
        for j := 1 to n do
            ans[i, j] := a[i + min_x - 1, j + min_y - 1];
    best := get(ans);
end;

procedure make2;
var
    i, j, min_x, min_y, m: int;
    now: int64;
begin
    fillchar(a, sizeof(a), 0);
    a[0, 0] := true;
    dec(n);
    for i := 1 to n do
        if 2 * i * (i + 1) > n then begin
            k := i - 1;
            break;
        end;
    for i := 1 to k do begin
        for j := 0 to i - 1 do
            a[j, i - j] := true;
        for j := 1 to i do
            a[j, j - i] := true;
        for j := -i + 1 to 0 do
            a[j, - j - i] := true;
        for j := -i to -1 do
            a[j, i + j] := true;
    end;
    m := 0;
    i := k + 1;
    for j := 0 to i - 1 do begin
        inc(m);
        x[m] := j;
        y[m] := i - j;
        o[m] := 4 * (sqr(2 * x[m]) + sqr(2 * y[m])) + 0;
    end;
    for j := 1 to i do begin
        inc(m);
        x[m] := j;
        y[m] := j - i;
        o[m] := 4 * (sqr(2 * x[m]) + sqr(2 * y[m])) + 1;
    end;
    for j := -i + 1 to 0 do begin
        inc(m);
        x[m] := j;
        y[m] := - j - i;
        o[m] := 4 * (sqr(2 * x[m]) + sqr(2 * y[m])) + 2;
    end;
    for j := -i to -1 do begin
        inc(m);
        x[m] := j;
        y[m] := j + i;
        o[m] := 4 * (sqr(2 * x[m]) + sqr(2 * y[m])) + 3;
    end;
    for i := 1 to m do
        for j := i + 1 to m do
            if o[i] > o[j] then begin
                swap(o[i], o[j]);
                swap(x[i], x[j]);
                swap(y[i], y[j]);
            end;
    for i := 1 to n - 2 * k * (k + 1) do
        a[x[i], y[i]] := true;

    inc(n);
    min_x := n;
    min_y := n;
    for i := -n to n do
        for j := -n to n do
            if a[i, j] then begin
                min_x := min(min_x, i);
                min_y := min(min_y, j);
            end;
    for i := 1 to n do
        for j := 1 to n do
            d[i, j] := a[i + min_x - 1, j + min_y - 1];
    now := get(d);
    if now < best then begin
        best := now;
        ans := d;
    end;
end;

var
    i, j: int;

begin
{    assign(input, 'input.txt');
    reset(input);
    assign(output, 'output.txt');
    rewrite(output);}

    read(n);
    make1;
    make2;
    writeln(n, ' ', n);
    for i := 1 to n do begin
        for j := 1 to n do
            if ans[i, j] then
                write('*')
            else
                write('.');
        writeln;
    end;
end.