//#define DEBUG2 // read from file


#include <iostream>
#include <fstream>

#include <vector>

using namespace std;


int n, m;
int a[500000], b[500000], c[500000]; // edges ends and color

int was[500000];  // is edge in main cycle

int cur[128000];  // some edge in current vertex, included in main cycle (index in edg list)

vector <int> edg[128000]; // list of edges numbers in current vertex
int twina[500000];
int twinb[500000];
int cnt[128000];
vector <int> job; // stack of not completed vertexes in main cycle
int pres[128000]; // is current vertex presented in job list;



#ifdef DEBUG2
ifstream in("stripes.in");
ofstream out("stripes.out");
#else
#define in cin
#define out cout
#endif


int jump(int e, int v)
{
	return a[e] == v ? b[e] : a[e];
}


void AddTwin(int e1, int v, int e2)
{
	if (v == a[e1]) twina[e1] = e2;
	else twinb[e1] = e2;
	if (v == a[e2]) twina[e2] = e1;
	else twinb[e2] = e1;	
}

int GetTwin(int e, int v)
{
	if (v == a[e]) return twina[e];
	else return twinb[e];
}



void Load()
{

	in >> n >> m;
	int i;
	for (i = 1; i <= m; i++)
	{
		in >> a[i] >> b[i] >> c[i];
	}
}       



int fst[128000];
int nxt[500000];
int dain[500000], daic[500000]; // cnt + color

void MapAll(int v)
{
	int i, j, k = 0;
	int prevc = -1;

	for (i = 0; i < edg[v].size(); i++)
	{
		k = edg[v][i];
		j = c[k];
		if (j != prevc) fst[j] = 0;
		nxt[k] = fst[j];
		fst[j] = k;
		prevc = j;
	}
	prevc = -1;
	for (i = 0; i < edg[v].size(); i++)
	{
		j = edg[v][i];
		j = c[j];
		if (j != prevc)		
		{
			daic[k] = j;
			dain[k++] = cnt[j];
		}
		prevc = j;		
	}



	int tmp;

	j = edg[v].size() - dain[k-1];
	while (dain[k-1] > j)
	{
		AddTwin(fst[daic[k-1]], v, nxt[fst[daic[k-1]]]);
		fst[daic[k-1]] = nxt[fst[daic[k-1]]]; dain[k-1]--;
		fst[daic[k-1]] = nxt[fst[daic[k-1]]]; dain[k-1]--;
	}

	if (k > 1) while (dain[k-2] > 0)
	{
		
		AddTwin(fst[daic[k-2]], v, fst[daic[k-1]]);
		fst[daic[k-2]] = nxt[fst[daic[k-2]]]; dain[k-2]--;
		fst[daic[k-1]] = nxt[fst[daic[k-1]]]; dain[k-1]--;
		if (k > 2)
		{
			for (i = k-3; i >= 0 && dain[i] > dain[k-2]; i--);
			i++;
	
			if (dain[i] > dain[k-2])
			{
				tmp = dain[k-2]; dain[k-2] = dain[i]; dain[i] = tmp;
				tmp = daic[k-2]; daic[k-2] = daic[i]; daic[i] = tmp;
			}
			for (i = k-2; i >= 0 && dain[i] > dain[k-1]; i--);
			i++;

			if (dain[i] > dain[k-1])
			{
				tmp = dain[k-1]; dain[k-1] = dain[i]; dain[i] = tmp;
				tmp = daic[k-1]; daic[k-1] = daic[i]; daic[i] = tmp;
			}
		}			
	
	}
	while (dain[k-1] > 0) {
		AddTwin(fst[daic[k-1]], v, nxt[fst[daic[k-1]]]);
		fst[daic[k-1]] = nxt[fst[daic[k-1]]]; dain[k-1]--;
		fst[daic[k-1]] = nxt[fst[daic[k-1]]]; dain[k-1]--;
	}
}


void AddC(int v, int e) // vertex & edge index in edg; must & mark was, cur, pres, job
{
	int ce = e, cv = v;
	
	do
	{
		was[ce] = 1;
		cur[cv] = ce;
		if (pres[cv] == 0)
		{
			pres[cv] = 1;
			job.push_back(cv);
		}
		cv = jump(ce, cv);
		ce = GetTwin(ce, cv);
	}
	while (cv != v || ce != e);

}


void Merge(int v, int e1, int e3)
{

	int e2, e4;
	e2 = GetTwin(e1, v);
	e4 = GetTwin(e3, v);
	int c1 = 0, c2 = 0;
	if (c[e1] != c[e3]) c1++;
	if (c[e2] != c[e4]) c1++;
	if (c[e1] != c[e4]) c2++;
	if (c[e2] != c[e3]) c2++;
	if (c1 > c2)
	{
		AddTwin(e1, v, e3);
		AddTwin(e2, v, e4);
	}
	else
	{
		AddTwin(e1, v, e4);
		AddTwin(e2, v, e3);
	}
}


int Compare(const int &a, const int &b)
{
	if (cnt[c[a]] < cnt[c[b]]) return 1;
	if (cnt[c[a]] > cnt[c[b]]) return 0;
	if (c[a] < c[b]) return 1;
	return 0;
}

void Solve()
{
	int i, j, gd;
	for (i = m; i >= 1; i--)
	{
	        edg[a[i]].push_back(i);
	        edg[b[i]].push_back(i);
	}
	for (i = 1; i <= n; i++)
	{
		if (edg[i].size() == 0) continue;
		memset(cnt, 0, sizeof(cnt));
		for (j = 0; j < edg[i].size(); j++)
			cnt[ c[ edg[i][j]] ]++;
		sort(edg[i].begin(),edg[i].end(), Compare);
		MapAll(i);
	}

	int beg = -1;
	for (i = 0; i < n; i++)
	{
		if (edg[i].size() > 0)  beg = i;
	}
	if (beg == -1) return;

	AddC(beg, edg[beg][0]);
	while (job.size() > 0)
	{
		i = job.back();
		job.pop_back();
		gd = cur[i];

		for (j = 0; j < edg[i].size(); j++)
		{
			if (was[edg[i][j]] == 0)
			{
				AddC(i, edg[i][j]); // vertex & edge; must mark was, cur, pres, job
				Merge(i, gd, edg[i][j]); // merge two cysles e1->e2 & e3->e4
                       	}
		}
	}
	//restore answer.
	if (job.size() > 0) job.clear();
	i = beg;
	j = edg[i][0];
	do
	{
	                      	
		job.push_back(j);
		i = jump(j, i);	
		j = GetTwin(j, i);
	
	}
	while (j != edg[beg][0] || i != beg);

	for (i = 0; i < job.size(); i++)
	{
		out << job[i] << " ";
	}

}


int main()
{
	Load();
	Solve();
	return 0;
}
